from __future__ import annotations
from ..fable_modules.fable_library.array_ import choose
from ..fable_modules.fable_library.string_ import replace
from ..fable_modules.fable_library.types import Array
from ..fable_modules.fable_library.util import to_enumerable
from .ldcontext import LDContext

terms_v1_2draft: str = "\r\n        \"3DModel\", \"http://schema.org/3DModel\"\r\n        \"AMRadioChannel\", \"http://schema.org/AMRadioChannel\"\r\n        \"APIReference\", \"http://schema.org/APIReference\"\r\n        \"Abdomen\", \"http://schema.org/Abdomen\"\r\n        \"AboutPage\", \"http://schema.org/AboutPage\"\r\n        \"AcceptAction\", \"http://schema.org/AcceptAction\"\r\n        \"Accommodation\", \"http://schema.org/Accommodation\"\r\n        \"AccountingService\", \"http://schema.org/AccountingService\"\r\n        \"AchieveAction\", \"http://schema.org/AchieveAction\"\r\n        \"Action\", \"http://schema.org/Action\"\r\n        \"ActionAccessSpecification\", \"http://schema.org/ActionAccessSpecification\"\r\n        \"ActionStatusType\", \"http://schema.org/ActionStatusType\"\r\n        \"ActivateAction\", \"http://schema.org/ActivateAction\"\r\n        \"ActivationFee\", \"http://schema.org/ActivationFee\"\r\n        \"ActiveActionStatus\", \"http://schema.org/ActiveActionStatus\"\r\n        \"ActiveNotRecruiting\", \"http://schema.org/ActiveNotRecruiting\"\r\n        \"AddAction\", \"http://schema.org/AddAction\"\r\n        \"AdministrativeArea\", \"http://schema.org/AdministrativeArea\"\r\n        \"AdultEntertainment\", \"http://schema.org/AdultEntertainment\"\r\n        \"AdultOrientedEnumeration\", \"http://schema.org/AdultOrientedEnumeration\"\r\n        \"AdvertiserContentArticle\", \"http://schema.org/AdvertiserContentArticle\"\r\n        \"AerobicActivity\", \"http://schema.org/AerobicActivity\"\r\n        \"AggregateOffer\", \"http://schema.org/AggregateOffer\"\r\n        \"AggregateRating\", \"http://schema.org/AggregateRating\"\r\n        \"AgreeAction\", \"http://schema.org/AgreeAction\"\r\n        \"Airline\", \"http://schema.org/Airline\"\r\n        \"Airport\", \"http://schema.org/Airport\"\r\n        \"AlbumRelease\", \"http://schema.org/AlbumRelease\"\r\n        \"AlcoholConsideration\", \"http://schema.org/AlcoholConsideration\"\r\n        \"AlignmentObject\", \"http://schema.org/AlignmentObject\"\r\n        \"AllWheelDriveConfiguration\", \"http://schema.org/AllWheelDriveConfiguration\"\r\n        \"AllergiesHealthAspect\", \"http://schema.org/AllergiesHealthAspect\"\r\n        \"AllocateAction\", \"http://schema.org/AllocateAction\"\r\n        \"AmpStory\", \"http://schema.org/AmpStory\"\r\n        \"AmusementPark\", \"http://schema.org/AmusementPark\"\r\n        \"AnaerobicActivity\", \"http://schema.org/AnaerobicActivity\"\r\n        \"AnalysisNewsArticle\", \"http://schema.org/AnalysisNewsArticle\"\r\n        \"AnatomicalStructure\", \"http://schema.org/AnatomicalStructure\"\r\n        \"AnatomicalSystem\", \"http://schema.org/AnatomicalSystem\"\r\n        \"AndroidPlatform\", \"http://schema.org/AndroidPlatform\"\r\n        \"Anesthesia\", \"http://schema.org/Anesthesia\"\r\n        \"AnimalShelter\", \"http://schema.org/AnimalShelter\"\r\n        \"Answer\", \"http://schema.org/Answer\"\r\n        \"Apartment\", \"http://schema.org/Apartment\"\r\n        \"ApartmentComplex\", \"http://schema.org/ApartmentComplex\"\r\n        \"Appearance\", \"http://schema.org/Appearance\"\r\n        \"AppendAction\", \"http://schema.org/AppendAction\"\r\n        \"ApplyAction\", \"http://schema.org/ApplyAction\"\r\n        \"ApprovedIndication\", \"http://schema.org/ApprovedIndication\"\r\n        \"Aquarium\", \"http://schema.org/Aquarium\"\r\n        \"ArchiveComponent\", \"http://schema.org/ArchiveComponent\"\r\n        \"ArchiveOrganization\", \"http://schema.org/ArchiveOrganization\"\r\n        \"ArriveAction\", \"http://schema.org/ArriveAction\"\r\n        \"ArtGallery\", \"http://schema.org/ArtGallery\"\r\n        \"Artery\", \"http://schema.org/Artery\"\r\n        \"Article\", \"http://schema.org/Article\"\r\n        \"AskAction\", \"http://schema.org/AskAction\"\r\n        \"AskPublicNewsArticle\", \"http://schema.org/AskPublicNewsArticle\"\r\n        \"AssessAction\", \"http://schema.org/AssessAction\"\r\n        \"AssignAction\", \"http://schema.org/AssignAction\"\r\n        \"Atlas\", \"http://schema.org/Atlas\"\r\n        \"Attorney\", \"http://schema.org/Attorney\"\r\n        \"Audience\", \"http://schema.org/Audience\"\r\n        \"AudioObject\", \"http://schema.org/AudioObject\"\r\n        \"AudioObjectSnapshot\", \"http://schema.org/AudioObjectSnapshot\"\r\n        \"Audiobook\", \"http://schema.org/Audiobook\"\r\n        \"AudiobookFormat\", \"http://schema.org/AudiobookFormat\"\r\n        \"AuthoritativeLegalValue\", \"http://schema.org/AuthoritativeLegalValue\"\r\n        \"AuthorizeAction\", \"http://schema.org/AuthorizeAction\"\r\n        \"AutoBodyShop\", \"http://schema.org/AutoBodyShop\"\r\n        \"AutoDealer\", \"http://schema.org/AutoDealer\"\r\n        \"AutoPartsStore\", \"http://schema.org/AutoPartsStore\"\r\n        \"AutoRental\", \"http://schema.org/AutoRental\"\r\n        \"AutoRepair\", \"http://schema.org/AutoRepair\"\r\n        \"AutoWash\", \"http://schema.org/AutoWash\"\r\n        \"AutomatedTeller\", \"http://schema.org/AutomatedTeller\"\r\n        \"AutomotiveBusiness\", \"http://schema.org/AutomotiveBusiness\"\r\n        \"Ayurvedic\", \"http://schema.org/Ayurvedic\"\r\n        \"BackOrder\", \"http://schema.org/BackOrder\"\r\n        \"BackgroundNewsArticle\", \"http://schema.org/BackgroundNewsArticle\"\r\n        \"Bacteria\", \"http://schema.org/Bacteria\"\r\n        \"Bakery\", \"http://schema.org/Bakery\"\r\n        \"Balance\", \"http://schema.org/Balance\"\r\n        \"BankAccount\", \"http://schema.org/BankAccount\"\r\n        \"BankOrCreditUnion\", \"http://schema.org/BankOrCreditUnion\"\r\n        \"BarOrPub\", \"http://schema.org/BarOrPub\"\r\n        \"Barcode\", \"http://schema.org/Barcode\"\r\n        \"BasicIncome\", \"http://schema.org/BasicIncome\"\r\n        \"Beach\", \"http://schema.org/Beach\"\r\n        \"BeautySalon\", \"http://schema.org/BeautySalon\"\r\n        \"BedAndBreakfast\", \"http://schema.org/BedAndBreakfast\"\r\n        \"BedDetails\", \"http://schema.org/BedDetails\"\r\n        \"BedType\", \"http://schema.org/BedType\"\r\n        \"BefriendAction\", \"http://schema.org/BefriendAction\"\r\n        \"BenefitsHealthAspect\", \"http://schema.org/BenefitsHealthAspect\"\r\n        \"BikeStore\", \"http://schema.org/BikeStore\"\r\n        \"BioChemEntity\", \"http://schema.org/BioChemEntity\"\r\n        \"Blog\", \"http://schema.org/Blog\"\r\n        \"BlogPosting\", \"http://schema.org/BlogPosting\"\r\n        \"BloodTest\", \"http://schema.org/BloodTest\"\r\n        \"BoardingPolicyType\", \"http://schema.org/BoardingPolicyType\"\r\n        \"BoatReservation\", \"http://schema.org/BoatReservation\"\r\n        \"BoatTerminal\", \"http://schema.org/BoatTerminal\"\r\n        \"BoatTrip\", \"http://schema.org/BoatTrip\"\r\n        \"BodyMeasurementArm\", \"http://schema.org/BodyMeasurementArm\"\r\n        \"BodyMeasurementBust\", \"http://schema.org/BodyMeasurementBust\"\r\n        \"BodyMeasurementChest\", \"http://schema.org/BodyMeasurementChest\"\r\n        \"BodyMeasurementFoot\", \"http://schema.org/BodyMeasurementFoot\"\r\n        \"BodyMeasurementHand\", \"http://schema.org/BodyMeasurementHand\"\r\n        \"BodyMeasurementHead\", \"http://schema.org/BodyMeasurementHead\"\r\n        \"BodyMeasurementHeight\", \"http://schema.org/BodyMeasurementHeight\"\r\n        \"BodyMeasurementHips\", \"http://schema.org/BodyMeasurementHips\"\r\n        \"BodyMeasurementInsideLeg\", \"http://schema.org/BodyMeasurementInsideLeg\"\r\n        \"BodyMeasurementNeck\", \"http://schema.org/BodyMeasurementNeck\"\r\n        \"BodyMeasurementTypeEnumeration\", \"http://schema.org/BodyMeasurementTypeEnumeration\"\r\n        \"BodyMeasurementUnderbust\", \"http://schema.org/BodyMeasurementUnderbust\"\r\n        \"BodyMeasurementWaist\", \"http://schema.org/BodyMeasurementWaist\"\r\n        \"BodyMeasurementWeight\", \"http://schema.org/BodyMeasurementWeight\"\r\n        \"BodyOfWater\", \"http://schema.org/BodyOfWater\"\r\n        \"Bone\", \"http://schema.org/Bone\"\r\n        \"Book\", \"http://schema.org/Book\"\r\n        \"BookFormatType\", \"http://schema.org/BookFormatType\"\r\n        \"BookSeries\", \"http://schema.org/BookSeries\"\r\n        \"BookStore\", \"http://schema.org/BookStore\"\r\n        \"BookmarkAction\", \"http://schema.org/BookmarkAction\"\r\n        \"Boolean\", \"http://schema.org/Boolean\"\r\n        \"BorrowAction\", \"http://schema.org/BorrowAction\"\r\n        \"BowlingAlley\", \"http://schema.org/BowlingAlley\"\r\n        \"BrainStructure\", \"http://schema.org/BrainStructure\"\r\n        \"Brand\", \"http://schema.org/Brand\"\r\n        \"BreadcrumbList\", \"http://schema.org/BreadcrumbList\"\r\n        \"Brewery\", \"http://schema.org/Brewery\"\r\n        \"Bridge\", \"http://schema.org/Bridge\"\r\n        \"BroadcastChannel\", \"http://schema.org/BroadcastChannel\"\r\n        \"BroadcastEvent\", \"http://schema.org/BroadcastEvent\"\r\n        \"BroadcastFrequencySpecification\", \"http://schema.org/BroadcastFrequencySpecification\"\r\n        \"BroadcastRelease\", \"http://schema.org/BroadcastRelease\"\r\n        \"BroadcastService\", \"http://schema.org/BroadcastService\"\r\n        \"BrokerageAccount\", \"http://schema.org/BrokerageAccount\"\r\n        \"BuddhistTemple\", \"http://schema.org/BuddhistTemple\"\r\n        \"BusOrCoach\", \"http://schema.org/BusOrCoach\"\r\n        \"BusReservation\", \"http://schema.org/BusReservation\"\r\n        \"BusStation\", \"http://schema.org/BusStation\"\r\n        \"BusStop\", \"http://schema.org/BusStop\"\r\n        \"BusTrip\", \"http://schema.org/BusTrip\"\r\n        \"BusinessAudience\", \"http://schema.org/BusinessAudience\"\r\n        \"BusinessEntityType\", \"http://schema.org/BusinessEntityType\"\r\n        \"BusinessEvent\", \"http://schema.org/BusinessEvent\"\r\n        \"BusinessFunction\", \"http://schema.org/BusinessFunction\"\r\n        \"BusinessSupport\", \"http://schema.org/BusinessSupport\"\r\n        \"BuyAction\", \"http://schema.org/BuyAction\"\r\n        \"CDCPMDRecord\", \"http://schema.org/CDCPMDRecord\"\r\n        \"CDFormat\", \"http://schema.org/CDFormat\"\r\n        \"CT\", \"http://schema.org/CT\"\r\n        \"CableOrSatelliteService\", \"http://schema.org/CableOrSatelliteService\"\r\n        \"CafeOrCoffeeShop\", \"http://schema.org/CafeOrCoffeeShop\"\r\n        \"Campground\", \"http://schema.org/Campground\"\r\n        \"CampingPitch\", \"http://schema.org/CampingPitch\"\r\n        \"Canal\", \"http://schema.org/Canal\"\r\n        \"CancelAction\", \"http://schema.org/CancelAction\"\r\n        \"Car\", \"http://schema.org/Car\"\r\n        \"CarUsageType\", \"http://schema.org/CarUsageType\"\r\n        \"Cardiovascular\", \"http://schema.org/Cardiovascular\"\r\n        \"CardiovascularExam\", \"http://schema.org/CardiovascularExam\"\r\n        \"CaseSeries\", \"http://schema.org/CaseSeries\"\r\n        \"Casino\", \"http://schema.org/Casino\"\r\n        \"CassetteFormat\", \"http://schema.org/CassetteFormat\"\r\n        \"CategoryCode\", \"http://schema.org/CategoryCode\"\r\n        \"CategoryCodeSet\", \"http://schema.org/CategoryCodeSet\"\r\n        \"CatholicChurch\", \"http://schema.org/CatholicChurch\"\r\n        \"CausesHealthAspect\", \"http://schema.org/CausesHealthAspect\"\r\n        \"Cemetery\", \"http://schema.org/Cemetery\"\r\n        \"Chapter\", \"http://schema.org/Chapter\"\r\n        \"CharitableIncorporatedOrganization\", \"http://schema.org/CharitableIncorporatedOrganization\"\r\n        \"CheckAction\", \"http://schema.org/CheckAction\"\r\n        \"CheckInAction\", \"http://schema.org/CheckInAction\"\r\n        \"CheckOutAction\", \"http://schema.org/CheckOutAction\"\r\n        \"CheckoutPage\", \"http://schema.org/CheckoutPage\"\r\n        \"ChemicalSubstance\", \"http://schema.org/ChemicalSubstance\"\r\n        \"ChildCare\", \"http://schema.org/ChildCare\"\r\n        \"ChildrensEvent\", \"http://schema.org/ChildrensEvent\"\r\n        \"Chiropractic\", \"http://schema.org/Chiropractic\"\r\n        \"ChooseAction\", \"http://schema.org/ChooseAction\"\r\n        \"Church\", \"http://schema.org/Church\"\r\n        \"City\", \"http://schema.org/City\"\r\n        \"CityHall\", \"http://schema.org/CityHall\"\r\n        \"CivicStructure\", \"http://schema.org/CivicStructure\"\r\n        \"Claim\", \"http://schema.org/Claim\"\r\n        \"ClaimReview\", \"http://schema.org/ClaimReview\"\r\n        \"Class\", \"http://schema.org/Class\"\r\n        \"CleaningFee\", \"http://schema.org/CleaningFee\"\r\n        \"Clinician\", \"http://schema.org/Clinician\"\r\n        \"Clip\", \"http://schema.org/Clip\"\r\n        \"ClothingStore\", \"http://schema.org/ClothingStore\"\r\n        \"CoOp\", \"http://schema.org/CoOp\"\r\n        \"Code\", \"http://schema.org/Code\"\r\n        \"CohortStudy\", \"http://schema.org/CohortStudy\"\r\n        \"Collection\", \"http://schema.org/Collection\"\r\n        \"CollectionPage\", \"http://schema.org/CollectionPage\"\r\n        \"CollegeOrUniversity\", \"http://schema.org/CollegeOrUniversity\"\r\n        \"ComedyClub\", \"http://schema.org/ComedyClub\"\r\n        \"ComedyEvent\", \"http://schema.org/ComedyEvent\"\r\n        \"ComicCoverArt\", \"http://schema.org/ComicCoverArt\"\r\n        \"ComicIssue\", \"http://schema.org/ComicIssue\"\r\n        \"ComicSeries\", \"http://schema.org/ComicSeries\"\r\n        \"ComicStory\", \"http://schema.org/ComicStory\"\r\n        \"Comment\", \"http://schema.org/Comment\"\r\n        \"CommentAction\", \"http://schema.org/CommentAction\"\r\n        \"CommentPermission\", \"http://schema.org/CommentPermission\"\r\n        \"CommunicateAction\", \"http://schema.org/CommunicateAction\"\r\n        \"CommunityHealth\", \"http://schema.org/CommunityHealth\"\r\n        \"CompilationAlbum\", \"http://schema.org/CompilationAlbum\"\r\n        \"CompleteDataFeed\", \"http://schema.org/CompleteDataFeed\"\r\n        \"Completed\", \"http://schema.org/Completed\"\r\n        \"CompletedActionStatus\", \"http://schema.org/CompletedActionStatus\"\r\n        \"CompoundPriceSpecification\", \"http://schema.org/CompoundPriceSpecification\"\r\n        \"ComputerLanguage\", \"http://schema.org/ComputerLanguage\"\r\n        \"ComputerStore\", \"http://schema.org/ComputerStore\"\r\n        \"ConfirmAction\", \"http://schema.org/ConfirmAction\"\r\n        \"Consortium\", \"http://schema.org/Consortium\"\r\n        \"ConstraintNode\", \"http://schema.org/ConstraintNode\"\r\n        \"ConsumeAction\", \"http://schema.org/ConsumeAction\"\r\n        \"ContactPage\", \"http://schema.org/ContactPage\"\r\n        \"ContactPoint\", \"http://schema.org/ContactPoint\"\r\n        \"ContactPointOption\", \"http://schema.org/ContactPointOption\"\r\n        \"ContagiousnessHealthAspect\", \"http://schema.org/ContagiousnessHealthAspect\"\r\n        \"Continent\", \"http://schema.org/Continent\"\r\n        \"ControlAction\", \"http://schema.org/ControlAction\"\r\n        \"ConvenienceStore\", \"http://schema.org/ConvenienceStore\"\r\n        \"Conversation\", \"http://schema.org/Conversation\"\r\n        \"CookAction\", \"http://schema.org/CookAction\"\r\n        \"Corporation\", \"http://schema.org/Corporation\"\r\n        \"CorrectionComment\", \"http://schema.org/CorrectionComment\"\r\n        \"Country\", \"http://schema.org/Country\"\r\n        \"Course\", \"http://schema.org/Course\"\r\n        \"CourseInstance\", \"http://schema.org/CourseInstance\"\r\n        \"Courthouse\", \"http://schema.org/Courthouse\"\r\n        \"CoverArt\", \"http://schema.org/CoverArt\"\r\n        \"CovidTestingFacility\", \"http://schema.org/CovidTestingFacility\"\r\n        \"CreateAction\", \"http://schema.org/CreateAction\"\r\n        \"CreativeWork\", \"http://schema.org/CreativeWork\"\r\n        \"CreativeWorkSeason\", \"http://schema.org/CreativeWorkSeason\"\r\n        \"CreativeWorkSeries\", \"http://schema.org/CreativeWorkSeries\"\r\n        \"CreditCard\", \"http://schema.org/CreditCard\"\r\n        \"Crematorium\", \"http://schema.org/Crematorium\"\r\n        \"CriticReview\", \"http://schema.org/CriticReview\"\r\n        \"CrossSectional\", \"http://schema.org/CrossSectional\"\r\n        \"CssSelectorType\", \"http://schema.org/CssSelectorType\"\r\n        \"CurrencyConversionService\", \"http://schema.org/CurrencyConversionService\"\r\n        \"DDxElement\", \"http://schema.org/DDxElement\"\r\n        \"DJMixAlbum\", \"http://schema.org/DJMixAlbum\"\r\n        \"DVDFormat\", \"http://schema.org/DVDFormat\"\r\n        \"DamagedCondition\", \"http://schema.org/DamagedCondition\"\r\n        \"DanceEvent\", \"http://schema.org/DanceEvent\"\r\n        \"DanceGroup\", \"http://schema.org/DanceGroup\"\r\n        \"DangerousGoodConsideration\", \"http://schema.org/DangerousGoodConsideration\"\r\n        \"DataCatalog\", \"http://schema.org/DataCatalog\"\r\n        \"DataDownload\", \"http://schema.org/DataDownload\"\r\n        \"DataFeed\", \"http://schema.org/DataFeed\"\r\n        \"DataFeedItem\", \"http://schema.org/DataFeedItem\"\r\n        \"DataType\", \"http://schema.org/DataType\"\r\n        \"Dataset\", \"http://schema.org/Dataset\"\r\n        \"Date\", \"http://schema.org/Date\"\r\n        \"DateTime\", \"http://schema.org/DateTime\"\r\n        \"DatedMoneySpecification\", \"http://schema.org/DatedMoneySpecification\"\r\n        \"DayOfWeek\", \"http://schema.org/DayOfWeek\"\r\n        \"DaySpa\", \"http://schema.org/DaySpa\"\r\n        \"DeactivateAction\", \"http://schema.org/DeactivateAction\"\r\n        \"DecontextualizedContent\", \"http://schema.org/DecontextualizedContent\"\r\n        \"DefenceEstablishment\", \"http://schema.org/DefenceEstablishment\"\r\n        \"DefinedRegion\", \"http://schema.org/DefinedRegion\"\r\n        \"DefinedTerm\", \"http://schema.org/DefinedTerm\"\r\n        \"DefinedTermSet\", \"http://schema.org/DefinedTermSet\"\r\n        \"DefinitiveLegalValue\", \"http://schema.org/DefinitiveLegalValue\"\r\n        \"DeleteAction\", \"http://schema.org/DeleteAction\"\r\n        \"DeliveryChargeSpecification\", \"http://schema.org/DeliveryChargeSpecification\"\r\n        \"DeliveryEvent\", \"http://schema.org/DeliveryEvent\"\r\n        \"DeliveryMethod\", \"http://schema.org/DeliveryMethod\"\r\n        \"DeliveryTimeSettings\", \"http://schema.org/DeliveryTimeSettings\"\r\n        \"Demand\", \"http://schema.org/Demand\"\r\n        \"DemoAlbum\", \"http://schema.org/DemoAlbum\"\r\n        \"DemoGameAvailability\", \"http://schema.org/DemoGameAvailability\"\r\n        \"Dentist\", \"http://schema.org/Dentist\"\r\n        \"Dentistry\", \"http://schema.org/Dentistry\"\r\n        \"DepartAction\", \"http://schema.org/DepartAction\"\r\n        \"DepartmentStore\", \"http://schema.org/DepartmentStore\"\r\n        \"DepositAccount\", \"http://schema.org/DepositAccount\"\r\n        \"Dermatologic\", \"http://schema.org/Dermatologic\"\r\n        \"Dermatology\", \"http://schema.org/Dermatology\"\r\n        \"DesktopWebPlatform\", \"http://schema.org/DesktopWebPlatform\"\r\n        \"DiabeticDiet\", \"http://schema.org/DiabeticDiet\"\r\n        \"Diagnostic\", \"http://schema.org/Diagnostic\"\r\n        \"DiagnosticLab\", \"http://schema.org/DiagnosticLab\"\r\n        \"DiagnosticProcedure\", \"http://schema.org/DiagnosticProcedure\"\r\n        \"Diet\", \"http://schema.org/Diet\"\r\n        \"DietNutrition\", \"http://schema.org/DietNutrition\"\r\n        \"DietarySupplement\", \"http://schema.org/DietarySupplement\"\r\n        \"DigitalAudioTapeFormat\", \"http://schema.org/DigitalAudioTapeFormat\"\r\n        \"DigitalDocument\", \"http://schema.org/DigitalDocument\"\r\n        \"DigitalDocumentPermission\", \"http://schema.org/DigitalDocumentPermission\"\r\n        \"DigitalDocumentPermissionType\", \"http://schema.org/DigitalDocumentPermissionType\"\r\n        \"DigitalFormat\", \"http://schema.org/DigitalFormat\"\r\n        \"DigitalPlatformEnumeration\", \"http://schema.org/DigitalPlatformEnumeration\"\r\n        \"DisabilitySupport\", \"http://schema.org/DisabilitySupport\"\r\n        \"DisagreeAction\", \"http://schema.org/DisagreeAction\"\r\n        \"Discontinued\", \"http://schema.org/Discontinued\"\r\n        \"DiscoverAction\", \"http://schema.org/DiscoverAction\"\r\n        \"DiscussionForumPosting\", \"http://schema.org/DiscussionForumPosting\"\r\n        \"DislikeAction\", \"http://schema.org/DislikeAction\"\r\n        \"Distance\", \"http://schema.org/Distance\"\r\n        \"DistanceFee\", \"http://schema.org/DistanceFee\"\r\n        \"Distillery\", \"http://schema.org/Distillery\"\r\n        \"DonateAction\", \"http://schema.org/DonateAction\"\r\n        \"DoseSchedule\", \"http://schema.org/DoseSchedule\"\r\n        \"DoubleBlindedTrial\", \"http://schema.org/DoubleBlindedTrial\"\r\n        \"DownloadAction\", \"http://schema.org/DownloadAction\"\r\n        \"Downpayment\", \"http://schema.org/Downpayment\"\r\n        \"DrawAction\", \"http://schema.org/DrawAction\"\r\n        \"Drawing\", \"http://schema.org/Drawing\"\r\n        \"DrinkAction\", \"http://schema.org/DrinkAction\"\r\n        \"DriveWheelConfigurationValue\", \"http://schema.org/DriveWheelConfigurationValue\"\r\n        \"DrivingSchoolVehicleUsage\", \"http://schema.org/DrivingSchoolVehicleUsage\"\r\n        \"Drug\", \"http://schema.org/Drug\"\r\n        \"DrugClass\", \"http://schema.org/DrugClass\"\r\n        \"DrugCost\", \"http://schema.org/DrugCost\"\r\n        \"DrugCostCategory\", \"http://schema.org/DrugCostCategory\"\r\n        \"DrugLegalStatus\", \"http://schema.org/DrugLegalStatus\"\r\n        \"DrugPregnancyCategory\", \"http://schema.org/DrugPregnancyCategory\"\r\n        \"DrugPrescriptionStatus\", \"http://schema.org/DrugPrescriptionStatus\"\r\n        \"DrugStrength\", \"http://schema.org/DrugStrength\"\r\n        \"DryCleaningOrLaundry\", \"http://schema.org/DryCleaningOrLaundry\"\r\n        \"Duration\", \"http://schema.org/Duration\"\r\n        \"EBook\", \"http://schema.org/EBook\"\r\n        \"EPRelease\", \"http://schema.org/EPRelease\"\r\n        \"EUEnergyEfficiencyCategoryA\", \"http://schema.org/EUEnergyEfficiencyCategoryA\"\r\n        \"EUEnergyEfficiencyCategoryA1Plus\", \"http://schema.org/EUEnergyEfficiencyCategoryA1Plus\"\r\n        \"EUEnergyEfficiencyCategoryA2Plus\", \"http://schema.org/EUEnergyEfficiencyCategoryA2Plus\"\r\n        \"EUEnergyEfficiencyCategoryA3Plus\", \"http://schema.org/EUEnergyEfficiencyCategoryA3Plus\"\r\n        \"EUEnergyEfficiencyCategoryB\", \"http://schema.org/EUEnergyEfficiencyCategoryB\"\r\n        \"EUEnergyEfficiencyCategoryC\", \"http://schema.org/EUEnergyEfficiencyCategoryC\"\r\n        \"EUEnergyEfficiencyCategoryD\", \"http://schema.org/EUEnergyEfficiencyCategoryD\"\r\n        \"EUEnergyEfficiencyCategoryE\", \"http://schema.org/EUEnergyEfficiencyCategoryE\"\r\n        \"EUEnergyEfficiencyCategoryF\", \"http://schema.org/EUEnergyEfficiencyCategoryF\"\r\n        \"EUEnergyEfficiencyCategoryG\", \"http://schema.org/EUEnergyEfficiencyCategoryG\"\r\n        \"EUEnergyEfficiencyEnumeration\", \"http://schema.org/EUEnergyEfficiencyEnumeration\"\r\n        \"Ear\", \"http://schema.org/Ear\"\r\n        \"EatAction\", \"http://schema.org/EatAction\"\r\n        \"EditedOrCroppedContent\", \"http://schema.org/EditedOrCroppedContent\"\r\n        \"EducationEvent\", \"http://schema.org/EducationEvent\"\r\n        \"EducationalAudience\", \"http://schema.org/EducationalAudience\"\r\n        \"EducationalOccupationalCredential\", \"http://schema.org/EducationalOccupationalCredential\"\r\n        \"EducationalOccupationalProgram\", \"http://schema.org/EducationalOccupationalProgram\"\r\n        \"EducationalOrganization\", \"http://schema.org/EducationalOrganization\"\r\n        \"EffectivenessHealthAspect\", \"http://schema.org/EffectivenessHealthAspect\"\r\n        \"Electrician\", \"http://schema.org/Electrician\"\r\n        \"ElectronicsStore\", \"http://schema.org/ElectronicsStore\"\r\n        \"ElementarySchool\", \"http://schema.org/ElementarySchool\"\r\n        \"EmailMessage\", \"http://schema.org/EmailMessage\"\r\n        \"Embassy\", \"http://schema.org/Embassy\"\r\n        \"Emergency\", \"http://schema.org/Emergency\"\r\n        \"EmergencyService\", \"http://schema.org/EmergencyService\"\r\n        \"EmployeeRole\", \"http://schema.org/EmployeeRole\"\r\n        \"EmployerAggregateRating\", \"http://schema.org/EmployerAggregateRating\"\r\n        \"EmployerReview\", \"http://schema.org/EmployerReview\"\r\n        \"EmploymentAgency\", \"http://schema.org/EmploymentAgency\"\r\n        \"Endocrine\", \"http://schema.org/Endocrine\"\r\n        \"EndorseAction\", \"http://schema.org/EndorseAction\"\r\n        \"EndorsementRating\", \"http://schema.org/EndorsementRating\"\r\n        \"Energy\", \"http://schema.org/Energy\"\r\n        \"EnergyConsumptionDetails\", \"http://schema.org/EnergyConsumptionDetails\"\r\n        \"EnergyEfficiencyEnumeration\", \"http://schema.org/EnergyEfficiencyEnumeration\"\r\n        \"EnergyStarCertified\", \"http://schema.org/EnergyStarCertified\"\r\n        \"EnergyStarEnergyEfficiencyEnumeration\", \"http://schema.org/EnergyStarEnergyEfficiencyEnumeration\"\r\n        \"EngineSpecification\", \"http://schema.org/EngineSpecification\"\r\n        \"EnrollingByInvitation\", \"http://schema.org/EnrollingByInvitation\"\r\n        \"EntertainmentBusiness\", \"http://schema.org/EntertainmentBusiness\"\r\n        \"EntryPoint\", \"http://schema.org/EntryPoint\"\r\n        \"Enumeration\", \"http://schema.org/Enumeration\"\r\n        \"Episode\", \"http://schema.org/Episode\"\r\n        \"Event\", \"http://schema.org/Event\"\r\n        \"EventAttendanceModeEnumeration\", \"http://schema.org/EventAttendanceModeEnumeration\"\r\n        \"EventCancelled\", \"http://schema.org/EventCancelled\"\r\n        \"EventMovedOnline\", \"http://schema.org/EventMovedOnline\"\r\n        \"EventPostponed\", \"http://schema.org/EventPostponed\"\r\n        \"EventRescheduled\", \"http://schema.org/EventRescheduled\"\r\n        \"EventReservation\", \"http://schema.org/EventReservation\"\r\n        \"EventScheduled\", \"http://schema.org/EventScheduled\"\r\n        \"EventSeries\", \"http://schema.org/EventSeries\"\r\n        \"EventStatusType\", \"http://schema.org/EventStatusType\"\r\n        \"EventVenue\", \"http://schema.org/EventVenue\"\r\n        \"EvidenceLevelA\", \"http://schema.org/EvidenceLevelA\"\r\n        \"EvidenceLevelB\", \"http://schema.org/EvidenceLevelB\"\r\n        \"EvidenceLevelC\", \"http://schema.org/EvidenceLevelC\"\r\n        \"ExampleMeasurementMethodEnum\", \"http://schema.org/ExampleMeasurementMethodEnum\"\r\n        \"ExchangeRateSpecification\", \"http://schema.org/ExchangeRateSpecification\"\r\n        \"ExchangeRefund\", \"http://schema.org/ExchangeRefund\"\r\n        \"ExerciseAction\", \"http://schema.org/ExerciseAction\"\r\n        \"ExerciseGym\", \"http://schema.org/ExerciseGym\"\r\n        \"ExercisePlan\", \"http://schema.org/ExercisePlan\"\r\n        \"ExhibitionEvent\", \"http://schema.org/ExhibitionEvent\"\r\n        \"Eye\", \"http://schema.org/Eye\"\r\n        \"FAQPage\", \"http://schema.org/FAQPage\"\r\n        \"FDAcategoryA\", \"http://schema.org/FDAcategoryA\"\r\n        \"FDAcategoryB\", \"http://schema.org/FDAcategoryB\"\r\n        \"FDAcategoryC\", \"http://schema.org/FDAcategoryC\"\r\n        \"FDAcategoryD\", \"http://schema.org/FDAcategoryD\"\r\n        \"FDAcategoryX\", \"http://schema.org/FDAcategoryX\"\r\n        \"FDAnotEvaluated\", \"http://schema.org/FDAnotEvaluated\"\r\n        \"FMRadioChannel\", \"http://schema.org/FMRadioChannel\"\r\n        \"FailedActionStatus\", \"http://schema.org/FailedActionStatus\"\r\n        \"False\", \"http://schema.org/False\"\r\n        \"FastFoodRestaurant\", \"http://schema.org/FastFoodRestaurant\"\r\n        \"Female\", \"http://schema.org/Female\"\r\n        \"Festival\", \"http://schema.org/Festival\"\r\n        \"FilmAction\", \"http://schema.org/FilmAction\"\r\n        \"FinancialProduct\", \"http://schema.org/FinancialProduct\"\r\n        \"FinancialService\", \"http://schema.org/FinancialService\"\r\n        \"FindAction\", \"http://schema.org/FindAction\"\r\n        \"FireStation\", \"http://schema.org/FireStation\"\r\n        \"Flexibility\", \"http://schema.org/Flexibility\"\r\n        \"Flight\", \"http://schema.org/Flight\"\r\n        \"FlightReservation\", \"http://schema.org/FlightReservation\"\r\n        \"Float\", \"http://schema.org/Float\"\r\n        \"FloorPlan\", \"http://schema.org/FloorPlan\"\r\n        \"Florist\", \"http://schema.org/Florist\"\r\n        \"FollowAction\", \"http://schema.org/FollowAction\"\r\n        \"FoodEstablishment\", \"http://schema.org/FoodEstablishment\"\r\n        \"FoodEstablishmentReservation\", \"http://schema.org/FoodEstablishmentReservation\"\r\n        \"FoodEvent\", \"http://schema.org/FoodEvent\"\r\n        \"FoodService\", \"http://schema.org/FoodService\"\r\n        \"FourWheelDriveConfiguration\", \"http://schema.org/FourWheelDriveConfiguration\"\r\n        \"FreeReturn\", \"http://schema.org/FreeReturn\"\r\n        \"Friday\", \"http://schema.org/Friday\"\r\n        \"FrontWheelDriveConfiguration\", \"http://schema.org/FrontWheelDriveConfiguration\"\r\n        \"FullGameAvailability\", \"http://schema.org/FullGameAvailability\"\r\n        \"FullRefund\", \"http://schema.org/FullRefund\"\r\n        \"FundingAgency\", \"http://schema.org/FundingAgency\"\r\n        \"FundingScheme\", \"http://schema.org/FundingScheme\"\r\n        \"Fungus\", \"http://schema.org/Fungus\"\r\n        \"FurnitureStore\", \"http://schema.org/FurnitureStore\"\r\n        \"Game\", \"http://schema.org/Game\"\r\n        \"GameAvailabilityEnumeration\", \"http://schema.org/GameAvailabilityEnumeration\"\r\n        \"GamePlayMode\", \"http://schema.org/GamePlayMode\"\r\n        \"GameServer\", \"http://schema.org/GameServer\"\r\n        \"GameServerStatus\", \"http://schema.org/GameServerStatus\"\r\n        \"GardenStore\", \"http://schema.org/GardenStore\"\r\n        \"GasStation\", \"http://schema.org/GasStation\"\r\n        \"Gastroenterologic\", \"http://schema.org/Gastroenterologic\"\r\n        \"GatedResidenceCommunity\", \"http://schema.org/GatedResidenceCommunity\"\r\n        \"GenderType\", \"http://schema.org/GenderType\"\r\n        \"Gene\", \"http://schema.org/Gene\"\r\n        \"GeneralContractor\", \"http://schema.org/GeneralContractor\"\r\n        \"GenericWebPlatform\", \"http://schema.org/GenericWebPlatform\"\r\n        \"Genetic\", \"http://schema.org/Genetic\"\r\n        \"Genitourinary\", \"http://schema.org/Genitourinary\"\r\n        \"GeoCircle\", \"http://schema.org/GeoCircle\"\r\n        \"GeoCoordinates\", \"http://schema.org/GeoCoordinates\"\r\n        \"GeoShape\", \"http://schema.org/GeoShape\"\r\n        \"GeospatialGeometry\", \"http://schema.org/GeospatialGeometry\"\r\n        \"Geriatric\", \"http://schema.org/Geriatric\"\r\n        \"GettingAccessHealthAspect\", \"http://schema.org/GettingAccessHealthAspect\"\r\n        \"GiveAction\", \"http://schema.org/GiveAction\"\r\n        \"GlutenFreeDiet\", \"http://schema.org/GlutenFreeDiet\"\r\n        \"GolfCourse\", \"http://schema.org/GolfCourse\"\r\n        \"GovernmentBenefitsType\", \"http://schema.org/GovernmentBenefitsType\"\r\n        \"GovernmentBuilding\", \"http://schema.org/GovernmentBuilding\"\r\n        \"GovernmentOffice\", \"http://schema.org/GovernmentOffice\"\r\n        \"GovernmentOrganization\", \"http://schema.org/GovernmentOrganization\"\r\n        \"GovernmentPermit\", \"http://schema.org/GovernmentPermit\"\r\n        \"GovernmentService\", \"http://schema.org/GovernmentService\"\r\n        \"Grant\", \"http://schema.org/Grant\"\r\n        \"GraphicNovel\", \"http://schema.org/GraphicNovel\"\r\n        \"GroceryStore\", \"http://schema.org/GroceryStore\"\r\n        \"GroupBoardingPolicy\", \"http://schema.org/GroupBoardingPolicy\"\r\n        \"Guide\", \"http://schema.org/Guide\"\r\n        \"Gynecologic\", \"http://schema.org/Gynecologic\"\r\n        \"HTML\", \"rdf:HTML\"\r\n        \"HVACBusiness\", \"http://schema.org/HVACBusiness\"\r\n        \"Hackathon\", \"http://schema.org/Hackathon\"\r\n        \"HairSalon\", \"http://schema.org/HairSalon\"\r\n        \"HalalDiet\", \"http://schema.org/HalalDiet\"\r\n        \"Hardcover\", \"http://schema.org/Hardcover\"\r\n        \"HardwareStore\", \"http://schema.org/HardwareStore\"\r\n        \"Head\", \"http://schema.org/Head\"\r\n        \"HealthAndBeautyBusiness\", \"http://schema.org/HealthAndBeautyBusiness\"\r\n        \"HealthAspectEnumeration\", \"http://schema.org/HealthAspectEnumeration\"\r\n        \"HealthCare\", \"http://schema.org/HealthCare\"\r\n        \"HealthClub\", \"http://schema.org/HealthClub\"\r\n        \"HealthInsurancePlan\", \"http://schema.org/HealthInsurancePlan\"\r\n        \"HealthPlanCostSharingSpecification\", \"http://schema.org/HealthPlanCostSharingSpecification\"\r\n        \"HealthPlanFormulary\", \"http://schema.org/HealthPlanFormulary\"\r\n        \"HealthPlanNetwork\", \"http://schema.org/HealthPlanNetwork\"\r\n        \"HealthTopicContent\", \"http://schema.org/HealthTopicContent\"\r\n        \"HealthcareConsideration\", \"http://schema.org/HealthcareConsideration\"\r\n        \"HearingImpairedSupported\", \"http://schema.org/HearingImpairedSupported\"\r\n        \"Hematologic\", \"http://schema.org/Hematologic\"\r\n        \"HighSchool\", \"http://schema.org/HighSchool\"\r\n        \"HinduDiet\", \"http://schema.org/HinduDiet\"\r\n        \"HinduTemple\", \"http://schema.org/HinduTemple\"\r\n        \"HobbyShop\", \"http://schema.org/HobbyShop\"\r\n        \"HomeAndConstructionBusiness\", \"http://schema.org/HomeAndConstructionBusiness\"\r\n        \"HomeGoodsStore\", \"http://schema.org/HomeGoodsStore\"\r\n        \"Homeopathic\", \"http://schema.org/Homeopathic\"\r\n        \"Hospital\", \"http://schema.org/Hospital\"\r\n        \"Hostel\", \"http://schema.org/Hostel\"\r\n        \"Hotel\", \"http://schema.org/Hotel\"\r\n        \"HotelRoom\", \"http://schema.org/HotelRoom\"\r\n        \"House\", \"http://schema.org/House\"\r\n        \"HousePainter\", \"http://schema.org/HousePainter\"\r\n        \"HowItWorksHealthAspect\", \"http://schema.org/HowItWorksHealthAspect\"\r\n        \"HowOrWhereHealthAspect\", \"http://schema.org/HowOrWhereHealthAspect\"\r\n        \"HowTo\", \"http://schema.org/HowTo\"\r\n        \"HowToDirection\", \"http://schema.org/HowToDirection\"\r\n        \"HowToItem\", \"http://schema.org/HowToItem\"\r\n        \"HowToSection\", \"http://schema.org/HowToSection\"\r\n        \"HowToStep\", \"http://schema.org/HowToStep\"\r\n        \"HowToSupply\", \"http://schema.org/HowToSupply\"\r\n        \"HowToTip\", \"http://schema.org/HowToTip\"\r\n        \"HowToTool\", \"http://schema.org/HowToTool\"\r\n        \"HyperToc\", \"http://schema.org/HyperToc\"\r\n        \"HyperTocEntry\", \"http://schema.org/HyperTocEntry\"\r\n        \"IOSPlatform\", \"http://schema.org/IOSPlatform\"\r\n        \"IceCreamShop\", \"http://schema.org/IceCreamShop\"\r\n        \"IgnoreAction\", \"http://schema.org/IgnoreAction\"\r\n        \"ImageGallery\", \"http://schema.org/ImageGallery\"\r\n        \"ImageObject\", \"http://schema.org/ImageObject\"\r\n        \"ImageObjectSnapshot\", \"http://schema.org/ImageObjectSnapshot\"\r\n        \"ImagingTest\", \"http://schema.org/ImagingTest\"\r\n        \"InForce\", \"http://schema.org/InForce\"\r\n        \"InStock\", \"http://schema.org/InStock\"\r\n        \"InStoreOnly\", \"http://schema.org/InStoreOnly\"\r\n        \"IndividualProduct\", \"http://schema.org/IndividualProduct\"\r\n        \"Infectious\", \"http://schema.org/Infectious\"\r\n        \"InfectiousAgentClass\", \"http://schema.org/InfectiousAgentClass\"\r\n        \"InfectiousDisease\", \"http://schema.org/InfectiousDisease\"\r\n        \"InformAction\", \"http://schema.org/InformAction\"\r\n        \"IngredientsHealthAspect\", \"http://schema.org/IngredientsHealthAspect\"\r\n        \"InsertAction\", \"http://schema.org/InsertAction\"\r\n        \"InstallAction\", \"http://schema.org/InstallAction\"\r\n        \"Installment\", \"http://schema.org/Installment\"\r\n        \"InsuranceAgency\", \"http://schema.org/InsuranceAgency\"\r\n        \"Intangible\", \"http://schema.org/Intangible\"\r\n        \"Integer\", \"http://schema.org/Integer\"\r\n        \"InteractAction\", \"http://schema.org/InteractAction\"\r\n        \"InteractionCounter\", \"http://schema.org/InteractionCounter\"\r\n        \"InternationalTrial\", \"http://schema.org/InternationalTrial\"\r\n        \"InternetCafe\", \"http://schema.org/InternetCafe\"\r\n        \"InvestmentFund\", \"http://schema.org/InvestmentFund\"\r\n        \"InvestmentOrDeposit\", \"http://schema.org/InvestmentOrDeposit\"\r\n        \"InviteAction\", \"http://schema.org/InviteAction\"\r\n        \"Invoice\", \"http://schema.org/Invoice\"\r\n        \"InvoicePrice\", \"http://schema.org/InvoicePrice\"\r\n        \"ItemAvailability\", \"http://schema.org/ItemAvailability\"\r\n        \"ItemList\", \"http://schema.org/ItemList\"\r\n        \"ItemListOrderAscending\", \"http://schema.org/ItemListOrderAscending\"\r\n        \"ItemListOrderDescending\", \"http://schema.org/ItemListOrderDescending\"\r\n        \"ItemListOrderType\", \"http://schema.org/ItemListOrderType\"\r\n        \"ItemListUnordered\", \"http://schema.org/ItemListUnordered\"\r\n        \"ItemPage\", \"http://schema.org/ItemPage\"\r\n        \"JewelryStore\", \"http://schema.org/JewelryStore\"\r\n        \"JobPosting\", \"http://schema.org/JobPosting\"\r\n        \"JoinAction\", \"http://schema.org/JoinAction\"\r\n        \"Joint\", \"http://schema.org/Joint\"\r\n        \"KosherDiet\", \"http://schema.org/KosherDiet\"\r\n        \"LaboratoryScience\", \"http://schema.org/LaboratoryScience\"\r\n        \"LakeBodyOfWater\", \"http://schema.org/LakeBodyOfWater\"\r\n        \"Landform\", \"http://schema.org/Landform\"\r\n        \"LandmarksOrHistoricalBuildings\", \"http://schema.org/LandmarksOrHistoricalBuildings\"\r\n        \"Language\", \"http://schema.org/Language\"\r\n        \"LaserDiscFormat\", \"http://schema.org/LaserDiscFormat\"\r\n        \"LearningResource\", \"http://schema.org/LearningResource\"\r\n        \"LeaveAction\", \"http://schema.org/LeaveAction\"\r\n        \"LeftHandDriving\", \"http://schema.org/LeftHandDriving\"\r\n        \"LegalForceStatus\", \"http://schema.org/LegalForceStatus\"\r\n        \"LegalService\", \"http://schema.org/LegalService\"\r\n        \"LegalValueLevel\", \"http://schema.org/LegalValueLevel\"\r\n        \"Legislation\", \"http://schema.org/Legislation\"\r\n        \"LegislationObject\", \"http://schema.org/LegislationObject\"\r\n        \"LegislativeBuilding\", \"http://schema.org/LegislativeBuilding\"\r\n        \"LeisureTimeActivity\", \"http://schema.org/LeisureTimeActivity\"\r\n        \"LendAction\", \"http://schema.org/LendAction\"\r\n        \"Library\", \"http://schema.org/Library\"\r\n        \"LibrarySystem\", \"http://schema.org/LibrarySystem\"\r\n        \"LifestyleModification\", \"http://schema.org/LifestyleModification\"\r\n        \"Ligament\", \"http://schema.org/Ligament\"\r\n        \"LikeAction\", \"http://schema.org/LikeAction\"\r\n        \"LimitedAvailability\", \"http://schema.org/LimitedAvailability\"\r\n        \"LimitedByGuaranteeCharity\", \"http://schema.org/LimitedByGuaranteeCharity\"\r\n        \"LinkRole\", \"http://schema.org/LinkRole\"\r\n        \"LiquorStore\", \"http://schema.org/LiquorStore\"\r\n        \"ListItem\", \"http://schema.org/ListItem\"\r\n        \"ListPrice\", \"http://schema.org/ListPrice\"\r\n        \"ListenAction\", \"http://schema.org/ListenAction\"\r\n        \"LiteraryEvent\", \"http://schema.org/LiteraryEvent\"\r\n        \"LiveAlbum\", \"http://schema.org/LiveAlbum\"\r\n        \"LiveBlogPosting\", \"http://schema.org/LiveBlogPosting\"\r\n        \"LivingWithHealthAspect\", \"http://schema.org/LivingWithHealthAspect\"\r\n        \"LoanOrCredit\", \"http://schema.org/LoanOrCredit\"\r\n        \"LocalBusiness\", \"http://schema.org/LocalBusiness\"\r\n        \"LocationFeatureSpecification\", \"http://schema.org/LocationFeatureSpecification\"\r\n        \"LockerDelivery\", \"http://schema.org/LockerDelivery\"\r\n        \"Locksmith\", \"http://schema.org/Locksmith\"\r\n        \"LodgingBusiness\", \"http://schema.org/LodgingBusiness\"\r\n        \"LodgingReservation\", \"http://schema.org/LodgingReservation\"\r\n        \"Longitudinal\", \"http://schema.org/Longitudinal\"\r\n        \"LoseAction\", \"http://schema.org/LoseAction\"\r\n        \"LowCalorieDiet\", \"http://schema.org/LowCalorieDiet\"\r\n        \"LowFatDiet\", \"http://schema.org/LowFatDiet\"\r\n        \"LowLactoseDiet\", \"http://schema.org/LowLactoseDiet\"\r\n        \"LowSaltDiet\", \"http://schema.org/LowSaltDiet\"\r\n        \"Lung\", \"http://schema.org/Lung\"\r\n        \"LymphaticVessel\", \"http://schema.org/LymphaticVessel\"\r\n        \"MRI\", \"http://schema.org/MRI\"\r\n        \"MSRP\", \"http://schema.org/MSRP\"\r\n        \"Male\", \"http://schema.org/Male\"\r\n        \"Manuscript\", \"http://schema.org/Manuscript\"\r\n        \"Map\", \"http://schema.org/Map\"\r\n        \"MapCategoryType\", \"http://schema.org/MapCategoryType\"\r\n        \"MarryAction\", \"http://schema.org/MarryAction\"\r\n        \"Mass\", \"http://schema.org/Mass\"\r\n        \"MathSolver\", \"http://schema.org/MathSolver\"\r\n        \"MaximumDoseSchedule\", \"http://schema.org/MaximumDoseSchedule\"\r\n        \"MayTreatHealthAspect\", \"http://schema.org/MayTreatHealthAspect\"\r\n        \"MeasurementMethodEnum\", \"http://schema.org/MeasurementMethodEnum\"\r\n        \"MeasurementTypeEnumeration\", \"http://schema.org/MeasurementTypeEnumeration\"\r\n        \"MediaGallery\", \"http://schema.org/MediaGallery\"\r\n        \"MediaManipulationRatingEnumeration\", \"http://schema.org/MediaManipulationRatingEnumeration\"\r\n        \"MediaObject\", \"http://schema.org/MediaObject\"\r\n        \"MediaReview\", \"http://schema.org/MediaReview\"\r\n        \"MediaReviewItem\", \"http://schema.org/MediaReviewItem\"\r\n        \"MediaSubscription\", \"http://schema.org/MediaSubscription\"\r\n        \"MedicalAudience\", \"http://schema.org/MedicalAudience\"\r\n        \"MedicalAudienceType\", \"http://schema.org/MedicalAudienceType\"\r\n        \"MedicalBusiness\", \"http://schema.org/MedicalBusiness\"\r\n        \"MedicalCause\", \"http://schema.org/MedicalCause\"\r\n        \"MedicalClinic\", \"http://schema.org/MedicalClinic\"\r\n        \"MedicalCode\", \"http://schema.org/MedicalCode\"\r\n        \"MedicalCondition\", \"http://schema.org/MedicalCondition\"\r\n        \"MedicalConditionStage\", \"http://schema.org/MedicalConditionStage\"\r\n        \"MedicalContraindication\", \"http://schema.org/MedicalContraindication\"\r\n        \"MedicalDevice\", \"http://schema.org/MedicalDevice\"\r\n        \"MedicalDevicePurpose\", \"http://schema.org/MedicalDevicePurpose\"\r\n        \"MedicalEntity\", \"http://schema.org/MedicalEntity\"\r\n        \"MedicalEnumeration\", \"http://schema.org/MedicalEnumeration\"\r\n        \"MedicalEvidenceLevel\", \"http://schema.org/MedicalEvidenceLevel\"\r\n        \"MedicalGuideline\", \"http://schema.org/MedicalGuideline\"\r\n        \"MedicalGuidelineContraindication\", \"http://schema.org/MedicalGuidelineContraindication\"\r\n        \"MedicalGuidelineRecommendation\", \"http://schema.org/MedicalGuidelineRecommendation\"\r\n        \"MedicalImagingTechnique\", \"http://schema.org/MedicalImagingTechnique\"\r\n        \"MedicalIndication\", \"http://schema.org/MedicalIndication\"\r\n        \"MedicalIntangible\", \"http://schema.org/MedicalIntangible\"\r\n        \"MedicalObservationalStudy\", \"http://schema.org/MedicalObservationalStudy\"\r\n        \"MedicalObservationalStudyDesign\", \"http://schema.org/MedicalObservationalStudyDesign\"\r\n        \"MedicalOrganization\", \"http://schema.org/MedicalOrganization\"\r\n        \"MedicalProcedure\", \"http://schema.org/MedicalProcedure\"\r\n        \"MedicalProcedureType\", \"http://schema.org/MedicalProcedureType\"\r\n        \"MedicalResearcher\", \"http://schema.org/MedicalResearcher\"\r\n        \"MedicalRiskCalculator\", \"http://schema.org/MedicalRiskCalculator\"\r\n        \"MedicalRiskEstimator\", \"http://schema.org/MedicalRiskEstimator\"\r\n        \"MedicalRiskFactor\", \"http://schema.org/MedicalRiskFactor\"\r\n        \"MedicalRiskScore\", \"http://schema.org/MedicalRiskScore\"\r\n        \"MedicalScholarlyArticle\", \"http://schema.org/MedicalScholarlyArticle\"\r\n        \"MedicalSign\", \"http://schema.org/MedicalSign\"\r\n        \"MedicalSignOrSymptom\", \"http://schema.org/MedicalSignOrSymptom\"\r\n        \"MedicalSpecialty\", \"http://schema.org/MedicalSpecialty\"\r\n        \"MedicalStudy\", \"http://schema.org/MedicalStudy\"\r\n        \"MedicalStudyStatus\", \"http://schema.org/MedicalStudyStatus\"\r\n        \"MedicalSymptom\", \"http://schema.org/MedicalSymptom\"\r\n        \"MedicalTest\", \"http://schema.org/MedicalTest\"\r\n        \"MedicalTestPanel\", \"http://schema.org/MedicalTestPanel\"\r\n        \"MedicalTherapy\", \"http://schema.org/MedicalTherapy\"\r\n        \"MedicalTrial\", \"http://schema.org/MedicalTrial\"\r\n        \"MedicalTrialDesign\", \"http://schema.org/MedicalTrialDesign\"\r\n        \"MedicalWebPage\", \"http://schema.org/MedicalWebPage\"\r\n        \"MedicineSystem\", \"http://schema.org/MedicineSystem\"\r\n        \"MeetingRoom\", \"http://schema.org/MeetingRoom\"\r\n        \"MensClothingStore\", \"http://schema.org/MensClothingStore\"\r\n        \"Menu\", \"http://schema.org/Menu\"\r\n        \"MenuItem\", \"http://schema.org/MenuItem\"\r\n        \"MenuSection\", \"http://schema.org/MenuSection\"\r\n        \"MerchantReturnEnumeration\", \"http://schema.org/MerchantReturnEnumeration\"\r\n        \"MerchantReturnFiniteReturnWindow\", \"http://schema.org/MerchantReturnFiniteReturnWindow\"\r\n        \"MerchantReturnNotPermitted\", \"http://schema.org/MerchantReturnNotPermitted\"\r\n        \"MerchantReturnPolicy\", \"http://schema.org/MerchantReturnPolicy\"\r\n        \"MerchantReturnPolicySeasonalOverride\", \"http://schema.org/MerchantReturnPolicySeasonalOverride\"\r\n        \"MerchantReturnUnlimitedWindow\", \"http://schema.org/MerchantReturnUnlimitedWindow\"\r\n        \"MerchantReturnUnspecified\", \"http://schema.org/MerchantReturnUnspecified\"\r\n        \"Message\", \"http://schema.org/Message\"\r\n        \"MiddleSchool\", \"http://schema.org/MiddleSchool\"\r\n        \"Midwifery\", \"http://schema.org/Midwifery\"\r\n        \"MinimumAdvertisedPrice\", \"http://schema.org/MinimumAdvertisedPrice\"\r\n        \"MisconceptionsHealthAspect\", \"http://schema.org/MisconceptionsHealthAspect\"\r\n        \"MixedEventAttendanceMode\", \"http://schema.org/MixedEventAttendanceMode\"\r\n        \"MixtapeAlbum\", \"http://schema.org/MixtapeAlbum\"\r\n        \"MobileApplication\", \"http://schema.org/MobileApplication\"\r\n        \"MobilePhoneStore\", \"http://schema.org/MobilePhoneStore\"\r\n        \"MobileWebPlatform\", \"http://schema.org/MobileWebPlatform\"\r\n        \"MolecularEntity\", \"http://schema.org/MolecularEntity\"\r\n        \"Monday\", \"http://schema.org/Monday\"\r\n        \"MonetaryAmount\", \"http://schema.org/MonetaryAmount\"\r\n        \"MonetaryAmountDistribution\", \"http://schema.org/MonetaryAmountDistribution\"\r\n        \"MonetaryGrant\", \"http://schema.org/MonetaryGrant\"\r\n        \"MoneyTransfer\", \"http://schema.org/MoneyTransfer\"\r\n        \"MortgageLoan\", \"http://schema.org/MortgageLoan\"\r\n        \"Mosque\", \"http://schema.org/Mosque\"\r\n        \"Motel\", \"http://schema.org/Motel\"\r\n        \"Motorcycle\", \"http://schema.org/Motorcycle\"\r\n        \"MotorcycleDealer\", \"http://schema.org/MotorcycleDealer\"\r\n        \"MotorcycleRepair\", \"http://schema.org/MotorcycleRepair\"\r\n        \"MotorizedBicycle\", \"http://schema.org/MotorizedBicycle\"\r\n        \"Mountain\", \"http://schema.org/Mountain\"\r\n        \"MoveAction\", \"http://schema.org/MoveAction\"\r\n        \"Movie\", \"http://schema.org/Movie\"\r\n        \"MovieClip\", \"http://schema.org/MovieClip\"\r\n        \"MovieRentalStore\", \"http://schema.org/MovieRentalStore\"\r\n        \"MovieSeries\", \"http://schema.org/MovieSeries\"\r\n        \"MovieTheater\", \"http://schema.org/MovieTheater\"\r\n        \"MovingCompany\", \"http://schema.org/MovingCompany\"\r\n        \"MultiCenterTrial\", \"http://schema.org/MultiCenterTrial\"\r\n        \"MultiPlayer\", \"http://schema.org/MultiPlayer\"\r\n        \"MulticellularParasite\", \"http://schema.org/MulticellularParasite\"\r\n        \"Muscle\", \"http://schema.org/Muscle\"\r\n        \"Musculoskeletal\", \"http://schema.org/Musculoskeletal\"\r\n        \"MusculoskeletalExam\", \"http://schema.org/MusculoskeletalExam\"\r\n        \"Museum\", \"http://schema.org/Museum\"\r\n        \"MusicAlbum\", \"http://schema.org/MusicAlbum\"\r\n        \"MusicAlbumProductionType\", \"http://schema.org/MusicAlbumProductionType\"\r\n        \"MusicAlbumReleaseType\", \"http://schema.org/MusicAlbumReleaseType\"\r\n        \"MusicComposition\", \"http://schema.org/MusicComposition\"\r\n        \"MusicEvent\", \"http://schema.org/MusicEvent\"\r\n        \"MusicGroup\", \"http://schema.org/MusicGroup\"\r\n        \"MusicPlaylist\", \"http://schema.org/MusicPlaylist\"\r\n        \"MusicRecording\", \"http://schema.org/MusicRecording\"\r\n        \"MusicRelease\", \"http://schema.org/MusicRelease\"\r\n        \"MusicReleaseFormatType\", \"http://schema.org/MusicReleaseFormatType\"\r\n        \"MusicStore\", \"http://schema.org/MusicStore\"\r\n        \"MusicVenue\", \"http://schema.org/MusicVenue\"\r\n        \"MusicVideoObject\", \"http://schema.org/MusicVideoObject\"\r\n        \"NGO\", \"http://schema.org/NGO\"\r\n        \"NLNonprofitType\", \"http://schema.org/NLNonprofitType\"\r\n        \"NailSalon\", \"http://schema.org/NailSalon\"\r\n        \"NarcoticConsideration\", \"http://schema.org/NarcoticConsideration\"\r\n        \"Neck\", \"http://schema.org/Neck\"\r\n        \"Nerve\", \"http://schema.org/Nerve\"\r\n        \"Neuro\", \"http://schema.org/Neuro\"\r\n        \"Neurologic\", \"http://schema.org/Neurologic\"\r\n        \"NewCondition\", \"http://schema.org/NewCondition\"\r\n        \"NewsArticle\", \"http://schema.org/NewsArticle\"\r\n        \"NewsMediaOrganization\", \"http://schema.org/NewsMediaOrganization\"\r\n        \"Newspaper\", \"http://schema.org/Newspaper\"\r\n        \"NightClub\", \"http://schema.org/NightClub\"\r\n        \"NoninvasiveProcedure\", \"http://schema.org/NoninvasiveProcedure\"\r\n        \"Nonprofit501a\", \"http://schema.org/Nonprofit501a\"\r\n        \"Nonprofit501c1\", \"http://schema.org/Nonprofit501c1\"\r\n        \"Nonprofit501c10\", \"http://schema.org/Nonprofit501c10\"\r\n        \"Nonprofit501c11\", \"http://schema.org/Nonprofit501c11\"\r\n        \"Nonprofit501c12\", \"http://schema.org/Nonprofit501c12\"\r\n        \"Nonprofit501c13\", \"http://schema.org/Nonprofit501c13\"\r\n        \"Nonprofit501c14\", \"http://schema.org/Nonprofit501c14\"\r\n        \"Nonprofit501c15\", \"http://schema.org/Nonprofit501c15\"\r\n        \"Nonprofit501c16\", \"http://schema.org/Nonprofit501c16\"\r\n        \"Nonprofit501c17\", \"http://schema.org/Nonprofit501c17\"\r\n        \"Nonprofit501c18\", \"http://schema.org/Nonprofit501c18\"\r\n        \"Nonprofit501c19\", \"http://schema.org/Nonprofit501c19\"\r\n        \"Nonprofit501c2\", \"http://schema.org/Nonprofit501c2\"\r\n        \"Nonprofit501c20\", \"http://schema.org/Nonprofit501c20\"\r\n        \"Nonprofit501c21\", \"http://schema.org/Nonprofit501c21\"\r\n        \"Nonprofit501c22\", \"http://schema.org/Nonprofit501c22\"\r\n        \"Nonprofit501c23\", \"http://schema.org/Nonprofit501c23\"\r\n        \"Nonprofit501c24\", \"http://schema.org/Nonprofit501c24\"\r\n        \"Nonprofit501c25\", \"http://schema.org/Nonprofit501c25\"\r\n        \"Nonprofit501c26\", \"http://schema.org/Nonprofit501c26\"\r\n        \"Nonprofit501c27\", \"http://schema.org/Nonprofit501c27\"\r\n        \"Nonprofit501c28\", \"http://schema.org/Nonprofit501c28\"\r\n        \"Nonprofit501c3\", \"http://schema.org/Nonprofit501c3\"\r\n        \"Nonprofit501c4\", \"http://schema.org/Nonprofit501c4\"\r\n        \"Nonprofit501c5\", \"http://schema.org/Nonprofit501c5\"\r\n        \"Nonprofit501c6\", \"http://schema.org/Nonprofit501c6\"\r\n        \"Nonprofit501c7\", \"http://schema.org/Nonprofit501c7\"\r\n        \"Nonprofit501c8\", \"http://schema.org/Nonprofit501c8\"\r\n        \"Nonprofit501c9\", \"http://schema.org/Nonprofit501c9\"\r\n        \"Nonprofit501d\", \"http://schema.org/Nonprofit501d\"\r\n        \"Nonprofit501e\", \"http://schema.org/Nonprofit501e\"\r\n        \"Nonprofit501f\", \"http://schema.org/Nonprofit501f\"\r\n        \"Nonprofit501k\", \"http://schema.org/Nonprofit501k\"\r\n        \"Nonprofit501n\", \"http://schema.org/Nonprofit501n\"\r\n        \"Nonprofit501q\", \"http://schema.org/Nonprofit501q\"\r\n        \"Nonprofit527\", \"http://schema.org/Nonprofit527\"\r\n        \"NonprofitANBI\", \"http://schema.org/NonprofitANBI\"\r\n        \"NonprofitSBBI\", \"http://schema.org/NonprofitSBBI\"\r\n        \"NonprofitType\", \"http://schema.org/NonprofitType\"\r\n        \"Nose\", \"http://schema.org/Nose\"\r\n        \"NotInForce\", \"http://schema.org/NotInForce\"\r\n        \"NotYetRecruiting\", \"http://schema.org/NotYetRecruiting\"\r\n        \"Notary\", \"http://schema.org/Notary\"\r\n        \"NoteDigitalDocument\", \"http://schema.org/NoteDigitalDocument\"\r\n        \"Number\", \"http://schema.org/Number\"\r\n        \"Nursing\", \"http://schema.org/Nursing\"\r\n        \"NutritionInformation\", \"http://schema.org/NutritionInformation\"\r\n        \"OTC\", \"http://schema.org/OTC\"\r\n        \"Observation\", \"http://schema.org/Observation\"\r\n        \"Observational\", \"http://schema.org/Observational\"\r\n        \"Obstetric\", \"http://schema.org/Obstetric\"\r\n        \"Occupation\", \"http://schema.org/Occupation\"\r\n        \"OccupationalActivity\", \"http://schema.org/OccupationalActivity\"\r\n        \"OccupationalExperienceRequirements\", \"http://schema.org/OccupationalExperienceRequirements\"\r\n        \"OccupationalTherapy\", \"http://schema.org/OccupationalTherapy\"\r\n        \"OceanBodyOfWater\", \"http://schema.org/OceanBodyOfWater\"\r\n        \"Offer\", \"http://schema.org/Offer\"\r\n        \"OfferCatalog\", \"http://schema.org/OfferCatalog\"\r\n        \"OfferForLease\", \"http://schema.org/OfferForLease\"\r\n        \"OfferForPurchase\", \"http://schema.org/OfferForPurchase\"\r\n        \"OfferItemCondition\", \"http://schema.org/OfferItemCondition\"\r\n        \"OfferShippingDetails\", \"http://schema.org/OfferShippingDetails\"\r\n        \"OfficeEquipmentStore\", \"http://schema.org/OfficeEquipmentStore\"\r\n        \"OfficialLegalValue\", \"http://schema.org/OfficialLegalValue\"\r\n        \"OfflineEventAttendanceMode\", \"http://schema.org/OfflineEventAttendanceMode\"\r\n        \"OfflinePermanently\", \"http://schema.org/OfflinePermanently\"\r\n        \"OfflineTemporarily\", \"http://schema.org/OfflineTemporarily\"\r\n        \"OnDemandEvent\", \"http://schema.org/OnDemandEvent\"\r\n        \"OnSitePickup\", \"http://schema.org/OnSitePickup\"\r\n        \"Oncologic\", \"http://schema.org/Oncologic\"\r\n        \"OneTimePayments\", \"http://schema.org/OneTimePayments\"\r\n        \"Online\", \"http://schema.org/Online\"\r\n        \"OnlineBusiness\", \"http://schema.org/OnlineBusiness\"\r\n        \"OnlineEventAttendanceMode\", \"http://schema.org/OnlineEventAttendanceMode\"\r\n        \"OnlineFull\", \"http://schema.org/OnlineFull\"\r\n        \"OnlineOnly\", \"http://schema.org/OnlineOnly\"\r\n        \"OnlineStore\", \"http://schema.org/OnlineStore\"\r\n        \"OpenTrial\", \"http://schema.org/OpenTrial\"\r\n        \"OpeningHoursSpecification\", \"http://schema.org/OpeningHoursSpecification\"\r\n        \"OpinionNewsArticle\", \"http://schema.org/OpinionNewsArticle\"\r\n        \"Optician\", \"http://schema.org/Optician\"\r\n        \"Optometric\", \"http://schema.org/Optometric\"\r\n        \"Order\", \"http://schema.org/Order\"\r\n        \"OrderAction\", \"http://schema.org/OrderAction\"\r\n        \"OrderCancelled\", \"http://schema.org/OrderCancelled\"\r\n        \"OrderDelivered\", \"http://schema.org/OrderDelivered\"\r\n        \"OrderInTransit\", \"http://schema.org/OrderInTransit\"\r\n        \"OrderItem\", \"http://schema.org/OrderItem\"\r\n        \"OrderPaymentDue\", \"http://schema.org/OrderPaymentDue\"\r\n        \"OrderPickupAvailable\", \"http://schema.org/OrderPickupAvailable\"\r\n        \"OrderProblem\", \"http://schema.org/OrderProblem\"\r\n        \"OrderProcessing\", \"http://schema.org/OrderProcessing\"\r\n        \"OrderReturned\", \"http://schema.org/OrderReturned\"\r\n        \"OrderStatus\", \"http://schema.org/OrderStatus\"\r\n        \"Organization\", \"http://schema.org/Organization\"\r\n        \"OrganizationRole\", \"http://schema.org/OrganizationRole\"\r\n        \"OrganizeAction\", \"http://schema.org/OrganizeAction\"\r\n        \"OriginalMediaContent\", \"http://schema.org/OriginalMediaContent\"\r\n        \"OriginalShippingFees\", \"http://schema.org/OriginalShippingFees\"\r\n        \"Osteopathic\", \"http://schema.org/Osteopathic\"\r\n        \"Otolaryngologic\", \"http://schema.org/Otolaryngologic\"\r\n        \"OutOfStock\", \"http://schema.org/OutOfStock\"\r\n        \"OutletStore\", \"http://schema.org/OutletStore\"\r\n        \"OverviewHealthAspect\", \"http://schema.org/OverviewHealthAspect\"\r\n        \"OwnershipInfo\", \"http://schema.org/OwnershipInfo\"\r\n        \"PET\", \"http://schema.org/PET\"\r\n        \"PaidLeave\", \"http://schema.org/PaidLeave\"\r\n        \"PaintAction\", \"http://schema.org/PaintAction\"\r\n        \"Painting\", \"http://schema.org/Painting\"\r\n        \"PalliativeProcedure\", \"http://schema.org/PalliativeProcedure\"\r\n        \"Paperback\", \"http://schema.org/Paperback\"\r\n        \"ParcelDelivery\", \"http://schema.org/ParcelDelivery\"\r\n        \"ParcelService\", \"http://schema.org/ParcelService\"\r\n        \"ParentAudience\", \"http://schema.org/ParentAudience\"\r\n        \"ParentalSupport\", \"http://schema.org/ParentalSupport\"\r\n        \"Park\", \"http://schema.org/Park\"\r\n        \"ParkingFacility\", \"http://schema.org/ParkingFacility\"\r\n        \"ParkingMap\", \"http://schema.org/ParkingMap\"\r\n        \"PartiallyInForce\", \"http://schema.org/PartiallyInForce\"\r\n        \"Pathology\", \"http://schema.org/Pathology\"\r\n        \"PathologyTest\", \"http://schema.org/PathologyTest\"\r\n        \"Patient\", \"http://schema.org/Patient\"\r\n        \"PatientExperienceHealthAspect\", \"http://schema.org/PatientExperienceHealthAspect\"\r\n        \"PawnShop\", \"http://schema.org/PawnShop\"\r\n        \"PayAction\", \"http://schema.org/PayAction\"\r\n        \"PaymentAutomaticallyApplied\", \"http://schema.org/PaymentAutomaticallyApplied\"\r\n        \"PaymentCard\", \"http://schema.org/PaymentCard\"\r\n        \"PaymentChargeSpecification\", \"http://schema.org/PaymentChargeSpecification\"\r\n        \"PaymentComplete\", \"http://schema.org/PaymentComplete\"\r\n        \"PaymentDeclined\", \"http://schema.org/PaymentDeclined\"\r\n        \"PaymentDue\", \"http://schema.org/PaymentDue\"\r\n        \"PaymentMethod\", \"http://schema.org/PaymentMethod\"\r\n        \"PaymentPastDue\", \"http://schema.org/PaymentPastDue\"\r\n        \"PaymentService\", \"http://schema.org/PaymentService\"\r\n        \"PaymentStatusType\", \"http://schema.org/PaymentStatusType\"\r\n        \"Pediatric\", \"http://schema.org/Pediatric\"\r\n        \"PeopleAudience\", \"http://schema.org/PeopleAudience\"\r\n        \"PercutaneousProcedure\", \"http://schema.org/PercutaneousProcedure\"\r\n        \"PerformAction\", \"http://schema.org/PerformAction\"\r\n        \"PerformanceRole\", \"http://schema.org/PerformanceRole\"\r\n        \"PerformingArtsTheater\", \"http://schema.org/PerformingArtsTheater\"\r\n        \"PerformingGroup\", \"http://schema.org/PerformingGroup\"\r\n        \"Periodical\", \"http://schema.org/Periodical\"\r\n        \"Permit\", \"http://schema.org/Permit\"\r\n        \"Person\", \"http://schema.org/Person\"\r\n        \"PetStore\", \"http://schema.org/PetStore\"\r\n        \"Pharmacy\", \"http://schema.org/Pharmacy\"\r\n        \"PharmacySpecialty\", \"http://schema.org/PharmacySpecialty\"\r\n        \"Photograph\", \"http://schema.org/Photograph\"\r\n        \"PhotographAction\", \"http://schema.org/PhotographAction\"\r\n        \"PhysicalActivity\", \"http://schema.org/PhysicalActivity\"\r\n        \"PhysicalActivityCategory\", \"http://schema.org/PhysicalActivityCategory\"\r\n        \"PhysicalExam\", \"http://schema.org/PhysicalExam\"\r\n        \"PhysicalTherapy\", \"http://schema.org/PhysicalTherapy\"\r\n        \"Physician\", \"http://schema.org/Physician\"\r\n        \"Physiotherapy\", \"http://schema.org/Physiotherapy\"\r\n        \"Place\", \"http://schema.org/Place\"\r\n        \"PlaceOfWorship\", \"http://schema.org/PlaceOfWorship\"\r\n        \"PlaceboControlledTrial\", \"http://schema.org/PlaceboControlledTrial\"\r\n        \"PlanAction\", \"http://schema.org/PlanAction\"\r\n        \"PlasticSurgery\", \"http://schema.org/PlasticSurgery\"\r\n        \"Play\", \"http://schema.org/Play\"\r\n        \"PlayAction\", \"http://schema.org/PlayAction\"\r\n        \"PlayGameAction\", \"http://schema.org/PlayGameAction\"\r\n        \"Playground\", \"http://schema.org/Playground\"\r\n        \"Plumber\", \"http://schema.org/Plumber\"\r\n        \"PodcastEpisode\", \"http://schema.org/PodcastEpisode\"\r\n        \"PodcastSeason\", \"http://schema.org/PodcastSeason\"\r\n        \"PodcastSeries\", \"http://schema.org/PodcastSeries\"\r\n        \"Podiatric\", \"http://schema.org/Podiatric\"\r\n        \"PoliceStation\", \"http://schema.org/PoliceStation\"\r\n        \"PoliticalParty\", \"http://schema.org/PoliticalParty\"\r\n        \"Pond\", \"http://schema.org/Pond\"\r\n        \"PostOffice\", \"http://schema.org/PostOffice\"\r\n        \"PostalAddress\", \"http://schema.org/PostalAddress\"\r\n        \"PostalCodeRangeSpecification\", \"http://schema.org/PostalCodeRangeSpecification\"\r\n        \"Poster\", \"http://schema.org/Poster\"\r\n        \"PotentialActionStatus\", \"http://schema.org/PotentialActionStatus\"\r\n        \"PreOrder\", \"http://schema.org/PreOrder\"\r\n        \"PreOrderAction\", \"http://schema.org/PreOrderAction\"\r\n        \"PreSale\", \"http://schema.org/PreSale\"\r\n        \"PregnancyHealthAspect\", \"http://schema.org/PregnancyHealthAspect\"\r\n        \"PrependAction\", \"http://schema.org/PrependAction\"\r\n        \"Preschool\", \"http://schema.org/Preschool\"\r\n        \"PrescriptionOnly\", \"http://schema.org/PrescriptionOnly\"\r\n        \"PresentationDigitalDocument\", \"http://schema.org/PresentationDigitalDocument\"\r\n        \"PreventionHealthAspect\", \"http://schema.org/PreventionHealthAspect\"\r\n        \"PreventionIndication\", \"http://schema.org/PreventionIndication\"\r\n        \"PriceComponentTypeEnumeration\", \"http://schema.org/PriceComponentTypeEnumeration\"\r\n        \"PriceSpecification\", \"http://schema.org/PriceSpecification\"\r\n        \"PriceTypeEnumeration\", \"http://schema.org/PriceTypeEnumeration\"\r\n        \"PrimaryCare\", \"http://schema.org/PrimaryCare\"\r\n        \"Prion\", \"http://schema.org/Prion\"\r\n        \"Product\", \"http://schema.org/Product\"\r\n        \"ProductCollection\", \"http://schema.org/ProductCollection\"\r\n        \"ProductGroup\", \"http://schema.org/ProductGroup\"\r\n        \"ProductModel\", \"http://schema.org/ProductModel\"\r\n        \"ProductReturnEnumeration\", \"http://schema.org/ProductReturnEnumeration\"\r\n        \"ProductReturnFiniteReturnWindow\", \"http://schema.org/ProductReturnFiniteReturnWindow\"\r\n        \"ProductReturnNotPermitted\", \"http://schema.org/ProductReturnNotPermitted\"\r\n        \"ProductReturnPolicy\", \"http://schema.org/ProductReturnPolicy\"\r\n        \"ProductReturnUnlimitedWindow\", \"http://schema.org/ProductReturnUnlimitedWindow\"\r\n        \"ProductReturnUnspecified\", \"http://schema.org/ProductReturnUnspecified\"\r\n        \"ProfessionalService\", \"http://schema.org/ProfessionalService\"\r\n        \"ProfilePage\", \"http://schema.org/ProfilePage\"\r\n        \"PrognosisHealthAspect\", \"http://schema.org/PrognosisHealthAspect\"\r\n        \"ProgramMembership\", \"http://schema.org/ProgramMembership\"\r\n        \"Project\", \"http://schema.org/Project\"\r\n        \"PronounceableText\", \"http://schema.org/PronounceableText\"\r\n        \"Property\", \"http://schema.org/Property\"\r\n        \"PropertyValue\", \"http://schema.org/PropertyValue\"\r\n        \"PropertyValueSpecification\", \"http://schema.org/PropertyValueSpecification\"\r\n        \"Protein\", \"http://schema.org/Protein\"\r\n        \"Protozoa\", \"http://schema.org/Protozoa\"\r\n        \"Psychiatric\", \"http://schema.org/Psychiatric\"\r\n        \"PsychologicalTreatment\", \"http://schema.org/PsychologicalTreatment\"\r\n        \"PublicHealth\", \"http://schema.org/PublicHealth\"\r\n        \"PublicHolidays\", \"http://schema.org/PublicHolidays\"\r\n        \"PublicSwimmingPool\", \"http://schema.org/PublicSwimmingPool\"\r\n        \"PublicToilet\", \"http://schema.org/PublicToilet\"\r\n        \"PublicationEvent\", \"http://schema.org/PublicationEvent\"\r\n        \"PublicationIssue\", \"http://schema.org/PublicationIssue\"\r\n        \"PublicationVolume\", \"http://schema.org/PublicationVolume\"\r\n        \"Pulmonary\", \"http://schema.org/Pulmonary\"\r\n        \"QAPage\", \"http://schema.org/QAPage\"\r\n        \"QualitativeValue\", \"http://schema.org/QualitativeValue\"\r\n        \"QuantitativeValue\", \"http://schema.org/QuantitativeValue\"\r\n        \"QuantitativeValueDistribution\", \"http://schema.org/QuantitativeValueDistribution\"\r\n        \"Quantity\", \"http://schema.org/Quantity\"\r\n        \"Question\", \"http://schema.org/Question\"\r\n        \"Quiz\", \"http://schema.org/Quiz\"\r\n        \"Quotation\", \"http://schema.org/Quotation\"\r\n        \"QuoteAction\", \"http://schema.org/QuoteAction\"\r\n        \"RVPark\", \"http://schema.org/RVPark\"\r\n        \"RadiationTherapy\", \"http://schema.org/RadiationTherapy\"\r\n        \"RadioBroadcastService\", \"http://schema.org/RadioBroadcastService\"\r\n        \"RadioChannel\", \"http://schema.org/RadioChannel\"\r\n        \"RadioClip\", \"http://schema.org/RadioClip\"\r\n        \"RadioEpisode\", \"http://schema.org/RadioEpisode\"\r\n        \"RadioSeason\", \"http://schema.org/RadioSeason\"\r\n        \"RadioSeries\", \"http://schema.org/RadioSeries\"\r\n        \"RadioStation\", \"http://schema.org/RadioStation\"\r\n        \"Radiography\", \"http://schema.org/Radiography\"\r\n        \"RandomizedTrial\", \"http://schema.org/RandomizedTrial\"\r\n        \"Rating\", \"http://schema.org/Rating\"\r\n        \"ReactAction\", \"http://schema.org/ReactAction\"\r\n        \"ReadAction\", \"http://schema.org/ReadAction\"\r\n        \"ReadPermission\", \"http://schema.org/ReadPermission\"\r\n        \"RealEstateAgent\", \"http://schema.org/RealEstateAgent\"\r\n        \"RealEstateListing\", \"http://schema.org/RealEstateListing\"\r\n        \"RearWheelDriveConfiguration\", \"http://schema.org/RearWheelDriveConfiguration\"\r\n        \"ReceiveAction\", \"http://schema.org/ReceiveAction\"\r\n        \"Recipe\", \"http://schema.org/Recipe\"\r\n        \"Recommendation\", \"http://schema.org/Recommendation\"\r\n        \"RecommendedDoseSchedule\", \"http://schema.org/RecommendedDoseSchedule\"\r\n        \"Recruiting\", \"http://schema.org/Recruiting\"\r\n        \"RecyclingCenter\", \"http://schema.org/RecyclingCenter\"\r\n        \"ReducedRelevanceForChildrenConsideration\", \"http://schema.org/ReducedRelevanceForChildrenConsideration\"\r\n        \"RefundTypeEnumeration\", \"http://schema.org/RefundTypeEnumeration\"\r\n        \"RefurbishedCondition\", \"http://schema.org/RefurbishedCondition\"\r\n        \"RegisterAction\", \"http://schema.org/RegisterAction\"\r\n        \"Registry\", \"http://schema.org/Registry\"\r\n        \"ReimbursementCap\", \"http://schema.org/ReimbursementCap\"\r\n        \"RejectAction\", \"http://schema.org/RejectAction\"\r\n        \"RelatedTopicsHealthAspect\", \"http://schema.org/RelatedTopicsHealthAspect\"\r\n        \"RemixAlbum\", \"http://schema.org/RemixAlbum\"\r\n        \"Renal\", \"http://schema.org/Renal\"\r\n        \"RentAction\", \"http://schema.org/RentAction\"\r\n        \"RentalCarReservation\", \"http://schema.org/RentalCarReservation\"\r\n        \"RentalVehicleUsage\", \"http://schema.org/RentalVehicleUsage\"\r\n        \"RepaymentSpecification\", \"http://schema.org/RepaymentSpecification\"\r\n        \"ReplaceAction\", \"http://schema.org/ReplaceAction\"\r\n        \"ReplyAction\", \"http://schema.org/ReplyAction\"\r\n        \"Report\", \"http://schema.org/Report\"\r\n        \"ReportageNewsArticle\", \"http://schema.org/ReportageNewsArticle\"\r\n        \"ReportedDoseSchedule\", \"http://schema.org/ReportedDoseSchedule\"\r\n        \"ResearchOrganization\", \"http://schema.org/ResearchOrganization\"\r\n        \"ResearchProject\", \"http://schema.org/ResearchProject\"\r\n        \"Researcher\", \"http://schema.org/Researcher\"\r\n        \"Reservation\", \"http://schema.org/Reservation\"\r\n        \"ReservationCancelled\", \"http://schema.org/ReservationCancelled\"\r\n        \"ReservationConfirmed\", \"http://schema.org/ReservationConfirmed\"\r\n        \"ReservationHold\", \"http://schema.org/ReservationHold\"\r\n        \"ReservationPackage\", \"http://schema.org/ReservationPackage\"\r\n        \"ReservationPending\", \"http://schema.org/ReservationPending\"\r\n        \"ReservationStatusType\", \"http://schema.org/ReservationStatusType\"\r\n        \"ReserveAction\", \"http://schema.org/ReserveAction\"\r\n        \"Reservoir\", \"http://schema.org/Reservoir\"\r\n        \"Residence\", \"http://schema.org/Residence\"\r\n        \"Resort\", \"http://schema.org/Resort\"\r\n        \"RespiratoryTherapy\", \"http://schema.org/RespiratoryTherapy\"\r\n        \"Restaurant\", \"http://schema.org/Restaurant\"\r\n        \"RestockingFees\", \"http://schema.org/RestockingFees\"\r\n        \"RestrictedDiet\", \"http://schema.org/RestrictedDiet\"\r\n        \"ResultsAvailable\", \"http://schema.org/ResultsAvailable\"\r\n        \"ResultsNotAvailable\", \"http://schema.org/ResultsNotAvailable\"\r\n        \"ResumeAction\", \"http://schema.org/ResumeAction\"\r\n        \"Retail\", \"http://schema.org/Retail\"\r\n        \"ReturnAction\", \"http://schema.org/ReturnAction\"\r\n        \"ReturnAtKiosk\", \"http://schema.org/ReturnAtKiosk\"\r\n        \"ReturnByMail\", \"http://schema.org/ReturnByMail\"\r\n        \"ReturnFeesCustomerResponsibility\", \"http://schema.org/ReturnFeesCustomerResponsibility\"\r\n        \"ReturnFeesEnumeration\", \"http://schema.org/ReturnFeesEnumeration\"\r\n        \"ReturnInStore\", \"http://schema.org/ReturnInStore\"\r\n        \"ReturnLabelCustomerResponsibility\", \"http://schema.org/ReturnLabelCustomerResponsibility\"\r\n        \"ReturnLabelDownloadAndPrint\", \"http://schema.org/ReturnLabelDownloadAndPrint\"\r\n        \"ReturnLabelInBox\", \"http://schema.org/ReturnLabelInBox\"\r\n        \"ReturnLabelSourceEnumeration\", \"http://schema.org/ReturnLabelSourceEnumeration\"\r\n        \"ReturnMethodEnumeration\", \"http://schema.org/ReturnMethodEnumeration\"\r\n        \"ReturnShippingFees\", \"http://schema.org/ReturnShippingFees\"\r\n        \"Review\", \"http://schema.org/Review\"\r\n        \"ReviewAction\", \"http://schema.org/ReviewAction\"\r\n        \"ReviewNewsArticle\", \"http://schema.org/ReviewNewsArticle\"\r\n        \"Rheumatologic\", \"http://schema.org/Rheumatologic\"\r\n        \"RightHandDriving\", \"http://schema.org/RightHandDriving\"\r\n        \"RisksOrComplicationsHealthAspect\", \"http://schema.org/RisksOrComplicationsHealthAspect\"\r\n        \"RiverBodyOfWater\", \"http://schema.org/RiverBodyOfWater\"\r\n        \"Role\", \"http://schema.org/Role\"\r\n        \"RoofingContractor\", \"http://schema.org/RoofingContractor\"\r\n        \"Room\", \"http://schema.org/Room\"\r\n        \"RsvpAction\", \"http://schema.org/RsvpAction\"\r\n        \"RsvpResponseMaybe\", \"http://schema.org/RsvpResponseMaybe\"\r\n        \"RsvpResponseNo\", \"http://schema.org/RsvpResponseNo\"\r\n        \"RsvpResponseType\", \"http://schema.org/RsvpResponseType\"\r\n        \"RsvpResponseYes\", \"http://schema.org/RsvpResponseYes\"\r\n        \"SRP\", \"http://schema.org/SRP\"\r\n        \"SafetyHealthAspect\", \"http://schema.org/SafetyHealthAspect\"\r\n        \"SaleEvent\", \"http://schema.org/SaleEvent\"\r\n        \"SalePrice\", \"http://schema.org/SalePrice\"\r\n        \"SatireOrParodyContent\", \"http://schema.org/SatireOrParodyContent\"\r\n        \"SatiricalArticle\", \"http://schema.org/SatiricalArticle\"\r\n        \"Saturday\", \"http://schema.org/Saturday\"\r\n        \"Schedule\", \"http://schema.org/Schedule\"\r\n        \"ScheduleAction\", \"http://schema.org/ScheduleAction\"\r\n        \"ScholarlyArticle\", \"http://schema.org/ScholarlyArticle\"\r\n        \"School\", \"http://schema.org/School\"\r\n        \"SchoolDistrict\", \"http://schema.org/SchoolDistrict\"\r\n        \"ScreeningEvent\", \"http://schema.org/ScreeningEvent\"\r\n        \"ScreeningHealthAspect\", \"http://schema.org/ScreeningHealthAspect\"\r\n        \"Sculpture\", \"http://schema.org/Sculpture\"\r\n        \"SeaBodyOfWater\", \"http://schema.org/SeaBodyOfWater\"\r\n        \"SearchAction\", \"http://schema.org/SearchAction\"\r\n        \"SearchRescueOrganization\", \"http://schema.org/SearchRescueOrganization\"\r\n        \"SearchResultsPage\", \"http://schema.org/SearchResultsPage\"\r\n        \"Season\", \"http://schema.org/Season\"\r\n        \"Seat\", \"http://schema.org/Seat\"\r\n        \"SeatingMap\", \"http://schema.org/SeatingMap\"\r\n        \"SeeDoctorHealthAspect\", \"http://schema.org/SeeDoctorHealthAspect\"\r\n        \"SeekToAction\", \"http://schema.org/SeekToAction\"\r\n        \"SelfCareHealthAspect\", \"http://schema.org/SelfCareHealthAspect\"\r\n        \"SelfStorage\", \"http://schema.org/SelfStorage\"\r\n        \"SellAction\", \"http://schema.org/SellAction\"\r\n        \"SendAction\", \"http://schema.org/SendAction\"\r\n        \"Series\", \"http://schema.org/Series\"\r\n        \"Service\", \"http://schema.org/Service\"\r\n        \"ServiceChannel\", \"http://schema.org/ServiceChannel\"\r\n        \"SexualContentConsideration\", \"http://schema.org/SexualContentConsideration\"\r\n        \"ShareAction\", \"http://schema.org/ShareAction\"\r\n        \"SheetMusic\", \"http://schema.org/SheetMusic\"\r\n        \"ShippingDeliveryTime\", \"http://schema.org/ShippingDeliveryTime\"\r\n        \"ShippingRateSettings\", \"http://schema.org/ShippingRateSettings\"\r\n        \"ShoeStore\", \"http://schema.org/ShoeStore\"\r\n        \"ShoppingCenter\", \"http://schema.org/ShoppingCenter\"\r\n        \"ShortStory\", \"http://schema.org/ShortStory\"\r\n        \"SideEffectsHealthAspect\", \"http://schema.org/SideEffectsHealthAspect\"\r\n        \"SingleBlindedTrial\", \"http://schema.org/SingleBlindedTrial\"\r\n        \"SingleCenterTrial\", \"http://schema.org/SingleCenterTrial\"\r\n        \"SingleFamilyResidence\", \"http://schema.org/SingleFamilyResidence\"\r\n        \"SinglePlayer\", \"http://schema.org/SinglePlayer\"\r\n        \"SingleRelease\", \"http://schema.org/SingleRelease\"\r\n        \"SiteNavigationElement\", \"http://schema.org/SiteNavigationElement\"\r\n        \"SizeGroupEnumeration\", \"http://schema.org/SizeGroupEnumeration\"\r\n        \"SizeSpecification\", \"http://schema.org/SizeSpecification\"\r\n        \"SizeSystemEnumeration\", \"http://schema.org/SizeSystemEnumeration\"\r\n        \"SizeSystemImperial\", \"http://schema.org/SizeSystemImperial\"\r\n        \"SizeSystemMetric\", \"http://schema.org/SizeSystemMetric\"\r\n        \"SkiResort\", \"http://schema.org/SkiResort\"\r\n        \"Skin\", \"http://schema.org/Skin\"\r\n        \"SocialEvent\", \"http://schema.org/SocialEvent\"\r\n        \"SocialMediaPosting\", \"http://schema.org/SocialMediaPosting\"\r\n        \"SoftwareApplication\", \"http://schema.org/SoftwareApplication\"\r\n        \"SoftwareSourceCode\", \"http://schema.org/SoftwareSourceCode\"\r\n        \"SoldOut\", \"http://schema.org/SoldOut\"\r\n        \"SolveMathAction\", \"http://schema.org/SolveMathAction\"\r\n        \"SomeProducts\", \"http://schema.org/SomeProducts\"\r\n        \"SoundtrackAlbum\", \"http://schema.org/SoundtrackAlbum\"\r\n        \"SpeakableSpecification\", \"http://schema.org/SpeakableSpecification\"\r\n        \"SpecialAnnouncement\", \"http://schema.org/SpecialAnnouncement\"\r\n        \"Specialty\", \"http://schema.org/Specialty\"\r\n        \"SpeechPathology\", \"http://schema.org/SpeechPathology\"\r\n        \"SpokenWordAlbum\", \"http://schema.org/SpokenWordAlbum\"\r\n        \"SportingGoodsStore\", \"http://schema.org/SportingGoodsStore\"\r\n        \"SportsActivityLocation\", \"http://schema.org/SportsActivityLocation\"\r\n        \"SportsClub\", \"http://schema.org/SportsClub\"\r\n        \"SportsEvent\", \"http://schema.org/SportsEvent\"\r\n        \"SportsOrganization\", \"http://schema.org/SportsOrganization\"\r\n        \"SportsTeam\", \"http://schema.org/SportsTeam\"\r\n        \"SpreadsheetDigitalDocument\", \"http://schema.org/SpreadsheetDigitalDocument\"\r\n        \"StadiumOrArena\", \"http://schema.org/StadiumOrArena\"\r\n        \"StagedContent\", \"http://schema.org/StagedContent\"\r\n        \"StagesHealthAspect\", \"http://schema.org/StagesHealthAspect\"\r\n        \"State\", \"http://schema.org/State\"\r\n        \"Statement\", \"http://schema.org/Statement\"\r\n        \"StatisticalPopulation\", \"http://schema.org/StatisticalPopulation\"\r\n        \"StatisticalVariable\", \"http://schema.org/StatisticalVariable\"\r\n        \"StatusEnumeration\", \"http://schema.org/StatusEnumeration\"\r\n        \"SteeringPositionValue\", \"http://schema.org/SteeringPositionValue\"\r\n        \"Store\", \"http://schema.org/Store\"\r\n        \"StoreCreditRefund\", \"http://schema.org/StoreCreditRefund\"\r\n        \"StrengthTraining\", \"http://schema.org/StrengthTraining\"\r\n        \"StructuredValue\", \"http://schema.org/StructuredValue\"\r\n        \"StudioAlbum\", \"http://schema.org/StudioAlbum\"\r\n        \"StupidType\", \"http://schema.org/StupidType\"\r\n        \"SubscribeAction\", \"http://schema.org/SubscribeAction\"\r\n        \"Subscription\", \"http://schema.org/Subscription\"\r\n        \"Substance\", \"http://schema.org/Substance\"\r\n        \"SubwayStation\", \"http://schema.org/SubwayStation\"\r\n        \"Suite\", \"http://schema.org/Suite\"\r\n        \"Sunday\", \"http://schema.org/Sunday\"\r\n        \"SuperficialAnatomy\", \"http://schema.org/SuperficialAnatomy\"\r\n        \"Surgical\", \"http://schema.org/Surgical\"\r\n        \"SurgicalProcedure\", \"http://schema.org/SurgicalProcedure\"\r\n        \"SuspendAction\", \"http://schema.org/SuspendAction\"\r\n        \"Suspended\", \"http://schema.org/Suspended\"\r\n        \"Syllabus\", \"http://schema.org/Syllabus\"\r\n        \"SymptomsHealthAspect\", \"http://schema.org/SymptomsHealthAspect\"\r\n        \"Synagogue\", \"http://schema.org/Synagogue\"\r\n        \"TVClip\", \"http://schema.org/TVClip\"\r\n        \"TVEpisode\", \"http://schema.org/TVEpisode\"\r\n        \"TVSeason\", \"http://schema.org/TVSeason\"\r\n        \"TVSeries\", \"http://schema.org/TVSeries\"\r\n        \"Table\", \"http://schema.org/Table\"\r\n        \"TakeAction\", \"http://schema.org/TakeAction\"\r\n        \"TattooParlor\", \"http://schema.org/TattooParlor\"\r\n        \"Taxi\", \"http://schema.org/Taxi\"\r\n        \"TaxiReservation\", \"http://schema.org/TaxiReservation\"\r\n        \"TaxiService\", \"http://schema.org/TaxiService\"\r\n        \"TaxiStand\", \"http://schema.org/TaxiStand\"\r\n        \"TaxiVehicleUsage\", \"http://schema.org/TaxiVehicleUsage\"\r\n        \"Taxon\", \"http://schema.org/Taxon\"\r\n        \"TechArticle\", \"http://schema.org/TechArticle\"\r\n        \"TelevisionChannel\", \"http://schema.org/TelevisionChannel\"\r\n        \"TelevisionStation\", \"http://schema.org/TelevisionStation\"\r\n        \"TennisComplex\", \"http://schema.org/TennisComplex\"\r\n        \"Terminated\", \"http://schema.org/Terminated\"\r\n        \"Text\", \"http://schema.org/Text\"\r\n        \"TextDigitalDocument\", \"http://schema.org/TextDigitalDocument\"\r\n        \"TextObject\", \"http://schema.org/TextObject\"\r\n        \"TheaterEvent\", \"http://schema.org/TheaterEvent\"\r\n        \"TheaterGroup\", \"http://schema.org/TheaterGroup\"\r\n        \"Therapeutic\", \"http://schema.org/Therapeutic\"\r\n        \"TherapeuticProcedure\", \"http://schema.org/TherapeuticProcedure\"\r\n        \"Thesis\", \"http://schema.org/Thesis\"\r\n        \"Thing\", \"http://schema.org/Thing\"\r\n        \"Throat\", \"http://schema.org/Throat\"\r\n        \"Thursday\", \"http://schema.org/Thursday\"\r\n        \"Ticket\", \"http://schema.org/Ticket\"\r\n        \"TieAction\", \"http://schema.org/TieAction\"\r\n        \"Time\", \"http://schema.org/Time\"\r\n        \"TipAction\", \"http://schema.org/TipAction\"\r\n        \"TireShop\", \"http://schema.org/TireShop\"\r\n        \"TobaccoNicotineConsideration\", \"http://schema.org/TobaccoNicotineConsideration\"\r\n        \"TollFree\", \"http://schema.org/TollFree\"\r\n        \"TouristAttraction\", \"http://schema.org/TouristAttraction\"\r\n        \"TouristDestination\", \"http://schema.org/TouristDestination\"\r\n        \"TouristInformationCenter\", \"http://schema.org/TouristInformationCenter\"\r\n        \"TouristTrip\", \"http://schema.org/TouristTrip\"\r\n        \"Toxicologic\", \"http://schema.org/Toxicologic\"\r\n        \"ToyStore\", \"http://schema.org/ToyStore\"\r\n        \"TrackAction\", \"http://schema.org/TrackAction\"\r\n        \"TradeAction\", \"http://schema.org/TradeAction\"\r\n        \"TraditionalChinese\", \"http://schema.org/TraditionalChinese\"\r\n        \"TrainReservation\", \"http://schema.org/TrainReservation\"\r\n        \"TrainStation\", \"http://schema.org/TrainStation\"\r\n        \"TrainTrip\", \"http://schema.org/TrainTrip\"\r\n        \"TransferAction\", \"http://schema.org/TransferAction\"\r\n        \"TransformedContent\", \"http://schema.org/TransformedContent\"\r\n        \"TransitMap\", \"http://schema.org/TransitMap\"\r\n        \"TravelAction\", \"http://schema.org/TravelAction\"\r\n        \"TravelAgency\", \"http://schema.org/TravelAgency\"\r\n        \"TreatmentIndication\", \"http://schema.org/TreatmentIndication\"\r\n        \"TreatmentsHealthAspect\", \"http://schema.org/TreatmentsHealthAspect\"\r\n        \"Trip\", \"http://schema.org/Trip\"\r\n        \"TripleBlindedTrial\", \"http://schema.org/TripleBlindedTrial\"\r\n        \"True\", \"http://schema.org/True\"\r\n        \"Tuesday\", \"http://schema.org/Tuesday\"\r\n        \"TypeAndQuantityNode\", \"http://schema.org/TypeAndQuantityNode\"\r\n        \"TypesHealthAspect\", \"http://schema.org/TypesHealthAspect\"\r\n        \"UKNonprofitType\", \"http://schema.org/UKNonprofitType\"\r\n        \"UKTrust\", \"http://schema.org/UKTrust\"\r\n        \"URL\", \"http://schema.org/URL\"\r\n        \"USNonprofitType\", \"http://schema.org/USNonprofitType\"\r\n        \"Ultrasound\", \"http://schema.org/Ultrasound\"\r\n        \"UnRegisterAction\", \"http://schema.org/UnRegisterAction\"\r\n        \"UnclassifiedAdultConsideration\", \"http://schema.org/UnclassifiedAdultConsideration\"\r\n        \"UnemploymentSupport\", \"http://schema.org/UnemploymentSupport\"\r\n        \"UnincorporatedAssociationCharity\", \"http://schema.org/UnincorporatedAssociationCharity\"\r\n        \"UnitPriceSpecification\", \"http://schema.org/UnitPriceSpecification\"\r\n        \"UnofficialLegalValue\", \"http://schema.org/UnofficialLegalValue\"\r\n        \"UpdateAction\", \"http://schema.org/UpdateAction\"\r\n        \"Urologic\", \"http://schema.org/Urologic\"\r\n        \"UsageOrScheduleHealthAspect\", \"http://schema.org/UsageOrScheduleHealthAspect\"\r\n        \"UseAction\", \"http://schema.org/UseAction\"\r\n        \"UsedCondition\", \"http://schema.org/UsedCondition\"\r\n        \"UserBlocks\", \"http://schema.org/UserBlocks\"\r\n        \"UserCheckins\", \"http://schema.org/UserCheckins\"\r\n        \"UserComments\", \"http://schema.org/UserComments\"\r\n        \"UserDownloads\", \"http://schema.org/UserDownloads\"\r\n        \"UserInteraction\", \"http://schema.org/UserInteraction\"\r\n        \"UserLikes\", \"http://schema.org/UserLikes\"\r\n        \"UserPageVisits\", \"http://schema.org/UserPageVisits\"\r\n        \"UserPlays\", \"http://schema.org/UserPlays\"\r\n        \"UserPlusOnes\", \"http://schema.org/UserPlusOnes\"\r\n        \"UserReview\", \"http://schema.org/UserReview\"\r\n        \"UserTweets\", \"http://schema.org/UserTweets\"\r\n        \"VacationRental\", \"http://schema.org/VacationRental\"\r\n        \"VeganDiet\", \"http://schema.org/VeganDiet\"\r\n        \"VegetarianDiet\", \"http://schema.org/VegetarianDiet\"\r\n        \"Vehicle\", \"http://schema.org/Vehicle\"\r\n        \"Vein\", \"http://schema.org/Vein\"\r\n        \"VenueMap\", \"http://schema.org/VenueMap\"\r\n        \"Vessel\", \"http://schema.org/Vessel\"\r\n        \"VeterinaryCare\", \"http://schema.org/VeterinaryCare\"\r\n        \"VideoGallery\", \"http://schema.org/VideoGallery\"\r\n        \"VideoGame\", \"http://schema.org/VideoGame\"\r\n        \"VideoGameClip\", \"http://schema.org/VideoGameClip\"\r\n        \"VideoGameSeries\", \"http://schema.org/VideoGameSeries\"\r\n        \"VideoObject\", \"http://schema.org/VideoObject\"\r\n        \"VideoObjectSnapshot\", \"http://schema.org/VideoObjectSnapshot\"\r\n        \"ViewAction\", \"http://schema.org/ViewAction\"\r\n        \"VinylFormat\", \"http://schema.org/VinylFormat\"\r\n        \"ViolenceConsideration\", \"http://schema.org/ViolenceConsideration\"\r\n        \"VirtualLocation\", \"http://schema.org/VirtualLocation\"\r\n        \"Virus\", \"http://schema.org/Virus\"\r\n        \"VisualArtsEvent\", \"http://schema.org/VisualArtsEvent\"\r\n        \"VisualArtwork\", \"http://schema.org/VisualArtwork\"\r\n        \"VitalSign\", \"http://schema.org/VitalSign\"\r\n        \"Volcano\", \"http://schema.org/Volcano\"\r\n        \"VoteAction\", \"http://schema.org/VoteAction\"\r\n        \"WPAdBlock\", \"http://schema.org/WPAdBlock\"\r\n        \"WPFooter\", \"http://schema.org/WPFooter\"\r\n        \"WPHeader\", \"http://schema.org/WPHeader\"\r\n        \"WPSideBar\", \"http://schema.org/WPSideBar\"\r\n        \"WantAction\", \"http://schema.org/WantAction\"\r\n        \"WarrantyPromise\", \"http://schema.org/WarrantyPromise\"\r\n        \"WarrantyScope\", \"http://schema.org/WarrantyScope\"\r\n        \"WatchAction\", \"http://schema.org/WatchAction\"\r\n        \"Waterfall\", \"http://schema.org/Waterfall\"\r\n        \"WeaponConsideration\", \"http://schema.org/WeaponConsideration\"\r\n        \"WearAction\", \"http://schema.org/WearAction\"\r\n        \"WearableMeasurementBack\", \"http://schema.org/WearableMeasurementBack\"\r\n        \"WearableMeasurementChestOrBust\", \"http://schema.org/WearableMeasurementChestOrBust\"\r\n        \"WearableMeasurementCollar\", \"http://schema.org/WearableMeasurementCollar\"\r\n        \"WearableMeasurementCup\", \"http://schema.org/WearableMeasurementCup\"\r\n        \"WearableMeasurementHeight\", \"http://schema.org/WearableMeasurementHeight\"\r\n        \"WearableMeasurementHips\", \"http://schema.org/WearableMeasurementHips\"\r\n        \"WearableMeasurementInseam\", \"http://schema.org/WearableMeasurementInseam\"\r\n        \"WearableMeasurementLength\", \"http://schema.org/WearableMeasurementLength\"\r\n        \"WearableMeasurementOutsideLeg\", \"http://schema.org/WearableMeasurementOutsideLeg\"\r\n        \"WearableMeasurementSleeve\", \"http://schema.org/WearableMeasurementSleeve\"\r\n        \"WearableMeasurementTypeEnumeration\", \"http://schema.org/WearableMeasurementTypeEnumeration\"\r\n        \"WearableMeasurementWaist\", \"http://schema.org/WearableMeasurementWaist\"\r\n        \"WearableMeasurementWidth\", \"http://schema.org/WearableMeasurementWidth\"\r\n        \"WearableSizeGroupBig\", \"http://schema.org/WearableSizeGroupBig\"\r\n        \"WearableSizeGroupBoys\", \"http://schema.org/WearableSizeGroupBoys\"\r\n        \"WearableSizeGroupEnumeration\", \"http://schema.org/WearableSizeGroupEnumeration\"\r\n        \"WearableSizeGroupExtraShort\", \"http://schema.org/WearableSizeGroupExtraShort\"\r\n        \"WearableSizeGroupExtraTall\", \"http://schema.org/WearableSizeGroupExtraTall\"\r\n        \"WearableSizeGroupGirls\", \"http://schema.org/WearableSizeGroupGirls\"\r\n        \"WearableSizeGroupHusky\", \"http://schema.org/WearableSizeGroupHusky\"\r\n        \"WearableSizeGroupInfants\", \"http://schema.org/WearableSizeGroupInfants\"\r\n        \"WearableSizeGroupJuniors\", \"http://schema.org/WearableSizeGroupJuniors\"\r\n        \"WearableSizeGroupMaternity\", \"http://schema.org/WearableSizeGroupMaternity\"\r\n        \"WearableSizeGroupMens\", \"http://schema.org/WearableSizeGroupMens\"\r\n        \"WearableSizeGroupMisses\", \"http://schema.org/WearableSizeGroupMisses\"\r\n        \"WearableSizeGroupPetite\", \"http://schema.org/WearableSizeGroupPetite\"\r\n        \"WearableSizeGroupPlus\", \"http://schema.org/WearableSizeGroupPlus\"\r\n        \"WearableSizeGroupRegular\", \"http://schema.org/WearableSizeGroupRegular\"\r\n        \"WearableSizeGroupShort\", \"http://schema.org/WearableSizeGroupShort\"\r\n        \"WearableSizeGroupTall\", \"http://schema.org/WearableSizeGroupTall\"\r\n        \"WearableSizeGroupWomens\", \"http://schema.org/WearableSizeGroupWomens\"\r\n        \"WearableSizeSystemAU\", \"http://schema.org/WearableSizeSystemAU\"\r\n        \"WearableSizeSystemBR\", \"http://schema.org/WearableSizeSystemBR\"\r\n        \"WearableSizeSystemCN\", \"http://schema.org/WearableSizeSystemCN\"\r\n        \"WearableSizeSystemContinental\", \"http://schema.org/WearableSizeSystemContinental\"\r\n        \"WearableSizeSystemDE\", \"http://schema.org/WearableSizeSystemDE\"\r\n        \"WearableSizeSystemEN13402\", \"http://schema.org/WearableSizeSystemEN13402\"\r\n        \"WearableSizeSystemEnumeration\", \"http://schema.org/WearableSizeSystemEnumeration\"\r\n        \"WearableSizeSystemEurope\", \"http://schema.org/WearableSizeSystemEurope\"\r\n        \"WearableSizeSystemFR\", \"http://schema.org/WearableSizeSystemFR\"\r\n        \"WearableSizeSystemGS1\", \"http://schema.org/WearableSizeSystemGS1\"\r\n        \"WearableSizeSystemIT\", \"http://schema.org/WearableSizeSystemIT\"\r\n        \"WearableSizeSystemJP\", \"http://schema.org/WearableSizeSystemJP\"\r\n        \"WearableSizeSystemMX\", \"http://schema.org/WearableSizeSystemMX\"\r\n        \"WearableSizeSystemUK\", \"http://schema.org/WearableSizeSystemUK\"\r\n        \"WearableSizeSystemUS\", \"http://schema.org/WearableSizeSystemUS\"\r\n        \"WebAPI\", \"http://schema.org/WebAPI\"\r\n        \"WebApplication\", \"http://schema.org/WebApplication\"\r\n        \"WebContent\", \"http://schema.org/WebContent\"\r\n        \"WebPage\", \"http://schema.org/WebPage\"\r\n        \"WebPageElement\", \"http://schema.org/WebPageElement\"\r\n        \"WebSite\", \"http://schema.org/WebSite\"\r\n        \"Wednesday\", \"http://schema.org/Wednesday\"\r\n        \"WesternConventional\", \"http://schema.org/WesternConventional\"\r\n        \"Wholesale\", \"http://schema.org/Wholesale\"\r\n        \"WholesaleStore\", \"http://schema.org/WholesaleStore\"\r\n        \"WinAction\", \"http://schema.org/WinAction\"\r\n        \"Winery\", \"http://schema.org/Winery\"\r\n        \"Withdrawn\", \"http://schema.org/Withdrawn\"\r\n        \"WorkBasedProgram\", \"http://schema.org/WorkBasedProgram\"\r\n        \"WorkersUnion\", \"http://schema.org/WorkersUnion\"\r\n        \"WriteAction\", \"http://schema.org/WriteAction\"\r\n        \"WritePermission\", \"http://schema.org/WritePermission\"\r\n        \"XPathType\", \"http://schema.org/XPathType\"\r\n        \"XRay\", \"http://schema.org/XRay\"\r\n        \"ZoneBoardingPolicy\", \"http://schema.org/ZoneBoardingPolicy\"\r\n        \"Zoo\", \"http://schema.org/Zoo\"\r\n        \"about\", \"http://schema.org/about\"\r\n        \"abridged\", \"http://schema.org/abridged\"\r\n        \"abstract\", \"http://schema.org/abstract\"\r\n        \"accelerationTime\", \"http://schema.org/accelerationTime\"\r\n        \"acceptedAnswer\", \"http://schema.org/acceptedAnswer\"\r\n        \"acceptedOffer\", \"http://schema.org/acceptedOffer\"\r\n        \"acceptedPaymentMethod\", \"http://schema.org/acceptedPaymentMethod\"\r\n        \"acceptsReservations\", \"http://schema.org/acceptsReservations\"\r\n        \"accessCode\", \"http://schema.org/accessCode\"\r\n        \"accessMode\", \"http://schema.org/accessMode\"\r\n        \"accessModeSufficient\", \"http://schema.org/accessModeSufficient\"\r\n        \"accessibilityAPI\", \"http://schema.org/accessibilityAPI\"\r\n        \"accessibilityControl\", \"http://schema.org/accessibilityControl\"\r\n        \"accessibilityFeature\", \"http://schema.org/accessibilityFeature\"\r\n        \"accessibilityHazard\", \"http://schema.org/accessibilityHazard\"\r\n        \"accessibilitySummary\", \"http://schema.org/accessibilitySummary\"\r\n        \"accommodationCategory\", \"http://schema.org/accommodationCategory\"\r\n        \"accommodationFloorPlan\", \"http://schema.org/accommodationFloorPlan\"\r\n        \"accountId\", \"http://schema.org/accountId\"\r\n        \"accountMinimumInflow\", \"http://schema.org/accountMinimumInflow\"\r\n        \"accountOverdraftLimit\", \"http://schema.org/accountOverdraftLimit\"\r\n        \"accountablePerson\", \"http://schema.org/accountablePerson\"\r\n        \"acquireLicensePage\", \"http://schema.org/acquireLicensePage\"\r\n        \"acquiredFrom\", \"http://schema.org/acquiredFrom\"\r\n        \"acrissCode\", \"http://schema.org/acrissCode\"\r\n        \"actionAccessibilityRequirement\", \"http://schema.org/actionAccessibilityRequirement\"\r\n        \"actionApplication\", \"http://schema.org/actionApplication\"\r\n        \"actionOption\", \"http://schema.org/actionOption\"\r\n        \"actionPlatform\", \"http://schema.org/actionPlatform\"\r\n        \"actionStatus\", \"http://schema.org/actionStatus\"\r\n        \"actionableFeedbackPolicy\", \"http://schema.org/actionableFeedbackPolicy\"\r\n        \"activeIngredient\", \"http://schema.org/activeIngredient\"\r\n        \"activityDuration\", \"http://schema.org/activityDuration\"\r\n        \"activityFrequency\", \"http://schema.org/activityFrequency\"\r\n        \"actor\", \"http://schema.org/actor\"\r\n        \"actors\", \"http://schema.org/actors\"\r\n        \"addOn\", \"http://schema.org/addOn\"\r\n        \"additionalName\", \"http://schema.org/additionalName\"\r\n        \"additionalNumberOfGuests\", \"http://schema.org/additionalNumberOfGuests\"\r\n        \"additionalProperty\", \"http://schema.org/additionalProperty\"\r\n        \"additionalType\", \"http://schema.org/additionalType\"\r\n        \"additionalVariable\", \"http://schema.org/additionalVariable\"\r\n        \"address\", \"http://schema.org/address\"\r\n        \"addressCountry\", \"http://schema.org/addressCountry\"\r\n        \"addressLocality\", \"http://schema.org/addressLocality\"\r\n        \"addressRegion\", \"http://schema.org/addressRegion\"\r\n        \"administrationRoute\", \"http://schema.org/administrationRoute\"\r\n        \"advanceBookingRequirement\", \"http://schema.org/advanceBookingRequirement\"\r\n        \"adverseOutcome\", \"http://schema.org/adverseOutcome\"\r\n        \"affectedBy\", \"http://schema.org/affectedBy\"\r\n        \"affiliation\", \"http://schema.org/affiliation\"\r\n        \"afterMedia\", \"http://schema.org/afterMedia\"\r\n        \"agent\", \"http://schema.org/agent\"\r\n        \"aggregateRating\", \"http://schema.org/aggregateRating\"\r\n        \"aircraft\", \"http://schema.org/aircraft\"\r\n        \"album\", \"http://schema.org/album\"\r\n        \"albumProductionType\", \"http://schema.org/albumProductionType\"\r\n        \"albumRelease\", \"http://schema.org/albumRelease\"\r\n        \"albumReleaseType\", \"http://schema.org/albumReleaseType\"\r\n        \"albums\", \"http://schema.org/albums\"\r\n        \"alcoholWarning\", \"http://schema.org/alcoholWarning\"\r\n        \"algorithm\", \"http://schema.org/algorithm\"\r\n        \"alignmentType\", \"http://schema.org/alignmentType\"\r\n        \"alternateName\", \"http://schema.org/alternateName\"\r\n        \"alternativeHeadline\", \"http://schema.org/alternativeHeadline\"\r\n        \"alternativeOf\", \"http://schema.org/alternativeOf\"\r\n        \"alumni\", \"http://schema.org/alumni\"\r\n        \"alumniOf\", \"http://schema.org/alumniOf\"\r\n        \"amenityFeature\", \"http://schema.org/amenityFeature\"\r\n        \"amount\", \"http://schema.org/amount\"\r\n        \"amountOfThisGood\", \"http://schema.org/amountOfThisGood\"\r\n        \"announcementLocation\", \"http://schema.org/announcementLocation\"\r\n        \"annualPercentageRate\", \"http://schema.org/annualPercentageRate\"\r\n        \"answerCount\", \"http://schema.org/answerCount\"\r\n        \"answerExplanation\", \"http://schema.org/answerExplanation\"\r\n        \"antagonist\", \"http://schema.org/antagonist\"\r\n        \"appearance\", \"http://schema.org/appearance\"\r\n        \"applicableCountry\", \"http://schema.org/applicableCountry\"\r\n        \"applicableLocation\", \"http://schema.org/applicableLocation\"\r\n        \"applicantLocationRequirements\", \"http://schema.org/applicantLocationRequirements\"\r\n        \"application\", \"http://schema.org/application\"\r\n        \"applicationCategory\", \"http://schema.org/applicationCategory\"\r\n        \"applicationContact\", \"http://schema.org/applicationContact\"\r\n        \"applicationDeadline\", \"http://schema.org/applicationDeadline\"\r\n        \"applicationStartDate\", \"http://schema.org/applicationStartDate\"\r\n        \"applicationSubCategory\", \"http://schema.org/applicationSubCategory\"\r\n        \"applicationSuite\", \"http://schema.org/applicationSuite\"\r\n        \"appliesToDeliveryMethod\", \"http://schema.org/appliesToDeliveryMethod\"\r\n        \"appliesToPaymentMethod\", \"http://schema.org/appliesToPaymentMethod\"\r\n        \"archiveHeld\", \"http://schema.org/archiveHeld\"\r\n        \"archivedAt\", \"http://schema.org/archivedAt\"\r\n        \"area\", \"http://schema.org/area\"\r\n        \"areaServed\", \"http://schema.org/areaServed\"\r\n        \"arrivalAirport\", \"http://schema.org/arrivalAirport\"\r\n        \"arrivalBoatTerminal\", \"http://schema.org/arrivalBoatTerminal\"\r\n        \"arrivalBusStop\", \"http://schema.org/arrivalBusStop\"\r\n        \"arrivalGate\", \"http://schema.org/arrivalGate\"\r\n        \"arrivalPlatform\", \"http://schema.org/arrivalPlatform\"\r\n        \"arrivalStation\", \"http://schema.org/arrivalStation\"\r\n        \"arrivalTerminal\", \"http://schema.org/arrivalTerminal\"\r\n        \"arrivalTime\", \"http://schema.org/arrivalTime\"\r\n        \"artEdition\", \"http://schema.org/artEdition\"\r\n        \"artMedium\", \"http://schema.org/artMedium\"\r\n        \"arterialBranch\", \"http://schema.org/arterialBranch\"\r\n        \"artform\", \"http://schema.org/artform\"\r\n        \"articleBody\", \"http://schema.org/articleBody\"\r\n        \"articleSection\", \"http://schema.org/articleSection\"\r\n        \"artist\", \"http://schema.org/artist\"\r\n        \"artworkSurface\", \"http://schema.org/artworkSurface\"\r\n        \"asin\", \"http://schema.org/asin\"\r\n        \"aspect\", \"http://schema.org/aspect\"\r\n        \"assembly\", \"http://schema.org/assembly\"\r\n        \"assemblyVersion\", \"http://schema.org/assemblyVersion\"\r\n        \"assesses\", \"http://schema.org/assesses\"\r\n        \"associatedAnatomy\", \"http://schema.org/associatedAnatomy\"\r\n        \"associatedArticle\", \"http://schema.org/associatedArticle\"\r\n        \"associatedClaimReview\", \"http://schema.org/associatedClaimReview\"\r\n        \"associatedDisease\", \"http://schema.org/associatedDisease\"\r\n        \"associatedMedia\", \"http://schema.org/associatedMedia\"\r\n        \"associatedMediaReview\", \"http://schema.org/associatedMediaReview\"\r\n        \"associatedPathophysiology\", \"http://schema.org/associatedPathophysiology\"\r\n        \"associatedReview\", \"http://schema.org/associatedReview\"\r\n        \"athlete\", \"http://schema.org/athlete\"\r\n        \"attendee\", \"http://schema.org/attendee\"\r\n        \"attendees\", \"http://schema.org/attendees\"\r\n        \"audience\", \"http://schema.org/audience\"\r\n        \"audienceType\", \"http://schema.org/audienceType\"\r\n        \"audio\", \"http://schema.org/audio\"\r\n        \"authenticator\", \"http://schema.org/authenticator\"\r\n        \"author\", \"http://schema.org/author\"\r\n        \"availability\", \"http://schema.org/availability\"\r\n        \"availabilityEnds\", \"http://schema.org/availabilityEnds\"\r\n        \"availabilityStarts\", \"http://schema.org/availabilityStarts\"\r\n        \"availableAtOrFrom\", \"http://schema.org/availableAtOrFrom\"\r\n        \"availableChannel\", \"http://schema.org/availableChannel\"\r\n        \"availableDeliveryMethod\", \"http://schema.org/availableDeliveryMethod\"\r\n        \"availableFrom\", \"http://schema.org/availableFrom\"\r\n        \"availableIn\", \"http://schema.org/availableIn\"\r\n        \"availableLanguage\", \"http://schema.org/availableLanguage\"\r\n        \"availableOnDevice\", \"http://schema.org/availableOnDevice\"\r\n        \"availableService\", \"http://schema.org/availableService\"\r\n        \"availableStrength\", \"http://schema.org/availableStrength\"\r\n        \"availableTest\", \"http://schema.org/availableTest\"\r\n        \"availableThrough\", \"http://schema.org/availableThrough\"\r\n        \"award\", \"http://schema.org/award\"\r\n        \"awards\", \"http://schema.org/awards\"\r\n        \"awayTeam\", \"http://schema.org/awayTeam\"\r\n        \"backstory\", \"http://schema.org/backstory\"\r\n        \"bankAccountType\", \"http://schema.org/bankAccountType\"\r\n        \"baseSalary\", \"http://schema.org/baseSalary\"\r\n        \"bccRecipient\", \"http://schema.org/bccRecipient\"\r\n        \"bed\", \"http://schema.org/bed\"\r\n        \"beforeMedia\", \"http://schema.org/beforeMedia\"\r\n        \"beneficiaryBank\", \"http://schema.org/beneficiaryBank\"\r\n        \"benefits\", \"http://schema.org/benefits\"\r\n        \"benefitsSummaryUrl\", \"http://schema.org/benefitsSummaryUrl\"\r\n        \"bestRating\", \"http://schema.org/bestRating\"\r\n        \"billingAddress\", \"http://schema.org/billingAddress\"\r\n        \"billingDuration\", \"http://schema.org/billingDuration\"\r\n        \"billingIncrement\", \"http://schema.org/billingIncrement\"\r\n        \"billingPeriod\", \"http://schema.org/billingPeriod\"\r\n        \"billingStart\", \"http://schema.org/billingStart\"\r\n        \"bioChemInteraction\", \"http://schema.org/bioChemInteraction\"\r\n        \"bioChemSimilarity\", \"http://schema.org/bioChemSimilarity\"\r\n        \"biologicalRole\", \"http://schema.org/biologicalRole\"\r\n        \"biomechnicalClass\", \"http://schema.org/biomechnicalClass\"\r\n        \"birthDate\", \"http://schema.org/birthDate\"\r\n        \"birthPlace\", \"http://schema.org/birthPlace\"\r\n        \"bitrate\", \"http://schema.org/bitrate\"\r\n        \"blogPost\", \"http://schema.org/blogPost\"\r\n        \"blogPosts\", \"http://schema.org/blogPosts\"\r\n        \"bloodSupply\", \"http://schema.org/bloodSupply\"\r\n        \"boardingGroup\", \"http://schema.org/boardingGroup\"\r\n        \"boardingPolicy\", \"http://schema.org/boardingPolicy\"\r\n        \"bodyLocation\", \"http://schema.org/bodyLocation\"\r\n        \"bodyType\", \"http://schema.org/bodyType\"\r\n        \"bookEdition\", \"http://schema.org/bookEdition\"\r\n        \"bookFormat\", \"http://schema.org/bookFormat\"\r\n        \"bookingAgent\", \"http://schema.org/bookingAgent\"\r\n        \"bookingTime\", \"http://schema.org/bookingTime\"\r\n        \"borrower\", \"http://schema.org/borrower\"\r\n        \"box\", \"http://schema.org/box\"\r\n        \"branch\", \"http://schema.org/branch\"\r\n        \"branchCode\", \"http://schema.org/branchCode\"\r\n        \"branchOf\", \"http://schema.org/branchOf\"\r\n        \"brand\", \"http://schema.org/brand\"\r\n        \"breadcrumb\", \"http://schema.org/breadcrumb\"\r\n        \"breastfeedingWarning\", \"http://schema.org/breastfeedingWarning\"\r\n        \"broadcastAffiliateOf\", \"http://schema.org/broadcastAffiliateOf\"\r\n        \"broadcastChannelId\", \"http://schema.org/broadcastChannelId\"\r\n        \"broadcastDisplayName\", \"http://schema.org/broadcastDisplayName\"\r\n        \"broadcastFrequency\", \"http://schema.org/broadcastFrequency\"\r\n        \"broadcastFrequencyValue\", \"http://schema.org/broadcastFrequencyValue\"\r\n        \"broadcastOfEvent\", \"http://schema.org/broadcastOfEvent\"\r\n        \"broadcastServiceTier\", \"http://schema.org/broadcastServiceTier\"\r\n        \"broadcastSignalModulation\", \"http://schema.org/broadcastSignalModulation\"\r\n        \"broadcastSubChannel\", \"http://schema.org/broadcastSubChannel\"\r\n        \"broadcastTimezone\", \"http://schema.org/broadcastTimezone\"\r\n        \"broadcaster\", \"http://schema.org/broadcaster\"\r\n        \"broker\", \"http://schema.org/broker\"\r\n        \"browserRequirements\", \"http://schema.org/browserRequirements\"\r\n        \"busName\", \"http://schema.org/busName\"\r\n        \"busNumber\", \"http://schema.org/busNumber\"\r\n        \"businessDays\", \"http://schema.org/businessDays\"\r\n        \"businessFunction\", \"http://schema.org/businessFunction\"\r\n        \"buyer\", \"http://schema.org/buyer\"\r\n        \"byArtist\", \"http://schema.org/byArtist\"\r\n        \"byDay\", \"http://schema.org/byDay\"\r\n        \"byMonth\", \"http://schema.org/byMonth\"\r\n        \"byMonthDay\", \"http://schema.org/byMonthDay\"\r\n        \"byMonthWeek\", \"http://schema.org/byMonthWeek\"\r\n        \"callSign\", \"http://schema.org/callSign\"\r\n        \"calories\", \"http://schema.org/calories\"\r\n        \"candidate\", \"http://schema.org/candidate\"\r\n        \"caption\", \"http://schema.org/caption\"\r\n        \"carbohydrateContent\", \"http://schema.org/carbohydrateContent\"\r\n        \"cargoVolume\", \"http://schema.org/cargoVolume\"\r\n        \"carrier\", \"http://schema.org/carrier\"\r\n        \"carrierRequirements\", \"http://schema.org/carrierRequirements\"\r\n        \"cashBack\", \"http://schema.org/cashBack\"\r\n        \"catalog\", \"http://schema.org/catalog\"\r\n        \"catalogNumber\", \"http://schema.org/catalogNumber\"\r\n        \"category\", \"http://schema.org/category\"\r\n        \"causeOf\", \"http://schema.org/causeOf\"\r\n        \"ccRecipient\", \"http://schema.org/ccRecipient\"\r\n        \"character\", \"http://schema.org/character\"\r\n        \"characterAttribute\", \"http://schema.org/characterAttribute\"\r\n        \"characterName\", \"http://schema.org/characterName\"\r\n        \"cheatCode\", \"http://schema.org/cheatCode\"\r\n        \"checkinTime\", \"http://schema.org/checkinTime\"\r\n        \"checkoutPageURLTemplate\", \"http://schema.org/checkoutPageURLTemplate\"\r\n        \"checkoutTime\", \"http://schema.org/checkoutTime\"\r\n        \"chemicalComposition\", \"http://schema.org/chemicalComposition\"\r\n        \"chemicalRole\", \"http://schema.org/chemicalRole\"\r\n        \"childMaxAge\", \"http://schema.org/childMaxAge\"\r\n        \"childMinAge\", \"http://schema.org/childMinAge\"\r\n        \"childTaxon\", \"http://schema.org/childTaxon\"\r\n        \"children\", \"http://schema.org/children\"\r\n        \"cholesterolContent\", \"http://schema.org/cholesterolContent\"\r\n        \"circle\", \"http://schema.org/circle\"\r\n        \"citation\", \"http://schema.org/citation\"\r\n        \"claimInterpreter\", \"http://schema.org/claimInterpreter\"\r\n        \"claimReviewed\", \"http://schema.org/claimReviewed\"\r\n        \"clincalPharmacology\", \"http://schema.org/clincalPharmacology\"\r\n        \"clinicalPharmacology\", \"http://schema.org/clinicalPharmacology\"\r\n        \"clipNumber\", \"http://schema.org/clipNumber\"\r\n        \"closes\", \"http://schema.org/closes\"\r\n        \"coach\", \"http://schema.org/coach\"\r\n        \"code\", \"http://schema.org/code\"\r\n        \"codeRepository\", \"http://schema.org/codeRepository\"\r\n        \"codeSampleType\", \"http://schema.org/codeSampleType\"\r\n        \"codeValue\", \"http://schema.org/codeValue\"\r\n        \"codingSystem\", \"http://schema.org/codingSystem\"\r\n        \"colleague\", \"http://schema.org/colleague\"\r\n        \"colleagues\", \"http://schema.org/colleagues\"\r\n        \"collection\", \"http://schema.org/collection\"\r\n        \"collectionSize\", \"http://schema.org/collectionSize\"\r\n        \"color\", \"http://schema.org/color\"\r\n        \"colorist\", \"http://schema.org/colorist\"\r\n        \"comment\", \"http://schema.org/comment\"\r\n        \"commentCount\", \"http://schema.org/commentCount\"\r\n        \"commentText\", \"http://schema.org/commentText\"\r\n        \"commentTime\", \"http://schema.org/commentTime\"\r\n        \"competencyRequired\", \"http://schema.org/competencyRequired\"\r\n        \"competitor\", \"http://schema.org/competitor\"\r\n        \"composer\", \"http://schema.org/composer\"\r\n        \"comprisedOf\", \"http://schema.org/comprisedOf\"\r\n        \"conditionsOfAccess\", \"http://schema.org/conditionsOfAccess\"\r\n        \"confirmationNumber\", \"http://schema.org/confirmationNumber\"\r\n        \"connectedTo\", \"http://schema.org/connectedTo\"\r\n        \"constraintProperty\", \"http://schema.org/constraintProperty\"\r\n        \"contactOption\", \"http://schema.org/contactOption\"\r\n        \"contactPoint\", \"http://schema.org/contactPoint\"\r\n        \"contactPoints\", \"http://schema.org/contactPoints\"\r\n        \"contactType\", \"http://schema.org/contactType\"\r\n        \"contactlessPayment\", \"http://schema.org/contactlessPayment\"\r\n        \"containedIn\", \"http://schema.org/containedIn\"\r\n        \"containedInPlace\", \"http://schema.org/containedInPlace\"\r\n        \"containsPlace\", \"http://schema.org/containsPlace\"\r\n        \"containsSeason\", \"http://schema.org/containsSeason\"\r\n        \"contentLocation\", \"http://schema.org/contentLocation\"\r\n        \"contentRating\", \"http://schema.org/contentRating\"\r\n        \"contentReferenceTime\", \"http://schema.org/contentReferenceTime\"\r\n        \"contentSize\", \"http://schema.org/contentSize\"\r\n        \"contentType\", \"http://schema.org/contentType\"\r\n        \"contentUrl\", \"http://schema.org/contentUrl\"\r\n        \"contraindication\", \"http://schema.org/contraindication\"\r\n        \"contributor\", \"http://schema.org/contributor\"\r\n        \"cookTime\", \"http://schema.org/cookTime\"\r\n        \"cookingMethod\", \"http://schema.org/cookingMethod\"\r\n        \"copyrightHolder\", \"http://schema.org/copyrightHolder\"\r\n        \"copyrightNotice\", \"http://schema.org/copyrightNotice\"\r\n        \"copyrightYear\", \"http://schema.org/copyrightYear\"\r\n        \"correction\", \"http://schema.org/correction\"\r\n        \"correctionsPolicy\", \"http://schema.org/correctionsPolicy\"\r\n        \"costCategory\", \"http://schema.org/costCategory\"\r\n        \"costCurrency\", \"http://schema.org/costCurrency\"\r\n        \"costOrigin\", \"http://schema.org/costOrigin\"\r\n        \"costPerUnit\", \"http://schema.org/costPerUnit\"\r\n        \"countriesNotSupported\", \"http://schema.org/countriesNotSupported\"\r\n        \"countriesSupported\", \"http://schema.org/countriesSupported\"\r\n        \"countryOfAssembly\", \"http://schema.org/countryOfAssembly\"\r\n        \"countryOfLastProcessing\", \"http://schema.org/countryOfLastProcessing\"\r\n        \"countryOfOrigin\", \"http://schema.org/countryOfOrigin\"\r\n        \"course\", \"http://schema.org/course\"\r\n        \"courseCode\", \"http://schema.org/courseCode\"\r\n        \"courseMode\", \"http://schema.org/courseMode\"\r\n        \"coursePrerequisites\", \"http://schema.org/coursePrerequisites\"\r\n        \"courseSchedule\", \"http://schema.org/courseSchedule\"\r\n        \"courseWorkload\", \"http://schema.org/courseWorkload\"\r\n        \"coverageEndTime\", \"http://schema.org/coverageEndTime\"\r\n        \"coverageStartTime\", \"http://schema.org/coverageStartTime\"\r\n        \"creativeWorkStatus\", \"http://schema.org/creativeWorkStatus\"\r\n        \"creator\", \"http://schema.org/creator\"\r\n        \"credentialCategory\", \"http://schema.org/credentialCategory\"\r\n        \"creditText\", \"http://schema.org/creditText\"\r\n        \"creditedTo\", \"http://schema.org/creditedTo\"\r\n        \"cssSelector\", \"http://schema.org/cssSelector\"\r\n        \"currenciesAccepted\", \"http://schema.org/currenciesAccepted\"\r\n        \"currency\", \"http://schema.org/currency\"\r\n        \"currentExchangeRate\", \"http://schema.org/currentExchangeRate\"\r\n        \"customer\", \"http://schema.org/customer\"\r\n        \"customerRemorseReturnFees\", \"http://schema.org/customerRemorseReturnFees\"\r\n        \"customerRemorseReturnLabelSource\", \"http://schema.org/customerRemorseReturnLabelSource\"\r\n        \"customerRemorseReturnShippingFeesAmount\", \"http://schema.org/customerRemorseReturnShippingFeesAmount\"\r\n        \"cutoffTime\", \"http://schema.org/cutoffTime\"\r\n        \"cvdCollectionDate\", \"http://schema.org/cvdCollectionDate\"\r\n        \"cvdFacilityCounty\", \"http://schema.org/cvdFacilityCounty\"\r\n        \"cvdFacilityId\", \"http://schema.org/cvdFacilityId\"\r\n        \"cvdNumBeds\", \"http://schema.org/cvdNumBeds\"\r\n        \"cvdNumBedsOcc\", \"http://schema.org/cvdNumBedsOcc\"\r\n        \"cvdNumC19Died\", \"http://schema.org/cvdNumC19Died\"\r\n        \"cvdNumC19HOPats\", \"http://schema.org/cvdNumC19HOPats\"\r\n        \"cvdNumC19HospPats\", \"http://schema.org/cvdNumC19HospPats\"\r\n        \"cvdNumC19MechVentPats\", \"http://schema.org/cvdNumC19MechVentPats\"\r\n        \"cvdNumC19OFMechVentPats\", \"http://schema.org/cvdNumC19OFMechVentPats\"\r\n        \"cvdNumC19OverflowPats\", \"http://schema.org/cvdNumC19OverflowPats\"\r\n        \"cvdNumICUBeds\", \"http://schema.org/cvdNumICUBeds\"\r\n        \"cvdNumICUBedsOcc\", \"http://schema.org/cvdNumICUBedsOcc\"\r\n        \"cvdNumTotBeds\", \"http://schema.org/cvdNumTotBeds\"\r\n        \"cvdNumVent\", \"http://schema.org/cvdNumVent\"\r\n        \"cvdNumVentUse\", \"http://schema.org/cvdNumVentUse\"\r\n        \"dataFeedElement\", \"http://schema.org/dataFeedElement\"\r\n        \"dataset\", \"http://schema.org/dataset\"\r\n        \"datasetTimeInterval\", \"http://schema.org/datasetTimeInterval\"\r\n        \"dateCreated\", \"http://schema.org/dateCreated\"\r\n        \"dateDeleted\", \"http://schema.org/dateDeleted\"\r\n        \"dateIssued\", \"http://schema.org/dateIssued\"\r\n        \"dateModified\", \"http://schema.org/dateModified\"\r\n        \"datePosted\", \"http://schema.org/datePosted\"\r\n        \"datePublished\", \"http://schema.org/datePublished\"\r\n        \"dateRead\", \"http://schema.org/dateRead\"\r\n        \"dateReceived\", \"http://schema.org/dateReceived\"\r\n        \"dateSent\", \"http://schema.org/dateSent\"\r\n        \"dateVehicleFirstRegistered\", \"http://schema.org/dateVehicleFirstRegistered\"\r\n        \"dateline\", \"http://schema.org/dateline\"\r\n        \"dayOfWeek\", \"http://schema.org/dayOfWeek\"\r\n        \"deathDate\", \"http://schema.org/deathDate\"\r\n        \"deathPlace\", \"http://schema.org/deathPlace\"\r\n        \"defaultValue\", \"http://schema.org/defaultValue\"\r\n        \"deliveryAddress\", \"http://schema.org/deliveryAddress\"\r\n        \"deliveryLeadTime\", \"http://schema.org/deliveryLeadTime\"\r\n        \"deliveryMethod\", \"http://schema.org/deliveryMethod\"\r\n        \"deliveryStatus\", \"http://schema.org/deliveryStatus\"\r\n        \"deliveryTime\", \"http://schema.org/deliveryTime\"\r\n        \"department\", \"http://schema.org/department\"\r\n        \"departureAirport\", \"http://schema.org/departureAirport\"\r\n        \"departureBoatTerminal\", \"http://schema.org/departureBoatTerminal\"\r\n        \"departureBusStop\", \"http://schema.org/departureBusStop\"\r\n        \"departureGate\", \"http://schema.org/departureGate\"\r\n        \"departurePlatform\", \"http://schema.org/departurePlatform\"\r\n        \"departureStation\", \"http://schema.org/departureStation\"\r\n        \"departureTerminal\", \"http://schema.org/departureTerminal\"\r\n        \"departureTime\", \"http://schema.org/departureTime\"\r\n        \"dependencies\", \"http://schema.org/dependencies\"\r\n        \"depth\", \"http://schema.org/depth\"\r\n        \"description\", \"http://schema.org/description\"\r\n        \"device\", \"http://schema.org/device\"\r\n        \"diagnosis\", \"http://schema.org/diagnosis\"\r\n        \"diagram\", \"http://schema.org/diagram\"\r\n        \"diet\", \"http://schema.org/diet\"\r\n        \"dietFeatures\", \"http://schema.org/dietFeatures\"\r\n        \"differentialDiagnosis\", \"http://schema.org/differentialDiagnosis\"\r\n        \"directApply\", \"http://schema.org/directApply\"\r\n        \"director\", \"http://schema.org/director\"\r\n        \"directors\", \"http://schema.org/directors\"\r\n        \"disambiguatingDescription\", \"http://schema.org/disambiguatingDescription\"\r\n        \"discount\", \"http://schema.org/discount\"\r\n        \"discountCode\", \"http://schema.org/discountCode\"\r\n        \"discountCurrency\", \"http://schema.org/discountCurrency\"\r\n        \"discusses\", \"http://schema.org/discusses\"\r\n        \"discussionUrl\", \"http://schema.org/discussionUrl\"\r\n        \"diseasePreventionInfo\", \"http://schema.org/diseasePreventionInfo\"\r\n        \"diseaseSpreadStatistics\", \"http://schema.org/diseaseSpreadStatistics\"\r\n        \"dissolutionDate\", \"http://schema.org/dissolutionDate\"\r\n        \"distance\", \"http://schema.org/distance\"\r\n        \"distinguishingSign\", \"http://schema.org/distinguishingSign\"\r\n        \"distribution\", \"http://schema.org/distribution\"\r\n        \"diversityPolicy\", \"http://schema.org/diversityPolicy\"\r\n        \"diversityStaffingReport\", \"http://schema.org/diversityStaffingReport\"\r\n        \"documentation\", \"http://schema.org/documentation\"\r\n        \"doesNotShip\", \"http://schema.org/doesNotShip\"\r\n        \"domainIncludes\", \"http://schema.org/domainIncludes\"\r\n        \"domiciledMortgage\", \"http://schema.org/domiciledMortgage\"\r\n        \"doorTime\", \"http://schema.org/doorTime\"\r\n        \"dosageForm\", \"http://schema.org/dosageForm\"\r\n        \"doseSchedule\", \"http://schema.org/doseSchedule\"\r\n        \"doseUnit\", \"http://schema.org/doseUnit\"\r\n        \"doseValue\", \"http://schema.org/doseValue\"\r\n        \"downPayment\", \"http://schema.org/downPayment\"\r\n        \"downloadUrl\", \"http://schema.org/downloadUrl\"\r\n        \"downvoteCount\", \"http://schema.org/downvoteCount\"\r\n        \"drainsTo\", \"http://schema.org/drainsTo\"\r\n        \"driveWheelConfiguration\", \"http://schema.org/driveWheelConfiguration\"\r\n        \"dropoffLocation\", \"http://schema.org/dropoffLocation\"\r\n        \"dropoffTime\", \"http://schema.org/dropoffTime\"\r\n        \"drug\", \"http://schema.org/drug\"\r\n        \"drugClass\", \"http://schema.org/drugClass\"\r\n        \"drugUnit\", \"http://schema.org/drugUnit\"\r\n        \"duns\", \"http://schema.org/duns\"\r\n        \"duplicateTherapy\", \"http://schema.org/duplicateTherapy\"\r\n        \"duration\", \"http://schema.org/duration\"\r\n        \"durationOfWarranty\", \"http://schema.org/durationOfWarranty\"\r\n        \"duringMedia\", \"http://schema.org/duringMedia\"\r\n        \"earlyPrepaymentPenalty\", \"http://schema.org/earlyPrepaymentPenalty\"\r\n        \"editEIDR\", \"http://schema.org/editEIDR\"\r\n        \"editor\", \"http://schema.org/editor\"\r\n        \"eduQuestionType\", \"http://schema.org/eduQuestionType\"\r\n        \"educationRequirements\", \"http://schema.org/educationRequirements\"\r\n        \"educationalAlignment\", \"http://schema.org/educationalAlignment\"\r\n        \"educationalCredentialAwarded\", \"http://schema.org/educationalCredentialAwarded\"\r\n        \"educationalFramework\", \"http://schema.org/educationalFramework\"\r\n        \"educationalLevel\", \"http://schema.org/educationalLevel\"\r\n        \"educationalProgramMode\", \"http://schema.org/educationalProgramMode\"\r\n        \"educationalRole\", \"http://schema.org/educationalRole\"\r\n        \"educationalUse\", \"http://schema.org/educationalUse\"\r\n        \"elevation\", \"http://schema.org/elevation\"\r\n        \"eligibilityToWorkRequirement\", \"http://schema.org/eligibilityToWorkRequirement\"\r\n        \"eligibleCustomerType\", \"http://schema.org/eligibleCustomerType\"\r\n        \"eligibleDuration\", \"http://schema.org/eligibleDuration\"\r\n        \"eligibleQuantity\", \"http://schema.org/eligibleQuantity\"\r\n        \"eligibleRegion\", \"http://schema.org/eligibleRegion\"\r\n        \"eligibleTransactionVolume\", \"http://schema.org/eligibleTransactionVolume\"\r\n        \"email\", \"http://schema.org/email\"\r\n        \"embedUrl\", \"http://schema.org/embedUrl\"\r\n        \"embeddedTextCaption\", \"http://schema.org/embeddedTextCaption\"\r\n        \"emissionsCO2\", \"http://schema.org/emissionsCO2\"\r\n        \"employee\", \"http://schema.org/employee\"\r\n        \"employees\", \"http://schema.org/employees\"\r\n        \"employerOverview\", \"http://schema.org/employerOverview\"\r\n        \"employmentType\", \"http://schema.org/employmentType\"\r\n        \"employmentUnit\", \"http://schema.org/employmentUnit\"\r\n        \"encodesBioChemEntity\", \"http://schema.org/encodesBioChemEntity\"\r\n        \"encodesCreativeWork\", \"http://schema.org/encodesCreativeWork\"\r\n        \"encoding\", \"http://schema.org/encoding\"\r\n        \"encodingFormat\", \"http://schema.org/encodingFormat\"\r\n        \"encodingType\", \"http://schema.org/encodingType\"\r\n        \"encodings\", \"http://schema.org/encodings\"\r\n        \"endDate\", \"http://schema.org/endDate\"\r\n        \"endOffset\", \"http://schema.org/endOffset\"\r\n        \"endTime\", \"http://schema.org/endTime\"\r\n        \"endorsee\", \"http://schema.org/endorsee\"\r\n        \"endorsers\", \"http://schema.org/endorsers\"\r\n        \"energyEfficiencyScaleMax\", \"http://schema.org/energyEfficiencyScaleMax\"\r\n        \"energyEfficiencyScaleMin\", \"http://schema.org/energyEfficiencyScaleMin\"\r\n        \"engineDisplacement\", \"http://schema.org/engineDisplacement\"\r\n        \"enginePower\", \"http://schema.org/enginePower\"\r\n        \"engineType\", \"http://schema.org/engineType\"\r\n        \"entertainmentBusiness\", \"http://schema.org/entertainmentBusiness\"\r\n        \"epidemiology\", \"http://schema.org/epidemiology\"\r\n        \"episode\", \"http://schema.org/episode\"\r\n        \"episodeNumber\", \"http://schema.org/episodeNumber\"\r\n        \"episodes\", \"http://schema.org/episodes\"\r\n        \"equal\", \"http://schema.org/equal\"\r\n        \"error\", \"http://schema.org/error\"\r\n        \"estimatedCost\", \"http://schema.org/estimatedCost\"\r\n        \"estimatedFlightDuration\", \"http://schema.org/estimatedFlightDuration\"\r\n        \"estimatedSalary\", \"http://schema.org/estimatedSalary\"\r\n        \"estimatesRiskOf\", \"http://schema.org/estimatesRiskOf\"\r\n        \"ethicsPolicy\", \"http://schema.org/ethicsPolicy\"\r\n        \"event\", \"http://schema.org/event\"\r\n        \"eventAttendanceMode\", \"http://schema.org/eventAttendanceMode\"\r\n        \"eventSchedule\", \"http://schema.org/eventSchedule\"\r\n        \"eventStatus\", \"http://schema.org/eventStatus\"\r\n        \"events\", \"http://schema.org/events\"\r\n        \"evidenceLevel\", \"http://schema.org/evidenceLevel\"\r\n        \"evidenceOrigin\", \"http://schema.org/evidenceOrigin\"\r\n        \"exampleOfWork\", \"http://schema.org/exampleOfWork\"\r\n        \"exceptDate\", \"http://schema.org/exceptDate\"\r\n        \"exchangeRateSpread\", \"http://schema.org/exchangeRateSpread\"\r\n        \"executableLibraryName\", \"http://schema.org/executableLibraryName\"\r\n        \"exerciseCourse\", \"http://schema.org/exerciseCourse\"\r\n        \"exercisePlan\", \"http://schema.org/exercisePlan\"\r\n        \"exerciseRelatedDiet\", \"http://schema.org/exerciseRelatedDiet\"\r\n        \"exerciseType\", \"http://schema.org/exerciseType\"\r\n        \"exifData\", \"http://schema.org/exifData\"\r\n        \"expectedArrivalFrom\", \"http://schema.org/expectedArrivalFrom\"\r\n        \"expectedArrivalUntil\", \"http://schema.org/expectedArrivalUntil\"\r\n        \"expectedPrognosis\", \"http://schema.org/expectedPrognosis\"\r\n        \"expectsAcceptanceOf\", \"http://schema.org/expectsAcceptanceOf\"\r\n        \"experienceInPlaceOfEducation\", \"http://schema.org/experienceInPlaceOfEducation\"\r\n        \"experienceRequirements\", \"http://schema.org/experienceRequirements\"\r\n        \"expertConsiderations\", \"http://schema.org/expertConsiderations\"\r\n        \"expires\", \"http://schema.org/expires\"\r\n        \"expressedIn\", \"http://schema.org/expressedIn\"\r\n        \"familyName\", \"http://schema.org/familyName\"\r\n        \"fatContent\", \"http://schema.org/fatContent\"\r\n        \"faxNumber\", \"http://schema.org/faxNumber\"\r\n        \"featureList\", \"http://schema.org/featureList\"\r\n        \"feesAndCommissionsSpecification\", \"http://schema.org/feesAndCommissionsSpecification\"\r\n        \"fiberContent\", \"http://schema.org/fiberContent\"\r\n        \"fileFormat\", \"http://schema.org/fileFormat\"\r\n        \"fileSize\", \"http://schema.org/fileSize\"\r\n        \"financialAidEligible\", \"http://schema.org/financialAidEligible\"\r\n        \"firstAppearance\", \"http://schema.org/firstAppearance\"\r\n        \"firstPerformance\", \"http://schema.org/firstPerformance\"\r\n        \"flightDistance\", \"http://schema.org/flightDistance\"\r\n        \"flightNumber\", \"http://schema.org/flightNumber\"\r\n        \"floorLevel\", \"http://schema.org/floorLevel\"\r\n        \"floorLimit\", \"http://schema.org/floorLimit\"\r\n        \"floorSize\", \"http://schema.org/floorSize\"\r\n        \"followee\", \"http://schema.org/followee\"\r\n        \"follows\", \"http://schema.org/follows\"\r\n        \"followup\", \"http://schema.org/followup\"\r\n        \"foodEstablishment\", \"http://schema.org/foodEstablishment\"\r\n        \"foodEvent\", \"http://schema.org/foodEvent\"\r\n        \"foodWarning\", \"http://schema.org/foodWarning\"\r\n        \"founder\", \"http://schema.org/founder\"\r\n        \"founders\", \"http://schema.org/founders\"\r\n        \"foundingDate\", \"http://schema.org/foundingDate\"\r\n        \"foundingLocation\", \"http://schema.org/foundingLocation\"\r\n        \"free\", \"http://schema.org/free\"\r\n        \"freeShippingThreshold\", \"http://schema.org/freeShippingThreshold\"\r\n        \"frequency\", \"http://schema.org/frequency\"\r\n        \"fromLocation\", \"http://schema.org/fromLocation\"\r\n        \"fuelCapacity\", \"http://schema.org/fuelCapacity\"\r\n        \"fuelConsumption\", \"http://schema.org/fuelConsumption\"\r\n        \"fuelEfficiency\", \"http://schema.org/fuelEfficiency\"\r\n        \"fuelType\", \"http://schema.org/fuelType\"\r\n        \"functionalClass\", \"http://schema.org/functionalClass\"\r\n        \"fundedItem\", \"http://schema.org/fundedItem\"\r\n        \"funder\", \"http://schema.org/funder\"\r\n        \"funding\", \"http://schema.org/funding\"\r\n        \"game\", \"http://schema.org/game\"\r\n        \"gameAvailabilityType\", \"http://schema.org/gameAvailabilityType\"\r\n        \"gameEdition\", \"http://schema.org/gameEdition\"\r\n        \"gameItem\", \"http://schema.org/gameItem\"\r\n        \"gameLocation\", \"http://schema.org/gameLocation\"\r\n        \"gamePlatform\", \"http://schema.org/gamePlatform\"\r\n        \"gameServer\", \"http://schema.org/gameServer\"\r\n        \"gameTip\", \"http://schema.org/gameTip\"\r\n        \"gender\", \"http://schema.org/gender\"\r\n        \"genre\", \"http://schema.org/genre\"\r\n        \"geo\", \"http://schema.org/geo\"\r\n        \"geoContains\", \"http://schema.org/geoContains\"\r\n        \"geoCoveredBy\", \"http://schema.org/geoCoveredBy\"\r\n        \"geoCovers\", \"http://schema.org/geoCovers\"\r\n        \"geoCrosses\", \"http://schema.org/geoCrosses\"\r\n        \"geoDisjoint\", \"http://schema.org/geoDisjoint\"\r\n        \"geoEquals\", \"http://schema.org/geoEquals\"\r\n        \"geoIntersects\", \"http://schema.org/geoIntersects\"\r\n        \"geoMidpoint\", \"http://schema.org/geoMidpoint\"\r\n        \"geoOverlaps\", \"http://schema.org/geoOverlaps\"\r\n        \"geoRadius\", \"http://schema.org/geoRadius\"\r\n        \"geoTouches\", \"http://schema.org/geoTouches\"\r\n        \"geoWithin\", \"http://schema.org/geoWithin\"\r\n        \"geographicArea\", \"http://schema.org/geographicArea\"\r\n        \"gettingTestedInfo\", \"http://schema.org/gettingTestedInfo\"\r\n        \"givenName\", \"http://schema.org/givenName\"\r\n        \"globalLocationNumber\", \"http://schema.org/globalLocationNumber\"\r\n        \"governmentBenefitsInfo\", \"http://schema.org/governmentBenefitsInfo\"\r\n        \"gracePeriod\", \"http://schema.org/gracePeriod\"\r\n        \"grantee\", \"http://schema.org/grantee\"\r\n        \"greater\", \"http://schema.org/greater\"\r\n        \"greaterOrEqual\", \"http://schema.org/greaterOrEqual\"\r\n        \"gtin\", \"http://schema.org/gtin\"\r\n        \"gtin12\", \"http://schema.org/gtin12\"\r\n        \"gtin13\", \"http://schema.org/gtin13\"\r\n        \"gtin14\", \"http://schema.org/gtin14\"\r\n        \"gtin8\", \"http://schema.org/gtin8\"\r\n        \"guideline\", \"http://schema.org/guideline\"\r\n        \"guidelineDate\", \"http://schema.org/guidelineDate\"\r\n        \"guidelineSubject\", \"http://schema.org/guidelineSubject\"\r\n        \"handlingTime\", \"http://schema.org/handlingTime\"\r\n        \"hasAdultConsideration\", \"http://schema.org/hasAdultConsideration\"\r\n        \"hasBioChemEntityPart\", \"http://schema.org/hasBioChemEntityPart\"\r\n        \"hasBioPolymerSequence\", \"http://schema.org/hasBioPolymerSequence\"\r\n        \"hasBroadcastChannel\", \"http://schema.org/hasBroadcastChannel\"\r\n        \"hasCategoryCode\", \"http://schema.org/hasCategoryCode\"\r\n        \"hasCourse\", \"http://schema.org/hasCourse\"\r\n        \"hasCourseInstance\", \"http://schema.org/hasCourseInstance\"\r\n        \"hasCredential\", \"http://schema.org/hasCredential\"\r\n        \"hasDefinedTerm\", \"http://schema.org/hasDefinedTerm\"\r\n        \"hasDeliveryMethod\", \"http://schema.org/hasDeliveryMethod\"\r\n        \"hasDigitalDocumentPermission\", \"http://schema.org/hasDigitalDocumentPermission\"\r\n        \"hasDriveThroughService\", \"http://schema.org/hasDriveThroughService\"\r\n        \"hasEnergyConsumptionDetails\", \"http://schema.org/hasEnergyConsumptionDetails\"\r\n        \"hasEnergyEfficiencyCategory\", \"http://schema.org/hasEnergyEfficiencyCategory\"\r\n        \"hasHealthAspect\", \"http://schema.org/hasHealthAspect\"\r\n        \"hasMap\", \"http://schema.org/hasMap\"\r\n        \"hasMeasurement\", \"http://schema.org/hasMeasurement\"\r\n        \"hasMenu\", \"http://schema.org/hasMenu\"\r\n        \"hasMenuItem\", \"http://schema.org/hasMenuItem\"\r\n        \"hasMenuSection\", \"http://schema.org/hasMenuSection\"\r\n        \"hasMerchantReturnPolicy\", \"http://schema.org/hasMerchantReturnPolicy\"\r\n        \"hasMolecularFunction\", \"http://schema.org/hasMolecularFunction\"\r\n        \"hasOccupation\", \"http://schema.org/hasOccupation\"\r\n        \"hasOfferCatalog\", \"http://schema.org/hasOfferCatalog\"\r\n        \"hasPOS\", \"http://schema.org/hasPOS\"\r\n        \"hasPart\", \"http://schema.org/hasPart\"\r\n        \"hasProductReturnPolicy\", \"http://schema.org/hasProductReturnPolicy\"\r\n        \"hasRepresentation\", \"http://schema.org/hasRepresentation\"\r\n        \"hasVariant\", \"http://schema.org/hasVariant\"\r\n        \"headline\", \"http://schema.org/headline\"\r\n        \"healthCondition\", \"http://schema.org/healthCondition\"\r\n        \"healthPlanCoinsuranceOption\", \"http://schema.org/healthPlanCoinsuranceOption\"\r\n        \"healthPlanCoinsuranceRate\", \"http://schema.org/healthPlanCoinsuranceRate\"\r\n        \"healthPlanCopay\", \"http://schema.org/healthPlanCopay\"\r\n        \"healthPlanCopayOption\", \"http://schema.org/healthPlanCopayOption\"\r\n        \"healthPlanCostSharing\", \"http://schema.org/healthPlanCostSharing\"\r\n        \"healthPlanDrugOption\", \"http://schema.org/healthPlanDrugOption\"\r\n        \"healthPlanDrugTier\", \"http://schema.org/healthPlanDrugTier\"\r\n        \"healthPlanId\", \"http://schema.org/healthPlanId\"\r\n        \"healthPlanMarketingUrl\", \"http://schema.org/healthPlanMarketingUrl\"\r\n        \"healthPlanNetworkId\", \"http://schema.org/healthPlanNetworkId\"\r\n        \"healthPlanNetworkTier\", \"http://schema.org/healthPlanNetworkTier\"\r\n        \"healthPlanPharmacyCategory\", \"http://schema.org/healthPlanPharmacyCategory\"\r\n        \"healthcareReportingData\", \"http://schema.org/healthcareReportingData\"\r\n        \"height\", \"http://schema.org/height\"\r\n        \"highPrice\", \"http://schema.org/highPrice\"\r\n        \"hiringOrganization\", \"http://schema.org/hiringOrganization\"\r\n        \"holdingArchive\", \"http://schema.org/holdingArchive\"\r\n        \"homeLocation\", \"http://schema.org/homeLocation\"\r\n        \"homeTeam\", \"http://schema.org/homeTeam\"\r\n        \"honorificPrefix\", \"http://schema.org/honorificPrefix\"\r\n        \"honorificSuffix\", \"http://schema.org/honorificSuffix\"\r\n        \"hospitalAffiliation\", \"http://schema.org/hospitalAffiliation\"\r\n        \"hostingOrganization\", \"http://schema.org/hostingOrganization\"\r\n        \"hoursAvailable\", \"http://schema.org/hoursAvailable\"\r\n        \"howPerformed\", \"http://schema.org/howPerformed\"\r\n        \"httpMethod\", \"http://schema.org/httpMethod\"\r\n        \"iataCode\", \"http://schema.org/iataCode\"\r\n        \"icaoCode\", \"http://schema.org/icaoCode\"\r\n        \"identifier\", \"http://schema.org/identifier\"\r\n        \"identifyingExam\", \"http://schema.org/identifyingExam\"\r\n        \"identifyingTest\", \"http://schema.org/identifyingTest\"\r\n        \"illustrator\", \"http://schema.org/illustrator\"\r\n        \"image\", \"http://schema.org/image\"\r\n        \"imagingTechnique\", \"http://schema.org/imagingTechnique\"\r\n        \"inAlbum\", \"http://schema.org/inAlbum\"\r\n        \"inBroadcastLineup\", \"http://schema.org/inBroadcastLineup\"\r\n        \"inChI\", \"http://schema.org/inChI\"\r\n        \"inChIKey\", \"http://schema.org/inChIKey\"\r\n        \"inCodeSet\", \"http://schema.org/inCodeSet\"\r\n        \"inDefinedTermSet\", \"http://schema.org/inDefinedTermSet\"\r\n        \"inLanguage\", \"http://schema.org/inLanguage\"\r\n        \"inPlaylist\", \"http://schema.org/inPlaylist\"\r\n        \"inProductGroupWithID\", \"http://schema.org/inProductGroupWithID\"\r\n        \"inStoreReturnsOffered\", \"http://schema.org/inStoreReturnsOffered\"\r\n        \"inSupportOf\", \"http://schema.org/inSupportOf\"\r\n        \"incentiveCompensation\", \"http://schema.org/incentiveCompensation\"\r\n        \"incentives\", \"http://schema.org/incentives\"\r\n        \"includedComposition\", \"http://schema.org/includedComposition\"\r\n        \"includedDataCatalog\", \"http://schema.org/includedDataCatalog\"\r\n        \"includedInDataCatalog\", \"http://schema.org/includedInDataCatalog\"\r\n        \"includedInHealthInsurancePlan\", \"http://schema.org/includedInHealthInsurancePlan\"\r\n        \"includedRiskFactor\", \"http://schema.org/includedRiskFactor\"\r\n        \"includesAttraction\", \"http://schema.org/includesAttraction\"\r\n        \"includesHealthPlanFormulary\", \"http://schema.org/includesHealthPlanFormulary\"\r\n        \"includesHealthPlanNetwork\", \"http://schema.org/includesHealthPlanNetwork\"\r\n        \"includesObject\", \"http://schema.org/includesObject\"\r\n        \"increasesRiskOf\", \"http://schema.org/increasesRiskOf\"\r\n        \"industry\", \"http://schema.org/industry\"\r\n        \"ineligibleRegion\", \"http://schema.org/ineligibleRegion\"\r\n        \"infectiousAgent\", \"http://schema.org/infectiousAgent\"\r\n        \"infectiousAgentClass\", \"http://schema.org/infectiousAgentClass\"\r\n        \"ingredients\", \"http://schema.org/ingredients\"\r\n        \"inker\", \"http://schema.org/inker\"\r\n        \"insertion\", \"http://schema.org/insertion\"\r\n        \"installUrl\", \"http://schema.org/installUrl\"\r\n        \"instructor\", \"http://schema.org/instructor\"\r\n        \"instrument\", \"http://schema.org/instrument\"\r\n        \"intensity\", \"http://schema.org/intensity\"\r\n        \"interactingDrug\", \"http://schema.org/interactingDrug\"\r\n        \"interactionCount\", \"http://schema.org/interactionCount\"\r\n        \"interactionService\", \"http://schema.org/interactionService\"\r\n        \"interactionStatistic\", \"http://schema.org/interactionStatistic\"\r\n        \"interactionType\", \"http://schema.org/interactionType\"\r\n        \"interactivityType\", \"http://schema.org/interactivityType\"\r\n        \"interestRate\", \"http://schema.org/interestRate\"\r\n        \"interpretedAsClaim\", \"http://schema.org/interpretedAsClaim\"\r\n        \"inventoryLevel\", \"http://schema.org/inventoryLevel\"\r\n        \"inverseOf\", \"http://schema.org/inverseOf\"\r\n        \"isAcceptingNewPatients\", \"http://schema.org/isAcceptingNewPatients\"\r\n        \"isAccessibleForFree\", \"http://schema.org/isAccessibleForFree\"\r\n        \"isAccessoryOrSparePartFor\", \"http://schema.org/isAccessoryOrSparePartFor\"\r\n        \"isAvailableGenerically\", \"http://schema.org/isAvailableGenerically\"\r\n        \"isBasedOn\", \"http://schema.org/isBasedOn\"\r\n        \"isBasedOnUrl\", \"http://schema.org/isBasedOnUrl\"\r\n        \"isConsumableFor\", \"http://schema.org/isConsumableFor\"\r\n        \"isEncodedByBioChemEntity\", \"http://schema.org/isEncodedByBioChemEntity\"\r\n        \"isFamilyFriendly\", \"http://schema.org/isFamilyFriendly\"\r\n        \"isGift\", \"http://schema.org/isGift\"\r\n        \"isInvolvedInBiologicalProcess\", \"http://schema.org/isInvolvedInBiologicalProcess\"\r\n        \"isLiveBroadcast\", \"http://schema.org/isLiveBroadcast\"\r\n        \"isLocatedInSubcellularLocation\", \"http://schema.org/isLocatedInSubcellularLocation\"\r\n        \"isPartOf\", \"http://schema.org/isPartOf\"\r\n        \"isPartOfBioChemEntity\", \"http://schema.org/isPartOfBioChemEntity\"\r\n        \"isPlanForApartment\", \"http://schema.org/isPlanForApartment\"\r\n        \"isProprietary\", \"http://schema.org/isProprietary\"\r\n        \"isRelatedTo\", \"http://schema.org/isRelatedTo\"\r\n        \"isResizable\", \"http://schema.org/isResizable\"\r\n        \"isSimilarTo\", \"http://schema.org/isSimilarTo\"\r\n        \"isUnlabelledFallback\", \"http://schema.org/isUnlabelledFallback\"\r\n        \"isVariantOf\", \"http://schema.org/isVariantOf\"\r\n        \"isbn\", \"http://schema.org/isbn\"\r\n        \"isicV4\", \"http://schema.org/isicV4\"\r\n        \"iso6523Code\", \"http://schema.org/iso6523Code\"\r\n        \"isrcCode\", \"http://schema.org/isrcCode\"\r\n        \"issn\", \"http://schema.org/issn\"\r\n        \"issueNumber\", \"http://schema.org/issueNumber\"\r\n        \"issuedBy\", \"http://schema.org/issuedBy\"\r\n        \"issuedThrough\", \"http://schema.org/issuedThrough\"\r\n        \"iswcCode\", \"http://schema.org/iswcCode\"\r\n        \"item\", \"http://schema.org/item\"\r\n        \"itemCondition\", \"http://schema.org/itemCondition\"\r\n        \"itemDefectReturnFees\", \"http://schema.org/itemDefectReturnFees\"\r\n        \"itemDefectReturnLabelSource\", \"http://schema.org/itemDefectReturnLabelSource\"\r\n        \"itemDefectReturnShippingFeesAmount\", \"http://schema.org/itemDefectReturnShippingFeesAmount\"\r\n        \"itemListElement\", \"http://schema.org/itemListElement\"\r\n        \"itemListOrder\", \"http://schema.org/itemListOrder\"\r\n        \"itemLocation\", \"http://schema.org/itemLocation\"\r\n        \"itemOffered\", \"http://schema.org/itemOffered\"\r\n        \"itemReviewed\", \"http://schema.org/itemReviewed\"\r\n        \"itemShipped\", \"http://schema.org/itemShipped\"\r\n        \"itinerary\", \"http://schema.org/itinerary\"\r\n        \"iupacName\", \"http://schema.org/iupacName\"\r\n        \"jobBenefits\", \"http://schema.org/jobBenefits\"\r\n        \"jobImmediateStart\", \"http://schema.org/jobImmediateStart\"\r\n        \"jobLocation\", \"http://schema.org/jobLocation\"\r\n        \"jobLocationType\", \"http://schema.org/jobLocationType\"\r\n        \"jobStartDate\", \"http://schema.org/jobStartDate\"\r\n        \"jobTitle\", \"http://schema.org/jobTitle\"\r\n        \"jurisdiction\", \"http://schema.org/jurisdiction\"\r\n        \"keywords\", \"http://schema.org/keywords\"\r\n        \"knownVehicleDamages\", \"http://schema.org/knownVehicleDamages\"\r\n        \"knows\", \"http://schema.org/knows\"\r\n        \"knowsAbout\", \"http://schema.org/knowsAbout\"\r\n        \"knowsLanguage\", \"http://schema.org/knowsLanguage\"\r\n        \"labelDetails\", \"http://schema.org/labelDetails\"\r\n        \"landlord\", \"http://schema.org/landlord\"\r\n        \"language\", \"http://schema.org/language\"\r\n        \"lastReviewed\", \"http://schema.org/lastReviewed\"\r\n        \"latitude\", \"http://schema.org/latitude\"\r\n        \"layoutImage\", \"http://schema.org/layoutImage\"\r\n        \"learningResourceType\", \"http://schema.org/learningResourceType\"\r\n        \"leaseLength\", \"http://schema.org/leaseLength\"\r\n        \"legalName\", \"http://schema.org/legalName\"\r\n        \"legalStatus\", \"http://schema.org/legalStatus\"\r\n        \"legislationApplies\", \"http://schema.org/legislationApplies\"\r\n        \"legislationChanges\", \"http://schema.org/legislationChanges\"\r\n        \"legislationConsolidates\", \"http://schema.org/legislationConsolidates\"\r\n        \"legislationDate\", \"http://schema.org/legislationDate\"\r\n        \"legislationDateVersion\", \"http://schema.org/legislationDateVersion\"\r\n        \"legislationIdentifier\", \"http://schema.org/legislationIdentifier\"\r\n        \"legislationJurisdiction\", \"http://schema.org/legislationJurisdiction\"\r\n        \"legislationLegalForce\", \"http://schema.org/legislationLegalForce\"\r\n        \"legislationLegalValue\", \"http://schema.org/legislationLegalValue\"\r\n        \"legislationPassedBy\", \"http://schema.org/legislationPassedBy\"\r\n        \"legislationResponsible\", \"http://schema.org/legislationResponsible\"\r\n        \"legislationTransposes\", \"http://schema.org/legislationTransposes\"\r\n        \"legislationType\", \"http://schema.org/legislationType\"\r\n        \"leiCode\", \"http://schema.org/leiCode\"\r\n        \"lender\", \"http://schema.org/lender\"\r\n        \"lesser\", \"http://schema.org/lesser\"\r\n        \"lesserOrEqual\", \"http://schema.org/lesserOrEqual\"\r\n        \"letterer\", \"http://schema.org/letterer\"\r\n        \"license\", \"http://schema.org/license\"\r\n        \"line\", \"http://schema.org/line\"\r\n        \"linkRelationship\", \"http://schema.org/linkRelationship\"\r\n        \"liveBlogUpdate\", \"http://schema.org/liveBlogUpdate\"\r\n        \"loanMortgageMandateAmount\", \"http://schema.org/loanMortgageMandateAmount\"\r\n        \"loanPaymentAmount\", \"http://schema.org/loanPaymentAmount\"\r\n        \"loanPaymentFrequency\", \"http://schema.org/loanPaymentFrequency\"\r\n        \"loanRepaymentForm\", \"http://schema.org/loanRepaymentForm\"\r\n        \"loanTerm\", \"http://schema.org/loanTerm\"\r\n        \"loanType\", \"http://schema.org/loanType\"\r\n        \"location\", \"http://schema.org/location\"\r\n        \"locationCreated\", \"http://schema.org/locationCreated\"\r\n        \"lodgingUnitDescription\", \"http://schema.org/lodgingUnitDescription\"\r\n        \"lodgingUnitType\", \"http://schema.org/lodgingUnitType\"\r\n        \"logo\", \"http://schema.org/logo\"\r\n        \"longitude\", \"http://schema.org/longitude\"\r\n        \"loser\", \"http://schema.org/loser\"\r\n        \"lowPrice\", \"http://schema.org/lowPrice\"\r\n        \"lyricist\", \"http://schema.org/lyricist\"\r\n        \"lyrics\", \"http://schema.org/lyrics\"\r\n        \"mainContentOfPage\", \"http://schema.org/mainContentOfPage\"\r\n        \"mainEntity\", \"http://schema.org/mainEntity\"\r\n        \"mainEntityOfPage\", \"http://schema.org/mainEntityOfPage\"\r\n        \"maintainer\", \"http://schema.org/maintainer\"\r\n        \"makesOffer\", \"http://schema.org/makesOffer\"\r\n        \"manufacturer\", \"http://schema.org/manufacturer\"\r\n        \"map\", \"http://schema.org/map\"\r\n        \"mapType\", \"http://schema.org/mapType\"\r\n        \"maps\", \"http://schema.org/maps\"\r\n        \"marginOfError\", \"http://schema.org/marginOfError\"\r\n        \"masthead\", \"http://schema.org/masthead\"\r\n        \"material\", \"http://schema.org/material\"\r\n        \"materialExtent\", \"http://schema.org/materialExtent\"\r\n        \"mathExpression\", \"http://schema.org/mathExpression\"\r\n        \"maxPrice\", \"http://schema.org/maxPrice\"\r\n        \"maxValue\", \"http://schema.org/maxValue\"\r\n        \"maximumAttendeeCapacity\", \"http://schema.org/maximumAttendeeCapacity\"\r\n        \"maximumEnrollment\", \"http://schema.org/maximumEnrollment\"\r\n        \"maximumIntake\", \"http://schema.org/maximumIntake\"\r\n        \"maximumPhysicalAttendeeCapacity\", \"http://schema.org/maximumPhysicalAttendeeCapacity\"\r\n        \"maximumVirtualAttendeeCapacity\", \"http://schema.org/maximumVirtualAttendeeCapacity\"\r\n        \"mealService\", \"http://schema.org/mealService\"\r\n        \"measuredProperty\", \"http://schema.org/measuredProperty\"\r\n        \"measurementDenominator\", \"http://schema.org/measurementDenominator\"\r\n        \"measurementMethod\", \"http://schema.org/measurementMethod\"\r\n        \"measurementQualifier\", \"http://schema.org/measurementQualifier\"\r\n        \"measurementTechnique\", \"http://schema.org/measurementTechnique\"\r\n        \"mechanismOfAction\", \"http://schema.org/mechanismOfAction\"\r\n        \"mediaAuthenticityCategory\", \"http://schema.org/mediaAuthenticityCategory\"\r\n        \"mediaItemAppearance\", \"http://schema.org/mediaItemAppearance\"\r\n        \"median\", \"http://schema.org/median\"\r\n        \"medicalAudience\", \"http://schema.org/medicalAudience\"\r\n        \"medicalSpecialty\", \"http://schema.org/medicalSpecialty\"\r\n        \"medicineSystem\", \"http://schema.org/medicineSystem\"\r\n        \"meetsEmissionStandard\", \"http://schema.org/meetsEmissionStandard\"\r\n        \"member\", \"http://schema.org/member\"\r\n        \"memberOf\", \"http://schema.org/memberOf\"\r\n        \"members\", \"http://schema.org/members\"\r\n        \"membershipNumber\", \"http://schema.org/membershipNumber\"\r\n        \"membershipPointsEarned\", \"http://schema.org/membershipPointsEarned\"\r\n        \"memoryRequirements\", \"http://schema.org/memoryRequirements\"\r\n        \"mentions\", \"http://schema.org/mentions\"\r\n        \"menu\", \"http://schema.org/menu\"\r\n        \"menuAddOn\", \"http://schema.org/menuAddOn\"\r\n        \"merchant\", \"http://schema.org/merchant\"\r\n        \"merchantReturnDays\", \"http://schema.org/merchantReturnDays\"\r\n        \"merchantReturnLink\", \"http://schema.org/merchantReturnLink\"\r\n        \"messageAttachment\", \"http://schema.org/messageAttachment\"\r\n        \"mileageFromOdometer\", \"http://schema.org/mileageFromOdometer\"\r\n        \"minPrice\", \"http://schema.org/minPrice\"\r\n        \"minValue\", \"http://schema.org/minValue\"\r\n        \"minimumPaymentDue\", \"http://schema.org/minimumPaymentDue\"\r\n        \"missionCoveragePrioritiesPolicy\", \"http://schema.org/missionCoveragePrioritiesPolicy\"\r\n        \"mobileUrl\", \"http://schema.org/mobileUrl\"\r\n        \"model\", \"http://schema.org/model\"\r\n        \"modelDate\", \"http://schema.org/modelDate\"\r\n        \"modifiedTime\", \"http://schema.org/modifiedTime\"\r\n        \"molecularFormula\", \"http://schema.org/molecularFormula\"\r\n        \"molecularWeight\", \"http://schema.org/molecularWeight\"\r\n        \"monoisotopicMolecularWeight\", \"http://schema.org/monoisotopicMolecularWeight\"\r\n        \"monthlyMinimumRepaymentAmount\", \"http://schema.org/monthlyMinimumRepaymentAmount\"\r\n        \"monthsOfExperience\", \"http://schema.org/monthsOfExperience\"\r\n        \"mpn\", \"http://schema.org/mpn\"\r\n        \"multipleValues\", \"http://schema.org/multipleValues\"\r\n        \"muscleAction\", \"http://schema.org/muscleAction\"\r\n        \"musicArrangement\", \"http://schema.org/musicArrangement\"\r\n        \"musicBy\", \"http://schema.org/musicBy\"\r\n        \"musicCompositionForm\", \"http://schema.org/musicCompositionForm\"\r\n        \"musicGroupMember\", \"http://schema.org/musicGroupMember\"\r\n        \"musicReleaseFormat\", \"http://schema.org/musicReleaseFormat\"\r\n        \"musicalKey\", \"http://schema.org/musicalKey\"\r\n        \"naics\", \"http://schema.org/naics\"\r\n        \"name\", \"http://schema.org/name\"\r\n        \"namedPosition\", \"http://schema.org/namedPosition\"\r\n        \"nationality\", \"http://schema.org/nationality\"\r\n        \"naturalProgression\", \"http://schema.org/naturalProgression\"\r\n        \"negativeNotes\", \"http://schema.org/negativeNotes\"\r\n        \"nerve\", \"http://schema.org/nerve\"\r\n        \"nerveMotor\", \"http://schema.org/nerveMotor\"\r\n        \"netWorth\", \"http://schema.org/netWorth\"\r\n        \"newsUpdatesAndGuidelines\", \"http://schema.org/newsUpdatesAndGuidelines\"\r\n        \"nextItem\", \"http://schema.org/nextItem\"\r\n        \"noBylinesPolicy\", \"http://schema.org/noBylinesPolicy\"\r\n        \"nonEqual\", \"http://schema.org/nonEqual\"\r\n        \"nonProprietaryName\", \"http://schema.org/nonProprietaryName\"\r\n        \"nonprofitStatus\", \"http://schema.org/nonprofitStatus\"\r\n        \"normalRange\", \"http://schema.org/normalRange\"\r\n        \"nsn\", \"http://schema.org/nsn\"\r\n        \"numAdults\", \"http://schema.org/numAdults\"\r\n        \"numChildren\", \"http://schema.org/numChildren\"\r\n        \"numConstraints\", \"http://schema.org/numConstraints\"\r\n        \"numTracks\", \"http://schema.org/numTracks\"\r\n        \"numberOfAccommodationUnits\", \"http://schema.org/numberOfAccommodationUnits\"\r\n        \"numberOfAirbags\", \"http://schema.org/numberOfAirbags\"\r\n        \"numberOfAvailableAccommodationUnits\", \"http://schema.org/numberOfAvailableAccommodationUnits\"\r\n        \"numberOfAxles\", \"http://schema.org/numberOfAxles\"\r\n        \"numberOfBathroomsTotal\", \"http://schema.org/numberOfBathroomsTotal\"\r\n        \"numberOfBedrooms\", \"http://schema.org/numberOfBedrooms\"\r\n        \"numberOfBeds\", \"http://schema.org/numberOfBeds\"\r\n        \"numberOfCredits\", \"http://schema.org/numberOfCredits\"\r\n        \"numberOfDoors\", \"http://schema.org/numberOfDoors\"\r\n        \"numberOfEmployees\", \"http://schema.org/numberOfEmployees\"\r\n        \"numberOfEpisodes\", \"http://schema.org/numberOfEpisodes\"\r\n        \"numberOfForwardGears\", \"http://schema.org/numberOfForwardGears\"\r\n        \"numberOfFullBathrooms\", \"http://schema.org/numberOfFullBathrooms\"\r\n        \"numberOfItems\", \"http://schema.org/numberOfItems\"\r\n        \"numberOfLoanPayments\", \"http://schema.org/numberOfLoanPayments\"\r\n        \"numberOfPages\", \"http://schema.org/numberOfPages\"\r\n        \"numberOfPartialBathrooms\", \"http://schema.org/numberOfPartialBathrooms\"\r\n        \"numberOfPlayers\", \"http://schema.org/numberOfPlayers\"\r\n        \"numberOfPreviousOwners\", \"http://schema.org/numberOfPreviousOwners\"\r\n        \"numberOfRooms\", \"http://schema.org/numberOfRooms\"\r\n        \"numberOfSeasons\", \"http://schema.org/numberOfSeasons\"\r\n        \"numberedPosition\", \"http://schema.org/numberedPosition\"\r\n        \"nutrition\", \"http://schema.org/nutrition\"\r\n        \"object\", \"http://schema.org/object\"\r\n        \"observationAbout\", \"http://schema.org/observationAbout\"\r\n        \"observationDate\", \"http://schema.org/observationDate\"\r\n        \"observationPeriod\", \"http://schema.org/observationPeriod\"\r\n        \"occupancy\", \"http://schema.org/occupancy\"\r\n        \"occupationLocation\", \"http://schema.org/occupationLocation\"\r\n        \"occupationalCategory\", \"http://schema.org/occupationalCategory\"\r\n        \"occupationalCredentialAwarded\", \"http://schema.org/occupationalCredentialAwarded\"\r\n        \"offerCount\", \"http://schema.org/offerCount\"\r\n        \"offeredBy\", \"http://schema.org/offeredBy\"\r\n        \"offers\", \"http://schema.org/offers\"\r\n        \"offersPrescriptionByMail\", \"http://schema.org/offersPrescriptionByMail\"\r\n        \"openingHours\", \"http://schema.org/openingHours\"\r\n        \"openingHoursSpecification\", \"http://schema.org/openingHoursSpecification\"\r\n        \"opens\", \"http://schema.org/opens\"\r\n        \"operatingSystem\", \"http://schema.org/operatingSystem\"\r\n        \"opponent\", \"http://schema.org/opponent\"\r\n        \"option\", \"http://schema.org/option\"\r\n        \"orderDate\", \"http://schema.org/orderDate\"\r\n        \"orderDelivery\", \"http://schema.org/orderDelivery\"\r\n        \"orderItemNumber\", \"http://schema.org/orderItemNumber\"\r\n        \"orderItemStatus\", \"http://schema.org/orderItemStatus\"\r\n        \"orderNumber\", \"http://schema.org/orderNumber\"\r\n        \"orderQuantity\", \"http://schema.org/orderQuantity\"\r\n        \"orderStatus\", \"http://schema.org/orderStatus\"\r\n        \"orderedItem\", \"http://schema.org/orderedItem\"\r\n        \"organizer\", \"http://schema.org/organizer\"\r\n        \"originAddress\", \"http://schema.org/originAddress\"\r\n        \"originalMediaContextDescription\", \"http://schema.org/originalMediaContextDescription\"\r\n        \"originalMediaLink\", \"http://schema.org/originalMediaLink\"\r\n        \"originatesFrom\", \"http://schema.org/originatesFrom\"\r\n        \"overdosage\", \"http://schema.org/overdosage\"\r\n        \"ownedFrom\", \"http://schema.org/ownedFrom\"\r\n        \"ownedThrough\", \"http://schema.org/ownedThrough\"\r\n        \"ownershipFundingInfo\", \"http://schema.org/ownershipFundingInfo\"\r\n        \"owns\", \"http://schema.org/owns\"\r\n        \"pageEnd\", \"http://schema.org/pageEnd\"\r\n        \"pageStart\", \"http://schema.org/pageStart\"\r\n        \"pagination\", \"http://schema.org/pagination\"\r\n        \"parent\", \"http://schema.org/parent\"\r\n        \"parentItem\", \"http://schema.org/parentItem\"\r\n        \"parentOrganization\", \"http://schema.org/parentOrganization\"\r\n        \"parentService\", \"http://schema.org/parentService\"\r\n        \"parentTaxon\", \"http://schema.org/parentTaxon\"\r\n        \"parents\", \"http://schema.org/parents\"\r\n        \"partOfEpisode\", \"http://schema.org/partOfEpisode\"\r\n        \"partOfInvoice\", \"http://schema.org/partOfInvoice\"\r\n        \"partOfOrder\", \"http://schema.org/partOfOrder\"\r\n        \"partOfSeason\", \"http://schema.org/partOfSeason\"\r\n        \"partOfSeries\", \"http://schema.org/partOfSeries\"\r\n        \"partOfSystem\", \"http://schema.org/partOfSystem\"\r\n        \"partOfTVSeries\", \"http://schema.org/partOfTVSeries\"\r\n        \"partOfTrip\", \"http://schema.org/partOfTrip\"\r\n        \"participant\", \"http://schema.org/participant\"\r\n        \"partySize\", \"http://schema.org/partySize\"\r\n        \"passengerPriorityStatus\", \"http://schema.org/passengerPriorityStatus\"\r\n        \"passengerSequenceNumber\", \"http://schema.org/passengerSequenceNumber\"\r\n        \"pathophysiology\", \"http://schema.org/pathophysiology\"\r\n        \"pattern\", \"http://schema.org/pattern\"\r\n        \"payload\", \"http://schema.org/payload\"\r\n        \"paymentAccepted\", \"http://schema.org/paymentAccepted\"\r\n        \"paymentDue\", \"http://schema.org/paymentDue\"\r\n        \"paymentDueDate\", \"http://schema.org/paymentDueDate\"\r\n        \"paymentMethod\", \"http://schema.org/paymentMethod\"\r\n        \"paymentMethodId\", \"http://schema.org/paymentMethodId\"\r\n        \"paymentStatus\", \"http://schema.org/paymentStatus\"\r\n        \"paymentUrl\", \"http://schema.org/paymentUrl\"\r\n        \"penciler\", \"http://schema.org/penciler\"\r\n        \"percentile10\", \"http://schema.org/percentile10\"\r\n        \"percentile25\", \"http://schema.org/percentile25\"\r\n        \"percentile75\", \"http://schema.org/percentile75\"\r\n        \"percentile90\", \"http://schema.org/percentile90\"\r\n        \"performTime\", \"http://schema.org/performTime\"\r\n        \"performer\", \"http://schema.org/performer\"\r\n        \"performerIn\", \"http://schema.org/performerIn\"\r\n        \"performers\", \"http://schema.org/performers\"\r\n        \"permissionType\", \"http://schema.org/permissionType\"\r\n        \"permissions\", \"http://schema.org/permissions\"\r\n        \"permitAudience\", \"http://schema.org/permitAudience\"\r\n        \"permittedUsage\", \"http://schema.org/permittedUsage\"\r\n        \"petsAllowed\", \"http://schema.org/petsAllowed\"\r\n        \"phoneticText\", \"http://schema.org/phoneticText\"\r\n        \"photo\", \"http://schema.org/photo\"\r\n        \"photos\", \"http://schema.org/photos\"\r\n        \"physicalRequirement\", \"http://schema.org/physicalRequirement\"\r\n        \"physiologicalBenefits\", \"http://schema.org/physiologicalBenefits\"\r\n        \"pickupLocation\", \"http://schema.org/pickupLocation\"\r\n        \"pickupTime\", \"http://schema.org/pickupTime\"\r\n        \"playMode\", \"http://schema.org/playMode\"\r\n        \"playerType\", \"http://schema.org/playerType\"\r\n        \"playersOnline\", \"http://schema.org/playersOnline\"\r\n        \"polygon\", \"http://schema.org/polygon\"\r\n        \"populationType\", \"http://schema.org/populationType\"\r\n        \"position\", \"http://schema.org/position\"\r\n        \"positiveNotes\", \"http://schema.org/positiveNotes\"\r\n        \"possibleComplication\", \"http://schema.org/possibleComplication\"\r\n        \"possibleTreatment\", \"http://schema.org/possibleTreatment\"\r\n        \"postOfficeBoxNumber\", \"http://schema.org/postOfficeBoxNumber\"\r\n        \"postOp\", \"http://schema.org/postOp\"\r\n        \"postalCode\", \"http://schema.org/postalCode\"\r\n        \"postalCodeBegin\", \"http://schema.org/postalCodeBegin\"\r\n        \"postalCodeEnd\", \"http://schema.org/postalCodeEnd\"\r\n        \"postalCodePrefix\", \"http://schema.org/postalCodePrefix\"\r\n        \"postalCodeRange\", \"http://schema.org/postalCodeRange\"\r\n        \"potentialAction\", \"http://schema.org/potentialAction\"\r\n        \"potentialUse\", \"http://schema.org/potentialUse\"\r\n        \"preOp\", \"http://schema.org/preOp\"\r\n        \"predecessorOf\", \"http://schema.org/predecessorOf\"\r\n        \"pregnancyCategory\", \"http://schema.org/pregnancyCategory\"\r\n        \"pregnancyWarning\", \"http://schema.org/pregnancyWarning\"\r\n        \"prepTime\", \"http://schema.org/prepTime\"\r\n        \"preparation\", \"http://schema.org/preparation\"\r\n        \"prescribingInfo\", \"http://schema.org/prescribingInfo\"\r\n        \"prescriptionStatus\", \"http://schema.org/prescriptionStatus\"\r\n        \"previousItem\", \"http://schema.org/previousItem\"\r\n        \"previousStartDate\", \"http://schema.org/previousStartDate\"\r\n        \"price\", \"http://schema.org/price\"\r\n        \"priceComponent\", \"http://schema.org/priceComponent\"\r\n        \"priceComponentType\", \"http://schema.org/priceComponentType\"\r\n        \"priceCurrency\", \"http://schema.org/priceCurrency\"\r\n        \"priceRange\", \"http://schema.org/priceRange\"\r\n        \"priceSpecification\", \"http://schema.org/priceSpecification\"\r\n        \"priceType\", \"http://schema.org/priceType\"\r\n        \"priceValidUntil\", \"http://schema.org/priceValidUntil\"\r\n        \"primaryImageOfPage\", \"http://schema.org/primaryImageOfPage\"\r\n        \"primaryPrevention\", \"http://schema.org/primaryPrevention\"\r\n        \"printColumn\", \"http://schema.org/printColumn\"\r\n        \"printEdition\", \"http://schema.org/printEdition\"\r\n        \"printPage\", \"http://schema.org/printPage\"\r\n        \"printSection\", \"http://schema.org/printSection\"\r\n        \"procedure\", \"http://schema.org/procedure\"\r\n        \"procedureType\", \"http://schema.org/procedureType\"\r\n        \"processingTime\", \"http://schema.org/processingTime\"\r\n        \"processorRequirements\", \"http://schema.org/processorRequirements\"\r\n        \"producer\", \"http://schema.org/producer\"\r\n        \"produces\", \"http://schema.org/produces\"\r\n        \"productGroupID\", \"http://schema.org/productGroupID\"\r\n        \"productID\", \"http://schema.org/productID\"\r\n        \"productReturnDays\", \"http://schema.org/productReturnDays\"\r\n        \"productReturnLink\", \"http://schema.org/productReturnLink\"\r\n        \"productSupported\", \"http://schema.org/productSupported\"\r\n        \"productionCompany\", \"http://schema.org/productionCompany\"\r\n        \"productionDate\", \"http://schema.org/productionDate\"\r\n        \"proficiencyLevel\", \"http://schema.org/proficiencyLevel\"\r\n        \"programMembershipUsed\", \"http://schema.org/programMembershipUsed\"\r\n        \"programName\", \"http://schema.org/programName\"\r\n        \"programPrerequisites\", \"http://schema.org/programPrerequisites\"\r\n        \"programType\", \"http://schema.org/programType\"\r\n        \"programmingLanguage\", \"http://schema.org/programmingLanguage\"\r\n        \"programmingModel\", \"http://schema.org/programmingModel\"\r\n        \"propertyID\", \"http://schema.org/propertyID\"\r\n        \"proprietaryName\", \"http://schema.org/proprietaryName\"\r\n        \"proteinContent\", \"http://schema.org/proteinContent\"\r\n        \"provider\", \"http://schema.org/provider\"\r\n        \"providerMobility\", \"http://schema.org/providerMobility\"\r\n        \"providesBroadcastService\", \"http://schema.org/providesBroadcastService\"\r\n        \"providesService\", \"http://schema.org/providesService\"\r\n        \"publicAccess\", \"http://schema.org/publicAccess\"\r\n        \"publicTransportClosuresInfo\", \"http://schema.org/publicTransportClosuresInfo\"\r\n        \"publication\", \"http://schema.org/publication\"\r\n        \"publicationType\", \"http://schema.org/publicationType\"\r\n        \"publishedBy\", \"http://schema.org/publishedBy\"\r\n        \"publishedOn\", \"http://schema.org/publishedOn\"\r\n        \"publisher\", \"http://schema.org/publisher\"\r\n        \"publisherImprint\", \"http://schema.org/publisherImprint\"\r\n        \"publishingPrinciples\", \"http://schema.org/publishingPrinciples\"\r\n        \"purchaseDate\", \"http://schema.org/purchaseDate\"\r\n        \"qualifications\", \"http://schema.org/qualifications\"\r\n        \"quarantineGuidelines\", \"http://schema.org/quarantineGuidelines\"\r\n        \"query\", \"http://schema.org/query\"\r\n        \"quest\", \"http://schema.org/quest\"\r\n        \"question\", \"http://schema.org/question\"\r\n        \"rangeIncludes\", \"http://schema.org/rangeIncludes\"\r\n        \"ratingCount\", \"http://schema.org/ratingCount\"\r\n        \"ratingExplanation\", \"http://schema.org/ratingExplanation\"\r\n        \"ratingValue\", \"http://schema.org/ratingValue\"\r\n        \"readBy\", \"http://schema.org/readBy\"\r\n        \"readonlyValue\", \"http://schema.org/readonlyValue\"\r\n        \"realEstateAgent\", \"http://schema.org/realEstateAgent\"\r\n        \"recipe\", \"http://schema.org/recipe\"\r\n        \"recipeCategory\", \"http://schema.org/recipeCategory\"\r\n        \"recipeCuisine\", \"http://schema.org/recipeCuisine\"\r\n        \"recipeIngredient\", \"http://schema.org/recipeIngredient\"\r\n        \"recipeInstructions\", \"http://schema.org/recipeInstructions\"\r\n        \"recipeYield\", \"http://schema.org/recipeYield\"\r\n        \"recipient\", \"http://schema.org/recipient\"\r\n        \"recognizedBy\", \"http://schema.org/recognizedBy\"\r\n        \"recognizingAuthority\", \"http://schema.org/recognizingAuthority\"\r\n        \"recommendationStrength\", \"http://schema.org/recommendationStrength\"\r\n        \"recommendedIntake\", \"http://schema.org/recommendedIntake\"\r\n        \"recordLabel\", \"http://schema.org/recordLabel\"\r\n        \"recordedAs\", \"http://schema.org/recordedAs\"\r\n        \"recordedAt\", \"http://schema.org/recordedAt\"\r\n        \"recordedIn\", \"http://schema.org/recordedIn\"\r\n        \"recordingOf\", \"http://schema.org/recordingOf\"\r\n        \"recourseLoan\", \"http://schema.org/recourseLoan\"\r\n        \"referenceQuantity\", \"http://schema.org/referenceQuantity\"\r\n        \"referencesOrder\", \"http://schema.org/referencesOrder\"\r\n        \"refundType\", \"http://schema.org/refundType\"\r\n        \"regionDrained\", \"http://schema.org/regionDrained\"\r\n        \"regionsAllowed\", \"http://schema.org/regionsAllowed\"\r\n        \"relatedAnatomy\", \"http://schema.org/relatedAnatomy\"\r\n        \"relatedCondition\", \"http://schema.org/relatedCondition\"\r\n        \"relatedDrug\", \"http://schema.org/relatedDrug\"\r\n        \"relatedLink\", \"http://schema.org/relatedLink\"\r\n        \"relatedStructure\", \"http://schema.org/relatedStructure\"\r\n        \"relatedTherapy\", \"http://schema.org/relatedTherapy\"\r\n        \"relatedTo\", \"http://schema.org/relatedTo\"\r\n        \"releaseDate\", \"http://schema.org/releaseDate\"\r\n        \"releaseNotes\", \"http://schema.org/releaseNotes\"\r\n        \"releaseOf\", \"http://schema.org/releaseOf\"\r\n        \"releasedEvent\", \"http://schema.org/releasedEvent\"\r\n        \"relevantOccupation\", \"http://schema.org/relevantOccupation\"\r\n        \"relevantSpecialty\", \"http://schema.org/relevantSpecialty\"\r\n        \"remainingAttendeeCapacity\", \"http://schema.org/remainingAttendeeCapacity\"\r\n        \"renegotiableLoan\", \"http://schema.org/renegotiableLoan\"\r\n        \"repeatCount\", \"http://schema.org/repeatCount\"\r\n        \"repeatFrequency\", \"http://schema.org/repeatFrequency\"\r\n        \"repetitions\", \"http://schema.org/repetitions\"\r\n        \"replacee\", \"http://schema.org/replacee\"\r\n        \"replacer\", \"http://schema.org/replacer\"\r\n        \"replyToUrl\", \"http://schema.org/replyToUrl\"\r\n        \"reportNumber\", \"http://schema.org/reportNumber\"\r\n        \"representativeOfPage\", \"http://schema.org/representativeOfPage\"\r\n        \"requiredCollateral\", \"http://schema.org/requiredCollateral\"\r\n        \"requiredGender\", \"http://schema.org/requiredGender\"\r\n        \"requiredMaxAge\", \"http://schema.org/requiredMaxAge\"\r\n        \"requiredMinAge\", \"http://schema.org/requiredMinAge\"\r\n        \"requiredQuantity\", \"http://schema.org/requiredQuantity\"\r\n        \"requirements\", \"http://schema.org/requirements\"\r\n        \"requiresSubscription\", \"http://schema.org/requiresSubscription\"\r\n        \"reservationFor\", \"http://schema.org/reservationFor\"\r\n        \"reservationId\", \"http://schema.org/reservationId\"\r\n        \"reservationStatus\", \"http://schema.org/reservationStatus\"\r\n        \"reservedTicket\", \"http://schema.org/reservedTicket\"\r\n        \"responsibilities\", \"http://schema.org/responsibilities\"\r\n        \"restPeriods\", \"http://schema.org/restPeriods\"\r\n        \"restockingFee\", \"http://schema.org/restockingFee\"\r\n        \"result\", \"http://schema.org/result\"\r\n        \"resultComment\", \"http://schema.org/resultComment\"\r\n        \"resultReview\", \"http://schema.org/resultReview\"\r\n        \"returnFees\", \"http://schema.org/returnFees\"\r\n        \"returnLabelSource\", \"http://schema.org/returnLabelSource\"\r\n        \"returnMethod\", \"http://schema.org/returnMethod\"\r\n        \"returnPolicyCategory\", \"http://schema.org/returnPolicyCategory\"\r\n        \"returnPolicyCountry\", \"http://schema.org/returnPolicyCountry\"\r\n        \"returnPolicySeasonalOverride\", \"http://schema.org/returnPolicySeasonalOverride\"\r\n        \"returnShippingFeesAmount\", \"http://schema.org/returnShippingFeesAmount\"\r\n        \"review\", \"http://schema.org/review\"\r\n        \"reviewAspect\", \"http://schema.org/reviewAspect\"\r\n        \"reviewBody\", \"http://schema.org/reviewBody\"\r\n        \"reviewCount\", \"http://schema.org/reviewCount\"\r\n        \"reviewRating\", \"http://schema.org/reviewRating\"\r\n        \"reviewedBy\", \"http://schema.org/reviewedBy\"\r\n        \"reviews\", \"http://schema.org/reviews\"\r\n        \"riskFactor\", \"http://schema.org/riskFactor\"\r\n        \"risks\", \"http://schema.org/risks\"\r\n        \"roleName\", \"http://schema.org/roleName\"\r\n        \"roofLoad\", \"http://schema.org/roofLoad\"\r\n        \"rsvpResponse\", \"http://schema.org/rsvpResponse\"\r\n        \"runsTo\", \"http://schema.org/runsTo\"\r\n        \"runtime\", \"http://schema.org/runtime\"\r\n        \"runtimePlatform\", \"http://schema.org/runtimePlatform\"\r\n        \"rxcui\", \"http://schema.org/rxcui\"\r\n        \"safetyConsideration\", \"http://schema.org/safetyConsideration\"\r\n        \"salaryCurrency\", \"http://schema.org/salaryCurrency\"\r\n        \"salaryUponCompletion\", \"http://schema.org/salaryUponCompletion\"\r\n        \"sameAs\", \"http://schema.org/sameAs\"\r\n        \"sampleType\", \"http://schema.org/sampleType\"\r\n        \"saturatedFatContent\", \"http://schema.org/saturatedFatContent\"\r\n        \"scheduleTimezone\", \"http://schema.org/scheduleTimezone\"\r\n        \"scheduledPaymentDate\", \"http://schema.org/scheduledPaymentDate\"\r\n        \"scheduledTime\", \"http://schema.org/scheduledTime\"\r\n        \"schemaVersion\", \"http://schema.org/schemaVersion\"\r\n        \"schoolClosuresInfo\", \"http://schema.org/schoolClosuresInfo\"\r\n        \"screenCount\", \"http://schema.org/screenCount\"\r\n        \"screenshot\", \"http://schema.org/screenshot\"\r\n        \"sdDatePublished\", \"http://schema.org/sdDatePublished\"\r\n        \"sdLicense\", \"http://schema.org/sdLicense\"\r\n        \"sdPublisher\", \"http://schema.org/sdPublisher\"\r\n        \"season\", \"http://schema.org/season\"\r\n        \"seasonNumber\", \"http://schema.org/seasonNumber\"\r\n        \"seasons\", \"http://schema.org/seasons\"\r\n        \"seatNumber\", \"http://schema.org/seatNumber\"\r\n        \"seatRow\", \"http://schema.org/seatRow\"\r\n        \"seatSection\", \"http://schema.org/seatSection\"\r\n        \"seatingCapacity\", \"http://schema.org/seatingCapacity\"\r\n        \"seatingType\", \"http://schema.org/seatingType\"\r\n        \"secondaryPrevention\", \"http://schema.org/secondaryPrevention\"\r\n        \"securityClearanceRequirement\", \"http://schema.org/securityClearanceRequirement\"\r\n        \"securityScreening\", \"http://schema.org/securityScreening\"\r\n        \"seeks\", \"http://schema.org/seeks\"\r\n        \"seller\", \"http://schema.org/seller\"\r\n        \"sender\", \"http://schema.org/sender\"\r\n        \"sensoryRequirement\", \"http://schema.org/sensoryRequirement\"\r\n        \"sensoryUnit\", \"http://schema.org/sensoryUnit\"\r\n        \"serialNumber\", \"http://schema.org/serialNumber\"\r\n        \"seriousAdverseOutcome\", \"http://schema.org/seriousAdverseOutcome\"\r\n        \"serverStatus\", \"http://schema.org/serverStatus\"\r\n        \"servesCuisine\", \"http://schema.org/servesCuisine\"\r\n        \"serviceArea\", \"http://schema.org/serviceArea\"\r\n        \"serviceAudience\", \"http://schema.org/serviceAudience\"\r\n        \"serviceLocation\", \"http://schema.org/serviceLocation\"\r\n        \"serviceOperator\", \"http://schema.org/serviceOperator\"\r\n        \"serviceOutput\", \"http://schema.org/serviceOutput\"\r\n        \"servicePhone\", \"http://schema.org/servicePhone\"\r\n        \"servicePostalAddress\", \"http://schema.org/servicePostalAddress\"\r\n        \"serviceSmsNumber\", \"http://schema.org/serviceSmsNumber\"\r\n        \"serviceType\", \"http://schema.org/serviceType\"\r\n        \"serviceUrl\", \"http://schema.org/serviceUrl\"\r\n        \"servingSize\", \"http://schema.org/servingSize\"\r\n        \"sha256\", \"http://schema.org/sha256\"\r\n        \"sharedContent\", \"http://schema.org/sharedContent\"\r\n        \"shippingDestination\", \"http://schema.org/shippingDestination\"\r\n        \"shippingDetails\", \"http://schema.org/shippingDetails\"\r\n        \"shippingLabel\", \"http://schema.org/shippingLabel\"\r\n        \"shippingOrigin\", \"http://schema.org/shippingOrigin\"\r\n        \"shippingRate\", \"http://schema.org/shippingRate\"\r\n        \"shippingSettingsLink\", \"http://schema.org/shippingSettingsLink\"\r\n        \"sibling\", \"http://schema.org/sibling\"\r\n        \"siblings\", \"http://schema.org/siblings\"\r\n        \"signDetected\", \"http://schema.org/signDetected\"\r\n        \"signOrSymptom\", \"http://schema.org/signOrSymptom\"\r\n        \"significance\", \"http://schema.org/significance\"\r\n        \"significantLink\", \"http://schema.org/significantLink\"\r\n        \"significantLinks\", \"http://schema.org/significantLinks\"\r\n        \"size\", \"http://schema.org/size\"\r\n        \"sizeGroup\", \"http://schema.org/sizeGroup\"\r\n        \"sizeSystem\", \"http://schema.org/sizeSystem\"\r\n        \"skills\", \"http://schema.org/skills\"\r\n        \"sku\", \"http://schema.org/sku\"\r\n        \"slogan\", \"http://schema.org/slogan\"\r\n        \"smiles\", \"http://schema.org/smiles\"\r\n        \"smokingAllowed\", \"http://schema.org/smokingAllowed\"\r\n        \"sodiumContent\", \"http://schema.org/sodiumContent\"\r\n        \"softwareAddOn\", \"http://schema.org/softwareAddOn\"\r\n        \"softwareHelp\", \"http://schema.org/softwareHelp\"\r\n        \"softwareRequirements\", \"http://schema.org/softwareRequirements\"\r\n        \"softwareVersion\", \"http://schema.org/softwareVersion\"\r\n        \"sourceOrganization\", \"http://schema.org/sourceOrganization\"\r\n        \"sourcedFrom\", \"http://schema.org/sourcedFrom\"\r\n        \"spatial\", \"http://schema.org/spatial\"\r\n        \"spatialCoverage\", \"http://schema.org/spatialCoverage\"\r\n        \"speakable\", \"http://schema.org/speakable\"\r\n        \"specialCommitments\", \"http://schema.org/specialCommitments\"\r\n        \"specialOpeningHoursSpecification\", \"http://schema.org/specialOpeningHoursSpecification\"\r\n        \"specialty\", \"http://schema.org/specialty\"\r\n        \"speechToTextMarkup\", \"http://schema.org/speechToTextMarkup\"\r\n        \"speed\", \"http://schema.org/speed\"\r\n        \"spokenByCharacter\", \"http://schema.org/spokenByCharacter\"\r\n        \"sponsor\", \"http://schema.org/sponsor\"\r\n        \"sport\", \"http://schema.org/sport\"\r\n        \"sportsActivityLocation\", \"http://schema.org/sportsActivityLocation\"\r\n        \"sportsEvent\", \"http://schema.org/sportsEvent\"\r\n        \"sportsTeam\", \"http://schema.org/sportsTeam\"\r\n        \"spouse\", \"http://schema.org/spouse\"\r\n        \"stage\", \"http://schema.org/stage\"\r\n        \"stageAsNumber\", \"http://schema.org/stageAsNumber\"\r\n        \"starRating\", \"http://schema.org/starRating\"\r\n        \"startDate\", \"http://schema.org/startDate\"\r\n        \"startOffset\", \"http://schema.org/startOffset\"\r\n        \"startTime\", \"http://schema.org/startTime\"\r\n        \"statType\", \"http://schema.org/statType\"\r\n        \"status\", \"http://schema.org/status\"\r\n        \"steeringPosition\", \"http://schema.org/steeringPosition\"\r\n        \"step\", \"http://schema.org/step\"\r\n        \"stepValue\", \"http://schema.org/stepValue\"\r\n        \"steps\", \"http://schema.org/steps\"\r\n        \"storageRequirements\", \"http://schema.org/storageRequirements\"\r\n        \"streetAddress\", \"http://schema.org/streetAddress\"\r\n        \"strengthUnit\", \"http://schema.org/strengthUnit\"\r\n        \"strengthValue\", \"http://schema.org/strengthValue\"\r\n        \"structuralClass\", \"http://schema.org/structuralClass\"\r\n        \"study\", \"http://schema.org/study\"\r\n        \"studyDesign\", \"http://schema.org/studyDesign\"\r\n        \"studyLocation\", \"http://schema.org/studyLocation\"\r\n        \"studySubject\", \"http://schema.org/studySubject\"\r\n        \"stupidProperty\", \"http://schema.org/stupidProperty\"\r\n        \"subEvent\", \"http://schema.org/subEvent\"\r\n        \"subEvents\", \"http://schema.org/subEvents\"\r\n        \"subOrganization\", \"http://schema.org/subOrganization\"\r\n        \"subReservation\", \"http://schema.org/subReservation\"\r\n        \"subStageSuffix\", \"http://schema.org/subStageSuffix\"\r\n        \"subStructure\", \"http://schema.org/subStructure\"\r\n        \"subTest\", \"http://schema.org/subTest\"\r\n        \"subTrip\", \"http://schema.org/subTrip\"\r\n        \"subjectOf\", \"http://schema.org/subjectOf\"\r\n        \"subtitleLanguage\", \"http://schema.org/subtitleLanguage\"\r\n        \"successorOf\", \"http://schema.org/successorOf\"\r\n        \"sugarContent\", \"http://schema.org/sugarContent\"\r\n        \"suggestedAge\", \"http://schema.org/suggestedAge\"\r\n        \"suggestedAnswer\", \"http://schema.org/suggestedAnswer\"\r\n        \"suggestedGender\", \"http://schema.org/suggestedGender\"\r\n        \"suggestedMaxAge\", \"http://schema.org/suggestedMaxAge\"\r\n        \"suggestedMeasurement\", \"http://schema.org/suggestedMeasurement\"\r\n        \"suggestedMinAge\", \"http://schema.org/suggestedMinAge\"\r\n        \"suitableForDiet\", \"http://schema.org/suitableForDiet\"\r\n        \"superEvent\", \"http://schema.org/superEvent\"\r\n        \"supersededBy\", \"http://schema.org/supersededBy\"\r\n        \"supply\", \"http://schema.org/supply\"\r\n        \"supplyTo\", \"http://schema.org/supplyTo\"\r\n        \"supportingData\", \"http://schema.org/supportingData\"\r\n        \"surface\", \"http://schema.org/surface\"\r\n        \"syllabusSections\", \"http://schema.org/syllabusSections\"\r\n        \"target\", \"http://schema.org/target\"\r\n        \"targetCollection\", \"http://schema.org/targetCollection\"\r\n        \"targetDescription\", \"http://schema.org/targetDescription\"\r\n        \"targetName\", \"http://schema.org/targetName\"\r\n        \"targetPlatform\", \"http://schema.org/targetPlatform\"\r\n        \"targetPopulation\", \"http://schema.org/targetPopulation\"\r\n        \"targetProduct\", \"http://schema.org/targetProduct\"\r\n        \"targetUrl\", \"http://schema.org/targetUrl\"\r\n        \"taxID\", \"http://schema.org/taxID\"\r\n        \"taxonRank\", \"http://schema.org/taxonRank\"\r\n        \"taxonomicRange\", \"http://schema.org/taxonomicRange\"\r\n        \"teaches\", \"http://schema.org/teaches\"\r\n        \"telephone\", \"http://schema.org/telephone\"\r\n        \"temporal\", \"http://schema.org/temporal\"\r\n        \"temporalCoverage\", \"http://schema.org/temporalCoverage\"\r\n        \"termCode\", \"http://schema.org/termCode\"\r\n        \"termDuration\", \"http://schema.org/termDuration\"\r\n        \"termsOfService\", \"http://schema.org/termsOfService\"\r\n        \"termsPerYear\", \"http://schema.org/termsPerYear\"\r\n        \"text\", \"http://schema.org/text\"\r\n        \"textValue\", \"http://schema.org/textValue\"\r\n        \"thumbnail\", \"http://schema.org/thumbnail\"\r\n        \"thumbnailUrl\", \"http://schema.org/thumbnailUrl\"\r\n        \"tickerSymbol\", \"http://schema.org/tickerSymbol\"\r\n        \"ticketNumber\", \"http://schema.org/ticketNumber\"\r\n        \"ticketToken\", \"http://schema.org/ticketToken\"\r\n        \"ticketedSeat\", \"http://schema.org/ticketedSeat\"\r\n        \"timeOfDay\", \"http://schema.org/timeOfDay\"\r\n        \"timeRequired\", \"http://schema.org/timeRequired\"\r\n        \"timeToComplete\", \"http://schema.org/timeToComplete\"\r\n        \"tissueSample\", \"http://schema.org/tissueSample\"\r\n        \"title\", \"http://schema.org/title\"\r\n        \"titleEIDR\", \"http://schema.org/titleEIDR\"\r\n        \"toLocation\", \"http://schema.org/toLocation\"\r\n        \"toRecipient\", \"http://schema.org/toRecipient\"\r\n        \"tocContinuation\", \"http://schema.org/tocContinuation\"\r\n        \"tocEntry\", \"http://schema.org/tocEntry\"\r\n        \"tongueWeight\", \"http://schema.org/tongueWeight\"\r\n        \"tool\", \"http://schema.org/tool\"\r\n        \"torque\", \"http://schema.org/torque\"\r\n        \"totalHistoricalEnrollment\", \"http://schema.org/totalHistoricalEnrollment\"\r\n        \"totalJobOpenings\", \"http://schema.org/totalJobOpenings\"\r\n        \"totalPaymentDue\", \"http://schema.org/totalPaymentDue\"\r\n        \"totalPrice\", \"http://schema.org/totalPrice\"\r\n        \"totalTime\", \"http://schema.org/totalTime\"\r\n        \"tourBookingPage\", \"http://schema.org/tourBookingPage\"\r\n        \"touristType\", \"http://schema.org/touristType\"\r\n        \"track\", \"http://schema.org/track\"\r\n        \"trackingNumber\", \"http://schema.org/trackingNumber\"\r\n        \"trackingUrl\", \"http://schema.org/trackingUrl\"\r\n        \"tracks\", \"http://schema.org/tracks\"\r\n        \"trailer\", \"http://schema.org/trailer\"\r\n        \"trailerWeight\", \"http://schema.org/trailerWeight\"\r\n        \"trainName\", \"http://schema.org/trainName\"\r\n        \"trainNumber\", \"http://schema.org/trainNumber\"\r\n        \"trainingSalary\", \"http://schema.org/trainingSalary\"\r\n        \"transFatContent\", \"http://schema.org/transFatContent\"\r\n        \"transcript\", \"http://schema.org/transcript\"\r\n        \"transitTime\", \"http://schema.org/transitTime\"\r\n        \"transitTimeLabel\", \"http://schema.org/transitTimeLabel\"\r\n        \"translationOfWork\", \"http://schema.org/translationOfWork\"\r\n        \"translator\", \"http://schema.org/translator\"\r\n        \"transmissionMethod\", \"http://schema.org/transmissionMethod\"\r\n        \"travelBans\", \"http://schema.org/travelBans\"\r\n        \"trialDesign\", \"http://schema.org/trialDesign\"\r\n        \"tributary\", \"http://schema.org/tributary\"\r\n        \"tripOrigin\", \"http://schema.org/tripOrigin\"\r\n        \"typeOfBed\", \"http://schema.org/typeOfBed\"\r\n        \"typeOfGood\", \"http://schema.org/typeOfGood\"\r\n        \"typicalAgeRange\", \"http://schema.org/typicalAgeRange\"\r\n        \"typicalCreditsPerTerm\", \"http://schema.org/typicalCreditsPerTerm\"\r\n        \"typicalTest\", \"http://schema.org/typicalTest\"\r\n        \"underName\", \"http://schema.org/underName\"\r\n        \"unitCode\", \"http://schema.org/unitCode\"\r\n        \"unitText\", \"http://schema.org/unitText\"\r\n        \"unnamedSourcesPolicy\", \"http://schema.org/unnamedSourcesPolicy\"\r\n        \"unsaturatedFatContent\", \"http://schema.org/unsaturatedFatContent\"\r\n        \"uploadDate\", \"http://schema.org/uploadDate\"\r\n        \"upvoteCount\", \"http://schema.org/upvoteCount\"\r\n        \"url\", \"http://schema.org/url\"\r\n        \"urlTemplate\", \"http://schema.org/urlTemplate\"\r\n        \"usageInfo\", \"http://schema.org/usageInfo\"\r\n        \"usedToDiagnose\", \"http://schema.org/usedToDiagnose\"\r\n        \"userInteractionCount\", \"http://schema.org/userInteractionCount\"\r\n        \"usesDevice\", \"http://schema.org/usesDevice\"\r\n        \"usesHealthPlanIdStandard\", \"http://schema.org/usesHealthPlanIdStandard\"\r\n        \"utterances\", \"http://schema.org/utterances\"\r\n        \"validFor\", \"http://schema.org/validFor\"\r\n        \"validFrom\", \"http://schema.org/validFrom\"\r\n        \"validIn\", \"http://schema.org/validIn\"\r\n        \"validThrough\", \"http://schema.org/validThrough\"\r\n        \"validUntil\", \"http://schema.org/validUntil\"\r\n        \"value\", \"http://schema.org/value\"\r\n        \"valueAddedTaxIncluded\", \"http://schema.org/valueAddedTaxIncluded\"\r\n        \"valueMaxLength\", \"http://schema.org/valueMaxLength\"\r\n        \"valueMinLength\", \"http://schema.org/valueMinLength\"\r\n        \"valueName\", \"http://schema.org/valueName\"\r\n        \"valuePattern\", \"http://schema.org/valuePattern\"\r\n        \"valueReference\", \"http://schema.org/valueReference\"\r\n        \"valueRequired\", \"http://schema.org/valueRequired\"\r\n        \"variableMeasured\", \"http://schema.org/variableMeasured\"\r\n        \"variablesMeasured\", \"http://schema.org/variablesMeasured\"\r\n        \"variantCover\", \"http://schema.org/variantCover\"\r\n        \"variesBy\", \"http://schema.org/variesBy\"\r\n        \"vatID\", \"http://schema.org/vatID\"\r\n        \"vehicleConfiguration\", \"http://schema.org/vehicleConfiguration\"\r\n        \"vehicleEngine\", \"http://schema.org/vehicleEngine\"\r\n        \"vehicleIdentificationNumber\", \"http://schema.org/vehicleIdentificationNumber\"\r\n        \"vehicleInteriorColor\", \"http://schema.org/vehicleInteriorColor\"\r\n        \"vehicleInteriorType\", \"http://schema.org/vehicleInteriorType\"\r\n        \"vehicleModelDate\", \"http://schema.org/vehicleModelDate\"\r\n        \"vehicleSeatingCapacity\", \"http://schema.org/vehicleSeatingCapacity\"\r\n        \"vehicleSpecialUsage\", \"http://schema.org/vehicleSpecialUsage\"\r\n        \"vehicleTransmission\", \"http://schema.org/vehicleTransmission\"\r\n        \"vendor\", \"http://schema.org/vendor\"\r\n        \"verificationFactCheckingPolicy\", \"http://schema.org/verificationFactCheckingPolicy\"\r\n        \"version\", \"http://schema.org/version\"\r\n        \"video\", \"http://schema.org/video\"\r\n        \"videoFormat\", \"http://schema.org/videoFormat\"\r\n        \"videoFrameSize\", \"http://schema.org/videoFrameSize\"\r\n        \"videoQuality\", \"http://schema.org/videoQuality\"\r\n        \"volumeNumber\", \"http://schema.org/volumeNumber\"\r\n        \"warning\", \"http://schema.org/warning\"\r\n        \"warranty\", \"http://schema.org/warranty\"\r\n        \"warrantyPromise\", \"http://schema.org/warrantyPromise\"\r\n        \"warrantyScope\", \"http://schema.org/warrantyScope\"\r\n        \"webCheckinTime\", \"http://schema.org/webCheckinTime\"\r\n        \"webFeed\", \"http://schema.org/webFeed\"\r\n        \"weight\", \"http://schema.org/weight\"\r\n        \"weightTotal\", \"http://schema.org/weightTotal\"\r\n        \"wheelbase\", \"http://schema.org/wheelbase\"\r\n        \"width\", \"http://schema.org/width\"\r\n        \"winner\", \"http://schema.org/winner\"\r\n        \"wordCount\", \"http://schema.org/wordCount\"\r\n        \"workExample\", \"http://schema.org/workExample\"\r\n        \"workFeatured\", \"http://schema.org/workFeatured\"\r\n        \"workHours\", \"http://schema.org/workHours\"\r\n        \"workLocation\", \"http://schema.org/workLocation\"\r\n        \"workPerformed\", \"http://schema.org/workPerformed\"\r\n        \"workPresented\", \"http://schema.org/workPresented\"\r\n        \"workTranslation\", \"http://schema.org/workTranslation\"\r\n        \"workload\", \"http://schema.org/workload\"\r\n        \"worksFor\", \"http://schema.org/worksFor\"\r\n        \"worstRating\", \"http://schema.org/worstRating\"\r\n        \"xpath\", \"http://schema.org/xpath\"\r\n        \"yearBuilt\", \"http://schema.org/yearBuilt\"\r\n        \"yearlyRevenue\", \"http://schema.org/yearlyRevenue\"\r\n        \"yearsInOperation\", \"http://schema.org/yearsInOperation\"\r\n        \"yield\", \"http://schema.org/yield\"\r\n        \"File\", \"http://schema.org/MediaObject\"\r\n        \"path\", \"http://schema.org/contentUrl\"\r\n        \"Journal\", \"http://schema.org/Periodical\"\r\n        \"cite-as\", \"http://www.iana.org/assignments/relation/cite-as\"\r\n        \"hasFile\", \"http://pcdm.org/models#hasFile\"\r\n        \"hasMember\", \"http://pcdm.org/models#hasMember\"\r\n        \"RepositoryCollection\", \"http://pcdm.org/models#Collection\"\r\n        \"RepositoryObject\", \"http://pcdm.org/models#Object\"\r\n        \"RepositoryFile\", \"http://pcdm.org/models#File\"\r\n        \"ComputationalWorkflow\", \"https://bioschemas.org/ComputationalWorkflow\"\r\n        \"input\", \"https://bioschemas.org/ComputationalWorkflow#input\"\r\n        \"output\", \"https://bioschemas.org/ComputationalWorkflow#output\"\r\n        \"FormalParameter\", \"https://bioschemas.org/FormalParameter\"\r\n        \"wasDerivedFrom\", \"http://www.w3.org/ns/prov#wasDerivedFrom\"\r\n        \"importedFrom\", \"http://purl.org/pav/importedFrom\"\r\n        \"importedOn\", \"http://purl.org/pav/importedOn\"\r\n        \"importedBy\", \"http://purl.org/pav/importedBy\"\r\n        \"retrievedFrom\", \"http://purl.org/pav/retrievedFrom\"\r\n        \"retrievedOn\", \"http://purl.org/pav/retrievedOn\"\r\n        \"retrievedBy\", \"http://purl.org/pav/retrievedBy\"\r\n        \"conformsTo\", \"http://purl.org/dc/terms/conformsTo\"\r\n        \"Standard\", \"http://purl.org/dc/terms/Standard\"\r\n        \"hasArtifact\", \"http://www.w3.org/ns/dx/prof/hasArtifact\"\r\n        \"hasResource\", \"http://www.w3.org/ns/dx/prof/hasResource\"\r\n        \"hasRole\", \"http://www.w3.org/ns/dx/prof/hasRole\"\r\n        \"hasToken\", \"http://www.w3.org/ns/dx/prof/hasToken\"\r\n        \"isProfileOf\", \"http://www.w3.org/ns/dx/prof/isProfileOf\"\r\n        \"ResourceDescriptor\", \"http://www.w3.org/ns/dx/prof/ResourceDescriptor\"\r\n        \"ResourceRole\", \"http://www.w3.org/ns/dx/prof/ResourceRole\"\r\n        \"Profile\", \"http://www.w3.org/ns/dx/prof/Profile\"\r\n        \"softwareSuggestions\", \"https://codemeta.github.io/terms/softwareSuggestions\"\r\n        \"continuousIntegration\", \"https://codemeta.github.io/terms/continuousIntegration\"\r\n        \"buildInstructions\", \"https://codemeta.github.io/terms/buildInstructions\"\r\n        \"developmentStatus\", \"https://codemeta.github.io/terms/developmentStatus\"\r\n        \"embargoEndDate\", \"https://codemeta.github.io/terms/embargoEndDate\"\r\n        \"readme\", \"https://codemeta.github.io/terms/readme\"\r\n        \"issueTracker\", \"https://codemeta.github.io/terms/issueTracker\"\r\n        \"referencePublication\", \"https://codemeta.github.io/terms/referencePublication\"\r\n        \"hasSourceCode\", \"https://codemeta.github.io/terms/hasSourceCode\"\r\n        \"isSourceCodeOf\", \"https://codemeta.github.io/terms/isSourceCodeOf\"\r\n        \"Geometry\", \"http://www.opengis.net/ont/geosparql#Geometry\"\r\n        \"asWKT\", \"http://www.opengis.net/ont/geosparql#asWKT\"\r\n        \"pcdm\", \"http://pcdm.org/models#\"\r\n        \"bibo\", \"http://purl.org/ontology/bibo/\"\r\n        \"cc\", \"http://creativecommons.org/ns#\"\r\n        \"dct\", \"http://purl.org/dc/terms/\"\r\n        \"foaf\", \"http://xmlns.com/foaf/0.1/\"\r\n        \"prof\", \"http://www.w3.org/ns/dx/prof/\"\r\n        \"profrole\", \"http://www.w3.org/ns/dx/prof/role/\"\r\n        \"rdf\", \"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\r\n        \"rdfa\", \"http://www.w3.org/ns/rdfa#\"\r\n        \"rdfs\", \"http://www.w3.org/2000/01/rdf-schema#\"\r\n        \"schema\", \"http://schema.org/\"\r\n        \"frapo\", \"http://purl.org/cerif/frapo/\"\r\n        \"rel\", \"https://www.w3.org/ns/iana/link-relations/relation#\"\r\n        \"pav\", \"http://purl.org/pav/\"\r\n        \"prov\", \"http://www.w3.org/ns/prov#\"\r\n        \"wfdesc\", \"http://purl.org/ro/wfdesc#\"\r\n        \"wfprov\", \"http://purl.org/ro/wfprov#\"\r\n        \"roterms\", \"http://purl.org/ro/roterms#\"\r\n        \"relation\", \"http://www.iana.org/assignments/relation/\"\r\n        \"wf4ever\", \"http://purl.org/ro/wf4ever#\"\r\n        \"vann\", \"http://purl.org/vocab/vann/\"\r\n        \"geosparql\", \"http://www.opengis.net/ont/geosparql#\"\r\n        "

terms_v1_1: str = "\r\n        \"3DModel\", \"http://schema.org/3DModel\"\r\n        \"AMRadioChannel\", \"http://schema.org/AMRadioChannel\"\r\n        \"APIReference\", \"http://schema.org/APIReference\"\r\n        \"Abdomen\", \"http://schema.org/Abdomen\"\r\n        \"AboutPage\", \"http://schema.org/AboutPage\"\r\n        \"AcceptAction\", \"http://schema.org/AcceptAction\"\r\n        \"Accommodation\", \"http://schema.org/Accommodation\"\r\n        \"AccountingService\", \"http://schema.org/AccountingService\"\r\n        \"AchieveAction\", \"http://schema.org/AchieveAction\"\r\n        \"Action\", \"http://schema.org/Action\"\r\n        \"ActionAccessSpecification\", \"http://schema.org/ActionAccessSpecification\"\r\n        \"ActionStatusType\", \"http://schema.org/ActionStatusType\"\r\n        \"ActivateAction\", \"http://schema.org/ActivateAction\"\r\n        \"ActiveActionStatus\", \"http://schema.org/ActiveActionStatus\"\r\n        \"ActiveNotRecruiting\", \"http://schema.org/ActiveNotRecruiting\"\r\n        \"AddAction\", \"http://schema.org/AddAction\"\r\n        \"AdministrativeArea\", \"http://schema.org/AdministrativeArea\"\r\n        \"AdultEntertainment\", \"http://schema.org/AdultEntertainment\"\r\n        \"AdvertiserContentArticle\", \"http://schema.org/AdvertiserContentArticle\"\r\n        \"AerobicActivity\", \"http://schema.org/AerobicActivity\"\r\n        \"AggregateOffer\", \"http://schema.org/AggregateOffer\"\r\n        \"AggregateRating\", \"http://schema.org/AggregateRating\"\r\n        \"AgreeAction\", \"http://schema.org/AgreeAction\"\r\n        \"Airline\", \"http://schema.org/Airline\"\r\n        \"Airport\", \"http://schema.org/Airport\"\r\n        \"AlbumRelease\", \"http://schema.org/AlbumRelease\"\r\n        \"AlignmentObject\", \"http://schema.org/AlignmentObject\"\r\n        \"AllWheelDriveConfiguration\", \"http://schema.org/AllWheelDriveConfiguration\"\r\n        \"AllocateAction\", \"http://schema.org/AllocateAction\"\r\n        \"AmusementPark\", \"http://schema.org/AmusementPark\"\r\n        \"AnaerobicActivity\", \"http://schema.org/AnaerobicActivity\"\r\n        \"AnalysisNewsArticle\", \"http://schema.org/AnalysisNewsArticle\"\r\n        \"AnatomicalStructure\", \"http://schema.org/AnatomicalStructure\"\r\n        \"AnatomicalSystem\", \"http://schema.org/AnatomicalSystem\"\r\n        \"Anesthesia\", \"http://schema.org/Anesthesia\"\r\n        \"AnimalShelter\", \"http://schema.org/AnimalShelter\"\r\n        \"Answer\", \"http://schema.org/Answer\"\r\n        \"Apartment\", \"http://schema.org/Apartment\"\r\n        \"ApartmentComplex\", \"http://schema.org/ApartmentComplex\"\r\n        \"Appearance\", \"http://schema.org/Appearance\"\r\n        \"AppendAction\", \"http://schema.org/AppendAction\"\r\n        \"ApplyAction\", \"http://schema.org/ApplyAction\"\r\n        \"ApprovedIndication\", \"http://schema.org/ApprovedIndication\"\r\n        \"Aquarium\", \"http://schema.org/Aquarium\"\r\n        \"ArchiveComponent\", \"http://schema.org/ArchiveComponent\"\r\n        \"ArchiveOrganization\", \"http://schema.org/ArchiveOrganization\"\r\n        \"ArriveAction\", \"http://schema.org/ArriveAction\"\r\n        \"ArtGallery\", \"http://schema.org/ArtGallery\"\r\n        \"Artery\", \"http://schema.org/Artery\"\r\n        \"Article\", \"http://schema.org/Article\"\r\n        \"AskAction\", \"http://schema.org/AskAction\"\r\n        \"AskPublicNewsArticle\", \"http://schema.org/AskPublicNewsArticle\"\r\n        \"AssessAction\", \"http://schema.org/AssessAction\"\r\n        \"AssignAction\", \"http://schema.org/AssignAction\"\r\n        \"Atlas\", \"http://schema.org/Atlas\"\r\n        \"Attorney\", \"http://schema.org/Attorney\"\r\n        \"Audience\", \"http://schema.org/Audience\"\r\n        \"AudioObject\", \"http://schema.org/AudioObject\"\r\n        \"Audiobook\", \"http://schema.org/Audiobook\"\r\n        \"AudiobookFormat\", \"http://schema.org/AudiobookFormat\"\r\n        \"AuthenticContent\", \"http://schema.org/AuthenticContent\"\r\n        \"AuthoritativeLegalValue\", \"http://schema.org/AuthoritativeLegalValue\"\r\n        \"AuthorizeAction\", \"http://schema.org/AuthorizeAction\"\r\n        \"AutoBodyShop\", \"http://schema.org/AutoBodyShop\"\r\n        \"AutoDealer\", \"http://schema.org/AutoDealer\"\r\n        \"AutoPartsStore\", \"http://schema.org/AutoPartsStore\"\r\n        \"AutoRental\", \"http://schema.org/AutoRental\"\r\n        \"AutoRepair\", \"http://schema.org/AutoRepair\"\r\n        \"AutoWash\", \"http://schema.org/AutoWash\"\r\n        \"AutomatedTeller\", \"http://schema.org/AutomatedTeller\"\r\n        \"AutomotiveBusiness\", \"http://schema.org/AutomotiveBusiness\"\r\n        \"Ayurvedic\", \"http://schema.org/Ayurvedic\"\r\n        \"BackgroundNewsArticle\", \"http://schema.org/BackgroundNewsArticle\"\r\n        \"Bacteria\", \"http://schema.org/Bacteria\"\r\n        \"Bakery\", \"http://schema.org/Bakery\"\r\n        \"Balance\", \"http://schema.org/Balance\"\r\n        \"BankAccount\", \"http://schema.org/BankAccount\"\r\n        \"BankOrCreditUnion\", \"http://schema.org/BankOrCreditUnion\"\r\n        \"BarOrPub\", \"http://schema.org/BarOrPub\"\r\n        \"Barcode\", \"http://schema.org/Barcode\"\r\n        \"BasicIncome\", \"http://schema.org/BasicIncome\"\r\n        \"Beach\", \"http://schema.org/Beach\"\r\n        \"BeautySalon\", \"http://schema.org/BeautySalon\"\r\n        \"BedAndBreakfast\", \"http://schema.org/BedAndBreakfast\"\r\n        \"BedDetails\", \"http://schema.org/BedDetails\"\r\n        \"BedType\", \"http://schema.org/BedType\"\r\n        \"BefriendAction\", \"http://schema.org/BefriendAction\"\r\n        \"BenefitsHealthAspect\", \"http://schema.org/BenefitsHealthAspect\"\r\n        \"BikeStore\", \"http://schema.org/BikeStore\"\r\n        \"Blog\", \"http://schema.org/Blog\"\r\n        \"BlogPosting\", \"http://schema.org/BlogPosting\"\r\n        \"BloodTest\", \"http://schema.org/BloodTest\"\r\n        \"BoardingPolicyType\", \"http://schema.org/BoardingPolicyType\"\r\n        \"BoatReservation\", \"http://schema.org/BoatReservation\"\r\n        \"BoatTerminal\", \"http://schema.org/BoatTerminal\"\r\n        \"BoatTrip\", \"http://schema.org/BoatTrip\"\r\n        \"BodyOfWater\", \"http://schema.org/BodyOfWater\"\r\n        \"Bone\", \"http://schema.org/Bone\"\r\n        \"Book\", \"http://schema.org/Book\"\r\n        \"BookFormatType\", \"http://schema.org/BookFormatType\"\r\n        \"BookSeries\", \"http://schema.org/BookSeries\"\r\n        \"BookStore\", \"http://schema.org/BookStore\"\r\n        \"BookmarkAction\", \"http://schema.org/BookmarkAction\"\r\n        \"Boolean\", \"http://schema.org/Boolean\"\r\n        \"BorrowAction\", \"http://schema.org/BorrowAction\"\r\n        \"BowlingAlley\", \"http://schema.org/BowlingAlley\"\r\n        \"BrainStructure\", \"http://schema.org/BrainStructure\"\r\n        \"Brand\", \"http://schema.org/Brand\"\r\n        \"BreadcrumbList\", \"http://schema.org/BreadcrumbList\"\r\n        \"Brewery\", \"http://schema.org/Brewery\"\r\n        \"Bridge\", \"http://schema.org/Bridge\"\r\n        \"BroadcastChannel\", \"http://schema.org/BroadcastChannel\"\r\n        \"BroadcastEvent\", \"http://schema.org/BroadcastEvent\"\r\n        \"BroadcastFrequencySpecification\", \"http://schema.org/BroadcastFrequencySpecification\"\r\n        \"BroadcastRelease\", \"http://schema.org/BroadcastRelease\"\r\n        \"BroadcastService\", \"http://schema.org/BroadcastService\"\r\n        \"BrokerageAccount\", \"http://schema.org/BrokerageAccount\"\r\n        \"BuddhistTemple\", \"http://schema.org/BuddhistTemple\"\r\n        \"BusOrCoach\", \"http://schema.org/BusOrCoach\"\r\n        \"BusReservation\", \"http://schema.org/BusReservation\"\r\n        \"BusStation\", \"http://schema.org/BusStation\"\r\n        \"BusStop\", \"http://schema.org/BusStop\"\r\n        \"BusTrip\", \"http://schema.org/BusTrip\"\r\n        \"BusinessAudience\", \"http://schema.org/BusinessAudience\"\r\n        \"BusinessEntityType\", \"http://schema.org/BusinessEntityType\"\r\n        \"BusinessEvent\", \"http://schema.org/BusinessEvent\"\r\n        \"BusinessFunction\", \"http://schema.org/BusinessFunction\"\r\n        \"BusinessSupport\", \"http://schema.org/BusinessSupport\"\r\n        \"BuyAction\", \"http://schema.org/BuyAction\"\r\n        \"CDCPMDRecord\", \"http://schema.org/CDCPMDRecord\"\r\n        \"CDFormat\", \"http://schema.org/CDFormat\"\r\n        \"CT\", \"http://schema.org/CT\"\r\n        \"CableOrSatelliteService\", \"http://schema.org/CableOrSatelliteService\"\r\n        \"CafeOrCoffeeShop\", \"http://schema.org/CafeOrCoffeeShop\"\r\n        \"Campground\", \"http://schema.org/Campground\"\r\n        \"CampingPitch\", \"http://schema.org/CampingPitch\"\r\n        \"Canal\", \"http://schema.org/Canal\"\r\n        \"CancelAction\", \"http://schema.org/CancelAction\"\r\n        \"Car\", \"http://schema.org/Car\"\r\n        \"CarUsageType\", \"http://schema.org/CarUsageType\"\r\n        \"Cardiovascular\", \"http://schema.org/Cardiovascular\"\r\n        \"CardiovascularExam\", \"http://schema.org/CardiovascularExam\"\r\n        \"CaseSeries\", \"http://schema.org/CaseSeries\"\r\n        \"Casino\", \"http://schema.org/Casino\"\r\n        \"CassetteFormat\", \"http://schema.org/CassetteFormat\"\r\n        \"CategoryCode\", \"http://schema.org/CategoryCode\"\r\n        \"CategoryCodeSet\", \"http://schema.org/CategoryCodeSet\"\r\n        \"CatholicChurch\", \"http://schema.org/CatholicChurch\"\r\n        \"CausesHealthAspect\", \"http://schema.org/CausesHealthAspect\"\r\n        \"Cemetery\", \"http://schema.org/Cemetery\"\r\n        \"Chapter\", \"http://schema.org/Chapter\"\r\n        \"CharitableIncorporatedOrganization\", \"http://schema.org/CharitableIncorporatedOrganization\"\r\n        \"CheckAction\", \"http://schema.org/CheckAction\"\r\n        \"CheckInAction\", \"http://schema.org/CheckInAction\"\r\n        \"CheckOutAction\", \"http://schema.org/CheckOutAction\"\r\n        \"CheckoutPage\", \"http://schema.org/CheckoutPage\"\r\n        \"ChildCare\", \"http://schema.org/ChildCare\"\r\n        \"ChildrensEvent\", \"http://schema.org/ChildrensEvent\"\r\n        \"Chiropractic\", \"http://schema.org/Chiropractic\"\r\n        \"ChooseAction\", \"http://schema.org/ChooseAction\"\r\n        \"Church\", \"http://schema.org/Church\"\r\n        \"City\", \"http://schema.org/City\"\r\n        \"CityHall\", \"http://schema.org/CityHall\"\r\n        \"CivicStructure\", \"http://schema.org/CivicStructure\"\r\n        \"Claim\", \"http://schema.org/Claim\"\r\n        \"ClaimReview\", \"http://schema.org/ClaimReview\"\r\n        \"Class\", \"http://schema.org/Class\"\r\n        \"Clinician\", \"http://schema.org/Clinician\"\r\n        \"Clip\", \"http://schema.org/Clip\"\r\n        \"ClothingStore\", \"http://schema.org/ClothingStore\"\r\n        \"CoOp\", \"http://schema.org/CoOp\"\r\n        \"Code\", \"http://schema.org/Code\"\r\n        \"CohortStudy\", \"http://schema.org/CohortStudy\"\r\n        \"Collection\", \"http://schema.org/Collection\"\r\n        \"CollectionPage\", \"http://schema.org/CollectionPage\"\r\n        \"CollegeOrUniversity\", \"http://schema.org/CollegeOrUniversity\"\r\n        \"ComedyClub\", \"http://schema.org/ComedyClub\"\r\n        \"ComedyEvent\", \"http://schema.org/ComedyEvent\"\r\n        \"ComicCoverArt\", \"http://schema.org/ComicCoverArt\"\r\n        \"ComicIssue\", \"http://schema.org/ComicIssue\"\r\n        \"ComicSeries\", \"http://schema.org/ComicSeries\"\r\n        \"ComicStory\", \"http://schema.org/ComicStory\"\r\n        \"Comment\", \"http://schema.org/Comment\"\r\n        \"CommentAction\", \"http://schema.org/CommentAction\"\r\n        \"CommentPermission\", \"http://schema.org/CommentPermission\"\r\n        \"CommunicateAction\", \"http://schema.org/CommunicateAction\"\r\n        \"CommunityHealth\", \"http://schema.org/CommunityHealth\"\r\n        \"CompilationAlbum\", \"http://schema.org/CompilationAlbum\"\r\n        \"CompleteDataFeed\", \"http://schema.org/CompleteDataFeed\"\r\n        \"Completed\", \"http://schema.org/Completed\"\r\n        \"CompletedActionStatus\", \"http://schema.org/CompletedActionStatus\"\r\n        \"CompoundPriceSpecification\", \"http://schema.org/CompoundPriceSpecification\"\r\n        \"ComputerLanguage\", \"http://schema.org/ComputerLanguage\"\r\n        \"ComputerStore\", \"http://schema.org/ComputerStore\"\r\n        \"ConfirmAction\", \"http://schema.org/ConfirmAction\"\r\n        \"Consortium\", \"http://schema.org/Consortium\"\r\n        \"ConsumeAction\", \"http://schema.org/ConsumeAction\"\r\n        \"ContactPage\", \"http://schema.org/ContactPage\"\r\n        \"ContactPoint\", \"http://schema.org/ContactPoint\"\r\n        \"ContactPointOption\", \"http://schema.org/ContactPointOption\"\r\n        \"ContagiousnessHealthAspect\", \"http://schema.org/ContagiousnessHealthAspect\"\r\n        \"Continent\", \"http://schema.org/Continent\"\r\n        \"ControlAction\", \"http://schema.org/ControlAction\"\r\n        \"ConvenienceStore\", \"http://schema.org/ConvenienceStore\"\r\n        \"Conversation\", \"http://schema.org/Conversation\"\r\n        \"CookAction\", \"http://schema.org/CookAction\"\r\n        \"Corporation\", \"http://schema.org/Corporation\"\r\n        \"CorrectionComment\", \"http://schema.org/CorrectionComment\"\r\n        \"Country\", \"http://schema.org/Country\"\r\n        \"Course\", \"http://schema.org/Course\"\r\n        \"CourseInstance\", \"http://schema.org/CourseInstance\"\r\n        \"Courthouse\", \"http://schema.org/Courthouse\"\r\n        \"CoverArt\", \"http://schema.org/CoverArt\"\r\n        \"CovidTestingFacility\", \"http://schema.org/CovidTestingFacility\"\r\n        \"CreateAction\", \"http://schema.org/CreateAction\"\r\n        \"CreativeWork\", \"http://schema.org/CreativeWork\"\r\n        \"CreativeWorkSeason\", \"http://schema.org/CreativeWorkSeason\"\r\n        \"CreativeWorkSeries\", \"http://schema.org/CreativeWorkSeries\"\r\n        \"CreditCard\", \"http://schema.org/CreditCard\"\r\n        \"Crematorium\", \"http://schema.org/Crematorium\"\r\n        \"CriticReview\", \"http://schema.org/CriticReview\"\r\n        \"CrossSectional\", \"http://schema.org/CrossSectional\"\r\n        \"CssSelectorType\", \"http://schema.org/CssSelectorType\"\r\n        \"CurrencyConversionService\", \"http://schema.org/CurrencyConversionService\"\r\n        \"DDxElement\", \"http://schema.org/DDxElement\"\r\n        \"DJMixAlbum\", \"http://schema.org/DJMixAlbum\"\r\n        \"DVDFormat\", \"http://schema.org/DVDFormat\"\r\n        \"DamagedCondition\", \"http://schema.org/DamagedCondition\"\r\n        \"DanceEvent\", \"http://schema.org/DanceEvent\"\r\n        \"DanceGroup\", \"http://schema.org/DanceGroup\"\r\n        \"DataCatalog\", \"http://schema.org/DataCatalog\"\r\n        \"DataDownload\", \"http://schema.org/DataDownload\"\r\n        \"DataFeed\", \"http://schema.org/DataFeed\"\r\n        \"DataFeedItem\", \"http://schema.org/DataFeedItem\"\r\n        \"DataType\", \"http://schema.org/DataType\"\r\n        \"Dataset\", \"http://schema.org/Dataset\"\r\n        \"Date\", \"http://schema.org/Date\"\r\n        \"DateTime\", \"http://schema.org/DateTime\"\r\n        \"DatedMoneySpecification\", \"http://schema.org/DatedMoneySpecification\"\r\n        \"DayOfWeek\", \"http://schema.org/DayOfWeek\"\r\n        \"DaySpa\", \"http://schema.org/DaySpa\"\r\n        \"DeactivateAction\", \"http://schema.org/DeactivateAction\"\r\n        \"DefenceEstablishment\", \"http://schema.org/DefenceEstablishment\"\r\n        \"DefinedRegion\", \"http://schema.org/DefinedRegion\"\r\n        \"DefinedTerm\", \"http://schema.org/DefinedTerm\"\r\n        \"DefinedTermSet\", \"http://schema.org/DefinedTermSet\"\r\n        \"DefinitiveLegalValue\", \"http://schema.org/DefinitiveLegalValue\"\r\n        \"DeleteAction\", \"http://schema.org/DeleteAction\"\r\n        \"DeliveryChargeSpecification\", \"http://schema.org/DeliveryChargeSpecification\"\r\n        \"DeliveryEvent\", \"http://schema.org/DeliveryEvent\"\r\n        \"DeliveryMethod\", \"http://schema.org/DeliveryMethod\"\r\n        \"DeliveryTimeSettings\", \"http://schema.org/DeliveryTimeSettings\"\r\n        \"Demand\", \"http://schema.org/Demand\"\r\n        \"DemoAlbum\", \"http://schema.org/DemoAlbum\"\r\n        \"Dentist\", \"http://schema.org/Dentist\"\r\n        \"Dentistry\", \"http://schema.org/Dentistry\"\r\n        \"DepartAction\", \"http://schema.org/DepartAction\"\r\n        \"DepartmentStore\", \"http://schema.org/DepartmentStore\"\r\n        \"DepositAccount\", \"http://schema.org/DepositAccount\"\r\n        \"Dermatologic\", \"http://schema.org/Dermatologic\"\r\n        \"Dermatology\", \"http://schema.org/Dermatology\"\r\n        \"DiabeticDiet\", \"http://schema.org/DiabeticDiet\"\r\n        \"Diagnostic\", \"http://schema.org/Diagnostic\"\r\n        \"DiagnosticLab\", \"http://schema.org/DiagnosticLab\"\r\n        \"DiagnosticProcedure\", \"http://schema.org/DiagnosticProcedure\"\r\n        \"Diet\", \"http://schema.org/Diet\"\r\n        \"DietNutrition\", \"http://schema.org/DietNutrition\"\r\n        \"DietarySupplement\", \"http://schema.org/DietarySupplement\"\r\n        \"DigitalAudioTapeFormat\", \"http://schema.org/DigitalAudioTapeFormat\"\r\n        \"DigitalDocument\", \"http://schema.org/DigitalDocument\"\r\n        \"DigitalDocumentPermission\", \"http://schema.org/DigitalDocumentPermission\"\r\n        \"DigitalDocumentPermissionType\", \"http://schema.org/DigitalDocumentPermissionType\"\r\n        \"DigitalFormat\", \"http://schema.org/DigitalFormat\"\r\n        \"DisabilitySupport\", \"http://schema.org/DisabilitySupport\"\r\n        \"DisagreeAction\", \"http://schema.org/DisagreeAction\"\r\n        \"Discontinued\", \"http://schema.org/Discontinued\"\r\n        \"DiscoverAction\", \"http://schema.org/DiscoverAction\"\r\n        \"DiscussionForumPosting\", \"http://schema.org/DiscussionForumPosting\"\r\n        \"DislikeAction\", \"http://schema.org/DislikeAction\"\r\n        \"Distance\", \"http://schema.org/Distance\"\r\n        \"Distillery\", \"http://schema.org/Distillery\"\r\n        \"DonateAction\", \"http://schema.org/DonateAction\"\r\n        \"DoseSchedule\", \"http://schema.org/DoseSchedule\"\r\n        \"DoubleBlindedTrial\", \"http://schema.org/DoubleBlindedTrial\"\r\n        \"DownloadAction\", \"http://schema.org/DownloadAction\"\r\n        \"DrawAction\", \"http://schema.org/DrawAction\"\r\n        \"Drawing\", \"http://schema.org/Drawing\"\r\n        \"DrinkAction\", \"http://schema.org/DrinkAction\"\r\n        \"DriveWheelConfigurationValue\", \"http://schema.org/DriveWheelConfigurationValue\"\r\n        \"DrivingSchoolVehicleUsage\", \"http://schema.org/DrivingSchoolVehicleUsage\"\r\n        \"Drug\", \"http://schema.org/Drug\"\r\n        \"DrugClass\", \"http://schema.org/DrugClass\"\r\n        \"DrugCost\", \"http://schema.org/DrugCost\"\r\n        \"DrugCostCategory\", \"http://schema.org/DrugCostCategory\"\r\n        \"DrugLegalStatus\", \"http://schema.org/DrugLegalStatus\"\r\n        \"DrugPregnancyCategory\", \"http://schema.org/DrugPregnancyCategory\"\r\n        \"DrugPrescriptionStatus\", \"http://schema.org/DrugPrescriptionStatus\"\r\n        \"DrugStrength\", \"http://schema.org/DrugStrength\"\r\n        \"DryCleaningOrLaundry\", \"http://schema.org/DryCleaningOrLaundry\"\r\n        \"Duration\", \"http://schema.org/Duration\"\r\n        \"EBook\", \"http://schema.org/EBook\"\r\n        \"EPRelease\", \"http://schema.org/EPRelease\"\r\n        \"EUEnergyEfficiencyCategoryA\", \"http://schema.org/EUEnergyEfficiencyCategoryA\"\r\n        \"EUEnergyEfficiencyCategoryA1Plus\", \"http://schema.org/EUEnergyEfficiencyCategoryA1Plus\"\r\n        \"EUEnergyEfficiencyCategoryA2Plus\", \"http://schema.org/EUEnergyEfficiencyCategoryA2Plus\"\r\n        \"EUEnergyEfficiencyCategoryA3Plus\", \"http://schema.org/EUEnergyEfficiencyCategoryA3Plus\"\r\n        \"EUEnergyEfficiencyCategoryB\", \"http://schema.org/EUEnergyEfficiencyCategoryB\"\r\n        \"EUEnergyEfficiencyCategoryC\", \"http://schema.org/EUEnergyEfficiencyCategoryC\"\r\n        \"EUEnergyEfficiencyCategoryD\", \"http://schema.org/EUEnergyEfficiencyCategoryD\"\r\n        \"EUEnergyEfficiencyCategoryE\", \"http://schema.org/EUEnergyEfficiencyCategoryE\"\r\n        \"EUEnergyEfficiencyCategoryF\", \"http://schema.org/EUEnergyEfficiencyCategoryF\"\r\n        \"EUEnergyEfficiencyCategoryG\", \"http://schema.org/EUEnergyEfficiencyCategoryG\"\r\n        \"EUEnergyEfficiencyEnumeration\", \"http://schema.org/EUEnergyEfficiencyEnumeration\"\r\n        \"Ear\", \"http://schema.org/Ear\"\r\n        \"EatAction\", \"http://schema.org/EatAction\"\r\n        \"EducationEvent\", \"http://schema.org/EducationEvent\"\r\n        \"EducationalAudience\", \"http://schema.org/EducationalAudience\"\r\n        \"EducationalOccupationalCredential\", \"http://schema.org/EducationalOccupationalCredential\"\r\n        \"EducationalOccupationalProgram\", \"http://schema.org/EducationalOccupationalProgram\"\r\n        \"EducationalOrganization\", \"http://schema.org/EducationalOrganization\"\r\n        \"Electrician\", \"http://schema.org/Electrician\"\r\n        \"ElectronicsStore\", \"http://schema.org/ElectronicsStore\"\r\n        \"ElementarySchool\", \"http://schema.org/ElementarySchool\"\r\n        \"EmailMessage\", \"http://schema.org/EmailMessage\"\r\n        \"Embassy\", \"http://schema.org/Embassy\"\r\n        \"Emergency\", \"http://schema.org/Emergency\"\r\n        \"EmergencyService\", \"http://schema.org/EmergencyService\"\r\n        \"EmployeeRole\", \"http://schema.org/EmployeeRole\"\r\n        \"EmployerAggregateRating\", \"http://schema.org/EmployerAggregateRating\"\r\n        \"EmployerReview\", \"http://schema.org/EmployerReview\"\r\n        \"EmploymentAgency\", \"http://schema.org/EmploymentAgency\"\r\n        \"Endocrine\", \"http://schema.org/Endocrine\"\r\n        \"EndorseAction\", \"http://schema.org/EndorseAction\"\r\n        \"EndorsementRating\", \"http://schema.org/EndorsementRating\"\r\n        \"Energy\", \"http://schema.org/Energy\"\r\n        \"EnergyConsumptionDetails\", \"http://schema.org/EnergyConsumptionDetails\"\r\n        \"EnergyEfficiencyEnumeration\", \"http://schema.org/EnergyEfficiencyEnumeration\"\r\n        \"EnergyStarCertified\", \"http://schema.org/EnergyStarCertified\"\r\n        \"EnergyStarEnergyEfficiencyEnumeration\", \"http://schema.org/EnergyStarEnergyEfficiencyEnumeration\"\r\n        \"EngineSpecification\", \"http://schema.org/EngineSpecification\"\r\n        \"EnrollingByInvitation\", \"http://schema.org/EnrollingByInvitation\"\r\n        \"EntertainmentBusiness\", \"http://schema.org/EntertainmentBusiness\"\r\n        \"EntryPoint\", \"http://schema.org/EntryPoint\"\r\n        \"Enumeration\", \"http://schema.org/Enumeration\"\r\n        \"Episode\", \"http://schema.org/Episode\"\r\n        \"Event\", \"http://schema.org/Event\"\r\n        \"EventAttendanceModeEnumeration\", \"http://schema.org/EventAttendanceModeEnumeration\"\r\n        \"EventCancelled\", \"http://schema.org/EventCancelled\"\r\n        \"EventMovedOnline\", \"http://schema.org/EventMovedOnline\"\r\n        \"EventPostponed\", \"http://schema.org/EventPostponed\"\r\n        \"EventRescheduled\", \"http://schema.org/EventRescheduled\"\r\n        \"EventReservation\", \"http://schema.org/EventReservation\"\r\n        \"EventScheduled\", \"http://schema.org/EventScheduled\"\r\n        \"EventSeries\", \"http://schema.org/EventSeries\"\r\n        \"EventStatusType\", \"http://schema.org/EventStatusType\"\r\n        \"EventVenue\", \"http://schema.org/EventVenue\"\r\n        \"EvidenceLevelA\", \"http://schema.org/EvidenceLevelA\"\r\n        \"EvidenceLevelB\", \"http://schema.org/EvidenceLevelB\"\r\n        \"EvidenceLevelC\", \"http://schema.org/EvidenceLevelC\"\r\n        \"ExchangeRateSpecification\", \"http://schema.org/ExchangeRateSpecification\"\r\n        \"ExchangeRefund\", \"http://schema.org/ExchangeRefund\"\r\n        \"ExerciseAction\", \"http://schema.org/ExerciseAction\"\r\n        \"ExerciseGym\", \"http://schema.org/ExerciseGym\"\r\n        \"ExercisePlan\", \"http://schema.org/ExercisePlan\"\r\n        \"ExhibitionEvent\", \"http://schema.org/ExhibitionEvent\"\r\n        \"Eye\", \"http://schema.org/Eye\"\r\n        \"FAQPage\", \"http://schema.org/FAQPage\"\r\n        \"FDAcategoryA\", \"http://schema.org/FDAcategoryA\"\r\n        \"FDAcategoryB\", \"http://schema.org/FDAcategoryB\"\r\n        \"FDAcategoryC\", \"http://schema.org/FDAcategoryC\"\r\n        \"FDAcategoryD\", \"http://schema.org/FDAcategoryD\"\r\n        \"FDAcategoryX\", \"http://schema.org/FDAcategoryX\"\r\n        \"FDAnotEvaluated\", \"http://schema.org/FDAnotEvaluated\"\r\n        \"FMRadioChannel\", \"http://schema.org/FMRadioChannel\"\r\n        \"FailedActionStatus\", \"http://schema.org/FailedActionStatus\"\r\n        \"False\", \"http://schema.org/False\"\r\n        \"FastFoodRestaurant\", \"http://schema.org/FastFoodRestaurant\"\r\n        \"Female\", \"http://schema.org/Female\"\r\n        \"Festival\", \"http://schema.org/Festival\"\r\n        \"FilmAction\", \"http://schema.org/FilmAction\"\r\n        \"FinancialProduct\", \"http://schema.org/FinancialProduct\"\r\n        \"FinancialService\", \"http://schema.org/FinancialService\"\r\n        \"FindAction\", \"http://schema.org/FindAction\"\r\n        \"FireStation\", \"http://schema.org/FireStation\"\r\n        \"Flexibility\", \"http://schema.org/Flexibility\"\r\n        \"Flight\", \"http://schema.org/Flight\"\r\n        \"FlightReservation\", \"http://schema.org/FlightReservation\"\r\n        \"Float\", \"http://schema.org/Float\"\r\n        \"FloorPlan\", \"http://schema.org/FloorPlan\"\r\n        \"Florist\", \"http://schema.org/Florist\"\r\n        \"FollowAction\", \"http://schema.org/FollowAction\"\r\n        \"FoodEstablishment\", \"http://schema.org/FoodEstablishment\"\r\n        \"FoodEstablishmentReservation\", \"http://schema.org/FoodEstablishmentReservation\"\r\n        \"FoodEvent\", \"http://schema.org/FoodEvent\"\r\n        \"FoodService\", \"http://schema.org/FoodService\"\r\n        \"FourWheelDriveConfiguration\", \"http://schema.org/FourWheelDriveConfiguration\"\r\n        \"Friday\", \"http://schema.org/Friday\"\r\n        \"FrontWheelDriveConfiguration\", \"http://schema.org/FrontWheelDriveConfiguration\"\r\n        \"FullRefund\", \"http://schema.org/FullRefund\"\r\n        \"FundingAgency\", \"http://schema.org/FundingAgency\"\r\n        \"FundingScheme\", \"http://schema.org/FundingScheme\"\r\n        \"Fungus\", \"http://schema.org/Fungus\"\r\n        \"FurnitureStore\", \"http://schema.org/FurnitureStore\"\r\n        \"Game\", \"http://schema.org/Game\"\r\n        \"GamePlayMode\", \"http://schema.org/GamePlayMode\"\r\n        \"GameServer\", \"http://schema.org/GameServer\"\r\n        \"GameServerStatus\", \"http://schema.org/GameServerStatus\"\r\n        \"GardenStore\", \"http://schema.org/GardenStore\"\r\n        \"GasStation\", \"http://schema.org/GasStation\"\r\n        \"Gastroenterologic\", \"http://schema.org/Gastroenterologic\"\r\n        \"GatedResidenceCommunity\", \"http://schema.org/GatedResidenceCommunity\"\r\n        \"GenderType\", \"http://schema.org/GenderType\"\r\n        \"GeneralContractor\", \"http://schema.org/GeneralContractor\"\r\n        \"Genetic\", \"http://schema.org/Genetic\"\r\n        \"Genitourinary\", \"http://schema.org/Genitourinary\"\r\n        \"GeoCircle\", \"http://schema.org/GeoCircle\"\r\n        \"GeoCoordinates\", \"http://schema.org/GeoCoordinates\"\r\n        \"GeoShape\", \"http://schema.org/GeoShape\"\r\n        \"GeospatialGeometry\", \"http://schema.org/GeospatialGeometry\"\r\n        \"Geriatric\", \"http://schema.org/Geriatric\"\r\n        \"GiveAction\", \"http://schema.org/GiveAction\"\r\n        \"GlutenFreeDiet\", \"http://schema.org/GlutenFreeDiet\"\r\n        \"GolfCourse\", \"http://schema.org/GolfCourse\"\r\n        \"GovernmentBenefitsType\", \"http://schema.org/GovernmentBenefitsType\"\r\n        \"GovernmentBuilding\", \"http://schema.org/GovernmentBuilding\"\r\n        \"GovernmentOffice\", \"http://schema.org/GovernmentOffice\"\r\n        \"GovernmentOrganization\", \"http://schema.org/GovernmentOrganization\"\r\n        \"GovernmentPermit\", \"http://schema.org/GovernmentPermit\"\r\n        \"GovernmentService\", \"http://schema.org/GovernmentService\"\r\n        \"Grant\", \"http://schema.org/Grant\"\r\n        \"GraphicNovel\", \"http://schema.org/GraphicNovel\"\r\n        \"GroceryStore\", \"http://schema.org/GroceryStore\"\r\n        \"GroupBoardingPolicy\", \"http://schema.org/GroupBoardingPolicy\"\r\n        \"Guide\", \"http://schema.org/Guide\"\r\n        \"Gynecologic\", \"http://schema.org/Gynecologic\"\r\n        \"HTML\", \"rdf,HTML\"\r\n        \"HVACBusiness\", \"http://schema.org/HVACBusiness\"\r\n        \"Hackathon\", \"http://schema.org/Hackathon\"\r\n        \"HairSalon\", \"http://schema.org/HairSalon\"\r\n        \"HalalDiet\", \"http://schema.org/HalalDiet\"\r\n        \"Hardcover\", \"http://schema.org/Hardcover\"\r\n        \"HardwareStore\", \"http://schema.org/HardwareStore\"\r\n        \"Head\", \"http://schema.org/Head\"\r\n        \"HealthAndBeautyBusiness\", \"http://schema.org/HealthAndBeautyBusiness\"\r\n        \"HealthAspectEnumeration\", \"http://schema.org/HealthAspectEnumeration\"\r\n        \"HealthCare\", \"http://schema.org/HealthCare\"\r\n        \"HealthClub\", \"http://schema.org/HealthClub\"\r\n        \"HealthInsurancePlan\", \"http://schema.org/HealthInsurancePlan\"\r\n        \"HealthPlanCostSharingSpecification\", \"http://schema.org/HealthPlanCostSharingSpecification\"\r\n        \"HealthPlanFormulary\", \"http://schema.org/HealthPlanFormulary\"\r\n        \"HealthPlanNetwork\", \"http://schema.org/HealthPlanNetwork\"\r\n        \"HealthTopicContent\", \"http://schema.org/HealthTopicContent\"\r\n        \"HearingImpairedSupported\", \"http://schema.org/HearingImpairedSupported\"\r\n        \"Hematologic\", \"http://schema.org/Hematologic\"\r\n        \"HighSchool\", \"http://schema.org/HighSchool\"\r\n        \"HinduDiet\", \"http://schema.org/HinduDiet\"\r\n        \"HinduTemple\", \"http://schema.org/HinduTemple\"\r\n        \"HobbyShop\", \"http://schema.org/HobbyShop\"\r\n        \"HomeAndConstructionBusiness\", \"http://schema.org/HomeAndConstructionBusiness\"\r\n        \"HomeGoodsStore\", \"http://schema.org/HomeGoodsStore\"\r\n        \"Homeopathic\", \"http://schema.org/Homeopathic\"\r\n        \"Hospital\", \"http://schema.org/Hospital\"\r\n        \"Hostel\", \"http://schema.org/Hostel\"\r\n        \"Hotel\", \"http://schema.org/Hotel\"\r\n        \"HotelRoom\", \"http://schema.org/HotelRoom\"\r\n        \"House\", \"http://schema.org/House\"\r\n        \"HousePainter\", \"http://schema.org/HousePainter\"\r\n        \"HowOrWhereHealthAspect\", \"http://schema.org/HowOrWhereHealthAspect\"\r\n        \"HowTo\", \"http://schema.org/HowTo\"\r\n        \"HowToDirection\", \"http://schema.org/HowToDirection\"\r\n        \"HowToItem\", \"http://schema.org/HowToItem\"\r\n        \"HowToSection\", \"http://schema.org/HowToSection\"\r\n        \"HowToStep\", \"http://schema.org/HowToStep\"\r\n        \"HowToSupply\", \"http://schema.org/HowToSupply\"\r\n        \"HowToTip\", \"http://schema.org/HowToTip\"\r\n        \"HowToTool\", \"http://schema.org/HowToTool\"\r\n        \"IceCreamShop\", \"http://schema.org/IceCreamShop\"\r\n        \"IgnoreAction\", \"http://schema.org/IgnoreAction\"\r\n        \"ImageGallery\", \"http://schema.org/ImageGallery\"\r\n        \"ImageObject\", \"http://schema.org/ImageObject\"\r\n        \"ImagingTest\", \"http://schema.org/ImagingTest\"\r\n        \"InForce\", \"http://schema.org/InForce\"\r\n        \"InStock\", \"http://schema.org/InStock\"\r\n        \"InStoreOnly\", \"http://schema.org/InStoreOnly\"\r\n        \"IndividualProduct\", \"http://schema.org/IndividualProduct\"\r\n        \"Infectious\", \"http://schema.org/Infectious\"\r\n        \"InfectiousAgentClass\", \"http://schema.org/InfectiousAgentClass\"\r\n        \"InfectiousDisease\", \"http://schema.org/InfectiousDisease\"\r\n        \"InformAction\", \"http://schema.org/InformAction\"\r\n        \"InsertAction\", \"http://schema.org/InsertAction\"\r\n        \"InstallAction\", \"http://schema.org/InstallAction\"\r\n        \"InsuranceAgency\", \"http://schema.org/InsuranceAgency\"\r\n        \"Intangible\", \"http://schema.org/Intangible\"\r\n        \"Integer\", \"http://schema.org/Integer\"\r\n        \"InteractAction\", \"http://schema.org/InteractAction\"\r\n        \"InteractionCounter\", \"http://schema.org/InteractionCounter\"\r\n        \"InternationalTrial\", \"http://schema.org/InternationalTrial\"\r\n        \"InternetCafe\", \"http://schema.org/InternetCafe\"\r\n        \"InvestmentFund\", \"http://schema.org/InvestmentFund\"\r\n        \"InvestmentOrDeposit\", \"http://schema.org/InvestmentOrDeposit\"\r\n        \"InviteAction\", \"http://schema.org/InviteAction\"\r\n        \"Invoice\", \"http://schema.org/Invoice\"\r\n        \"ItemAvailability\", \"http://schema.org/ItemAvailability\"\r\n        \"ItemList\", \"http://schema.org/ItemList\"\r\n        \"ItemListOrderAscending\", \"http://schema.org/ItemListOrderAscending\"\r\n        \"ItemListOrderDescending\", \"http://schema.org/ItemListOrderDescending\"\r\n        \"ItemListOrderType\", \"http://schema.org/ItemListOrderType\"\r\n        \"ItemListUnordered\", \"http://schema.org/ItemListUnordered\"\r\n        \"ItemPage\", \"http://schema.org/ItemPage\"\r\n        \"JewelryStore\", \"http://schema.org/JewelryStore\"\r\n        \"JobPosting\", \"http://schema.org/JobPosting\"\r\n        \"JoinAction\", \"http://schema.org/JoinAction\"\r\n        \"Joint\", \"http://schema.org/Joint\"\r\n        \"KosherDiet\", \"http://schema.org/KosherDiet\"\r\n        \"LaboratoryScience\", \"http://schema.org/LaboratoryScience\"\r\n        \"LakeBodyOfWater\", \"http://schema.org/LakeBodyOfWater\"\r\n        \"Landform\", \"http://schema.org/Landform\"\r\n        \"LandmarksOrHistoricalBuildings\", \"http://schema.org/LandmarksOrHistoricalBuildings\"\r\n        \"Language\", \"http://schema.org/Language\"\r\n        \"LaserDiscFormat\", \"http://schema.org/LaserDiscFormat\"\r\n        \"LearningResource\", \"http://schema.org/LearningResource\"\r\n        \"LeaveAction\", \"http://schema.org/LeaveAction\"\r\n        \"LeftHandDriving\", \"http://schema.org/LeftHandDriving\"\r\n        \"LegalForceStatus\", \"http://schema.org/LegalForceStatus\"\r\n        \"LegalService\", \"http://schema.org/LegalService\"\r\n        \"LegalValueLevel\", \"http://schema.org/LegalValueLevel\"\r\n        \"Legislation\", \"http://schema.org/Legislation\"\r\n        \"LegislationObject\", \"http://schema.org/LegislationObject\"\r\n        \"LegislativeBuilding\", \"http://schema.org/LegislativeBuilding\"\r\n        \"LeisureTimeActivity\", \"http://schema.org/LeisureTimeActivity\"\r\n        \"LendAction\", \"http://schema.org/LendAction\"\r\n        \"Library\", \"http://schema.org/Library\"\r\n        \"LibrarySystem\", \"http://schema.org/LibrarySystem\"\r\n        \"LifestyleModification\", \"http://schema.org/LifestyleModification\"\r\n        \"Ligament\", \"http://schema.org/Ligament\"\r\n        \"LikeAction\", \"http://schema.org/LikeAction\"\r\n        \"LimitedAvailability\", \"http://schema.org/LimitedAvailability\"\r\n        \"LimitedByGuaranteeCharity\", \"http://schema.org/LimitedByGuaranteeCharity\"\r\n        \"LinkRole\", \"http://schema.org/LinkRole\"\r\n        \"LiquorStore\", \"http://schema.org/LiquorStore\"\r\n        \"ListItem\", \"http://schema.org/ListItem\"\r\n        \"ListenAction\", \"http://schema.org/ListenAction\"\r\n        \"LiteraryEvent\", \"http://schema.org/LiteraryEvent\"\r\n        \"LiveAlbum\", \"http://schema.org/LiveAlbum\"\r\n        \"LiveBlogPosting\", \"http://schema.org/LiveBlogPosting\"\r\n        \"LivingWithHealthAspect\", \"http://schema.org/LivingWithHealthAspect\"\r\n        \"LoanOrCredit\", \"http://schema.org/LoanOrCredit\"\r\n        \"LocalBusiness\", \"http://schema.org/LocalBusiness\"\r\n        \"LocationFeatureSpecification\", \"http://schema.org/LocationFeatureSpecification\"\r\n        \"LockerDelivery\", \"http://schema.org/LockerDelivery\"\r\n        \"Locksmith\", \"http://schema.org/Locksmith\"\r\n        \"LodgingBusiness\", \"http://schema.org/LodgingBusiness\"\r\n        \"LodgingReservation\", \"http://schema.org/LodgingReservation\"\r\n        \"Longitudinal\", \"http://schema.org/Longitudinal\"\r\n        \"LoseAction\", \"http://schema.org/LoseAction\"\r\n        \"LowCalorieDiet\", \"http://schema.org/LowCalorieDiet\"\r\n        \"LowFatDiet\", \"http://schema.org/LowFatDiet\"\r\n        \"LowLactoseDiet\", \"http://schema.org/LowLactoseDiet\"\r\n        \"LowSaltDiet\", \"http://schema.org/LowSaltDiet\"\r\n        \"Lung\", \"http://schema.org/Lung\"\r\n        \"LymphaticVessel\", \"http://schema.org/LymphaticVessel\"\r\n        \"MRI\", \"http://schema.org/MRI\"\r\n        \"Male\", \"http://schema.org/Male\"\r\n        \"Manuscript\", \"http://schema.org/Manuscript\"\r\n        \"Map\", \"http://schema.org/Map\"\r\n        \"MapCategoryType\", \"http://schema.org/MapCategoryType\"\r\n        \"MarryAction\", \"http://schema.org/MarryAction\"\r\n        \"Mass\", \"http://schema.org/Mass\"\r\n        \"MaximumDoseSchedule\", \"http://schema.org/MaximumDoseSchedule\"\r\n        \"MayTreatHealthAspect\", \"http://schema.org/MayTreatHealthAspect\"\r\n        \"MediaGallery\", \"http://schema.org/MediaGallery\"\r\n        \"MediaManipulationRatingEnumeration\", \"http://schema.org/MediaManipulationRatingEnumeration\"\r\n        \"MediaObject\", \"http://schema.org/MediaObject\"\r\n        \"MediaReview\", \"http://schema.org/MediaReview\"\r\n        \"MediaSubscription\", \"http://schema.org/MediaSubscription\"\r\n        \"MedicalAudience\", \"http://schema.org/MedicalAudience\"\r\n        \"MedicalAudienceType\", \"http://schema.org/MedicalAudienceType\"\r\n        \"MedicalBusiness\", \"http://schema.org/MedicalBusiness\"\r\n        \"MedicalCause\", \"http://schema.org/MedicalCause\"\r\n        \"MedicalClinic\", \"http://schema.org/MedicalClinic\"\r\n        \"MedicalCode\", \"http://schema.org/MedicalCode\"\r\n        \"MedicalCondition\", \"http://schema.org/MedicalCondition\"\r\n        \"MedicalConditionStage\", \"http://schema.org/MedicalConditionStage\"\r\n        \"MedicalContraindication\", \"http://schema.org/MedicalContraindication\"\r\n        \"MedicalDevice\", \"http://schema.org/MedicalDevice\"\r\n        \"MedicalDevicePurpose\", \"http://schema.org/MedicalDevicePurpose\"\r\n        \"MedicalEntity\", \"http://schema.org/MedicalEntity\"\r\n        \"MedicalEnumeration\", \"http://schema.org/MedicalEnumeration\"\r\n        \"MedicalEvidenceLevel\", \"http://schema.org/MedicalEvidenceLevel\"\r\n        \"MedicalGuideline\", \"http://schema.org/MedicalGuideline\"\r\n        \"MedicalGuidelineContraindication\", \"http://schema.org/MedicalGuidelineContraindication\"\r\n        \"MedicalGuidelineRecommendation\", \"http://schema.org/MedicalGuidelineRecommendation\"\r\n        \"MedicalImagingTechnique\", \"http://schema.org/MedicalImagingTechnique\"\r\n        \"MedicalIndication\", \"http://schema.org/MedicalIndication\"\r\n        \"MedicalIntangible\", \"http://schema.org/MedicalIntangible\"\r\n        \"MedicalObservationalStudy\", \"http://schema.org/MedicalObservationalStudy\"\r\n        \"MedicalObservationalStudyDesign\", \"http://schema.org/MedicalObservationalStudyDesign\"\r\n        \"MedicalOrganization\", \"http://schema.org/MedicalOrganization\"\r\n        \"MedicalProcedure\", \"http://schema.org/MedicalProcedure\"\r\n        \"MedicalProcedureType\", \"http://schema.org/MedicalProcedureType\"\r\n        \"MedicalResearcher\", \"http://schema.org/MedicalResearcher\"\r\n        \"MedicalRiskCalculator\", \"http://schema.org/MedicalRiskCalculator\"\r\n        \"MedicalRiskEstimator\", \"http://schema.org/MedicalRiskEstimator\"\r\n        \"MedicalRiskFactor\", \"http://schema.org/MedicalRiskFactor\"\r\n        \"MedicalRiskScore\", \"http://schema.org/MedicalRiskScore\"\r\n        \"MedicalScholarlyArticle\", \"http://schema.org/MedicalScholarlyArticle\"\r\n        \"MedicalSign\", \"http://schema.org/MedicalSign\"\r\n        \"MedicalSignOrSymptom\", \"http://schema.org/MedicalSignOrSymptom\"\r\n        \"MedicalSpecialty\", \"http://schema.org/MedicalSpecialty\"\r\n        \"MedicalStudy\", \"http://schema.org/MedicalStudy\"\r\n        \"MedicalStudyStatus\", \"http://schema.org/MedicalStudyStatus\"\r\n        \"MedicalSymptom\", \"http://schema.org/MedicalSymptom\"\r\n        \"MedicalTest\", \"http://schema.org/MedicalTest\"\r\n        \"MedicalTestPanel\", \"http://schema.org/MedicalTestPanel\"\r\n        \"MedicalTherapy\", \"http://schema.org/MedicalTherapy\"\r\n        \"MedicalTrial\", \"http://schema.org/MedicalTrial\"\r\n        \"MedicalTrialDesign\", \"http://schema.org/MedicalTrialDesign\"\r\n        \"MedicalWebPage\", \"http://schema.org/MedicalWebPage\"\r\n        \"MedicineSystem\", \"http://schema.org/MedicineSystem\"\r\n        \"MeetingRoom\", \"http://schema.org/MeetingRoom\"\r\n        \"MensClothingStore\", \"http://schema.org/MensClothingStore\"\r\n        \"Menu\", \"http://schema.org/Menu\"\r\n        \"MenuItem\", \"http://schema.org/MenuItem\"\r\n        \"MenuSection\", \"http://schema.org/MenuSection\"\r\n        \"MerchantReturnEnumeration\", \"http://schema.org/MerchantReturnEnumeration\"\r\n        \"MerchantReturnFiniteReturnWindow\", \"http://schema.org/MerchantReturnFiniteReturnWindow\"\r\n        \"MerchantReturnNotPermitted\", \"http://schema.org/MerchantReturnNotPermitted\"\r\n        \"MerchantReturnPolicy\", \"http://schema.org/MerchantReturnPolicy\"\r\n        \"MerchantReturnUnlimitedWindow\", \"http://schema.org/MerchantReturnUnlimitedWindow\"\r\n        \"MerchantReturnUnspecified\", \"http://schema.org/MerchantReturnUnspecified\"\r\n        \"Message\", \"http://schema.org/Message\"\r\n        \"MiddleSchool\", \"http://schema.org/MiddleSchool\"\r\n        \"Midwifery\", \"http://schema.org/Midwifery\"\r\n        \"MisconceptionsHealthAspect\", \"http://schema.org/MisconceptionsHealthAspect\"\r\n        \"MissingContext\", \"http://schema.org/MissingContext\"\r\n        \"MixedEventAttendanceMode\", \"http://schema.org/MixedEventAttendanceMode\"\r\n        \"MixtapeAlbum\", \"http://schema.org/MixtapeAlbum\"\r\n        \"MobileApplication\", \"http://schema.org/MobileApplication\"\r\n        \"MobilePhoneStore\", \"http://schema.org/MobilePhoneStore\"\r\n        \"Monday\", \"http://schema.org/Monday\"\r\n        \"MonetaryAmount\", \"http://schema.org/MonetaryAmount\"\r\n        \"MonetaryAmountDistribution\", \"http://schema.org/MonetaryAmountDistribution\"\r\n        \"MonetaryGrant\", \"http://schema.org/MonetaryGrant\"\r\n        \"MoneyTransfer\", \"http://schema.org/MoneyTransfer\"\r\n        \"MortgageLoan\", \"http://schema.org/MortgageLoan\"\r\n        \"Mosque\", \"http://schema.org/Mosque\"\r\n        \"Motel\", \"http://schema.org/Motel\"\r\n        \"Motorcycle\", \"http://schema.org/Motorcycle\"\r\n        \"MotorcycleDealer\", \"http://schema.org/MotorcycleDealer\"\r\n        \"MotorcycleRepair\", \"http://schema.org/MotorcycleRepair\"\r\n        \"MotorizedBicycle\", \"http://schema.org/MotorizedBicycle\"\r\n        \"Mountain\", \"http://schema.org/Mountain\"\r\n        \"MoveAction\", \"http://schema.org/MoveAction\"\r\n        \"Movie\", \"http://schema.org/Movie\"\r\n        \"MovieClip\", \"http://schema.org/MovieClip\"\r\n        \"MovieRentalStore\", \"http://schema.org/MovieRentalStore\"\r\n        \"MovieSeries\", \"http://schema.org/MovieSeries\"\r\n        \"MovieTheater\", \"http://schema.org/MovieTheater\"\r\n        \"MovingCompany\", \"http://schema.org/MovingCompany\"\r\n        \"MultiCenterTrial\", \"http://schema.org/MultiCenterTrial\"\r\n        \"MultiPlayer\", \"http://schema.org/MultiPlayer\"\r\n        \"MulticellularParasite\", \"http://schema.org/MulticellularParasite\"\r\n        \"Muscle\", \"http://schema.org/Muscle\"\r\n        \"Musculoskeletal\", \"http://schema.org/Musculoskeletal\"\r\n        \"MusculoskeletalExam\", \"http://schema.org/MusculoskeletalExam\"\r\n        \"Museum\", \"http://schema.org/Museum\"\r\n        \"MusicAlbum\", \"http://schema.org/MusicAlbum\"\r\n        \"MusicAlbumProductionType\", \"http://schema.org/MusicAlbumProductionType\"\r\n        \"MusicAlbumReleaseType\", \"http://schema.org/MusicAlbumReleaseType\"\r\n        \"MusicComposition\", \"http://schema.org/MusicComposition\"\r\n        \"MusicEvent\", \"http://schema.org/MusicEvent\"\r\n        \"MusicGroup\", \"http://schema.org/MusicGroup\"\r\n        \"MusicPlaylist\", \"http://schema.org/MusicPlaylist\"\r\n        \"MusicRecording\", \"http://schema.org/MusicRecording\"\r\n        \"MusicRelease\", \"http://schema.org/MusicRelease\"\r\n        \"MusicReleaseFormatType\", \"http://schema.org/MusicReleaseFormatType\"\r\n        \"MusicStore\", \"http://schema.org/MusicStore\"\r\n        \"MusicVenue\", \"http://schema.org/MusicVenue\"\r\n        \"MusicVideoObject\", \"http://schema.org/MusicVideoObject\"\r\n        \"NGO\", \"http://schema.org/NGO\"\r\n        \"NLNonprofitType\", \"http://schema.org/NLNonprofitType\"\r\n        \"NailSalon\", \"http://schema.org/NailSalon\"\r\n        \"Neck\", \"http://schema.org/Neck\"\r\n        \"Nerve\", \"http://schema.org/Nerve\"\r\n        \"Neuro\", \"http://schema.org/Neuro\"\r\n        \"Neurologic\", \"http://schema.org/Neurologic\"\r\n        \"NewCondition\", \"http://schema.org/NewCondition\"\r\n        \"NewsArticle\", \"http://schema.org/NewsArticle\"\r\n        \"NewsMediaOrganization\", \"http://schema.org/NewsMediaOrganization\"\r\n        \"Newspaper\", \"http://schema.org/Newspaper\"\r\n        \"NightClub\", \"http://schema.org/NightClub\"\r\n        \"NoninvasiveProcedure\", \"http://schema.org/NoninvasiveProcedure\"\r\n        \"Nonprofit501a\", \"http://schema.org/Nonprofit501a\"\r\n        \"Nonprofit501c1\", \"http://schema.org/Nonprofit501c1\"\r\n        \"Nonprofit501c10\", \"http://schema.org/Nonprofit501c10\"\r\n        \"Nonprofit501c11\", \"http://schema.org/Nonprofit501c11\"\r\n        \"Nonprofit501c12\", \"http://schema.org/Nonprofit501c12\"\r\n        \"Nonprofit501c13\", \"http://schema.org/Nonprofit501c13\"\r\n        \"Nonprofit501c14\", \"http://schema.org/Nonprofit501c14\"\r\n        \"Nonprofit501c15\", \"http://schema.org/Nonprofit501c15\"\r\n        \"Nonprofit501c16\", \"http://schema.org/Nonprofit501c16\"\r\n        \"Nonprofit501c17\", \"http://schema.org/Nonprofit501c17\"\r\n        \"Nonprofit501c18\", \"http://schema.org/Nonprofit501c18\"\r\n        \"Nonprofit501c19\", \"http://schema.org/Nonprofit501c19\"\r\n        \"Nonprofit501c2\", \"http://schema.org/Nonprofit501c2\"\r\n        \"Nonprofit501c20\", \"http://schema.org/Nonprofit501c20\"\r\n        \"Nonprofit501c21\", \"http://schema.org/Nonprofit501c21\"\r\n        \"Nonprofit501c22\", \"http://schema.org/Nonprofit501c22\"\r\n        \"Nonprofit501c23\", \"http://schema.org/Nonprofit501c23\"\r\n        \"Nonprofit501c24\", \"http://schema.org/Nonprofit501c24\"\r\n        \"Nonprofit501c25\", \"http://schema.org/Nonprofit501c25\"\r\n        \"Nonprofit501c26\", \"http://schema.org/Nonprofit501c26\"\r\n        \"Nonprofit501c27\", \"http://schema.org/Nonprofit501c27\"\r\n        \"Nonprofit501c28\", \"http://schema.org/Nonprofit501c28\"\r\n        \"Nonprofit501c3\", \"http://schema.org/Nonprofit501c3\"\r\n        \"Nonprofit501c4\", \"http://schema.org/Nonprofit501c4\"\r\n        \"Nonprofit501c5\", \"http://schema.org/Nonprofit501c5\"\r\n        \"Nonprofit501c6\", \"http://schema.org/Nonprofit501c6\"\r\n        \"Nonprofit501c7\", \"http://schema.org/Nonprofit501c7\"\r\n        \"Nonprofit501c8\", \"http://schema.org/Nonprofit501c8\"\r\n        \"Nonprofit501c9\", \"http://schema.org/Nonprofit501c9\"\r\n        \"Nonprofit501d\", \"http://schema.org/Nonprofit501d\"\r\n        \"Nonprofit501e\", \"http://schema.org/Nonprofit501e\"\r\n        \"Nonprofit501f\", \"http://schema.org/Nonprofit501f\"\r\n        \"Nonprofit501k\", \"http://schema.org/Nonprofit501k\"\r\n        \"Nonprofit501n\", \"http://schema.org/Nonprofit501n\"\r\n        \"Nonprofit501q\", \"http://schema.org/Nonprofit501q\"\r\n        \"Nonprofit527\", \"http://schema.org/Nonprofit527\"\r\n        \"NonprofitANBI\", \"http://schema.org/NonprofitANBI\"\r\n        \"NonprofitSBBI\", \"http://schema.org/NonprofitSBBI\"\r\n        \"NonprofitType\", \"http://schema.org/NonprofitType\"\r\n        \"Nose\", \"http://schema.org/Nose\"\r\n        \"NotInForce\", \"http://schema.org/NotInForce\"\r\n        \"NotYetRecruiting\", \"http://schema.org/NotYetRecruiting\"\r\n        \"Notary\", \"http://schema.org/Notary\"\r\n        \"NoteDigitalDocument\", \"http://schema.org/NoteDigitalDocument\"\r\n        \"Number\", \"http://schema.org/Number\"\r\n        \"Nursing\", \"http://schema.org/Nursing\"\r\n        \"NutritionInformation\", \"http://schema.org/NutritionInformation\"\r\n        \"OTC\", \"http://schema.org/OTC\"\r\n        \"Observation\", \"http://schema.org/Observation\"\r\n        \"Observational\", \"http://schema.org/Observational\"\r\n        \"Obstetric\", \"http://schema.org/Obstetric\"\r\n        \"Occupation\", \"http://schema.org/Occupation\"\r\n        \"OccupationalActivity\", \"http://schema.org/OccupationalActivity\"\r\n        \"OccupationalTherapy\", \"http://schema.org/OccupationalTherapy\"\r\n        \"OceanBodyOfWater\", \"http://schema.org/OceanBodyOfWater\"\r\n        \"Offer\", \"http://schema.org/Offer\"\r\n        \"OfferCatalog\", \"http://schema.org/OfferCatalog\"\r\n        \"OfferForLease\", \"http://schema.org/OfferForLease\"\r\n        \"OfferForPurchase\", \"http://schema.org/OfferForPurchase\"\r\n        \"OfferItemCondition\", \"http://schema.org/OfferItemCondition\"\r\n        \"OfferShippingDetails\", \"http://schema.org/OfferShippingDetails\"\r\n        \"OfficeEquipmentStore\", \"http://schema.org/OfficeEquipmentStore\"\r\n        \"OfficialLegalValue\", \"http://schema.org/OfficialLegalValue\"\r\n        \"OfflineEventAttendanceMode\", \"http://schema.org/OfflineEventAttendanceMode\"\r\n        \"OfflinePermanently\", \"http://schema.org/OfflinePermanently\"\r\n        \"OfflineTemporarily\", \"http://schema.org/OfflineTemporarily\"\r\n        \"OnDemandEvent\", \"http://schema.org/OnDemandEvent\"\r\n        \"OnSitePickup\", \"http://schema.org/OnSitePickup\"\r\n        \"Oncologic\", \"http://schema.org/Oncologic\"\r\n        \"OneTimePayments\", \"http://schema.org/OneTimePayments\"\r\n        \"Online\", \"http://schema.org/Online\"\r\n        \"OnlineEventAttendanceMode\", \"http://schema.org/OnlineEventAttendanceMode\"\r\n        \"OnlineFull\", \"http://schema.org/OnlineFull\"\r\n        \"OnlineOnly\", \"http://schema.org/OnlineOnly\"\r\n        \"OpenTrial\", \"http://schema.org/OpenTrial\"\r\n        \"OpeningHoursSpecification\", \"http://schema.org/OpeningHoursSpecification\"\r\n        \"OpinionNewsArticle\", \"http://schema.org/OpinionNewsArticle\"\r\n        \"Optician\", \"http://schema.org/Optician\"\r\n        \"Optometric\", \"http://schema.org/Optometric\"\r\n        \"Order\", \"http://schema.org/Order\"\r\n        \"OrderAction\", \"http://schema.org/OrderAction\"\r\n        \"OrderCancelled\", \"http://schema.org/OrderCancelled\"\r\n        \"OrderDelivered\", \"http://schema.org/OrderDelivered\"\r\n        \"OrderInTransit\", \"http://schema.org/OrderInTransit\"\r\n        \"OrderItem\", \"http://schema.org/OrderItem\"\r\n        \"OrderPaymentDue\", \"http://schema.org/OrderPaymentDue\"\r\n        \"OrderPickupAvailable\", \"http://schema.org/OrderPickupAvailable\"\r\n        \"OrderProblem\", \"http://schema.org/OrderProblem\"\r\n        \"OrderProcessing\", \"http://schema.org/OrderProcessing\"\r\n        \"OrderReturned\", \"http://schema.org/OrderReturned\"\r\n        \"OrderStatus\", \"http://schema.org/OrderStatus\"\r\n        \"Organization\", \"http://schema.org/Organization\"\r\n        \"OrganizationRole\", \"http://schema.org/OrganizationRole\"\r\n        \"OrganizeAction\", \"http://schema.org/OrganizeAction\"\r\n        \"OriginalShippingFees\", \"http://schema.org/OriginalShippingFees\"\r\n        \"Osteopathic\", \"http://schema.org/Osteopathic\"\r\n        \"Otolaryngologic\", \"http://schema.org/Otolaryngologic\"\r\n        \"OutOfStock\", \"http://schema.org/OutOfStock\"\r\n        \"OutletStore\", \"http://schema.org/OutletStore\"\r\n        \"OverviewHealthAspect\", \"http://schema.org/OverviewHealthAspect\"\r\n        \"OwnershipInfo\", \"http://schema.org/OwnershipInfo\"\r\n        \"PET\", \"http://schema.org/PET\"\r\n        \"PaidLeave\", \"http://schema.org/PaidLeave\"\r\n        \"PaintAction\", \"http://schema.org/PaintAction\"\r\n        \"Painting\", \"http://schema.org/Painting\"\r\n        \"PalliativeProcedure\", \"http://schema.org/PalliativeProcedure\"\r\n        \"Paperback\", \"http://schema.org/Paperback\"\r\n        \"ParcelDelivery\", \"http://schema.org/ParcelDelivery\"\r\n        \"ParcelService\", \"http://schema.org/ParcelService\"\r\n        \"ParentAudience\", \"http://schema.org/ParentAudience\"\r\n        \"ParentalSupport\", \"http://schema.org/ParentalSupport\"\r\n        \"Park\", \"http://schema.org/Park\"\r\n        \"ParkingFacility\", \"http://schema.org/ParkingFacility\"\r\n        \"ParkingMap\", \"http://schema.org/ParkingMap\"\r\n        \"PartiallyInForce\", \"http://schema.org/PartiallyInForce\"\r\n        \"Pathology\", \"http://schema.org/Pathology\"\r\n        \"PathologyTest\", \"http://schema.org/PathologyTest\"\r\n        \"Patient\", \"http://schema.org/Patient\"\r\n        \"PatientExperienceHealthAspect\", \"http://schema.org/PatientExperienceHealthAspect\"\r\n        \"PawnShop\", \"http://schema.org/PawnShop\"\r\n        \"PayAction\", \"http://schema.org/PayAction\"\r\n        \"PaymentAutomaticallyApplied\", \"http://schema.org/PaymentAutomaticallyApplied\"\r\n        \"PaymentCard\", \"http://schema.org/PaymentCard\"\r\n        \"PaymentChargeSpecification\", \"http://schema.org/PaymentChargeSpecification\"\r\n        \"PaymentComplete\", \"http://schema.org/PaymentComplete\"\r\n        \"PaymentDeclined\", \"http://schema.org/PaymentDeclined\"\r\n        \"PaymentDue\", \"http://schema.org/PaymentDue\"\r\n        \"PaymentMethod\", \"http://schema.org/PaymentMethod\"\r\n        \"PaymentPastDue\", \"http://schema.org/PaymentPastDue\"\r\n        \"PaymentService\", \"http://schema.org/PaymentService\"\r\n        \"PaymentStatusType\", \"http://schema.org/PaymentStatusType\"\r\n        \"Pediatric\", \"http://schema.org/Pediatric\"\r\n        \"PeopleAudience\", \"http://schema.org/PeopleAudience\"\r\n        \"PercutaneousProcedure\", \"http://schema.org/PercutaneousProcedure\"\r\n        \"PerformAction\", \"http://schema.org/PerformAction\"\r\n        \"PerformanceRole\", \"http://schema.org/PerformanceRole\"\r\n        \"PerformingArtsTheater\", \"http://schema.org/PerformingArtsTheater\"\r\n        \"PerformingGroup\", \"http://schema.org/PerformingGroup\"\r\n        \"Periodical\", \"http://schema.org/Periodical\"\r\n        \"Permit\", \"http://schema.org/Permit\"\r\n        \"Person\", \"http://schema.org/Person\"\r\n        \"PetStore\", \"http://schema.org/PetStore\"\r\n        \"Pharmacy\", \"http://schema.org/Pharmacy\"\r\n        \"PharmacySpecialty\", \"http://schema.org/PharmacySpecialty\"\r\n        \"Photograph\", \"http://schema.org/Photograph\"\r\n        \"PhotographAction\", \"http://schema.org/PhotographAction\"\r\n        \"PhysicalActivity\", \"http://schema.org/PhysicalActivity\"\r\n        \"PhysicalActivityCategory\", \"http://schema.org/PhysicalActivityCategory\"\r\n        \"PhysicalExam\", \"http://schema.org/PhysicalExam\"\r\n        \"PhysicalTherapy\", \"http://schema.org/PhysicalTherapy\"\r\n        \"Physician\", \"http://schema.org/Physician\"\r\n        \"Physiotherapy\", \"http://schema.org/Physiotherapy\"\r\n        \"Place\", \"http://schema.org/Place\"\r\n        \"PlaceOfWorship\", \"http://schema.org/PlaceOfWorship\"\r\n        \"PlaceboControlledTrial\", \"http://schema.org/PlaceboControlledTrial\"\r\n        \"PlanAction\", \"http://schema.org/PlanAction\"\r\n        \"PlasticSurgery\", \"http://schema.org/PlasticSurgery\"\r\n        \"Play\", \"http://schema.org/Play\"\r\n        \"PlayAction\", \"http://schema.org/PlayAction\"\r\n        \"Playground\", \"http://schema.org/Playground\"\r\n        \"Plumber\", \"http://schema.org/Plumber\"\r\n        \"PodcastEpisode\", \"http://schema.org/PodcastEpisode\"\r\n        \"PodcastSeason\", \"http://schema.org/PodcastSeason\"\r\n        \"PodcastSeries\", \"http://schema.org/PodcastSeries\"\r\n        \"Podiatric\", \"http://schema.org/Podiatric\"\r\n        \"PoliceStation\", \"http://schema.org/PoliceStation\"\r\n        \"Pond\", \"http://schema.org/Pond\"\r\n        \"PostOffice\", \"http://schema.org/PostOffice\"\r\n        \"PostalAddress\", \"http://schema.org/PostalAddress\"\r\n        \"PostalCodeRangeSpecification\", \"http://schema.org/PostalCodeRangeSpecification\"\r\n        \"Poster\", \"http://schema.org/Poster\"\r\n        \"PotentialActionStatus\", \"http://schema.org/PotentialActionStatus\"\r\n        \"PreOrder\", \"http://schema.org/PreOrder\"\r\n        \"PreOrderAction\", \"http://schema.org/PreOrderAction\"\r\n        \"PreSale\", \"http://schema.org/PreSale\"\r\n        \"PrependAction\", \"http://schema.org/PrependAction\"\r\n        \"Preschool\", \"http://schema.org/Preschool\"\r\n        \"PrescriptionOnly\", \"http://schema.org/PrescriptionOnly\"\r\n        \"PresentationDigitalDocument\", \"http://schema.org/PresentationDigitalDocument\"\r\n        \"PreventionHealthAspect\", \"http://schema.org/PreventionHealthAspect\"\r\n        \"PreventionIndication\", \"http://schema.org/PreventionIndication\"\r\n        \"PriceSpecification\", \"http://schema.org/PriceSpecification\"\r\n        \"PrimaryCare\", \"http://schema.org/PrimaryCare\"\r\n        \"Prion\", \"http://schema.org/Prion\"\r\n        \"Product\", \"http://schema.org/Product\"\r\n        \"ProductCollection\", \"http://schema.org/ProductCollection\"\r\n        \"ProductGroup\", \"http://schema.org/ProductGroup\"\r\n        \"ProductModel\", \"http://schema.org/ProductModel\"\r\n        \"ProductReturnEnumeration\", \"http://schema.org/ProductReturnEnumeration\"\r\n        \"ProductReturnFiniteReturnWindow\", \"http://schema.org/ProductReturnFiniteReturnWindow\"\r\n        \"ProductReturnNotPermitted\", \"http://schema.org/ProductReturnNotPermitted\"\r\n        \"ProductReturnPolicy\", \"http://schema.org/ProductReturnPolicy\"\r\n        \"ProductReturnUnlimitedWindow\", \"http://schema.org/ProductReturnUnlimitedWindow\"\r\n        \"ProductReturnUnspecified\", \"http://schema.org/ProductReturnUnspecified\"\r\n        \"ProfessionalService\", \"http://schema.org/ProfessionalService\"\r\n        \"ProfilePage\", \"http://schema.org/ProfilePage\"\r\n        \"PrognosisHealthAspect\", \"http://schema.org/PrognosisHealthAspect\"\r\n        \"ProgramMembership\", \"http://schema.org/ProgramMembership\"\r\n        \"Project\", \"http://schema.org/Project\"\r\n        \"PronounceableText\", \"http://schema.org/PronounceableText\"\r\n        \"Property\", \"http://schema.org/Property\"\r\n        \"PropertyValue\", \"http://schema.org/PropertyValue\"\r\n        \"PropertyValueSpecification\", \"http://schema.org/PropertyValueSpecification\"\r\n        \"Protozoa\", \"http://schema.org/Protozoa\"\r\n        \"Psychiatric\", \"http://schema.org/Psychiatric\"\r\n        \"PsychologicalTreatment\", \"http://schema.org/PsychologicalTreatment\"\r\n        \"PublicHealth\", \"http://schema.org/PublicHealth\"\r\n        \"PublicHolidays\", \"http://schema.org/PublicHolidays\"\r\n        \"PublicSwimmingPool\", \"http://schema.org/PublicSwimmingPool\"\r\n        \"PublicToilet\", \"http://schema.org/PublicToilet\"\r\n        \"PublicationEvent\", \"http://schema.org/PublicationEvent\"\r\n        \"PublicationIssue\", \"http://schema.org/PublicationIssue\"\r\n        \"PublicationVolume\", \"http://schema.org/PublicationVolume\"\r\n        \"Pulmonary\", \"http://schema.org/Pulmonary\"\r\n        \"QAPage\", \"http://schema.org/QAPage\"\r\n        \"QualitativeValue\", \"http://schema.org/QualitativeValue\"\r\n        \"QuantitativeValue\", \"http://schema.org/QuantitativeValue\"\r\n        \"QuantitativeValueDistribution\", \"http://schema.org/QuantitativeValueDistribution\"\r\n        \"Quantity\", \"http://schema.org/Quantity\"\r\n        \"Question\", \"http://schema.org/Question\"\r\n        \"Quiz\", \"http://schema.org/Quiz\"\r\n        \"Quotation\", \"http://schema.org/Quotation\"\r\n        \"QuoteAction\", \"http://schema.org/QuoteAction\"\r\n        \"RVPark\", \"http://schema.org/RVPark\"\r\n        \"RadiationTherapy\", \"http://schema.org/RadiationTherapy\"\r\n        \"RadioBroadcastService\", \"http://schema.org/RadioBroadcastService\"\r\n        \"RadioChannel\", \"http://schema.org/RadioChannel\"\r\n        \"RadioClip\", \"http://schema.org/RadioClip\"\r\n        \"RadioEpisode\", \"http://schema.org/RadioEpisode\"\r\n        \"RadioSeason\", \"http://schema.org/RadioSeason\"\r\n        \"RadioSeries\", \"http://schema.org/RadioSeries\"\r\n        \"RadioStation\", \"http://schema.org/RadioStation\"\r\n        \"Radiography\", \"http://schema.org/Radiography\"\r\n        \"RandomizedTrial\", \"http://schema.org/RandomizedTrial\"\r\n        \"Rating\", \"http://schema.org/Rating\"\r\n        \"ReactAction\", \"http://schema.org/ReactAction\"\r\n        \"ReadAction\", \"http://schema.org/ReadAction\"\r\n        \"ReadPermission\", \"http://schema.org/ReadPermission\"\r\n        \"RealEstateAgent\", \"http://schema.org/RealEstateAgent\"\r\n        \"RealEstateListing\", \"http://schema.org/RealEstateListing\"\r\n        \"RearWheelDriveConfiguration\", \"http://schema.org/RearWheelDriveConfiguration\"\r\n        \"ReceiveAction\", \"http://schema.org/ReceiveAction\"\r\n        \"Recipe\", \"http://schema.org/Recipe\"\r\n        \"Recommendation\", \"http://schema.org/Recommendation\"\r\n        \"RecommendedDoseSchedule\", \"http://schema.org/RecommendedDoseSchedule\"\r\n        \"Recruiting\", \"http://schema.org/Recruiting\"\r\n        \"RecyclingCenter\", \"http://schema.org/RecyclingCenter\"\r\n        \"RefundTypeEnumeration\", \"http://schema.org/RefundTypeEnumeration\"\r\n        \"RefurbishedCondition\", \"http://schema.org/RefurbishedCondition\"\r\n        \"RegisterAction\", \"http://schema.org/RegisterAction\"\r\n        \"Registry\", \"http://schema.org/Registry\"\r\n        \"ReimbursementCap\", \"http://schema.org/ReimbursementCap\"\r\n        \"RejectAction\", \"http://schema.org/RejectAction\"\r\n        \"RelatedTopicsHealthAspect\", \"http://schema.org/RelatedTopicsHealthAspect\"\r\n        \"RemixAlbum\", \"http://schema.org/RemixAlbum\"\r\n        \"Renal\", \"http://schema.org/Renal\"\r\n        \"RentAction\", \"http://schema.org/RentAction\"\r\n        \"RentalCarReservation\", \"http://schema.org/RentalCarReservation\"\r\n        \"RentalVehicleUsage\", \"http://schema.org/RentalVehicleUsage\"\r\n        \"RepaymentSpecification\", \"http://schema.org/RepaymentSpecification\"\r\n        \"ReplaceAction\", \"http://schema.org/ReplaceAction\"\r\n        \"ReplyAction\", \"http://schema.org/ReplyAction\"\r\n        \"Report\", \"http://schema.org/Report\"\r\n        \"ReportageNewsArticle\", \"http://schema.org/ReportageNewsArticle\"\r\n        \"ReportedDoseSchedule\", \"http://schema.org/ReportedDoseSchedule\"\r\n        \"ResearchProject\", \"http://schema.org/ResearchProject\"\r\n        \"Researcher\", \"http://schema.org/Researcher\"\r\n        \"Reservation\", \"http://schema.org/Reservation\"\r\n        \"ReservationCancelled\", \"http://schema.org/ReservationCancelled\"\r\n        \"ReservationConfirmed\", \"http://schema.org/ReservationConfirmed\"\r\n        \"ReservationHold\", \"http://schema.org/ReservationHold\"\r\n        \"ReservationPackage\", \"http://schema.org/ReservationPackage\"\r\n        \"ReservationPending\", \"http://schema.org/ReservationPending\"\r\n        \"ReservationStatusType\", \"http://schema.org/ReservationStatusType\"\r\n        \"ReserveAction\", \"http://schema.org/ReserveAction\"\r\n        \"Reservoir\", \"http://schema.org/Reservoir\"\r\n        \"Residence\", \"http://schema.org/Residence\"\r\n        \"Resort\", \"http://schema.org/Resort\"\r\n        \"RespiratoryTherapy\", \"http://schema.org/RespiratoryTherapy\"\r\n        \"Restaurant\", \"http://schema.org/Restaurant\"\r\n        \"RestockingFees\", \"http://schema.org/RestockingFees\"\r\n        \"RestrictedDiet\", \"http://schema.org/RestrictedDiet\"\r\n        \"ResultsAvailable\", \"http://schema.org/ResultsAvailable\"\r\n        \"ResultsNotAvailable\", \"http://schema.org/ResultsNotAvailable\"\r\n        \"ResumeAction\", \"http://schema.org/ResumeAction\"\r\n        \"Retail\", \"http://schema.org/Retail\"\r\n        \"ReturnAction\", \"http://schema.org/ReturnAction\"\r\n        \"ReturnFeesEnumeration\", \"http://schema.org/ReturnFeesEnumeration\"\r\n        \"ReturnShippingFees\", \"http://schema.org/ReturnShippingFees\"\r\n        \"Review\", \"http://schema.org/Review\"\r\n        \"ReviewAction\", \"http://schema.org/ReviewAction\"\r\n        \"ReviewNewsArticle\", \"http://schema.org/ReviewNewsArticle\"\r\n        \"Rheumatologic\", \"http://schema.org/Rheumatologic\"\r\n        \"RightHandDriving\", \"http://schema.org/RightHandDriving\"\r\n        \"RisksOrComplicationsHealthAspect\", \"http://schema.org/RisksOrComplicationsHealthAspect\"\r\n        \"RiverBodyOfWater\", \"http://schema.org/RiverBodyOfWater\"\r\n        \"Role\", \"http://schema.org/Role\"\r\n        \"RoofingContractor\", \"http://schema.org/RoofingContractor\"\r\n        \"Room\", \"http://schema.org/Room\"\r\n        \"RsvpAction\", \"http://schema.org/RsvpAction\"\r\n        \"RsvpResponseMaybe\", \"http://schema.org/RsvpResponseMaybe\"\r\n        \"RsvpResponseNo\", \"http://schema.org/RsvpResponseNo\"\r\n        \"RsvpResponseType\", \"http://schema.org/RsvpResponseType\"\r\n        \"RsvpResponseYes\", \"http://schema.org/RsvpResponseYes\"\r\n        \"SaleEvent\", \"http://schema.org/SaleEvent\"\r\n        \"SatiricalArticle\", \"http://schema.org/SatiricalArticle\"\r\n        \"Saturday\", \"http://schema.org/Saturday\"\r\n        \"Schedule\", \"http://schema.org/Schedule\"\r\n        \"ScheduleAction\", \"http://schema.org/ScheduleAction\"\r\n        \"ScholarlyArticle\", \"http://schema.org/ScholarlyArticle\"\r\n        \"School\", \"http://schema.org/School\"\r\n        \"SchoolDistrict\", \"http://schema.org/SchoolDistrict\"\r\n        \"ScreeningEvent\", \"http://schema.org/ScreeningEvent\"\r\n        \"ScreeningHealthAspect\", \"http://schema.org/ScreeningHealthAspect\"\r\n        \"Sculpture\", \"http://schema.org/Sculpture\"\r\n        \"SeaBodyOfWater\", \"http://schema.org/SeaBodyOfWater\"\r\n        \"SearchAction\", \"http://schema.org/SearchAction\"\r\n        \"SearchResultsPage\", \"http://schema.org/SearchResultsPage\"\r\n        \"Season\", \"http://schema.org/Season\"\r\n        \"Seat\", \"http://schema.org/Seat\"\r\n        \"SeatingMap\", \"http://schema.org/SeatingMap\"\r\n        \"SeeDoctorHealthAspect\", \"http://schema.org/SeeDoctorHealthAspect\"\r\n        \"SelfCareHealthAspect\", \"http://schema.org/SelfCareHealthAspect\"\r\n        \"SelfStorage\", \"http://schema.org/SelfStorage\"\r\n        \"SellAction\", \"http://schema.org/SellAction\"\r\n        \"SendAction\", \"http://schema.org/SendAction\"\r\n        \"Series\", \"http://schema.org/Series\"\r\n        \"Service\", \"http://schema.org/Service\"\r\n        \"ServiceChannel\", \"http://schema.org/ServiceChannel\"\r\n        \"ShareAction\", \"http://schema.org/ShareAction\"\r\n        \"SheetMusic\", \"http://schema.org/SheetMusic\"\r\n        \"ShippingDeliveryTime\", \"http://schema.org/ShippingDeliveryTime\"\r\n        \"ShippingRateSettings\", \"http://schema.org/ShippingRateSettings\"\r\n        \"ShoeStore\", \"http://schema.org/ShoeStore\"\r\n        \"ShoppingCenter\", \"http://schema.org/ShoppingCenter\"\r\n        \"ShortStory\", \"http://schema.org/ShortStory\"\r\n        \"SideEffectsHealthAspect\", \"http://schema.org/SideEffectsHealthAspect\"\r\n        \"SingleBlindedTrial\", \"http://schema.org/SingleBlindedTrial\"\r\n        \"SingleCenterTrial\", \"http://schema.org/SingleCenterTrial\"\r\n        \"SingleFamilyResidence\", \"http://schema.org/SingleFamilyResidence\"\r\n        \"SinglePlayer\", \"http://schema.org/SinglePlayer\"\r\n        \"SingleRelease\", \"http://schema.org/SingleRelease\"\r\n        \"SiteNavigationElement\", \"http://schema.org/SiteNavigationElement\"\r\n        \"SkiResort\", \"http://schema.org/SkiResort\"\r\n        \"Skin\", \"http://schema.org/Skin\"\r\n        \"SocialEvent\", \"http://schema.org/SocialEvent\"\r\n        \"SocialMediaPosting\", \"http://schema.org/SocialMediaPosting\"\r\n        \"SoftwareApplication\", \"http://schema.org/SoftwareApplication\"\r\n        \"SoftwareSourceCode\", \"http://schema.org/SoftwareSourceCode\"\r\n        \"SoldOut\", \"http://schema.org/SoldOut\"\r\n        \"SomeProducts\", \"http://schema.org/SomeProducts\"\r\n        \"SoundtrackAlbum\", \"http://schema.org/SoundtrackAlbum\"\r\n        \"SpeakableSpecification\", \"http://schema.org/SpeakableSpecification\"\r\n        \"SpecialAnnouncement\", \"http://schema.org/SpecialAnnouncement\"\r\n        \"Specialty\", \"http://schema.org/Specialty\"\r\n        \"SpeechPathology\", \"http://schema.org/SpeechPathology\"\r\n        \"SpokenWordAlbum\", \"http://schema.org/SpokenWordAlbum\"\r\n        \"SportingGoodsStore\", \"http://schema.org/SportingGoodsStore\"\r\n        \"SportsActivityLocation\", \"http://schema.org/SportsActivityLocation\"\r\n        \"SportsClub\", \"http://schema.org/SportsClub\"\r\n        \"SportsEvent\", \"http://schema.org/SportsEvent\"\r\n        \"SportsOrganization\", \"http://schema.org/SportsOrganization\"\r\n        \"SportsTeam\", \"http://schema.org/SportsTeam\"\r\n        \"SpreadsheetDigitalDocument\", \"http://schema.org/SpreadsheetDigitalDocument\"\r\n        \"StadiumOrArena\", \"http://schema.org/StadiumOrArena\"\r\n        \"StagesHealthAspect\", \"http://schema.org/StagesHealthAspect\"\r\n        \"State\", \"http://schema.org/State\"\r\n        \"StatisticalPopulation\", \"http://schema.org/StatisticalPopulation\"\r\n        \"StatusEnumeration\", \"http://schema.org/StatusEnumeration\"\r\n        \"SteeringPositionValue\", \"http://schema.org/SteeringPositionValue\"\r\n        \"Store\", \"http://schema.org/Store\"\r\n        \"StoreCreditRefund\", \"http://schema.org/StoreCreditRefund\"\r\n        \"StrengthTraining\", \"http://schema.org/StrengthTraining\"\r\n        \"StructuredValue\", \"http://schema.org/StructuredValue\"\r\n        \"StudioAlbum\", \"http://schema.org/StudioAlbum\"\r\n        \"StupidType\", \"http://schema.org/StupidType\"\r\n        \"SubscribeAction\", \"http://schema.org/SubscribeAction\"\r\n        \"Substance\", \"http://schema.org/Substance\"\r\n        \"SubwayStation\", \"http://schema.org/SubwayStation\"\r\n        \"Suite\", \"http://schema.org/Suite\"\r\n        \"Sunday\", \"http://schema.org/Sunday\"\r\n        \"SuperficialAnatomy\", \"http://schema.org/SuperficialAnatomy\"\r\n        \"Surgical\", \"http://schema.org/Surgical\"\r\n        \"SurgicalProcedure\", \"http://schema.org/SurgicalProcedure\"\r\n        \"SuspendAction\", \"http://schema.org/SuspendAction\"\r\n        \"Suspended\", \"http://schema.org/Suspended\"\r\n        \"SymptomsHealthAspect\", \"http://schema.org/SymptomsHealthAspect\"\r\n        \"Synagogue\", \"http://schema.org/Synagogue\"\r\n        \"TVClip\", \"http://schema.org/TVClip\"\r\n        \"TVEpisode\", \"http://schema.org/TVEpisode\"\r\n        \"TVSeason\", \"http://schema.org/TVSeason\"\r\n        \"TVSeries\", \"http://schema.org/TVSeries\"\r\n        \"Table\", \"http://schema.org/Table\"\r\n        \"TakeAction\", \"http://schema.org/TakeAction\"\r\n        \"TattooParlor\", \"http://schema.org/TattooParlor\"\r\n        \"Taxi\", \"http://schema.org/Taxi\"\r\n        \"TaxiReservation\", \"http://schema.org/TaxiReservation\"\r\n        \"TaxiService\", \"http://schema.org/TaxiService\"\r\n        \"TaxiStand\", \"http://schema.org/TaxiStand\"\r\n        \"TaxiVehicleUsage\", \"http://schema.org/TaxiVehicleUsage\"\r\n        \"TechArticle\", \"http://schema.org/TechArticle\"\r\n        \"TelevisionChannel\", \"http://schema.org/TelevisionChannel\"\r\n        \"TelevisionStation\", \"http://schema.org/TelevisionStation\"\r\n        \"TennisComplex\", \"http://schema.org/TennisComplex\"\r\n        \"Terminated\", \"http://schema.org/Terminated\"\r\n        \"Text\", \"http://schema.org/Text\"\r\n        \"TextDigitalDocument\", \"http://schema.org/TextDigitalDocument\"\r\n        \"TheaterEvent\", \"http://schema.org/TheaterEvent\"\r\n        \"TheaterGroup\", \"http://schema.org/TheaterGroup\"\r\n        \"Therapeutic\", \"http://schema.org/Therapeutic\"\r\n        \"TherapeuticProcedure\", \"http://schema.org/TherapeuticProcedure\"\r\n        \"Thesis\", \"http://schema.org/Thesis\"\r\n        \"Thing\", \"http://schema.org/Thing\"\r\n        \"Throat\", \"http://schema.org/Throat\"\r\n        \"Thursday\", \"http://schema.org/Thursday\"\r\n        \"Ticket\", \"http://schema.org/Ticket\"\r\n        \"TieAction\", \"http://schema.org/TieAction\"\r\n        \"Time\", \"http://schema.org/Time\"\r\n        \"TipAction\", \"http://schema.org/TipAction\"\r\n        \"TireShop\", \"http://schema.org/TireShop\"\r\n        \"TollFree\", \"http://schema.org/TollFree\"\r\n        \"TouristAttraction\", \"http://schema.org/TouristAttraction\"\r\n        \"TouristDestination\", \"http://schema.org/TouristDestination\"\r\n        \"TouristInformationCenter\", \"http://schema.org/TouristInformationCenter\"\r\n        \"TouristTrip\", \"http://schema.org/TouristTrip\"\r\n        \"Toxicologic\", \"http://schema.org/Toxicologic\"\r\n        \"ToyStore\", \"http://schema.org/ToyStore\"\r\n        \"TrackAction\", \"http://schema.org/TrackAction\"\r\n        \"TradeAction\", \"http://schema.org/TradeAction\"\r\n        \"TraditionalChinese\", \"http://schema.org/TraditionalChinese\"\r\n        \"TrainReservation\", \"http://schema.org/TrainReservation\"\r\n        \"TrainStation\", \"http://schema.org/TrainStation\"\r\n        \"TrainTrip\", \"http://schema.org/TrainTrip\"\r\n        \"TransferAction\", \"http://schema.org/TransferAction\"\r\n        \"TransitMap\", \"http://schema.org/TransitMap\"\r\n        \"TravelAction\", \"http://schema.org/TravelAction\"\r\n        \"TravelAgency\", \"http://schema.org/TravelAgency\"\r\n        \"TreatmentIndication\", \"http://schema.org/TreatmentIndication\"\r\n        \"TreatmentsHealthAspect\", \"http://schema.org/TreatmentsHealthAspect\"\r\n        \"Trip\", \"http://schema.org/Trip\"\r\n        \"TripleBlindedTrial\", \"http://schema.org/TripleBlindedTrial\"\r\n        \"True\", \"http://schema.org/True\"\r\n        \"Tuesday\", \"http://schema.org/Tuesday\"\r\n        \"TypeAndQuantityNode\", \"http://schema.org/TypeAndQuantityNode\"\r\n        \"TypesHealthAspect\", \"http://schema.org/TypesHealthAspect\"\r\n        \"UKNonprofitType\", \"http://schema.org/UKNonprofitType\"\r\n        \"UKTrust\", \"http://schema.org/UKTrust\"\r\n        \"URL\", \"http://schema.org/URL\"\r\n        \"USNonprofitType\", \"http://schema.org/USNonprofitType\"\r\n        \"Ultrasound\", \"http://schema.org/Ultrasound\"\r\n        \"UnRegisterAction\", \"http://schema.org/UnRegisterAction\"\r\n        \"UnemploymentSupport\", \"http://schema.org/UnemploymentSupport\"\r\n        \"UnincorporatedAssociationCharity\", \"http://schema.org/UnincorporatedAssociationCharity\"\r\n        \"UnitPriceSpecification\", \"http://schema.org/UnitPriceSpecification\"\r\n        \"UnofficialLegalValue\", \"http://schema.org/UnofficialLegalValue\"\r\n        \"UpdateAction\", \"http://schema.org/UpdateAction\"\r\n        \"Urologic\", \"http://schema.org/Urologic\"\r\n        \"UsageOrScheduleHealthAspect\", \"http://schema.org/UsageOrScheduleHealthAspect\"\r\n        \"UseAction\", \"http://schema.org/UseAction\"\r\n        \"UsedCondition\", \"http://schema.org/UsedCondition\"\r\n        \"UserBlocks\", \"http://schema.org/UserBlocks\"\r\n        \"UserCheckins\", \"http://schema.org/UserCheckins\"\r\n        \"UserComments\", \"http://schema.org/UserComments\"\r\n        \"UserDownloads\", \"http://schema.org/UserDownloads\"\r\n        \"UserInteraction\", \"http://schema.org/UserInteraction\"\r\n        \"UserLikes\", \"http://schema.org/UserLikes\"\r\n        \"UserPageVisits\", \"http://schema.org/UserPageVisits\"\r\n        \"UserPlays\", \"http://schema.org/UserPlays\"\r\n        \"UserPlusOnes\", \"http://schema.org/UserPlusOnes\"\r\n        \"UserReview\", \"http://schema.org/UserReview\"\r\n        \"UserTweets\", \"http://schema.org/UserTweets\"\r\n        \"VeganDiet\", \"http://schema.org/VeganDiet\"\r\n        \"VegetarianDiet\", \"http://schema.org/VegetarianDiet\"\r\n        \"Vehicle\", \"http://schema.org/Vehicle\"\r\n        \"Vein\", \"http://schema.org/Vein\"\r\n        \"VenueMap\", \"http://schema.org/VenueMap\"\r\n        \"Vessel\", \"http://schema.org/Vessel\"\r\n        \"VeterinaryCare\", \"http://schema.org/VeterinaryCare\"\r\n        \"VideoGallery\", \"http://schema.org/VideoGallery\"\r\n        \"VideoGame\", \"http://schema.org/VideoGame\"\r\n        \"VideoGameClip\", \"http://schema.org/VideoGameClip\"\r\n        \"VideoGameSeries\", \"http://schema.org/VideoGameSeries\"\r\n        \"VideoObject\", \"http://schema.org/VideoObject\"\r\n        \"ViewAction\", \"http://schema.org/ViewAction\"\r\n        \"VinylFormat\", \"http://schema.org/VinylFormat\"\r\n        \"VirtualLocation\", \"http://schema.org/VirtualLocation\"\r\n        \"Virus\", \"http://schema.org/Virus\"\r\n        \"VisualArtsEvent\", \"http://schema.org/VisualArtsEvent\"\r\n        \"VisualArtwork\", \"http://schema.org/VisualArtwork\"\r\n        \"VitalSign\", \"http://schema.org/VitalSign\"\r\n        \"Volcano\", \"http://schema.org/Volcano\"\r\n        \"VoteAction\", \"http://schema.org/VoteAction\"\r\n        \"WPAdBlock\", \"http://schema.org/WPAdBlock\"\r\n        \"WPFooter\", \"http://schema.org/WPFooter\"\r\n        \"WPHeader\", \"http://schema.org/WPHeader\"\r\n        \"WPSideBar\", \"http://schema.org/WPSideBar\"\r\n        \"WantAction\", \"http://schema.org/WantAction\"\r\n        \"WarrantyPromise\", \"http://schema.org/WarrantyPromise\"\r\n        \"WarrantyScope\", \"http://schema.org/WarrantyScope\"\r\n        \"WatchAction\", \"http://schema.org/WatchAction\"\r\n        \"Waterfall\", \"http://schema.org/Waterfall\"\r\n        \"WearAction\", \"http://schema.org/WearAction\"\r\n        \"WebAPI\", \"http://schema.org/WebAPI\"\r\n        \"WebApplication\", \"http://schema.org/WebApplication\"\r\n        \"WebContent\", \"http://schema.org/WebContent\"\r\n        \"WebPage\", \"http://schema.org/WebPage\"\r\n        \"WebPageElement\", \"http://schema.org/WebPageElement\"\r\n        \"WebSite\", \"http://schema.org/WebSite\"\r\n        \"Wednesday\", \"http://schema.org/Wednesday\"\r\n        \"WesternConventional\", \"http://schema.org/WesternConventional\"\r\n        \"Wholesale\", \"http://schema.org/Wholesale\"\r\n        \"WholesaleStore\", \"http://schema.org/WholesaleStore\"\r\n        \"WinAction\", \"http://schema.org/WinAction\"\r\n        \"Winery\", \"http://schema.org/Winery\"\r\n        \"Withdrawn\", \"http://schema.org/Withdrawn\"\r\n        \"WorkBasedProgram\", \"http://schema.org/WorkBasedProgram\"\r\n        \"WorkersUnion\", \"http://schema.org/WorkersUnion\"\r\n        \"WriteAction\", \"http://schema.org/WriteAction\"\r\n        \"WritePermission\", \"http://schema.org/WritePermission\"\r\n        \"XPathType\", \"http://schema.org/XPathType\"\r\n        \"XRay\", \"http://schema.org/XRay\"\r\n        \"ZoneBoardingPolicy\", \"http://schema.org/ZoneBoardingPolicy\"\r\n        \"Zoo\", \"http://schema.org/Zoo\"\r\n        \"about\", \"http://schema.org/about\"\r\n        \"abridged\", \"http://schema.org/abridged\"\r\n        \"abstract\", \"http://schema.org/abstract\"\r\n        \"accelerationTime\", \"http://schema.org/accelerationTime\"\r\n        \"acceptedAnswer\", \"http://schema.org/acceptedAnswer\"\r\n        \"acceptedOffer\", \"http://schema.org/acceptedOffer\"\r\n        \"acceptedPaymentMethod\", \"http://schema.org/acceptedPaymentMethod\"\r\n        \"acceptsReservations\", \"http://schema.org/acceptsReservations\"\r\n        \"accessCode\", \"http://schema.org/accessCode\"\r\n        \"accessMode\", \"http://schema.org/accessMode\"\r\n        \"accessModeSufficient\", \"http://schema.org/accessModeSufficient\"\r\n        \"accessibilityAPI\", \"http://schema.org/accessibilityAPI\"\r\n        \"accessibilityControl\", \"http://schema.org/accessibilityControl\"\r\n        \"accessibilityFeature\", \"http://schema.org/accessibilityFeature\"\r\n        \"accessibilityHazard\", \"http://schema.org/accessibilityHazard\"\r\n        \"accessibilitySummary\", \"http://schema.org/accessibilitySummary\"\r\n        \"accommodationCategory\", \"http://schema.org/accommodationCategory\"\r\n        \"accommodationFloorPlan\", \"http://schema.org/accommodationFloorPlan\"\r\n        \"accountId\", \"http://schema.org/accountId\"\r\n        \"accountMinimumInflow\", \"http://schema.org/accountMinimumInflow\"\r\n        \"accountOverdraftLimit\", \"http://schema.org/accountOverdraftLimit\"\r\n        \"accountablePerson\", \"http://schema.org/accountablePerson\"\r\n        \"acquireLicensePage\", \"http://schema.org/acquireLicensePage\"\r\n        \"acquiredFrom\", \"http://schema.org/acquiredFrom\"\r\n        \"acrissCode\", \"http://schema.org/acrissCode\"\r\n        \"actionAccessibilityRequirement\", \"http://schema.org/actionAccessibilityRequirement\"\r\n        \"actionApplication\", \"http://schema.org/actionApplication\"\r\n        \"actionOption\", \"http://schema.org/actionOption\"\r\n        \"actionPlatform\", \"http://schema.org/actionPlatform\"\r\n        \"actionStatus\", \"http://schema.org/actionStatus\"\r\n        \"actionableFeedbackPolicy\", \"http://schema.org/actionableFeedbackPolicy\"\r\n        \"activeIngredient\", \"http://schema.org/activeIngredient\"\r\n        \"activityDuration\", \"http://schema.org/activityDuration\"\r\n        \"activityFrequency\", \"http://schema.org/activityFrequency\"\r\n        \"actor\", \"http://schema.org/actor\"\r\n        \"actors\", \"http://schema.org/actors\"\r\n        \"addOn\", \"http://schema.org/addOn\"\r\n        \"additionalName\", \"http://schema.org/additionalName\"\r\n        \"additionalNumberOfGuests\", \"http://schema.org/additionalNumberOfGuests\"\r\n        \"additionalProperty\", \"http://schema.org/additionalProperty\"\r\n        \"additionalType\", \"http://schema.org/additionalType\"\r\n        \"additionalVariable\", \"http://schema.org/additionalVariable\"\r\n        \"address\", \"http://schema.org/address\"\r\n        \"addressCountry\", \"http://schema.org/addressCountry\"\r\n        \"addressLocality\", \"http://schema.org/addressLocality\"\r\n        \"addressRegion\", \"http://schema.org/addressRegion\"\r\n        \"administrationRoute\", \"http://schema.org/administrationRoute\"\r\n        \"advanceBookingRequirement\", \"http://schema.org/advanceBookingRequirement\"\r\n        \"adverseOutcome\", \"http://schema.org/adverseOutcome\"\r\n        \"affectedBy\", \"http://schema.org/affectedBy\"\r\n        \"affiliation\", \"http://schema.org/affiliation\"\r\n        \"afterMedia\", \"http://schema.org/afterMedia\"\r\n        \"agent\", \"http://schema.org/agent\"\r\n        \"aggregateRating\", \"http://schema.org/aggregateRating\"\r\n        \"aircraft\", \"http://schema.org/aircraft\"\r\n        \"album\", \"http://schema.org/album\"\r\n        \"albumProductionType\", \"http://schema.org/albumProductionType\"\r\n        \"albumRelease\", \"http://schema.org/albumRelease\"\r\n        \"albumReleaseType\", \"http://schema.org/albumReleaseType\"\r\n        \"albums\", \"http://schema.org/albums\"\r\n        \"alcoholWarning\", \"http://schema.org/alcoholWarning\"\r\n        \"algorithm\", \"http://schema.org/algorithm\"\r\n        \"alignmentType\", \"http://schema.org/alignmentType\"\r\n        \"alternateName\", \"http://schema.org/alternateName\"\r\n        \"alternativeHeadline\", \"http://schema.org/alternativeHeadline\"\r\n        \"alumni\", \"http://schema.org/alumni\"\r\n        \"alumniOf\", \"http://schema.org/alumniOf\"\r\n        \"amenityFeature\", \"http://schema.org/amenityFeature\"\r\n        \"amount\", \"http://schema.org/amount\"\r\n        \"amountOfThisGood\", \"http://schema.org/amountOfThisGood\"\r\n        \"announcementLocation\", \"http://schema.org/announcementLocation\"\r\n        \"annualPercentageRate\", \"http://schema.org/annualPercentageRate\"\r\n        \"answerCount\", \"http://schema.org/answerCount\"\r\n        \"answerExplanation\", \"http://schema.org/answerExplanation\"\r\n        \"antagonist\", \"http://schema.org/antagonist\"\r\n        \"appearance\", \"http://schema.org/appearance\"\r\n        \"applicableLocation\", \"http://schema.org/applicableLocation\"\r\n        \"applicantLocationRequirements\", \"http://schema.org/applicantLocationRequirements\"\r\n        \"application\", \"http://schema.org/application\"\r\n        \"applicationCategory\", \"http://schema.org/applicationCategory\"\r\n        \"applicationContact\", \"http://schema.org/applicationContact\"\r\n        \"applicationDeadline\", \"http://schema.org/applicationDeadline\"\r\n        \"applicationStartDate\", \"http://schema.org/applicationStartDate\"\r\n        \"applicationSubCategory\", \"http://schema.org/applicationSubCategory\"\r\n        \"applicationSuite\", \"http://schema.org/applicationSuite\"\r\n        \"appliesToDeliveryMethod\", \"http://schema.org/appliesToDeliveryMethod\"\r\n        \"appliesToPaymentMethod\", \"http://schema.org/appliesToPaymentMethod\"\r\n        \"archiveHeld\", \"http://schema.org/archiveHeld\"\r\n        \"area\", \"http://schema.org/area\"\r\n        \"areaServed\", \"http://schema.org/areaServed\"\r\n        \"arrivalAirport\", \"http://schema.org/arrivalAirport\"\r\n        \"arrivalBoatTerminal\", \"http://schema.org/arrivalBoatTerminal\"\r\n        \"arrivalBusStop\", \"http://schema.org/arrivalBusStop\"\r\n        \"arrivalGate\", \"http://schema.org/arrivalGate\"\r\n        \"arrivalPlatform\", \"http://schema.org/arrivalPlatform\"\r\n        \"arrivalStation\", \"http://schema.org/arrivalStation\"\r\n        \"arrivalTerminal\", \"http://schema.org/arrivalTerminal\"\r\n        \"arrivalTime\", \"http://schema.org/arrivalTime\"\r\n        \"artEdition\", \"http://schema.org/artEdition\"\r\n        \"artMedium\", \"http://schema.org/artMedium\"\r\n        \"arterialBranch\", \"http://schema.org/arterialBranch\"\r\n        \"artform\", \"http://schema.org/artform\"\r\n        \"articleBody\", \"http://schema.org/articleBody\"\r\n        \"articleSection\", \"http://schema.org/articleSection\"\r\n        \"artist\", \"http://schema.org/artist\"\r\n        \"artworkSurface\", \"http://schema.org/artworkSurface\"\r\n        \"aspect\", \"http://schema.org/aspect\"\r\n        \"assembly\", \"http://schema.org/assembly\"\r\n        \"assemblyVersion\", \"http://schema.org/assemblyVersion\"\r\n        \"assesses\", \"http://schema.org/assesses\"\r\n        \"associatedAnatomy\", \"http://schema.org/associatedAnatomy\"\r\n        \"associatedArticle\", \"http://schema.org/associatedArticle\"\r\n        \"associatedMedia\", \"http://schema.org/associatedMedia\"\r\n        \"associatedPathophysiology\", \"http://schema.org/associatedPathophysiology\"\r\n        \"athlete\", \"http://schema.org/athlete\"\r\n        \"attendee\", \"http://schema.org/attendee\"\r\n        \"attendees\", \"http://schema.org/attendees\"\r\n        \"audience\", \"http://schema.org/audience\"\r\n        \"audienceType\", \"http://schema.org/audienceType\"\r\n        \"audio\", \"http://schema.org/audio\"\r\n        \"authenticator\", \"http://schema.org/authenticator\"\r\n        \"author\", \"http://schema.org/author\"\r\n        \"availability\", \"http://schema.org/availability\"\r\n        \"availabilityEnds\", \"http://schema.org/availabilityEnds\"\r\n        \"availabilityStarts\", \"http://schema.org/availabilityStarts\"\r\n        \"availableAtOrFrom\", \"http://schema.org/availableAtOrFrom\"\r\n        \"availableChannel\", \"http://schema.org/availableChannel\"\r\n        \"availableDeliveryMethod\", \"http://schema.org/availableDeliveryMethod\"\r\n        \"availableFrom\", \"http://schema.org/availableFrom\"\r\n        \"availableIn\", \"http://schema.org/availableIn\"\r\n        \"availableLanguage\", \"http://schema.org/availableLanguage\"\r\n        \"availableOnDevice\", \"http://schema.org/availableOnDevice\"\r\n        \"availableService\", \"http://schema.org/availableService\"\r\n        \"availableStrength\", \"http://schema.org/availableStrength\"\r\n        \"availableTest\", \"http://schema.org/availableTest\"\r\n        \"availableThrough\", \"http://schema.org/availableThrough\"\r\n        \"award\", \"http://schema.org/award\"\r\n        \"awards\", \"http://schema.org/awards\"\r\n        \"awayTeam\", \"http://schema.org/awayTeam\"\r\n        \"backstory\", \"http://schema.org/backstory\"\r\n        \"bankAccountType\", \"http://schema.org/bankAccountType\"\r\n        \"baseSalary\", \"http://schema.org/baseSalary\"\r\n        \"bccRecipient\", \"http://schema.org/bccRecipient\"\r\n        \"bed\", \"http://schema.org/bed\"\r\n        \"beforeMedia\", \"http://schema.org/beforeMedia\"\r\n        \"beneficiaryBank\", \"http://schema.org/beneficiaryBank\"\r\n        \"benefits\", \"http://schema.org/benefits\"\r\n        \"benefitsSummaryUrl\", \"http://schema.org/benefitsSummaryUrl\"\r\n        \"bestRating\", \"http://schema.org/bestRating\"\r\n        \"billingAddress\", \"http://schema.org/billingAddress\"\r\n        \"billingIncrement\", \"http://schema.org/billingIncrement\"\r\n        \"billingPeriod\", \"http://schema.org/billingPeriod\"\r\n        \"biomechnicalClass\", \"http://schema.org/biomechnicalClass\"\r\n        \"birthDate\", \"http://schema.org/birthDate\"\r\n        \"birthPlace\", \"http://schema.org/birthPlace\"\r\n        \"bitrate\", \"http://schema.org/bitrate\"\r\n        \"blogPost\", \"http://schema.org/blogPost\"\r\n        \"blogPosts\", \"http://schema.org/blogPosts\"\r\n        \"bloodSupply\", \"http://schema.org/bloodSupply\"\r\n        \"boardingGroup\", \"http://schema.org/boardingGroup\"\r\n        \"boardingPolicy\", \"http://schema.org/boardingPolicy\"\r\n        \"bodyLocation\", \"http://schema.org/bodyLocation\"\r\n        \"bodyType\", \"http://schema.org/bodyType\"\r\n        \"bookEdition\", \"http://schema.org/bookEdition\"\r\n        \"bookFormat\", \"http://schema.org/bookFormat\"\r\n        \"bookingAgent\", \"http://schema.org/bookingAgent\"\r\n        \"bookingTime\", \"http://schema.org/bookingTime\"\r\n        \"borrower\", \"http://schema.org/borrower\"\r\n        \"box\", \"http://schema.org/box\"\r\n        \"branch\", \"http://schema.org/branch\"\r\n        \"branchCode\", \"http://schema.org/branchCode\"\r\n        \"branchOf\", \"http://schema.org/branchOf\"\r\n        \"brand\", \"http://schema.org/brand\"\r\n        \"breadcrumb\", \"http://schema.org/breadcrumb\"\r\n        \"breastfeedingWarning\", \"http://schema.org/breastfeedingWarning\"\r\n        \"broadcastAffiliateOf\", \"http://schema.org/broadcastAffiliateOf\"\r\n        \"broadcastChannelId\", \"http://schema.org/broadcastChannelId\"\r\n        \"broadcastDisplayName\", \"http://schema.org/broadcastDisplayName\"\r\n        \"broadcastFrequency\", \"http://schema.org/broadcastFrequency\"\r\n        \"broadcastFrequencyValue\", \"http://schema.org/broadcastFrequencyValue\"\r\n        \"broadcastOfEvent\", \"http://schema.org/broadcastOfEvent\"\r\n        \"broadcastServiceTier\", \"http://schema.org/broadcastServiceTier\"\r\n        \"broadcastSignalModulation\", \"http://schema.org/broadcastSignalModulation\"\r\n        \"broadcastSubChannel\", \"http://schema.org/broadcastSubChannel\"\r\n        \"broadcastTimezone\", \"http://schema.org/broadcastTimezone\"\r\n        \"broadcaster\", \"http://schema.org/broadcaster\"\r\n        \"broker\", \"http://schema.org/broker\"\r\n        \"browserRequirements\", \"http://schema.org/browserRequirements\"\r\n        \"busName\", \"http://schema.org/busName\"\r\n        \"busNumber\", \"http://schema.org/busNumber\"\r\n        \"businessDays\", \"http://schema.org/businessDays\"\r\n        \"businessFunction\", \"http://schema.org/businessFunction\"\r\n        \"buyer\", \"http://schema.org/buyer\"\r\n        \"byArtist\", \"http://schema.org/byArtist\"\r\n        \"byDay\", \"http://schema.org/byDay\"\r\n        \"byMonth\", \"http://schema.org/byMonth\"\r\n        \"byMonthDay\", \"http://schema.org/byMonthDay\"\r\n        \"byMonthWeek\", \"http://schema.org/byMonthWeek\"\r\n        \"callSign\", \"http://schema.org/callSign\"\r\n        \"calories\", \"http://schema.org/calories\"\r\n        \"candidate\", \"http://schema.org/candidate\"\r\n        \"caption\", \"http://schema.org/caption\"\r\n        \"carbohydrateContent\", \"http://schema.org/carbohydrateContent\"\r\n        \"cargoVolume\", \"http://schema.org/cargoVolume\"\r\n        \"carrier\", \"http://schema.org/carrier\"\r\n        \"carrierRequirements\", \"http://schema.org/carrierRequirements\"\r\n        \"cashBack\", \"http://schema.org/cashBack\"\r\n        \"catalog\", \"http://schema.org/catalog\"\r\n        \"catalogNumber\", \"http://schema.org/catalogNumber\"\r\n        \"category\", \"http://schema.org/category\"\r\n        \"causeOf\", \"http://schema.org/causeOf\"\r\n        \"ccRecipient\", \"http://schema.org/ccRecipient\"\r\n        \"character\", \"http://schema.org/character\"\r\n        \"characterAttribute\", \"http://schema.org/characterAttribute\"\r\n        \"characterName\", \"http://schema.org/characterName\"\r\n        \"cheatCode\", \"http://schema.org/cheatCode\"\r\n        \"checkinTime\", \"http://schema.org/checkinTime\"\r\n        \"checkoutTime\", \"http://schema.org/checkoutTime\"\r\n        \"childMaxAge\", \"http://schema.org/childMaxAge\"\r\n        \"childMinAge\", \"http://schema.org/childMinAge\"\r\n        \"children\", \"http://schema.org/children\"\r\n        \"cholesterolContent\", \"http://schema.org/cholesterolContent\"\r\n        \"circle\", \"http://schema.org/circle\"\r\n        \"citation\", \"http://schema.org/citation\"\r\n        \"claimReviewed\", \"http://schema.org/claimReviewed\"\r\n        \"clincalPharmacology\", \"http://schema.org/clincalPharmacology\"\r\n        \"clinicalPharmacology\", \"http://schema.org/clinicalPharmacology\"\r\n        \"clipNumber\", \"http://schema.org/clipNumber\"\r\n        \"closes\", \"http://schema.org/closes\"\r\n        \"coach\", \"http://schema.org/coach\"\r\n        \"code\", \"http://schema.org/code\"\r\n        \"codeRepository\", \"http://schema.org/codeRepository\"\r\n        \"codeSampleType\", \"http://schema.org/codeSampleType\"\r\n        \"codeValue\", \"http://schema.org/codeValue\"\r\n        \"codingSystem\", \"http://schema.org/codingSystem\"\r\n        \"colleague\", \"http://schema.org/colleague\"\r\n        \"colleagues\", \"http://schema.org/colleagues\"\r\n        \"collection\", \"http://schema.org/collection\"\r\n        \"collectionSize\", \"http://schema.org/collectionSize\"\r\n        \"color\", \"http://schema.org/color\"\r\n        \"colorist\", \"http://schema.org/colorist\"\r\n        \"comment\", \"http://schema.org/comment\"\r\n        \"commentCount\", \"http://schema.org/commentCount\"\r\n        \"commentText\", \"http://schema.org/commentText\"\r\n        \"commentTime\", \"http://schema.org/commentTime\"\r\n        \"competencyRequired\", \"http://schema.org/competencyRequired\"\r\n        \"competitor\", \"http://schema.org/competitor\"\r\n        \"composer\", \"http://schema.org/composer\"\r\n        \"comprisedOf\", \"http://schema.org/comprisedOf\"\r\n        \"conditionsOfAccess\", \"http://schema.org/conditionsOfAccess\"\r\n        \"confirmationNumber\", \"http://schema.org/confirmationNumber\"\r\n        \"connectedTo\", \"http://schema.org/connectedTo\"\r\n        \"constrainingProperty\", \"http://schema.org/constrainingProperty\"\r\n        \"contactOption\", \"http://schema.org/contactOption\"\r\n        \"contactPoint\", \"http://schema.org/contactPoint\"\r\n        \"contactPoints\", \"http://schema.org/contactPoints\"\r\n        \"contactType\", \"http://schema.org/contactType\"\r\n        \"contactlessPayment\", \"http://schema.org/contactlessPayment\"\r\n        \"containedIn\", \"http://schema.org/containedIn\"\r\n        \"containedInPlace\", \"http://schema.org/containedInPlace\"\r\n        \"containsPlace\", \"http://schema.org/containsPlace\"\r\n        \"containsSeason\", \"http://schema.org/containsSeason\"\r\n        \"contentLocation\", \"http://schema.org/contentLocation\"\r\n        \"contentRating\", \"http://schema.org/contentRating\"\r\n        \"contentReferenceTime\", \"http://schema.org/contentReferenceTime\"\r\n        \"contentSize\", \"http://schema.org/contentSize\"\r\n        \"contentType\", \"http://schema.org/contentType\"\r\n        \"contentUrl\", \"http://schema.org/contentUrl\"\r\n        \"contraindication\", \"http://schema.org/contraindication\"\r\n        \"contributor\", \"http://schema.org/contributor\"\r\n        \"cookTime\", \"http://schema.org/cookTime\"\r\n        \"cookingMethod\", \"http://schema.org/cookingMethod\"\r\n        \"copyrightHolder\", \"http://schema.org/copyrightHolder\"\r\n        \"copyrightYear\", \"http://schema.org/copyrightYear\"\r\n        \"correction\", \"http://schema.org/correction\"\r\n        \"correctionsPolicy\", \"http://schema.org/correctionsPolicy\"\r\n        \"costCategory\", \"http://schema.org/costCategory\"\r\n        \"costCurrency\", \"http://schema.org/costCurrency\"\r\n        \"costOrigin\", \"http://schema.org/costOrigin\"\r\n        \"costPerUnit\", \"http://schema.org/costPerUnit\"\r\n        \"countriesNotSupported\", \"http://schema.org/countriesNotSupported\"\r\n        \"countriesSupported\", \"http://schema.org/countriesSupported\"\r\n        \"countryOfOrigin\", \"http://schema.org/countryOfOrigin\"\r\n        \"course\", \"http://schema.org/course\"\r\n        \"courseCode\", \"http://schema.org/courseCode\"\r\n        \"courseMode\", \"http://schema.org/courseMode\"\r\n        \"coursePrerequisites\", \"http://schema.org/coursePrerequisites\"\r\n        \"courseWorkload\", \"http://schema.org/courseWorkload\"\r\n        \"coverageEndTime\", \"http://schema.org/coverageEndTime\"\r\n        \"coverageStartTime\", \"http://schema.org/coverageStartTime\"\r\n        \"creativeWorkStatus\", \"http://schema.org/creativeWorkStatus\"\r\n        \"creator\", \"http://schema.org/creator\"\r\n        \"credentialCategory\", \"http://schema.org/credentialCategory\"\r\n        \"creditedTo\", \"http://schema.org/creditedTo\"\r\n        \"cssSelector\", \"http://schema.org/cssSelector\"\r\n        \"currenciesAccepted\", \"http://schema.org/currenciesAccepted\"\r\n        \"currency\", \"http://schema.org/currency\"\r\n        \"currentExchangeRate\", \"http://schema.org/currentExchangeRate\"\r\n        \"customer\", \"http://schema.org/customer\"\r\n        \"cutoffTime\", \"http://schema.org/cutoffTime\"\r\n        \"cvdCollectionDate\", \"http://schema.org/cvdCollectionDate\"\r\n        \"cvdFacilityCounty\", \"http://schema.org/cvdFacilityCounty\"\r\n        \"cvdFacilityId\", \"http://schema.org/cvdFacilityId\"\r\n        \"cvdNumBeds\", \"http://schema.org/cvdNumBeds\"\r\n        \"cvdNumBedsOcc\", \"http://schema.org/cvdNumBedsOcc\"\r\n        \"cvdNumC19Died\", \"http://schema.org/cvdNumC19Died\"\r\n        \"cvdNumC19HOPats\", \"http://schema.org/cvdNumC19HOPats\"\r\n        \"cvdNumC19HospPats\", \"http://schema.org/cvdNumC19HospPats\"\r\n        \"cvdNumC19MechVentPats\", \"http://schema.org/cvdNumC19MechVentPats\"\r\n        \"cvdNumC19OFMechVentPats\", \"http://schema.org/cvdNumC19OFMechVentPats\"\r\n        \"cvdNumC19OverflowPats\", \"http://schema.org/cvdNumC19OverflowPats\"\r\n        \"cvdNumICUBeds\", \"http://schema.org/cvdNumICUBeds\"\r\n        \"cvdNumICUBedsOcc\", \"http://schema.org/cvdNumICUBedsOcc\"\r\n        \"cvdNumTotBeds\", \"http://schema.org/cvdNumTotBeds\"\r\n        \"cvdNumVent\", \"http://schema.org/cvdNumVent\"\r\n        \"cvdNumVentUse\", \"http://schema.org/cvdNumVentUse\"\r\n        \"dataFeedElement\", \"http://schema.org/dataFeedElement\"\r\n        \"dataset\", \"http://schema.org/dataset\"\r\n        \"datasetTimeInterval\", \"http://schema.org/datasetTimeInterval\"\r\n        \"dateCreated\", \"http://schema.org/dateCreated\"\r\n        \"dateDeleted\", \"http://schema.org/dateDeleted\"\r\n        \"dateIssued\", \"http://schema.org/dateIssued\"\r\n        \"dateModified\", \"http://schema.org/dateModified\"\r\n        \"datePosted\", \"http://schema.org/datePosted\"\r\n        \"datePublished\", \"http://schema.org/datePublished\"\r\n        \"dateRead\", \"http://schema.org/dateRead\"\r\n        \"dateReceived\", \"http://schema.org/dateReceived\"\r\n        \"dateSent\", \"http://schema.org/dateSent\"\r\n        \"dateVehicleFirstRegistered\", \"http://schema.org/dateVehicleFirstRegistered\"\r\n        \"dateline\", \"http://schema.org/dateline\"\r\n        \"dayOfWeek\", \"http://schema.org/dayOfWeek\"\r\n        \"deathDate\", \"http://schema.org/deathDate\"\r\n        \"deathPlace\", \"http://schema.org/deathPlace\"\r\n        \"defaultValue\", \"http://schema.org/defaultValue\"\r\n        \"deliveryAddress\", \"http://schema.org/deliveryAddress\"\r\n        \"deliveryLeadTime\", \"http://schema.org/deliveryLeadTime\"\r\n        \"deliveryMethod\", \"http://schema.org/deliveryMethod\"\r\n        \"deliveryStatus\", \"http://schema.org/deliveryStatus\"\r\n        \"deliveryTime\", \"http://schema.org/deliveryTime\"\r\n        \"department\", \"http://schema.org/department\"\r\n        \"departureAirport\", \"http://schema.org/departureAirport\"\r\n        \"departureBoatTerminal\", \"http://schema.org/departureBoatTerminal\"\r\n        \"departureBusStop\", \"http://schema.org/departureBusStop\"\r\n        \"departureGate\", \"http://schema.org/departureGate\"\r\n        \"departurePlatform\", \"http://schema.org/departurePlatform\"\r\n        \"departureStation\", \"http://schema.org/departureStation\"\r\n        \"departureTerminal\", \"http://schema.org/departureTerminal\"\r\n        \"departureTime\", \"http://schema.org/departureTime\"\r\n        \"dependencies\", \"http://schema.org/dependencies\"\r\n        \"depth\", \"http://schema.org/depth\"\r\n        \"description\", \"http://schema.org/description\"\r\n        \"device\", \"http://schema.org/device\"\r\n        \"diagnosis\", \"http://schema.org/diagnosis\"\r\n        \"diagram\", \"http://schema.org/diagram\"\r\n        \"diet\", \"http://schema.org/diet\"\r\n        \"dietFeatures\", \"http://schema.org/dietFeatures\"\r\n        \"differentialDiagnosis\", \"http://schema.org/differentialDiagnosis\"\r\n        \"director\", \"http://schema.org/director\"\r\n        \"directors\", \"http://schema.org/directors\"\r\n        \"disambiguatingDescription\", \"http://schema.org/disambiguatingDescription\"\r\n        \"discount\", \"http://schema.org/discount\"\r\n        \"discountCode\", \"http://schema.org/discountCode\"\r\n        \"discountCurrency\", \"http://schema.org/discountCurrency\"\r\n        \"discusses\", \"http://schema.org/discusses\"\r\n        \"discussionUrl\", \"http://schema.org/discussionUrl\"\r\n        \"diseasePreventionInfo\", \"http://schema.org/diseasePreventionInfo\"\r\n        \"diseaseSpreadStatistics\", \"http://schema.org/diseaseSpreadStatistics\"\r\n        \"dissolutionDate\", \"http://schema.org/dissolutionDate\"\r\n        \"distance\", \"http://schema.org/distance\"\r\n        \"distinguishingSign\", \"http://schema.org/distinguishingSign\"\r\n        \"distribution\", \"http://schema.org/distribution\"\r\n        \"diversityPolicy\", \"http://schema.org/diversityPolicy\"\r\n        \"diversityStaffingReport\", \"http://schema.org/diversityStaffingReport\"\r\n        \"documentation\", \"http://schema.org/documentation\"\r\n        \"doesNotShip\", \"http://schema.org/doesNotShip\"\r\n        \"domainIncludes\", \"http://schema.org/domainIncludes\"\r\n        \"domiciledMortgage\", \"http://schema.org/domiciledMortgage\"\r\n        \"doorTime\", \"http://schema.org/doorTime\"\r\n        \"dosageForm\", \"http://schema.org/dosageForm\"\r\n        \"doseSchedule\", \"http://schema.org/doseSchedule\"\r\n        \"doseUnit\", \"http://schema.org/doseUnit\"\r\n        \"doseValue\", \"http://schema.org/doseValue\"\r\n        \"downPayment\", \"http://schema.org/downPayment\"\r\n        \"downloadUrl\", \"http://schema.org/downloadUrl\"\r\n        \"downvoteCount\", \"http://schema.org/downvoteCount\"\r\n        \"drainsTo\", \"http://schema.org/drainsTo\"\r\n        \"driveWheelConfiguration\", \"http://schema.org/driveWheelConfiguration\"\r\n        \"dropoffLocation\", \"http://schema.org/dropoffLocation\"\r\n        \"dropoffTime\", \"http://schema.org/dropoffTime\"\r\n        \"drug\", \"http://schema.org/drug\"\r\n        \"drugClass\", \"http://schema.org/drugClass\"\r\n        \"drugUnit\", \"http://schema.org/drugUnit\"\r\n        \"duns\", \"http://schema.org/duns\"\r\n        \"duplicateTherapy\", \"http://schema.org/duplicateTherapy\"\r\n        \"duration\", \"http://schema.org/duration\"\r\n        \"durationOfWarranty\", \"http://schema.org/durationOfWarranty\"\r\n        \"duringMedia\", \"http://schema.org/duringMedia\"\r\n        \"earlyPrepaymentPenalty\", \"http://schema.org/earlyPrepaymentPenalty\"\r\n        \"editEIDR\", \"http://schema.org/editEIDR\"\r\n        \"editor\", \"http://schema.org/editor\"\r\n        \"eduQuestionType\", \"http://schema.org/eduQuestionType\"\r\n        \"educationRequirements\", \"http://schema.org/educationRequirements\"\r\n        \"educationalAlignment\", \"http://schema.org/educationalAlignment\"\r\n        \"educationalCredentialAwarded\", \"http://schema.org/educationalCredentialAwarded\"\r\n        \"educationalFramework\", \"http://schema.org/educationalFramework\"\r\n        \"educationalLevel\", \"http://schema.org/educationalLevel\"\r\n        \"educationalProgramMode\", \"http://schema.org/educationalProgramMode\"\r\n        \"educationalRole\", \"http://schema.org/educationalRole\"\r\n        \"educationalUse\", \"http://schema.org/educationalUse\"\r\n        \"elevation\", \"http://schema.org/elevation\"\r\n        \"eligibilityToWorkRequirement\", \"http://schema.org/eligibilityToWorkRequirement\"\r\n        \"eligibleCustomerType\", \"http://schema.org/eligibleCustomerType\"\r\n        \"eligibleDuration\", \"http://schema.org/eligibleDuration\"\r\n        \"eligibleQuantity\", \"http://schema.org/eligibleQuantity\"\r\n        \"eligibleRegion\", \"http://schema.org/eligibleRegion\"\r\n        \"eligibleTransactionVolume\", \"http://schema.org/eligibleTransactionVolume\"\r\n        \"email\", \"http://schema.org/email\"\r\n        \"embedUrl\", \"http://schema.org/embedUrl\"\r\n        \"emissionsCO2\", \"http://schema.org/emissionsCO2\"\r\n        \"employee\", \"http://schema.org/employee\"\r\n        \"employees\", \"http://schema.org/employees\"\r\n        \"employerOverview\", \"http://schema.org/employerOverview\"\r\n        \"employmentType\", \"http://schema.org/employmentType\"\r\n        \"employmentUnit\", \"http://schema.org/employmentUnit\"\r\n        \"encodesCreativeWork\", \"http://schema.org/encodesCreativeWork\"\r\n        \"encoding\", \"http://schema.org/encoding\"\r\n        \"encodingFormat\", \"http://schema.org/encodingFormat\"\r\n        \"encodingType\", \"http://schema.org/encodingType\"\r\n        \"encodings\", \"http://schema.org/encodings\"\r\n        \"endDate\", \"http://schema.org/endDate\"\r\n        \"endOffset\", \"http://schema.org/endOffset\"\r\n        \"endTime\", \"http://schema.org/endTime\"\r\n        \"endorsee\", \"http://schema.org/endorsee\"\r\n        \"endorsers\", \"http://schema.org/endorsers\"\r\n        \"energyEfficiencyScaleMax\", \"http://schema.org/energyEfficiencyScaleMax\"\r\n        \"energyEfficiencyScaleMin\", \"http://schema.org/energyEfficiencyScaleMin\"\r\n        \"engineDisplacement\", \"http://schema.org/engineDisplacement\"\r\n        \"enginePower\", \"http://schema.org/enginePower\"\r\n        \"engineType\", \"http://schema.org/engineType\"\r\n        \"entertainmentBusiness\", \"http://schema.org/entertainmentBusiness\"\r\n        \"epidemiology\", \"http://schema.org/epidemiology\"\r\n        \"episode\", \"http://schema.org/episode\"\r\n        \"episodeNumber\", \"http://schema.org/episodeNumber\"\r\n        \"episodes\", \"http://schema.org/episodes\"\r\n        \"equal\", \"http://schema.org/equal\"\r\n        \"error\", \"http://schema.org/error\"\r\n        \"estimatedCost\", \"http://schema.org/estimatedCost\"\r\n        \"estimatedFlightDuration\", \"http://schema.org/estimatedFlightDuration\"\r\n        \"estimatedSalary\", \"http://schema.org/estimatedSalary\"\r\n        \"estimatesRiskOf\", \"http://schema.org/estimatesRiskOf\"\r\n        \"ethicsPolicy\", \"http://schema.org/ethicsPolicy\"\r\n        \"event\", \"http://schema.org/event\"\r\n        \"eventAttendanceMode\", \"http://schema.org/eventAttendanceMode\"\r\n        \"eventSchedule\", \"http://schema.org/eventSchedule\"\r\n        \"eventStatus\", \"http://schema.org/eventStatus\"\r\n        \"events\", \"http://schema.org/events\"\r\n        \"evidenceLevel\", \"http://schema.org/evidenceLevel\"\r\n        \"evidenceOrigin\", \"http://schema.org/evidenceOrigin\"\r\n        \"exampleOfWork\", \"http://schema.org/exampleOfWork\"\r\n        \"exceptDate\", \"http://schema.org/exceptDate\"\r\n        \"exchangeRateSpread\", \"http://schema.org/exchangeRateSpread\"\r\n        \"executableLibraryName\", \"http://schema.org/executableLibraryName\"\r\n        \"exerciseCourse\", \"http://schema.org/exerciseCourse\"\r\n        \"exercisePlan\", \"http://schema.org/exercisePlan\"\r\n        \"exerciseRelatedDiet\", \"http://schema.org/exerciseRelatedDiet\"\r\n        \"exerciseType\", \"http://schema.org/exerciseType\"\r\n        \"exifData\", \"http://schema.org/exifData\"\r\n        \"expectedArrivalFrom\", \"http://schema.org/expectedArrivalFrom\"\r\n        \"expectedArrivalUntil\", \"http://schema.org/expectedArrivalUntil\"\r\n        \"expectedPrognosis\", \"http://schema.org/expectedPrognosis\"\r\n        \"expectsAcceptanceOf\", \"http://schema.org/expectsAcceptanceOf\"\r\n        \"experienceRequirements\", \"http://schema.org/experienceRequirements\"\r\n        \"expertConsiderations\", \"http://schema.org/expertConsiderations\"\r\n        \"expires\", \"http://schema.org/expires\"\r\n        \"familyName\", \"http://schema.org/familyName\"\r\n        \"fatContent\", \"http://schema.org/fatContent\"\r\n        \"faxNumber\", \"http://schema.org/faxNumber\"\r\n        \"featureList\", \"http://schema.org/featureList\"\r\n        \"feesAndCommissionsSpecification\", \"http://schema.org/feesAndCommissionsSpecification\"\r\n        \"fiberContent\", \"http://schema.org/fiberContent\"\r\n        \"fileFormat\", \"http://schema.org/fileFormat\"\r\n        \"fileSize\", \"http://schema.org/fileSize\"\r\n        \"financialAidEligible\", \"http://schema.org/financialAidEligible\"\r\n        \"firstAppearance\", \"http://schema.org/firstAppearance\"\r\n        \"firstPerformance\", \"http://schema.org/firstPerformance\"\r\n        \"flightDistance\", \"http://schema.org/flightDistance\"\r\n        \"flightNumber\", \"http://schema.org/flightNumber\"\r\n        \"floorLevel\", \"http://schema.org/floorLevel\"\r\n        \"floorLimit\", \"http://schema.org/floorLimit\"\r\n        \"floorSize\", \"http://schema.org/floorSize\"\r\n        \"followee\", \"http://schema.org/followee\"\r\n        \"follows\", \"http://schema.org/follows\"\r\n        \"followup\", \"http://schema.org/followup\"\r\n        \"foodEstablishment\", \"http://schema.org/foodEstablishment\"\r\n        \"foodEvent\", \"http://schema.org/foodEvent\"\r\n        \"foodWarning\", \"http://schema.org/foodWarning\"\r\n        \"founder\", \"http://schema.org/founder\"\r\n        \"founders\", \"http://schema.org/founders\"\r\n        \"foundingDate\", \"http://schema.org/foundingDate\"\r\n        \"foundingLocation\", \"http://schema.org/foundingLocation\"\r\n        \"free\", \"http://schema.org/free\"\r\n        \"freeShippingThreshold\", \"http://schema.org/freeShippingThreshold\"\r\n        \"frequency\", \"http://schema.org/frequency\"\r\n        \"fromLocation\", \"http://schema.org/fromLocation\"\r\n        \"fuelCapacity\", \"http://schema.org/fuelCapacity\"\r\n        \"fuelConsumption\", \"http://schema.org/fuelConsumption\"\r\n        \"fuelEfficiency\", \"http://schema.org/fuelEfficiency\"\r\n        \"fuelType\", \"http://schema.org/fuelType\"\r\n        \"functionalClass\", \"http://schema.org/functionalClass\"\r\n        \"fundedItem\", \"http://schema.org/fundedItem\"\r\n        \"funder\", \"http://schema.org/funder\"\r\n        \"game\", \"http://schema.org/game\"\r\n        \"gameItem\", \"http://schema.org/gameItem\"\r\n        \"gameLocation\", \"http://schema.org/gameLocation\"\r\n        \"gamePlatform\", \"http://schema.org/gamePlatform\"\r\n        \"gameServer\", \"http://schema.org/gameServer\"\r\n        \"gameTip\", \"http://schema.org/gameTip\"\r\n        \"gender\", \"http://schema.org/gender\"\r\n        \"genre\", \"http://schema.org/genre\"\r\n        \"geo\", \"http://schema.org/geo\"\r\n        \"geoContains\", \"http://schema.org/geoContains\"\r\n        \"geoCoveredBy\", \"http://schema.org/geoCoveredBy\"\r\n        \"geoCovers\", \"http://schema.org/geoCovers\"\r\n        \"geoCrosses\", \"http://schema.org/geoCrosses\"\r\n        \"geoDisjoint\", \"http://schema.org/geoDisjoint\"\r\n        \"geoEquals\", \"http://schema.org/geoEquals\"\r\n        \"geoIntersects\", \"http://schema.org/geoIntersects\"\r\n        \"geoMidpoint\", \"http://schema.org/geoMidpoint\"\r\n        \"geoOverlaps\", \"http://schema.org/geoOverlaps\"\r\n        \"geoRadius\", \"http://schema.org/geoRadius\"\r\n        \"geoTouches\", \"http://schema.org/geoTouches\"\r\n        \"geoWithin\", \"http://schema.org/geoWithin\"\r\n        \"geographicArea\", \"http://schema.org/geographicArea\"\r\n        \"gettingTestedInfo\", \"http://schema.org/gettingTestedInfo\"\r\n        \"givenName\", \"http://schema.org/givenName\"\r\n        \"globalLocationNumber\", \"http://schema.org/globalLocationNumber\"\r\n        \"governmentBenefitsInfo\", \"http://schema.org/governmentBenefitsInfo\"\r\n        \"gracePeriod\", \"http://schema.org/gracePeriod\"\r\n        \"grantee\", \"http://schema.org/grantee\"\r\n        \"greater\", \"http://schema.org/greater\"\r\n        \"greaterOrEqual\", \"http://schema.org/greaterOrEqual\"\r\n        \"gtin\", \"http://schema.org/gtin\"\r\n        \"gtin12\", \"http://schema.org/gtin12\"\r\n        \"gtin13\", \"http://schema.org/gtin13\"\r\n        \"gtin14\", \"http://schema.org/gtin14\"\r\n        \"gtin8\", \"http://schema.org/gtin8\"\r\n        \"guideline\", \"http://schema.org/guideline\"\r\n        \"guidelineDate\", \"http://schema.org/guidelineDate\"\r\n        \"guidelineSubject\", \"http://schema.org/guidelineSubject\"\r\n        \"handlingTime\", \"http://schema.org/handlingTime\"\r\n        \"hasBroadcastChannel\", \"http://schema.org/hasBroadcastChannel\"\r\n        \"hasCategoryCode\", \"http://schema.org/hasCategoryCode\"\r\n        \"hasCourse\", \"http://schema.org/hasCourse\"\r\n        \"hasCourseInstance\", \"http://schema.org/hasCourseInstance\"\r\n        \"hasCredential\", \"http://schema.org/hasCredential\"\r\n        \"hasDefinedTerm\", \"http://schema.org/hasDefinedTerm\"\r\n        \"hasDeliveryMethod\", \"http://schema.org/hasDeliveryMethod\"\r\n        \"hasDigitalDocumentPermission\", \"http://schema.org/hasDigitalDocumentPermission\"\r\n        \"hasDriveThroughService\", \"http://schema.org/hasDriveThroughService\"\r\n        \"hasEnergyConsumptionDetails\", \"http://schema.org/hasEnergyConsumptionDetails\"\r\n        \"hasEnergyEfficiencyCategory\", \"http://schema.org/hasEnergyEfficiencyCategory\"\r\n        \"hasHealthAspect\", \"http://schema.org/hasHealthAspect\"\r\n        \"hasMap\", \"http://schema.org/hasMap\"\r\n        \"hasMenu\", \"http://schema.org/hasMenu\"\r\n        \"hasMenuItem\", \"http://schema.org/hasMenuItem\"\r\n        \"hasMenuSection\", \"http://schema.org/hasMenuSection\"\r\n        \"hasMerchantReturnPolicy\", \"http://schema.org/hasMerchantReturnPolicy\"\r\n        \"hasOccupation\", \"http://schema.org/hasOccupation\"\r\n        \"hasOfferCatalog\", \"http://schema.org/hasOfferCatalog\"\r\n        \"hasPOS\", \"http://schema.org/hasPOS\"\r\n        \"hasPart\", \"http://schema.org/hasPart\"\r\n        \"hasProductReturnPolicy\", \"http://schema.org/hasProductReturnPolicy\"\r\n        \"hasVariant\", \"http://schema.org/hasVariant\"\r\n        \"headline\", \"http://schema.org/headline\"\r\n        \"healthCondition\", \"http://schema.org/healthCondition\"\r\n        \"healthPlanCoinsuranceOption\", \"http://schema.org/healthPlanCoinsuranceOption\"\r\n        \"healthPlanCoinsuranceRate\", \"http://schema.org/healthPlanCoinsuranceRate\"\r\n        \"healthPlanCopay\", \"http://schema.org/healthPlanCopay\"\r\n        \"healthPlanCopayOption\", \"http://schema.org/healthPlanCopayOption\"\r\n        \"healthPlanCostSharing\", \"http://schema.org/healthPlanCostSharing\"\r\n        \"healthPlanDrugOption\", \"http://schema.org/healthPlanDrugOption\"\r\n        \"healthPlanDrugTier\", \"http://schema.org/healthPlanDrugTier\"\r\n        \"healthPlanId\", \"http://schema.org/healthPlanId\"\r\n        \"healthPlanMarketingUrl\", \"http://schema.org/healthPlanMarketingUrl\"\r\n        \"healthPlanNetworkId\", \"http://schema.org/healthPlanNetworkId\"\r\n        \"healthPlanNetworkTier\", \"http://schema.org/healthPlanNetworkTier\"\r\n        \"healthPlanPharmacyCategory\", \"http://schema.org/healthPlanPharmacyCategory\"\r\n        \"healthcareReportingData\", \"http://schema.org/healthcareReportingData\"\r\n        \"height\", \"http://schema.org/height\"\r\n        \"highPrice\", \"http://schema.org/highPrice\"\r\n        \"hiringOrganization\", \"http://schema.org/hiringOrganization\"\r\n        \"holdingArchive\", \"http://schema.org/holdingArchive\"\r\n        \"homeLocation\", \"http://schema.org/homeLocation\"\r\n        \"homeTeam\", \"http://schema.org/homeTeam\"\r\n        \"honorificPrefix\", \"http://schema.org/honorificPrefix\"\r\n        \"honorificSuffix\", \"http://schema.org/honorificSuffix\"\r\n        \"hospitalAffiliation\", \"http://schema.org/hospitalAffiliation\"\r\n        \"hostingOrganization\", \"http://schema.org/hostingOrganization\"\r\n        \"hoursAvailable\", \"http://schema.org/hoursAvailable\"\r\n        \"howPerformed\", \"http://schema.org/howPerformed\"\r\n        \"httpMethod\", \"http://schema.org/httpMethod\"\r\n        \"iataCode\", \"http://schema.org/iataCode\"\r\n        \"icaoCode\", \"http://schema.org/icaoCode\"\r\n        \"identifier\", \"http://schema.org/identifier\"\r\n        \"identifyingExam\", \"http://schema.org/identifyingExam\"\r\n        \"identifyingTest\", \"http://schema.org/identifyingTest\"\r\n        \"illustrator\", \"http://schema.org/illustrator\"\r\n        \"image\", \"http://schema.org/image\"\r\n        \"imagingTechnique\", \"http://schema.org/imagingTechnique\"\r\n        \"inAlbum\", \"http://schema.org/inAlbum\"\r\n        \"inBroadcastLineup\", \"http://schema.org/inBroadcastLineup\"\r\n        \"inCodeSet\", \"http://schema.org/inCodeSet\"\r\n        \"inDefinedTermSet\", \"http://schema.org/inDefinedTermSet\"\r\n        \"inLanguage\", \"http://schema.org/inLanguage\"\r\n        \"inPlaylist\", \"http://schema.org/inPlaylist\"\r\n        \"inProductGroupWithID\", \"http://schema.org/inProductGroupWithID\"\r\n        \"inStoreReturnsOffered\", \"http://schema.org/inStoreReturnsOffered\"\r\n        \"inSupportOf\", \"http://schema.org/inSupportOf\"\r\n        \"incentiveCompensation\", \"http://schema.org/incentiveCompensation\"\r\n        \"incentives\", \"http://schema.org/incentives\"\r\n        \"includedComposition\", \"http://schema.org/includedComposition\"\r\n        \"includedDataCatalog\", \"http://schema.org/includedDataCatalog\"\r\n        \"includedInDataCatalog\", \"http://schema.org/includedInDataCatalog\"\r\n        \"includedInHealthInsurancePlan\", \"http://schema.org/includedInHealthInsurancePlan\"\r\n        \"includedRiskFactor\", \"http://schema.org/includedRiskFactor\"\r\n        \"includesAttraction\", \"http://schema.org/includesAttraction\"\r\n        \"includesHealthPlanFormulary\", \"http://schema.org/includesHealthPlanFormulary\"\r\n        \"includesHealthPlanNetwork\", \"http://schema.org/includesHealthPlanNetwork\"\r\n        \"includesObject\", \"http://schema.org/includesObject\"\r\n        \"increasesRiskOf\", \"http://schema.org/increasesRiskOf\"\r\n        \"industry\", \"http://schema.org/industry\"\r\n        \"ineligibleRegion\", \"http://schema.org/ineligibleRegion\"\r\n        \"infectiousAgent\", \"http://schema.org/infectiousAgent\"\r\n        \"infectiousAgentClass\", \"http://schema.org/infectiousAgentClass\"\r\n        \"ingredients\", \"http://schema.org/ingredients\"\r\n        \"inker\", \"http://schema.org/inker\"\r\n        \"insertion\", \"http://schema.org/insertion\"\r\n        \"installUrl\", \"http://schema.org/installUrl\"\r\n        \"instructor\", \"http://schema.org/instructor\"\r\n        \"instrument\", \"http://schema.org/instrument\"\r\n        \"intensity\", \"http://schema.org/intensity\"\r\n        \"interactingDrug\", \"http://schema.org/interactingDrug\"\r\n        \"interactionCount\", \"http://schema.org/interactionCount\"\r\n        \"interactionService\", \"http://schema.org/interactionService\"\r\n        \"interactionStatistic\", \"http://schema.org/interactionStatistic\"\r\n        \"interactionType\", \"http://schema.org/interactionType\"\r\n        \"interactivityType\", \"http://schema.org/interactivityType\"\r\n        \"interestRate\", \"http://schema.org/interestRate\"\r\n        \"inventoryLevel\", \"http://schema.org/inventoryLevel\"\r\n        \"inverseOf\", \"http://schema.org/inverseOf\"\r\n        \"isAcceptingNewPatients\", \"http://schema.org/isAcceptingNewPatients\"\r\n        \"isAccessibleForFree\", \"http://schema.org/isAccessibleForFree\"\r\n        \"isAccessoryOrSparePartFor\", \"http://schema.org/isAccessoryOrSparePartFor\"\r\n        \"isAvailableGenerically\", \"http://schema.org/isAvailableGenerically\"\r\n        \"isBasedOn\", \"http://schema.org/isBasedOn\"\r\n        \"isBasedOnUrl\", \"http://schema.org/isBasedOnUrl\"\r\n        \"isConsumableFor\", \"http://schema.org/isConsumableFor\"\r\n        \"isFamilyFriendly\", \"http://schema.org/isFamilyFriendly\"\r\n        \"isGift\", \"http://schema.org/isGift\"\r\n        \"isLiveBroadcast\", \"http://schema.org/isLiveBroadcast\"\r\n        \"isPartOf\", \"http://schema.org/isPartOf\"\r\n        \"isPlanForApartment\", \"http://schema.org/isPlanForApartment\"\r\n        \"isProprietary\", \"http://schema.org/isProprietary\"\r\n        \"isRelatedTo\", \"http://schema.org/isRelatedTo\"\r\n        \"isResizable\", \"http://schema.org/isResizable\"\r\n        \"isSimilarTo\", \"http://schema.org/isSimilarTo\"\r\n        \"isUnlabelledFallback\", \"http://schema.org/isUnlabelledFallback\"\r\n        \"isVariantOf\", \"http://schema.org/isVariantOf\"\r\n        \"isbn\", \"http://schema.org/isbn\"\r\n        \"isicV4\", \"http://schema.org/isicV4\"\r\n        \"isrcCode\", \"http://schema.org/isrcCode\"\r\n        \"issn\", \"http://schema.org/issn\"\r\n        \"issueNumber\", \"http://schema.org/issueNumber\"\r\n        \"issuedBy\", \"http://schema.org/issuedBy\"\r\n        \"issuedThrough\", \"http://schema.org/issuedThrough\"\r\n        \"iswcCode\", \"http://schema.org/iswcCode\"\r\n        \"item\", \"http://schema.org/item\"\r\n        \"itemCondition\", \"http://schema.org/itemCondition\"\r\n        \"itemListElement\", \"http://schema.org/itemListElement\"\r\n        \"itemListOrder\", \"http://schema.org/itemListOrder\"\r\n        \"itemLocation\", \"http://schema.org/itemLocation\"\r\n        \"itemOffered\", \"http://schema.org/itemOffered\"\r\n        \"itemReviewed\", \"http://schema.org/itemReviewed\"\r\n        \"itemShipped\", \"http://schema.org/itemShipped\"\r\n        \"itinerary\", \"http://schema.org/itinerary\"\r\n        \"jobBenefits\", \"http://schema.org/jobBenefits\"\r\n        \"jobImmediateStart\", \"http://schema.org/jobImmediateStart\"\r\n        \"jobLocation\", \"http://schema.org/jobLocation\"\r\n        \"jobLocationType\", \"http://schema.org/jobLocationType\"\r\n        \"jobStartDate\", \"http://schema.org/jobStartDate\"\r\n        \"jobTitle\", \"http://schema.org/jobTitle\"\r\n        \"jurisdiction\", \"http://schema.org/jurisdiction\"\r\n        \"keywords\", \"http://schema.org/keywords\"\r\n        \"knownVehicleDamages\", \"http://schema.org/knownVehicleDamages\"\r\n        \"knows\", \"http://schema.org/knows\"\r\n        \"knowsAbout\", \"http://schema.org/knowsAbout\"\r\n        \"knowsLanguage\", \"http://schema.org/knowsLanguage\"\r\n        \"labelDetails\", \"http://schema.org/labelDetails\"\r\n        \"landlord\", \"http://schema.org/landlord\"\r\n        \"language\", \"http://schema.org/language\"\r\n        \"lastReviewed\", \"http://schema.org/lastReviewed\"\r\n        \"latitude\", \"http://schema.org/latitude\"\r\n        \"layoutImage\", \"http://schema.org/layoutImage\"\r\n        \"learningResourceType\", \"http://schema.org/learningResourceType\"\r\n        \"leaseLength\", \"http://schema.org/leaseLength\"\r\n        \"legalName\", \"http://schema.org/legalName\"\r\n        \"legalStatus\", \"http://schema.org/legalStatus\"\r\n        \"legislationApplies\", \"http://schema.org/legislationApplies\"\r\n        \"legislationChanges\", \"http://schema.org/legislationChanges\"\r\n        \"legislationConsolidates\", \"http://schema.org/legislationConsolidates\"\r\n        \"legislationDate\", \"http://schema.org/legislationDate\"\r\n        \"legislationDateVersion\", \"http://schema.org/legislationDateVersion\"\r\n        \"legislationIdentifier\", \"http://schema.org/legislationIdentifier\"\r\n        \"legislationJurisdiction\", \"http://schema.org/legislationJurisdiction\"\r\n        \"legislationLegalForce\", \"http://schema.org/legislationLegalForce\"\r\n        \"legislationLegalValue\", \"http://schema.org/legislationLegalValue\"\r\n        \"legislationPassedBy\", \"http://schema.org/legislationPassedBy\"\r\n        \"legislationResponsible\", \"http://schema.org/legislationResponsible\"\r\n        \"legislationTransposes\", \"http://schema.org/legislationTransposes\"\r\n        \"legislationType\", \"http://schema.org/legislationType\"\r\n        \"leiCode\", \"http://schema.org/leiCode\"\r\n        \"lender\", \"http://schema.org/lender\"\r\n        \"lesser\", \"http://schema.org/lesser\"\r\n        \"lesserOrEqual\", \"http://schema.org/lesserOrEqual\"\r\n        \"letterer\", \"http://schema.org/letterer\"\r\n        \"license\", \"http://schema.org/license\"\r\n        \"line\", \"http://schema.org/line\"\r\n        \"linkRelationship\", \"http://schema.org/linkRelationship\"\r\n        \"liveBlogUpdate\", \"http://schema.org/liveBlogUpdate\"\r\n        \"loanMortgageMandateAmount\", \"http://schema.org/loanMortgageMandateAmount\"\r\n        \"loanPaymentAmount\", \"http://schema.org/loanPaymentAmount\"\r\n        \"loanPaymentFrequency\", \"http://schema.org/loanPaymentFrequency\"\r\n        \"loanRepaymentForm\", \"http://schema.org/loanRepaymentForm\"\r\n        \"loanTerm\", \"http://schema.org/loanTerm\"\r\n        \"loanType\", \"http://schema.org/loanType\"\r\n        \"location\", \"http://schema.org/location\"\r\n        \"locationCreated\", \"http://schema.org/locationCreated\"\r\n        \"lodgingUnitDescription\", \"http://schema.org/lodgingUnitDescription\"\r\n        \"lodgingUnitType\", \"http://schema.org/lodgingUnitType\"\r\n        \"logo\", \"http://schema.org/logo\"\r\n        \"longitude\", \"http://schema.org/longitude\"\r\n        \"loser\", \"http://schema.org/loser\"\r\n        \"lowPrice\", \"http://schema.org/lowPrice\"\r\n        \"lyricist\", \"http://schema.org/lyricist\"\r\n        \"lyrics\", \"http://schema.org/lyrics\"\r\n        \"mainContentOfPage\", \"http://schema.org/mainContentOfPage\"\r\n        \"mainEntity\", \"http://schema.org/mainEntity\"\r\n        \"mainEntityOfPage\", \"http://schema.org/mainEntityOfPage\"\r\n        \"maintainer\", \"http://schema.org/maintainer\"\r\n        \"makesOffer\", \"http://schema.org/makesOffer\"\r\n        \"manufacturer\", \"http://schema.org/manufacturer\"\r\n        \"map\", \"http://schema.org/map\"\r\n        \"mapType\", \"http://schema.org/mapType\"\r\n        \"maps\", \"http://schema.org/maps\"\r\n        \"marginOfError\", \"http://schema.org/marginOfError\"\r\n        \"masthead\", \"http://schema.org/masthead\"\r\n        \"material\", \"http://schema.org/material\"\r\n        \"materialExtent\", \"http://schema.org/materialExtent\"\r\n        \"maxPrice\", \"http://schema.org/maxPrice\"\r\n        \"maxValue\", \"http://schema.org/maxValue\"\r\n        \"maximumAttendeeCapacity\", \"http://schema.org/maximumAttendeeCapacity\"\r\n        \"maximumEnrollment\", \"http://schema.org/maximumEnrollment\"\r\n        \"maximumIntake\", \"http://schema.org/maximumIntake\"\r\n        \"maximumPhysicalAttendeeCapacity\", \"http://schema.org/maximumPhysicalAttendeeCapacity\"\r\n        \"maximumVirtualAttendeeCapacity\", \"http://schema.org/maximumVirtualAttendeeCapacity\"\r\n        \"mealService\", \"http://schema.org/mealService\"\r\n        \"measuredProperty\", \"http://schema.org/measuredProperty\"\r\n        \"measuredValue\", \"http://schema.org/measuredValue\"\r\n        \"measurementTechnique\", \"http://schema.org/measurementTechnique\"\r\n        \"mechanismOfAction\", \"http://schema.org/mechanismOfAction\"\r\n        \"mediaAuthenticityCategory\", \"http://schema.org/mediaAuthenticityCategory\"\r\n        \"median\", \"http://schema.org/median\"\r\n        \"medicalAudience\", \"http://schema.org/medicalAudience\"\r\n        \"medicalSpecialty\", \"http://schema.org/medicalSpecialty\"\r\n        \"medicineSystem\", \"http://schema.org/medicineSystem\"\r\n        \"meetsEmissionStandard\", \"http://schema.org/meetsEmissionStandard\"\r\n        \"member\", \"http://schema.org/member\"\r\n        \"memberOf\", \"http://schema.org/memberOf\"\r\n        \"members\", \"http://schema.org/members\"\r\n        \"membershipNumber\", \"http://schema.org/membershipNumber\"\r\n        \"membershipPointsEarned\", \"http://schema.org/membershipPointsEarned\"\r\n        \"memoryRequirements\", \"http://schema.org/memoryRequirements\"\r\n        \"mentions\", \"http://schema.org/mentions\"\r\n        \"menu\", \"http://schema.org/menu\"\r\n        \"menuAddOn\", \"http://schema.org/menuAddOn\"\r\n        \"merchant\", \"http://schema.org/merchant\"\r\n        \"merchantReturnDays\", \"http://schema.org/merchantReturnDays\"\r\n        \"merchantReturnLink\", \"http://schema.org/merchantReturnLink\"\r\n        \"messageAttachment\", \"http://schema.org/messageAttachment\"\r\n        \"mileageFromOdometer\", \"http://schema.org/mileageFromOdometer\"\r\n        \"minPrice\", \"http://schema.org/minPrice\"\r\n        \"minValue\", \"http://schema.org/minValue\"\r\n        \"minimumPaymentDue\", \"http://schema.org/minimumPaymentDue\"\r\n        \"missionCoveragePrioritiesPolicy\", \"http://schema.org/missionCoveragePrioritiesPolicy\"\r\n        \"model\", \"http://schema.org/model\"\r\n        \"modelDate\", \"http://schema.org/modelDate\"\r\n        \"modifiedTime\", \"http://schema.org/modifiedTime\"\r\n        \"monthlyMinimumRepaymentAmount\", \"http://schema.org/monthlyMinimumRepaymentAmount\"\r\n        \"mpn\", \"http://schema.org/mpn\"\r\n        \"multipleValues\", \"http://schema.org/multipleValues\"\r\n        \"muscleAction\", \"http://schema.org/muscleAction\"\r\n        \"musicArrangement\", \"http://schema.org/musicArrangement\"\r\n        \"musicBy\", \"http://schema.org/musicBy\"\r\n        \"musicCompositionForm\", \"http://schema.org/musicCompositionForm\"\r\n        \"musicGroupMember\", \"http://schema.org/musicGroupMember\"\r\n        \"musicReleaseFormat\", \"http://schema.org/musicReleaseFormat\"\r\n        \"musicalKey\", \"http://schema.org/musicalKey\"\r\n        \"naics\", \"http://schema.org/naics\"\r\n        \"name\", \"http://schema.org/name\"\r\n        \"namedPosition\", \"http://schema.org/namedPosition\"\r\n        \"nationality\", \"http://schema.org/nationality\"\r\n        \"naturalProgression\", \"http://schema.org/naturalProgression\"\r\n        \"nerve\", \"http://schema.org/nerve\"\r\n        \"nerveMotor\", \"http://schema.org/nerveMotor\"\r\n        \"netWorth\", \"http://schema.org/netWorth\"\r\n        \"newsUpdatesAndGuidelines\", \"http://schema.org/newsUpdatesAndGuidelines\"\r\n        \"nextItem\", \"http://schema.org/nextItem\"\r\n        \"noBylinesPolicy\", \"http://schema.org/noBylinesPolicy\"\r\n        \"nonEqual\", \"http://schema.org/nonEqual\"\r\n        \"nonProprietaryName\", \"http://schema.org/nonProprietaryName\"\r\n        \"nonprofitStatus\", \"http://schema.org/nonprofitStatus\"\r\n        \"normalRange\", \"http://schema.org/normalRange\"\r\n        \"nsn\", \"http://schema.org/nsn\"\r\n        \"numAdults\", \"http://schema.org/numAdults\"\r\n        \"numChildren\", \"http://schema.org/numChildren\"\r\n        \"numConstraints\", \"http://schema.org/numConstraints\"\r\n        \"numTracks\", \"http://schema.org/numTracks\"\r\n        \"numberOfAccommodationUnits\", \"http://schema.org/numberOfAccommodationUnits\"\r\n        \"numberOfAirbags\", \"http://schema.org/numberOfAirbags\"\r\n        \"numberOfAvailableAccommodationUnits\", \"http://schema.org/numberOfAvailableAccommodationUnits\"\r\n        \"numberOfAxles\", \"http://schema.org/numberOfAxles\"\r\n        \"numberOfBathroomsTotal\", \"http://schema.org/numberOfBathroomsTotal\"\r\n        \"numberOfBedrooms\", \"http://schema.org/numberOfBedrooms\"\r\n        \"numberOfBeds\", \"http://schema.org/numberOfBeds\"\r\n        \"numberOfCredits\", \"http://schema.org/numberOfCredits\"\r\n        \"numberOfDoors\", \"http://schema.org/numberOfDoors\"\r\n        \"numberOfEmployees\", \"http://schema.org/numberOfEmployees\"\r\n        \"numberOfEpisodes\", \"http://schema.org/numberOfEpisodes\"\r\n        \"numberOfForwardGears\", \"http://schema.org/numberOfForwardGears\"\r\n        \"numberOfFullBathrooms\", \"http://schema.org/numberOfFullBathrooms\"\r\n        \"numberOfItems\", \"http://schema.org/numberOfItems\"\r\n        \"numberOfLoanPayments\", \"http://schema.org/numberOfLoanPayments\"\r\n        \"numberOfPages\", \"http://schema.org/numberOfPages\"\r\n        \"numberOfPartialBathrooms\", \"http://schema.org/numberOfPartialBathrooms\"\r\n        \"numberOfPlayers\", \"http://schema.org/numberOfPlayers\"\r\n        \"numberOfPreviousOwners\", \"http://schema.org/numberOfPreviousOwners\"\r\n        \"numberOfRooms\", \"http://schema.org/numberOfRooms\"\r\n        \"numberOfSeasons\", \"http://schema.org/numberOfSeasons\"\r\n        \"numberedPosition\", \"http://schema.org/numberedPosition\"\r\n        \"nutrition\", \"http://schema.org/nutrition\"\r\n        \"object\", \"http://schema.org/object\"\r\n        \"observationDate\", \"http://schema.org/observationDate\"\r\n        \"observedNode\", \"http://schema.org/observedNode\"\r\n        \"occupancy\", \"http://schema.org/occupancy\"\r\n        \"occupationLocation\", \"http://schema.org/occupationLocation\"\r\n        \"occupationalCategory\", \"http://schema.org/occupationalCategory\"\r\n        \"occupationalCredentialAwarded\", \"http://schema.org/occupationalCredentialAwarded\"\r\n        \"offerCount\", \"http://schema.org/offerCount\"\r\n        \"offeredBy\", \"http://schema.org/offeredBy\"\r\n        \"offers\", \"http://schema.org/offers\"\r\n        \"offersPrescriptionByMail\", \"http://schema.org/offersPrescriptionByMail\"\r\n        \"openingHours\", \"http://schema.org/openingHours\"\r\n        \"openingHoursSpecification\", \"http://schema.org/openingHoursSpecification\"\r\n        \"opens\", \"http://schema.org/opens\"\r\n        \"operatingSystem\", \"http://schema.org/operatingSystem\"\r\n        \"opponent\", \"http://schema.org/opponent\"\r\n        \"option\", \"http://schema.org/option\"\r\n        \"orderDate\", \"http://schema.org/orderDate\"\r\n        \"orderDelivery\", \"http://schema.org/orderDelivery\"\r\n        \"orderItemNumber\", \"http://schema.org/orderItemNumber\"\r\n        \"orderItemStatus\", \"http://schema.org/orderItemStatus\"\r\n        \"orderNumber\", \"http://schema.org/orderNumber\"\r\n        \"orderQuantity\", \"http://schema.org/orderQuantity\"\r\n        \"orderStatus\", \"http://schema.org/orderStatus\"\r\n        \"orderedItem\", \"http://schema.org/orderedItem\"\r\n        \"organizer\", \"http://schema.org/organizer\"\r\n        \"originAddress\", \"http://schema.org/originAddress\"\r\n        \"originatesFrom\", \"http://schema.org/originatesFrom\"\r\n        \"overdosage\", \"http://schema.org/overdosage\"\r\n        \"ownedFrom\", \"http://schema.org/ownedFrom\"\r\n        \"ownedThrough\", \"http://schema.org/ownedThrough\"\r\n        \"ownershipFundingInfo\", \"http://schema.org/ownershipFundingInfo\"\r\n        \"owns\", \"http://schema.org/owns\"\r\n        \"pageEnd\", \"http://schema.org/pageEnd\"\r\n        \"pageStart\", \"http://schema.org/pageStart\"\r\n        \"pagination\", \"http://schema.org/pagination\"\r\n        \"parent\", \"http://schema.org/parent\"\r\n        \"parentItem\", \"http://schema.org/parentItem\"\r\n        \"parentOrganization\", \"http://schema.org/parentOrganization\"\r\n        \"parentService\", \"http://schema.org/parentService\"\r\n        \"parents\", \"http://schema.org/parents\"\r\n        \"partOfEpisode\", \"http://schema.org/partOfEpisode\"\r\n        \"partOfInvoice\", \"http://schema.org/partOfInvoice\"\r\n        \"partOfOrder\", \"http://schema.org/partOfOrder\"\r\n        \"partOfSeason\", \"http://schema.org/partOfSeason\"\r\n        \"partOfSeries\", \"http://schema.org/partOfSeries\"\r\n        \"partOfSystem\", \"http://schema.org/partOfSystem\"\r\n        \"partOfTVSeries\", \"http://schema.org/partOfTVSeries\"\r\n        \"partOfTrip\", \"http://schema.org/partOfTrip\"\r\n        \"participant\", \"http://schema.org/participant\"\r\n        \"partySize\", \"http://schema.org/partySize\"\r\n        \"passengerPriorityStatus\", \"http://schema.org/passengerPriorityStatus\"\r\n        \"passengerSequenceNumber\", \"http://schema.org/passengerSequenceNumber\"\r\n        \"pathophysiology\", \"http://schema.org/pathophysiology\"\r\n        \"pattern\", \"http://schema.org/pattern\"\r\n        \"payload\", \"http://schema.org/payload\"\r\n        \"paymentAccepted\", \"http://schema.org/paymentAccepted\"\r\n        \"paymentDue\", \"http://schema.org/paymentDue\"\r\n        \"paymentDueDate\", \"http://schema.org/paymentDueDate\"\r\n        \"paymentMethod\", \"http://schema.org/paymentMethod\"\r\n        \"paymentMethodId\", \"http://schema.org/paymentMethodId\"\r\n        \"paymentStatus\", \"http://schema.org/paymentStatus\"\r\n        \"paymentUrl\", \"http://schema.org/paymentUrl\"\r\n        \"penciler\", \"http://schema.org/penciler\"\r\n        \"percentile10\", \"http://schema.org/percentile10\"\r\n        \"percentile25\", \"http://schema.org/percentile25\"\r\n        \"percentile75\", \"http://schema.org/percentile75\"\r\n        \"percentile90\", \"http://schema.org/percentile90\"\r\n        \"performTime\", \"http://schema.org/performTime\"\r\n        \"performer\", \"http://schema.org/performer\"\r\n        \"performerIn\", \"http://schema.org/performerIn\"\r\n        \"performers\", \"http://schema.org/performers\"\r\n        \"permissionType\", \"http://schema.org/permissionType\"\r\n        \"permissions\", \"http://schema.org/permissions\"\r\n        \"permitAudience\", \"http://schema.org/permitAudience\"\r\n        \"permittedUsage\", \"http://schema.org/permittedUsage\"\r\n        \"petsAllowed\", \"http://schema.org/petsAllowed\"\r\n        \"phoneticText\", \"http://schema.org/phoneticText\"\r\n        \"photo\", \"http://schema.org/photo\"\r\n        \"photos\", \"http://schema.org/photos\"\r\n        \"physicalRequirement\", \"http://schema.org/physicalRequirement\"\r\n        \"physiologicalBenefits\", \"http://schema.org/physiologicalBenefits\"\r\n        \"pickupLocation\", \"http://schema.org/pickupLocation\"\r\n        \"pickupTime\", \"http://schema.org/pickupTime\"\r\n        \"playMode\", \"http://schema.org/playMode\"\r\n        \"playerType\", \"http://schema.org/playerType\"\r\n        \"playersOnline\", \"http://schema.org/playersOnline\"\r\n        \"polygon\", \"http://schema.org/polygon\"\r\n        \"populationType\", \"http://schema.org/populationType\"\r\n        \"position\", \"http://schema.org/position\"\r\n        \"possibleComplication\", \"http://schema.org/possibleComplication\"\r\n        \"possibleTreatment\", \"http://schema.org/possibleTreatment\"\r\n        \"postOfficeBoxNumber\", \"http://schema.org/postOfficeBoxNumber\"\r\n        \"postOp\", \"http://schema.org/postOp\"\r\n        \"postalCode\", \"http://schema.org/postalCode\"\r\n        \"postalCodeBegin\", \"http://schema.org/postalCodeBegin\"\r\n        \"postalCodeEnd\", \"http://schema.org/postalCodeEnd\"\r\n        \"postalCodePrefix\", \"http://schema.org/postalCodePrefix\"\r\n        \"postalCodeRange\", \"http://schema.org/postalCodeRange\"\r\n        \"potentialAction\", \"http://schema.org/potentialAction\"\r\n        \"preOp\", \"http://schema.org/preOp\"\r\n        \"predecessorOf\", \"http://schema.org/predecessorOf\"\r\n        \"pregnancyCategory\", \"http://schema.org/pregnancyCategory\"\r\n        \"pregnancyWarning\", \"http://schema.org/pregnancyWarning\"\r\n        \"prepTime\", \"http://schema.org/prepTime\"\r\n        \"preparation\", \"http://schema.org/preparation\"\r\n        \"prescribingInfo\", \"http://schema.org/prescribingInfo\"\r\n        \"prescriptionStatus\", \"http://schema.org/prescriptionStatus\"\r\n        \"previousItem\", \"http://schema.org/previousItem\"\r\n        \"previousStartDate\", \"http://schema.org/previousStartDate\"\r\n        \"price\", \"http://schema.org/price\"\r\n        \"priceComponent\", \"http://schema.org/priceComponent\"\r\n        \"priceCurrency\", \"http://schema.org/priceCurrency\"\r\n        \"priceRange\", \"http://schema.org/priceRange\"\r\n        \"priceSpecification\", \"http://schema.org/priceSpecification\"\r\n        \"priceType\", \"http://schema.org/priceType\"\r\n        \"priceValidUntil\", \"http://schema.org/priceValidUntil\"\r\n        \"primaryImageOfPage\", \"http://schema.org/primaryImageOfPage\"\r\n        \"primaryPrevention\", \"http://schema.org/primaryPrevention\"\r\n        \"printColumn\", \"http://schema.org/printColumn\"\r\n        \"printEdition\", \"http://schema.org/printEdition\"\r\n        \"printPage\", \"http://schema.org/printPage\"\r\n        \"printSection\", \"http://schema.org/printSection\"\r\n        \"procedure\", \"http://schema.org/procedure\"\r\n        \"procedureType\", \"http://schema.org/procedureType\"\r\n        \"processingTime\", \"http://schema.org/processingTime\"\r\n        \"processorRequirements\", \"http://schema.org/processorRequirements\"\r\n        \"producer\", \"http://schema.org/producer\"\r\n        \"produces\", \"http://schema.org/produces\"\r\n        \"productGroupID\", \"http://schema.org/productGroupID\"\r\n        \"productID\", \"http://schema.org/productID\"\r\n        \"productReturnDays\", \"http://schema.org/productReturnDays\"\r\n        \"productReturnLink\", \"http://schema.org/productReturnLink\"\r\n        \"productSupported\", \"http://schema.org/productSupported\"\r\n        \"productionCompany\", \"http://schema.org/productionCompany\"\r\n        \"productionDate\", \"http://schema.org/productionDate\"\r\n        \"proficiencyLevel\", \"http://schema.org/proficiencyLevel\"\r\n        \"programMembershipUsed\", \"http://schema.org/programMembershipUsed\"\r\n        \"programName\", \"http://schema.org/programName\"\r\n        \"programPrerequisites\", \"http://schema.org/programPrerequisites\"\r\n        \"programType\", \"http://schema.org/programType\"\r\n        \"programmingLanguage\", \"http://schema.org/programmingLanguage\"\r\n        \"programmingModel\", \"http://schema.org/programmingModel\"\r\n        \"propertyID\", \"http://schema.org/propertyID\"\r\n        \"proprietaryName\", \"http://schema.org/proprietaryName\"\r\n        \"proteinContent\", \"http://schema.org/proteinContent\"\r\n        \"provider\", \"http://schema.org/provider\"\r\n        \"providerMobility\", \"http://schema.org/providerMobility\"\r\n        \"providesBroadcastService\", \"http://schema.org/providesBroadcastService\"\r\n        \"providesService\", \"http://schema.org/providesService\"\r\n        \"publicAccess\", \"http://schema.org/publicAccess\"\r\n        \"publicTransportClosuresInfo\", \"http://schema.org/publicTransportClosuresInfo\"\r\n        \"publication\", \"http://schema.org/publication\"\r\n        \"publicationType\", \"http://schema.org/publicationType\"\r\n        \"publishedBy\", \"http://schema.org/publishedBy\"\r\n        \"publishedOn\", \"http://schema.org/publishedOn\"\r\n        \"publisher\", \"http://schema.org/publisher\"\r\n        \"publisherImprint\", \"http://schema.org/publisherImprint\"\r\n        \"publishingPrinciples\", \"http://schema.org/publishingPrinciples\"\r\n        \"purchaseDate\", \"http://schema.org/purchaseDate\"\r\n        \"qualifications\", \"http://schema.org/qualifications\"\r\n        \"quarantineGuidelines\", \"http://schema.org/quarantineGuidelines\"\r\n        \"query\", \"http://schema.org/query\"\r\n        \"quest\", \"http://schema.org/quest\"\r\n        \"question\", \"http://schema.org/question\"\r\n        \"rangeIncludes\", \"http://schema.org/rangeIncludes\"\r\n        \"ratingCount\", \"http://schema.org/ratingCount\"\r\n        \"ratingExplanation\", \"http://schema.org/ratingExplanation\"\r\n        \"ratingValue\", \"http://schema.org/ratingValue\"\r\n        \"readBy\", \"http://schema.org/readBy\"\r\n        \"readonlyValue\", \"http://schema.org/readonlyValue\"\r\n        \"realEstateAgent\", \"http://schema.org/realEstateAgent\"\r\n        \"recipe\", \"http://schema.org/recipe\"\r\n        \"recipeCategory\", \"http://schema.org/recipeCategory\"\r\n        \"recipeCuisine\", \"http://schema.org/recipeCuisine\"\r\n        \"recipeIngredient\", \"http://schema.org/recipeIngredient\"\r\n        \"recipeInstructions\", \"http://schema.org/recipeInstructions\"\r\n        \"recipeYield\", \"http://schema.org/recipeYield\"\r\n        \"recipient\", \"http://schema.org/recipient\"\r\n        \"recognizedBy\", \"http://schema.org/recognizedBy\"\r\n        \"recognizingAuthority\", \"http://schema.org/recognizingAuthority\"\r\n        \"recommendationStrength\", \"http://schema.org/recommendationStrength\"\r\n        \"recommendedIntake\", \"http://schema.org/recommendedIntake\"\r\n        \"recordLabel\", \"http://schema.org/recordLabel\"\r\n        \"recordedAs\", \"http://schema.org/recordedAs\"\r\n        \"recordedAt\", \"http://schema.org/recordedAt\"\r\n        \"recordedIn\", \"http://schema.org/recordedIn\"\r\n        \"recordingOf\", \"http://schema.org/recordingOf\"\r\n        \"recourseLoan\", \"http://schema.org/recourseLoan\"\r\n        \"referenceQuantity\", \"http://schema.org/referenceQuantity\"\r\n        \"referencesOrder\", \"http://schema.org/referencesOrder\"\r\n        \"refundType\", \"http://schema.org/refundType\"\r\n        \"regionDrained\", \"http://schema.org/regionDrained\"\r\n        \"regionsAllowed\", \"http://schema.org/regionsAllowed\"\r\n        \"relatedAnatomy\", \"http://schema.org/relatedAnatomy\"\r\n        \"relatedCondition\", \"http://schema.org/relatedCondition\"\r\n        \"relatedDrug\", \"http://schema.org/relatedDrug\"\r\n        \"relatedLink\", \"http://schema.org/relatedLink\"\r\n        \"relatedStructure\", \"http://schema.org/relatedStructure\"\r\n        \"relatedTherapy\", \"http://schema.org/relatedTherapy\"\r\n        \"relatedTo\", \"http://schema.org/relatedTo\"\r\n        \"releaseDate\", \"http://schema.org/releaseDate\"\r\n        \"releaseNotes\", \"http://schema.org/releaseNotes\"\r\n        \"releaseOf\", \"http://schema.org/releaseOf\"\r\n        \"releasedEvent\", \"http://schema.org/releasedEvent\"\r\n        \"relevantOccupation\", \"http://schema.org/relevantOccupation\"\r\n        \"relevantSpecialty\", \"http://schema.org/relevantSpecialty\"\r\n        \"remainingAttendeeCapacity\", \"http://schema.org/remainingAttendeeCapacity\"\r\n        \"renegotiableLoan\", \"http://schema.org/renegotiableLoan\"\r\n        \"repeatCount\", \"http://schema.org/repeatCount\"\r\n        \"repeatFrequency\", \"http://schema.org/repeatFrequency\"\r\n        \"repetitions\", \"http://schema.org/repetitions\"\r\n        \"replacee\", \"http://schema.org/replacee\"\r\n        \"replacer\", \"http://schema.org/replacer\"\r\n        \"replyToUrl\", \"http://schema.org/replyToUrl\"\r\n        \"reportNumber\", \"http://schema.org/reportNumber\"\r\n        \"representativeOfPage\", \"http://schema.org/representativeOfPage\"\r\n        \"requiredCollateral\", \"http://schema.org/requiredCollateral\"\r\n        \"requiredGender\", \"http://schema.org/requiredGender\"\r\n        \"requiredMaxAge\", \"http://schema.org/requiredMaxAge\"\r\n        \"requiredMinAge\", \"http://schema.org/requiredMinAge\"\r\n        \"requiredQuantity\", \"http://schema.org/requiredQuantity\"\r\n        \"requirements\", \"http://schema.org/requirements\"\r\n        \"requiresSubscription\", \"http://schema.org/requiresSubscription\"\r\n        \"reservationFor\", \"http://schema.org/reservationFor\"\r\n        \"reservationId\", \"http://schema.org/reservationId\"\r\n        \"reservationStatus\", \"http://schema.org/reservationStatus\"\r\n        \"reservedTicket\", \"http://schema.org/reservedTicket\"\r\n        \"responsibilities\", \"http://schema.org/responsibilities\"\r\n        \"restPeriods\", \"http://schema.org/restPeriods\"\r\n        \"result\", \"http://schema.org/result\"\r\n        \"resultComment\", \"http://schema.org/resultComment\"\r\n        \"resultReview\", \"http://schema.org/resultReview\"\r\n        \"returnFees\", \"http://schema.org/returnFees\"\r\n        \"returnPolicyCategory\", \"http://schema.org/returnPolicyCategory\"\r\n        \"review\", \"http://schema.org/review\"\r\n        \"reviewAspect\", \"http://schema.org/reviewAspect\"\r\n        \"reviewBody\", \"http://schema.org/reviewBody\"\r\n        \"reviewCount\", \"http://schema.org/reviewCount\"\r\n        \"reviewRating\", \"http://schema.org/reviewRating\"\r\n        \"reviewedBy\", \"http://schema.org/reviewedBy\"\r\n        \"reviews\", \"http://schema.org/reviews\"\r\n        \"riskFactor\", \"http://schema.org/riskFactor\"\r\n        \"risks\", \"http://schema.org/risks\"\r\n        \"roleName\", \"http://schema.org/roleName\"\r\n        \"roofLoad\", \"http://schema.org/roofLoad\"\r\n        \"rsvpResponse\", \"http://schema.org/rsvpResponse\"\r\n        \"runsTo\", \"http://schema.org/runsTo\"\r\n        \"runtime\", \"http://schema.org/runtime\"\r\n        \"runtimePlatform\", \"http://schema.org/runtimePlatform\"\r\n        \"rxcui\", \"http://schema.org/rxcui\"\r\n        \"safetyConsideration\", \"http://schema.org/safetyConsideration\"\r\n        \"salaryCurrency\", \"http://schema.org/salaryCurrency\"\r\n        \"salaryUponCompletion\", \"http://schema.org/salaryUponCompletion\"\r\n        \"sameAs\", \"http://schema.org/sameAs\"\r\n        \"sampleType\", \"http://schema.org/sampleType\"\r\n        \"saturatedFatContent\", \"http://schema.org/saturatedFatContent\"\r\n        \"scheduleTimezone\", \"http://schema.org/scheduleTimezone\"\r\n        \"scheduledPaymentDate\", \"http://schema.org/scheduledPaymentDate\"\r\n        \"scheduledTime\", \"http://schema.org/scheduledTime\"\r\n        \"schemaVersion\", \"http://schema.org/schemaVersion\"\r\n        \"schoolClosuresInfo\", \"http://schema.org/schoolClosuresInfo\"\r\n        \"screenCount\", \"http://schema.org/screenCount\"\r\n        \"screenshot\", \"http://schema.org/screenshot\"\r\n        \"sdDatePublished\", \"http://schema.org/sdDatePublished\"\r\n        \"sdLicense\", \"http://schema.org/sdLicense\"\r\n        \"sdPublisher\", \"http://schema.org/sdPublisher\"\r\n        \"season\", \"http://schema.org/season\"\r\n        \"seasonNumber\", \"http://schema.org/seasonNumber\"\r\n        \"seasons\", \"http://schema.org/seasons\"\r\n        \"seatNumber\", \"http://schema.org/seatNumber\"\r\n        \"seatRow\", \"http://schema.org/seatRow\"\r\n        \"seatSection\", \"http://schema.org/seatSection\"\r\n        \"seatingCapacity\", \"http://schema.org/seatingCapacity\"\r\n        \"seatingType\", \"http://schema.org/seatingType\"\r\n        \"secondaryPrevention\", \"http://schema.org/secondaryPrevention\"\r\n        \"securityClearanceRequirement\", \"http://schema.org/securityClearanceRequirement\"\r\n        \"securityScreening\", \"http://schema.org/securityScreening\"\r\n        \"seeks\", \"http://schema.org/seeks\"\r\n        \"seller\", \"http://schema.org/seller\"\r\n        \"sender\", \"http://schema.org/sender\"\r\n        \"sensoryRequirement\", \"http://schema.org/sensoryRequirement\"\r\n        \"sensoryUnit\", \"http://schema.org/sensoryUnit\"\r\n        \"serialNumber\", \"http://schema.org/serialNumber\"\r\n        \"seriousAdverseOutcome\", \"http://schema.org/seriousAdverseOutcome\"\r\n        \"serverStatus\", \"http://schema.org/serverStatus\"\r\n        \"servesCuisine\", \"http://schema.org/servesCuisine\"\r\n        \"serviceArea\", \"http://schema.org/serviceArea\"\r\n        \"serviceAudience\", \"http://schema.org/serviceAudience\"\r\n        \"serviceLocation\", \"http://schema.org/serviceLocation\"\r\n        \"serviceOperator\", \"http://schema.org/serviceOperator\"\r\n        \"serviceOutput\", \"http://schema.org/serviceOutput\"\r\n        \"servicePhone\", \"http://schema.org/servicePhone\"\r\n        \"servicePostalAddress\", \"http://schema.org/servicePostalAddress\"\r\n        \"serviceSmsNumber\", \"http://schema.org/serviceSmsNumber\"\r\n        \"serviceType\", \"http://schema.org/serviceType\"\r\n        \"serviceUrl\", \"http://schema.org/serviceUrl\"\r\n        \"servingSize\", \"http://schema.org/servingSize\"\r\n        \"sharedContent\", \"http://schema.org/sharedContent\"\r\n        \"shippingDestination\", \"http://schema.org/shippingDestination\"\r\n        \"shippingDetails\", \"http://schema.org/shippingDetails\"\r\n        \"shippingLabel\", \"http://schema.org/shippingLabel\"\r\n        \"shippingRate\", \"http://schema.org/shippingRate\"\r\n        \"shippingSettingsLink\", \"http://schema.org/shippingSettingsLink\"\r\n        \"sibling\", \"http://schema.org/sibling\"\r\n        \"siblings\", \"http://schema.org/siblings\"\r\n        \"signDetected\", \"http://schema.org/signDetected\"\r\n        \"signOrSymptom\", \"http://schema.org/signOrSymptom\"\r\n        \"significance\", \"http://schema.org/significance\"\r\n        \"significantLink\", \"http://schema.org/significantLink\"\r\n        \"significantLinks\", \"http://schema.org/significantLinks\"\r\n        \"size\", \"http://schema.org/size\"\r\n        \"skills\", \"http://schema.org/skills\"\r\n        \"sku\", \"http://schema.org/sku\"\r\n        \"slogan\", \"http://schema.org/slogan\"\r\n        \"smokingAllowed\", \"http://schema.org/smokingAllowed\"\r\n        \"sodiumContent\", \"http://schema.org/sodiumContent\"\r\n        \"softwareAddOn\", \"http://schema.org/softwareAddOn\"\r\n        \"softwareHelp\", \"http://schema.org/softwareHelp\"\r\n        \"softwareRequirements\", \"http://schema.org/softwareRequirements\"\r\n        \"softwareVersion\", \"http://schema.org/softwareVersion\"\r\n        \"sourceOrganization\", \"http://schema.org/sourceOrganization\"\r\n        \"sourcedFrom\", \"http://schema.org/sourcedFrom\"\r\n        \"spatial\", \"http://schema.org/spatial\"\r\n        \"spatialCoverage\", \"http://schema.org/spatialCoverage\"\r\n        \"speakable\", \"http://schema.org/speakable\"\r\n        \"specialCommitments\", \"http://schema.org/specialCommitments\"\r\n        \"specialOpeningHoursSpecification\", \"http://schema.org/specialOpeningHoursSpecification\"\r\n        \"specialty\", \"http://schema.org/specialty\"\r\n        \"speechToTextMarkup\", \"http://schema.org/speechToTextMarkup\"\r\n        \"speed\", \"http://schema.org/speed\"\r\n        \"spokenByCharacter\", \"http://schema.org/spokenByCharacter\"\r\n        \"sponsor\", \"http://schema.org/sponsor\"\r\n        \"sport\", \"http://schema.org/sport\"\r\n        \"sportsActivityLocation\", \"http://schema.org/sportsActivityLocation\"\r\n        \"sportsEvent\", \"http://schema.org/sportsEvent\"\r\n        \"sportsTeam\", \"http://schema.org/sportsTeam\"\r\n        \"spouse\", \"http://schema.org/spouse\"\r\n        \"stage\", \"http://schema.org/stage\"\r\n        \"stageAsNumber\", \"http://schema.org/stageAsNumber\"\r\n        \"starRating\", \"http://schema.org/starRating\"\r\n        \"startDate\", \"http://schema.org/startDate\"\r\n        \"startOffset\", \"http://schema.org/startOffset\"\r\n        \"startTime\", \"http://schema.org/startTime\"\r\n        \"status\", \"http://schema.org/status\"\r\n        \"steeringPosition\", \"http://schema.org/steeringPosition\"\r\n        \"step\", \"http://schema.org/step\"\r\n        \"stepValue\", \"http://schema.org/stepValue\"\r\n        \"steps\", \"http://schema.org/steps\"\r\n        \"storageRequirements\", \"http://schema.org/storageRequirements\"\r\n        \"streetAddress\", \"http://schema.org/streetAddress\"\r\n        \"strengthUnit\", \"http://schema.org/strengthUnit\"\r\n        \"strengthValue\", \"http://schema.org/strengthValue\"\r\n        \"structuralClass\", \"http://schema.org/structuralClass\"\r\n        \"study\", \"http://schema.org/study\"\r\n        \"studyDesign\", \"http://schema.org/studyDesign\"\r\n        \"studyLocation\", \"http://schema.org/studyLocation\"\r\n        \"studySubject\", \"http://schema.org/studySubject\"\r\n        \"stupidProperty\", \"http://schema.org/stupidProperty\"\r\n        \"subEvent\", \"http://schema.org/subEvent\"\r\n        \"subEvents\", \"http://schema.org/subEvents\"\r\n        \"subOrganization\", \"http://schema.org/subOrganization\"\r\n        \"subReservation\", \"http://schema.org/subReservation\"\r\n        \"subStageSuffix\", \"http://schema.org/subStageSuffix\"\r\n        \"subStructure\", \"http://schema.org/subStructure\"\r\n        \"subTest\", \"http://schema.org/subTest\"\r\n        \"subTrip\", \"http://schema.org/subTrip\"\r\n        \"subjectOf\", \"http://schema.org/subjectOf\"\r\n        \"subtitleLanguage\", \"http://schema.org/subtitleLanguage\"\r\n        \"successorOf\", \"http://schema.org/successorOf\"\r\n        \"sugarContent\", \"http://schema.org/sugarContent\"\r\n        \"suggestedAnswer\", \"http://schema.org/suggestedAnswer\"\r\n        \"suggestedGender\", \"http://schema.org/suggestedGender\"\r\n        \"suggestedMaxAge\", \"http://schema.org/suggestedMaxAge\"\r\n        \"suggestedMinAge\", \"http://schema.org/suggestedMinAge\"\r\n        \"suitableForDiet\", \"http://schema.org/suitableForDiet\"\r\n        \"superEvent\", \"http://schema.org/superEvent\"\r\n        \"supersededBy\", \"http://schema.org/supersededBy\"\r\n        \"supply\", \"http://schema.org/supply\"\r\n        \"supplyTo\", \"http://schema.org/supplyTo\"\r\n        \"supportingData\", \"http://schema.org/supportingData\"\r\n        \"surface\", \"http://schema.org/surface\"\r\n        \"target\", \"http://schema.org/target\"\r\n        \"targetCollection\", \"http://schema.org/targetCollection\"\r\n        \"targetDescription\", \"http://schema.org/targetDescription\"\r\n        \"targetName\", \"http://schema.org/targetName\"\r\n        \"targetPlatform\", \"http://schema.org/targetPlatform\"\r\n        \"targetPopulation\", \"http://schema.org/targetPopulation\"\r\n        \"targetProduct\", \"http://schema.org/targetProduct\"\r\n        \"targetUrl\", \"http://schema.org/targetUrl\"\r\n        \"taxID\", \"http://schema.org/taxID\"\r\n        \"teaches\", \"http://schema.org/teaches\"\r\n        \"telephone\", \"http://schema.org/telephone\"\r\n        \"temporal\", \"http://schema.org/temporal\"\r\n        \"temporalCoverage\", \"http://schema.org/temporalCoverage\"\r\n        \"termCode\", \"http://schema.org/termCode\"\r\n        \"termDuration\", \"http://schema.org/termDuration\"\r\n        \"termsOfService\", \"http://schema.org/termsOfService\"\r\n        \"termsPerYear\", \"http://schema.org/termsPerYear\"\r\n        \"text\", \"http://schema.org/text\"\r\n        \"textValue\", \"http://schema.org/textValue\"\r\n        \"thumbnail\", \"http://schema.org/thumbnail\"\r\n        \"thumbnailUrl\", \"http://schema.org/thumbnailUrl\"\r\n        \"tickerSymbol\", \"http://schema.org/tickerSymbol\"\r\n        \"ticketNumber\", \"http://schema.org/ticketNumber\"\r\n        \"ticketToken\", \"http://schema.org/ticketToken\"\r\n        \"ticketedSeat\", \"http://schema.org/ticketedSeat\"\r\n        \"timeOfDay\", \"http://schema.org/timeOfDay\"\r\n        \"timeRequired\", \"http://schema.org/timeRequired\"\r\n        \"timeToComplete\", \"http://schema.org/timeToComplete\"\r\n        \"tissueSample\", \"http://schema.org/tissueSample\"\r\n        \"title\", \"http://schema.org/title\"\r\n        \"titleEIDR\", \"http://schema.org/titleEIDR\"\r\n        \"toLocation\", \"http://schema.org/toLocation\"\r\n        \"toRecipient\", \"http://schema.org/toRecipient\"\r\n        \"tongueWeight\", \"http://schema.org/tongueWeight\"\r\n        \"tool\", \"http://schema.org/tool\"\r\n        \"torque\", \"http://schema.org/torque\"\r\n        \"totalJobOpenings\", \"http://schema.org/totalJobOpenings\"\r\n        \"totalPaymentDue\", \"http://schema.org/totalPaymentDue\"\r\n        \"totalPrice\", \"http://schema.org/totalPrice\"\r\n        \"totalTime\", \"http://schema.org/totalTime\"\r\n        \"tourBookingPage\", \"http://schema.org/tourBookingPage\"\r\n        \"touristType\", \"http://schema.org/touristType\"\r\n        \"track\", \"http://schema.org/track\"\r\n        \"trackingNumber\", \"http://schema.org/trackingNumber\"\r\n        \"trackingUrl\", \"http://schema.org/trackingUrl\"\r\n        \"tracks\", \"http://schema.org/tracks\"\r\n        \"trailer\", \"http://schema.org/trailer\"\r\n        \"trailerWeight\", \"http://schema.org/trailerWeight\"\r\n        \"trainName\", \"http://schema.org/trainName\"\r\n        \"trainNumber\", \"http://schema.org/trainNumber\"\r\n        \"trainingSalary\", \"http://schema.org/trainingSalary\"\r\n        \"transFatContent\", \"http://schema.org/transFatContent\"\r\n        \"transcript\", \"http://schema.org/transcript\"\r\n        \"transitTime\", \"http://schema.org/transitTime\"\r\n        \"transitTimeLabel\", \"http://schema.org/transitTimeLabel\"\r\n        \"translationOfWork\", \"http://schema.org/translationOfWork\"\r\n        \"translator\", \"http://schema.org/translator\"\r\n        \"transmissionMethod\", \"http://schema.org/transmissionMethod\"\r\n        \"travelBans\", \"http://schema.org/travelBans\"\r\n        \"trialDesign\", \"http://schema.org/trialDesign\"\r\n        \"tributary\", \"http://schema.org/tributary\"\r\n        \"typeOfBed\", \"http://schema.org/typeOfBed\"\r\n        \"typeOfGood\", \"http://schema.org/typeOfGood\"\r\n        \"typicalAgeRange\", \"http://schema.org/typicalAgeRange\"\r\n        \"typicalCreditsPerTerm\", \"http://schema.org/typicalCreditsPerTerm\"\r\n        \"typicalTest\", \"http://schema.org/typicalTest\"\r\n        \"underName\", \"http://schema.org/underName\"\r\n        \"unitCode\", \"http://schema.org/unitCode\"\r\n        \"unitText\", \"http://schema.org/unitText\"\r\n        \"unnamedSourcesPolicy\", \"http://schema.org/unnamedSourcesPolicy\"\r\n        \"unsaturatedFatContent\", \"http://schema.org/unsaturatedFatContent\"\r\n        \"uploadDate\", \"http://schema.org/uploadDate\"\r\n        \"upvoteCount\", \"http://schema.org/upvoteCount\"\r\n        \"url\", \"http://schema.org/url\"\r\n        \"urlTemplate\", \"http://schema.org/urlTemplate\"\r\n        \"usageInfo\", \"http://schema.org/usageInfo\"\r\n        \"usedToDiagnose\", \"http://schema.org/usedToDiagnose\"\r\n        \"userInteractionCount\", \"http://schema.org/userInteractionCount\"\r\n        \"usesDevice\", \"http://schema.org/usesDevice\"\r\n        \"usesHealthPlanIdStandard\", \"http://schema.org/usesHealthPlanIdStandard\"\r\n        \"validFor\", \"http://schema.org/validFor\"\r\n        \"validFrom\", \"http://schema.org/validFrom\"\r\n        \"validIn\", \"http://schema.org/validIn\"\r\n        \"validThrough\", \"http://schema.org/validThrough\"\r\n        \"validUntil\", \"http://schema.org/validUntil\"\r\n        \"value\", \"http://schema.org/value\"\r\n        \"valueAddedTaxIncluded\", \"http://schema.org/valueAddedTaxIncluded\"\r\n        \"valueMaxLength\", \"http://schema.org/valueMaxLength\"\r\n        \"valueMinLength\", \"http://schema.org/valueMinLength\"\r\n        \"valueName\", \"http://schema.org/valueName\"\r\n        \"valuePattern\", \"http://schema.org/valuePattern\"\r\n        \"valueReference\", \"http://schema.org/valueReference\"\r\n        \"valueRequired\", \"http://schema.org/valueRequired\"\r\n        \"variableMeasured\", \"http://schema.org/variableMeasured\"\r\n        \"variablesMeasured\", \"http://schema.org/variablesMeasured\"\r\n        \"variantCover\", \"http://schema.org/variantCover\"\r\n        \"variesBy\", \"http://schema.org/variesBy\"\r\n        \"vatID\", \"http://schema.org/vatID\"\r\n        \"vehicleConfiguration\", \"http://schema.org/vehicleConfiguration\"\r\n        \"vehicleEngine\", \"http://schema.org/vehicleEngine\"\r\n        \"vehicleIdentificationNumber\", \"http://schema.org/vehicleIdentificationNumber\"\r\n        \"vehicleInteriorColor\", \"http://schema.org/vehicleInteriorColor\"\r\n        \"vehicleInteriorType\", \"http://schema.org/vehicleInteriorType\"\r\n        \"vehicleModelDate\", \"http://schema.org/vehicleModelDate\"\r\n        \"vehicleSeatingCapacity\", \"http://schema.org/vehicleSeatingCapacity\"\r\n        \"vehicleSpecialUsage\", \"http://schema.org/vehicleSpecialUsage\"\r\n        \"vehicleTransmission\", \"http://schema.org/vehicleTransmission\"\r\n        \"vendor\", \"http://schema.org/vendor\"\r\n        \"verificationFactCheckingPolicy\", \"http://schema.org/verificationFactCheckingPolicy\"\r\n        \"version\", \"http://schema.org/version\"\r\n        \"video\", \"http://schema.org/video\"\r\n        \"videoFormat\", \"http://schema.org/videoFormat\"\r\n        \"videoFrameSize\", \"http://schema.org/videoFrameSize\"\r\n        \"videoQuality\", \"http://schema.org/videoQuality\"\r\n        \"volumeNumber\", \"http://schema.org/volumeNumber\"\r\n        \"warning\", \"http://schema.org/warning\"\r\n        \"warranty\", \"http://schema.org/warranty\"\r\n        \"warrantyPromise\", \"http://schema.org/warrantyPromise\"\r\n        \"warrantyScope\", \"http://schema.org/warrantyScope\"\r\n        \"webCheckinTime\", \"http://schema.org/webCheckinTime\"\r\n        \"webFeed\", \"http://schema.org/webFeed\"\r\n        \"weight\", \"http://schema.org/weight\"\r\n        \"weightTotal\", \"http://schema.org/weightTotal\"\r\n        \"wheelbase\", \"http://schema.org/wheelbase\"\r\n        \"width\", \"http://schema.org/width\"\r\n        \"winner\", \"http://schema.org/winner\"\r\n        \"wordCount\", \"http://schema.org/wordCount\"\r\n        \"workExample\", \"http://schema.org/workExample\"\r\n        \"workFeatured\", \"http://schema.org/workFeatured\"\r\n        \"workHours\", \"http://schema.org/workHours\"\r\n        \"workLocation\", \"http://schema.org/workLocation\"\r\n        \"workPerformed\", \"http://schema.org/workPerformed\"\r\n        \"workPresented\", \"http://schema.org/workPresented\"\r\n        \"workTranslation\", \"http://schema.org/workTranslation\"\r\n        \"workload\", \"http://schema.org/workload\"\r\n        \"worksFor\", \"http://schema.org/worksFor\"\r\n        \"worstRating\", \"http://schema.org/worstRating\"\r\n        \"xpath\", \"http://schema.org/xpath\"\r\n        \"yearBuilt\", \"http://schema.org/yearBuilt\"\r\n        \"yearlyRevenue\", \"http://schema.org/yearlyRevenue\"\r\n        \"yearsInOperation\", \"http://schema.org/yearsInOperation\"\r\n        \"yield\", \"http://schema.org/yield\"\r\n        \"File\", \"http://schema.org/MediaObject\"\r\n        \"path\", \"http://schema.org/contentUrl\"\r\n        \"Journal\", \"http://schema.org/Periodical\"\r\n        \"cite-as\", \"https,//www.w3.org/ns/iana/link-relations/relation#cite-as\"\r\n        \"hasFile\", \"http://pcdm.org/models#hasFile\"\r\n        \"hasMember\", \"http://pcdm.org/models#hasMember\"\r\n        \"RepositoryCollection\", \"http://pcdm.org/models#Collection\"\r\n        \"RepositoryObject\", \"http://pcdm.org/models#Object\"\r\n        \"ComputationalWorkflow\", \"https,//bioschemas.org/ComputationalWorkflow\"\r\n        \"input\", \"https,//bioschemas.org/ComputationalWorkflow#input\"\r\n        \"output\", \"https,//bioschemas.org/ComputationalWorkflow#output\"\r\n        \"FormalParameter\", \"https,//bioschemas.org/FormalParameter\"\r\n        \"funding\", \"http://schema.org/funding\"\r\n        \"wasDerivedFrom\", \"http://www.w3.org/ns/prov#wasDerivedFrom\"\r\n        \"importedFrom\", \"http://purl.org/pav/importedFrom\"\r\n        \"importedOn\", \"http://purl.org/pav/importedOn\"\r\n        \"importedBy\", \"http://purl.org/pav/importedBy\"\r\n        \"retrievedFrom\", \"http://purl.org/pav/retrievedFrom\"\r\n        \"retrievedOn\", \"http://purl.org/pav/retrievedOn\"\r\n        \"retrievedBy\", \"http://purl.org/pav/retrievedBy\"\r\n        \"conformsTo\", \"http://purl.org/dc/terms/conformsTo\"\r\n        \"pcdm\", \"http://pcdm.org/models#\"\r\n        \"bibo\", \"http://purl.org/ontology/bibo/\"\r\n        \"cc\", \"http://creativecommons.org/ns#\"\r\n        \"dct\", \"http://purl.org/dc/terms/\"\r\n        \"foaf\", \"http://xmlns.com/foaf/0.1/\"\r\n        \"rdf\", \"http://www.w3.org/1999/02/22-rdf-syntax-ns#\"\r\n        \"rdfa\", \"http://www.w3.org/ns/rdfa#\"\r\n        \"rdfs\", \"http://www.w3.org/2000/01/rdf-schema#\"\r\n        \"schema\", \"http://schema.org/\"\r\n        \"frapo\", \"http://purl.org/cerif/frapo/\"\r\n        \"rel\", \"https,//www.w3.org/ns/iana/link-relations/relation#\"\r\n        \"pav\", \"http://purl.org/pav/\"\r\n        \"prov\", \"http://www.w3.org/ns/prov#\"\r\n        \"wfdesc\", \"http://purl.org/ro/wfdesc#\"\r\n        \"wfprov\", \"http://purl.org/ro/wfprov#\"\r\n        \"roterms\", \"http://purl.org/ro/roterms#\"\r\n        \"wf4ever\", \"http://purl.org/ro/wf4ever#\"\r\n        "

def init_bioschemas_context(__unit: None=None) -> LDContext:
    return LDContext.from_mapping_seq(to_enumerable([("Sample", "https://bioschemas.org/Sample"), ("additionalProperty", "http://schema.org/additionalProperty"), ("intendedUse", "https://bioschemas.org/intendedUse"), ("computationalTool", "https://bioschemas.org/computationalTool"), ("labEquipment", "https://bioschemas.org/labEquipment"), ("reagent", "https://bioschemas.org/reagent"), ("LabProtocol", "https://bioschemas.org/LabProtocol"), ("executesLabProtocol", "https://bioschemas.org/executesLabProtocol"), ("parameterValue", "https://bioschemas.org/parameterValue"), ("LabProcess", "https://bioschemas.org/LabProcess"), ("measurementMethod", "http://schema.org/measurementMethod")]))


def init_v1_1(__unit: None=None) -> LDContext:
    def chooser(s: str) -> tuple[str, str] | None:
        match_value: str = s.strip()
        if match_value == "":
            return None

        else: 
            a: Array[str] = replace(match_value, "\"", "").split(",")
            return (a[0].strip(), a[1].strip())


    terms: Array[tuple[str, str]] = choose(chooser, terms_v1_1.split("\n"), None)
    c: LDContext = LDContext.from_mapping_seq(terms)
    c.Name = "https://w3id.org/ro/crate/1.1/context"
    return c


def init_v1_2draft(__unit: None=None) -> LDContext:
    def chooser(s: str) -> tuple[str, str] | None:
        match_value: str = s.strip()
        if match_value == "":
            return None

        else: 
            a: Array[str] = replace(match_value, "\"", "").split(",")
            return (a[0].strip(), a[1].strip())


    terms: Array[tuple[str, str]] = choose(chooser, terms_v1_2draft.split("\n"), None)
    c: LDContext = LDContext.from_mapping_seq(terms)
    c.Name = "https://w3id.org/ro/crate/1.2-DRAFT/context"
    return c


__all__ = ["terms_v1_2draft", "terms_v1_1", "init_bioschemas_context", "init_v1_1", "init_v1_2draft"]

